//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armappservice

import (
	"encoding/json"
	"io"
)

// CertificatesClientCreateOrUpdateResponse contains the response from method CertificatesClient.CreateOrUpdate.
type CertificatesClientCreateOrUpdateResponse struct {
	AppCertificate
}

// CertificatesClientDeleteResponse contains the response from method CertificatesClient.Delete.
type CertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificatesClientGetResponse contains the response from method CertificatesClient.Get.
type CertificatesClientGetResponse struct {
	AppCertificate
}

// CertificatesClientListByResourceGroupResponse contains the response from method CertificatesClient.NewListByResourceGroupPager.
type CertificatesClientListByResourceGroupResponse struct {
	AppCertificateCollection
}

// CertificatesClientListResponse contains the response from method CertificatesClient.NewListPager.
type CertificatesClientListResponse struct {
	AppCertificateCollection
}

// CertificatesClientUpdateResponse contains the response from method CertificatesClient.Update.
type CertificatesClientUpdateResponse struct {
	AppCertificate
}

// PlansClientCreateOrUpdateResponse contains the response from method PlansClient.BeginCreateOrUpdate.
type PlansClientCreateOrUpdateResponse struct {
	Plan
}

// PlansClientCreateOrUpdateVnetRouteResponse contains the response from method PlansClient.CreateOrUpdateVnetRoute.
type PlansClientCreateOrUpdateVnetRouteResponse struct {
	VnetRoute
}

// PlansClientDeleteHybridConnectionResponse contains the response from method PlansClient.DeleteHybridConnection.
type PlansClientDeleteHybridConnectionResponse struct {
	// placeholder for future response values
}

// PlansClientDeleteResponse contains the response from method PlansClient.Delete.
type PlansClientDeleteResponse struct {
	// placeholder for future response values
}

// PlansClientDeleteVnetRouteResponse contains the response from method PlansClient.DeleteVnetRoute.
type PlansClientDeleteVnetRouteResponse struct {
	// placeholder for future response values
}

// PlansClientGetHybridConnectionPlanLimitResponse contains the response from method PlansClient.GetHybridConnectionPlanLimit.
type PlansClientGetHybridConnectionPlanLimitResponse struct {
	HybridConnectionLimits
}

// PlansClientGetHybridConnectionResponse contains the response from method PlansClient.GetHybridConnection.
type PlansClientGetHybridConnectionResponse struct {
	HybridConnection
}

// PlansClientGetResponse contains the response from method PlansClient.Get.
type PlansClientGetResponse struct {
	Plan
}

// PlansClientGetRouteForVnetResponse contains the response from method PlansClient.GetRouteForVnet.
type PlansClientGetRouteForVnetResponse struct {
	// Array of VnetRoute
	VnetRouteArray []*VnetRoute
}

// PlansClientGetServerFarmSKUsResponse contains the response from method PlansClient.GetServerFarmSKUs.
type PlansClientGetServerFarmSKUsResponse struct {
	// Anything
	Interface any
}

// PlansClientGetVnetFromServerFarmResponse contains the response from method PlansClient.GetVnetFromServerFarm.
type PlansClientGetVnetFromServerFarmResponse struct {
	VnetInfo
}

// PlansClientGetVnetGatewayResponse contains the response from method PlansClient.GetVnetGateway.
type PlansClientGetVnetGatewayResponse struct {
	VnetGateway
}

// PlansClientListByResourceGroupResponse contains the response from method PlansClient.NewListByResourceGroupPager.
type PlansClientListByResourceGroupResponse struct {
	PlanCollection
}

// PlansClientListCapabilitiesResponse contains the response from method PlansClient.ListCapabilities.
type PlansClientListCapabilitiesResponse struct {
	// Array of Capability
	CapabilityArray []*Capability
}

// PlansClientListHybridConnectionKeysResponse contains the response from method PlansClient.ListHybridConnectionKeys.
type PlansClientListHybridConnectionKeysResponse struct {
	HybridConnectionKey
}

// PlansClientListHybridConnectionsResponse contains the response from method PlansClient.NewListHybridConnectionsPager.
type PlansClientListHybridConnectionsResponse struct {
	HybridConnectionCollection
}

// PlansClientListMetricDefintionsResponse contains the response from method PlansClient.NewListMetricDefintionsPager.
type PlansClientListMetricDefintionsResponse struct {
	ResourceMetricDefinitionCollection
}

// PlansClientListMetricsResponse contains the response from method PlansClient.NewListMetricsPager.
type PlansClientListMetricsResponse struct {
	ResourceMetricCollection
}

// PlansClientListResponse contains the response from method PlansClient.NewListPager.
type PlansClientListResponse struct {
	PlanCollection
}

// PlansClientListRoutesForVnetResponse contains the response from method PlansClient.ListRoutesForVnet.
type PlansClientListRoutesForVnetResponse struct {
	// Array of VnetRoute
	VnetRouteArray []*VnetRoute
}

// PlansClientListUsagesResponse contains the response from method PlansClient.NewListUsagesPager.
type PlansClientListUsagesResponse struct {
	CsmUsageQuotaCollection
}

// PlansClientListVnetsResponse contains the response from method PlansClient.ListVnets.
type PlansClientListVnetsResponse struct {
	// Array of VnetInfo
	VnetInfoArray []*VnetInfo
}

// PlansClientListWebAppsByHybridConnectionResponse contains the response from method PlansClient.NewListWebAppsByHybridConnectionPager.
type PlansClientListWebAppsByHybridConnectionResponse struct {
	ResourceCollection
}

// PlansClientListWebAppsResponse contains the response from method PlansClient.NewListWebAppsPager.
type PlansClientListWebAppsResponse struct {
	WebAppCollection
}

// PlansClientRebootWorkerResponse contains the response from method PlansClient.RebootWorker.
type PlansClientRebootWorkerResponse struct {
	// placeholder for future response values
}

// PlansClientRestartWebAppsResponse contains the response from method PlansClient.RestartWebApps.
type PlansClientRestartWebAppsResponse struct {
	// placeholder for future response values
}

// PlansClientUpdateResponse contains the response from method PlansClient.Update.
type PlansClientUpdateResponse struct {
	Plan
}

// PlansClientUpdateVnetGatewayResponse contains the response from method PlansClient.UpdateVnetGateway.
type PlansClientUpdateVnetGatewayResponse struct {
	VnetGateway
}

// PlansClientUpdateVnetRouteResponse contains the response from method PlansClient.UpdateVnetRoute.
type PlansClientUpdateVnetRouteResponse struct {
	VnetRoute
}

// ProviderClientGetAvailableStacksOnPremResponse contains the response from method ProviderClient.NewGetAvailableStacksOnPremPager.
type ProviderClientGetAvailableStacksOnPremResponse struct {
	ApplicationStackCollection
}

// ProviderClientGetAvailableStacksResponse contains the response from method ProviderClient.NewGetAvailableStacksPager.
type ProviderClientGetAvailableStacksResponse struct {
	ApplicationStackCollection
}

// ProviderClientListOperationsResponse contains the response from method ProviderClient.NewListOperationsPager.
type ProviderClientListOperationsResponse struct {
	CsmOperationCollection
}

// RecommendationsClientDisableAllForHostingEnvironmentResponse contains the response from method RecommendationsClient.DisableAllForHostingEnvironment.
type RecommendationsClientDisableAllForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableAllForWebAppResponse contains the response from method RecommendationsClient.DisableAllForWebApp.
type RecommendationsClientDisableAllForWebAppResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForHostingEnvironmentResponse contains the response from method RecommendationsClient.DisableRecommendationForHostingEnvironment.
type RecommendationsClientDisableRecommendationForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForSiteResponse contains the response from method RecommendationsClient.DisableRecommendationForSite.
type RecommendationsClientDisableRecommendationForSiteResponse struct {
	// placeholder for future response values
}

// RecommendationsClientDisableRecommendationForSubscriptionResponse contains the response from method RecommendationsClient.DisableRecommendationForSubscription.
type RecommendationsClientDisableRecommendationForSubscriptionResponse struct {
	// placeholder for future response values
}

// RecommendationsClientGetRuleDetailsByHostingEnvironmentResponse contains the response from method RecommendationsClient.GetRuleDetailsByHostingEnvironment.
type RecommendationsClientGetRuleDetailsByHostingEnvironmentResponse struct {
	RecommendationRule
}

// RecommendationsClientGetRuleDetailsByWebAppResponse contains the response from method RecommendationsClient.GetRuleDetailsByWebApp.
type RecommendationsClientGetRuleDetailsByWebAppResponse struct {
	RecommendationRule
}

// RecommendationsClientListHistoryForHostingEnvironmentResponse contains the response from method RecommendationsClient.NewListHistoryForHostingEnvironmentPager.
type RecommendationsClientListHistoryForHostingEnvironmentResponse struct {
	RecommendationCollection
}

// RecommendationsClientListHistoryForWebAppResponse contains the response from method RecommendationsClient.NewListHistoryForWebAppPager.
type RecommendationsClientListHistoryForWebAppResponse struct {
	RecommendationCollection
}

// RecommendationsClientListRecommendedRulesForHostingEnvironmentResponse contains the response from method RecommendationsClient.NewListRecommendedRulesForHostingEnvironmentPager.
type RecommendationsClientListRecommendedRulesForHostingEnvironmentResponse struct {
	RecommendationCollection
}

// RecommendationsClientListRecommendedRulesForWebAppResponse contains the response from method RecommendationsClient.NewListRecommendedRulesForWebAppPager.
type RecommendationsClientListRecommendedRulesForWebAppResponse struct {
	RecommendationCollection
}

// RecommendationsClientListResponse contains the response from method RecommendationsClient.NewListPager.
type RecommendationsClientListResponse struct {
	RecommendationCollection
}

// RecommendationsClientResetAllFiltersForHostingEnvironmentResponse contains the response from method RecommendationsClient.ResetAllFiltersForHostingEnvironment.
type RecommendationsClientResetAllFiltersForHostingEnvironmentResponse struct {
	// placeholder for future response values
}

// RecommendationsClientResetAllFiltersForWebAppResponse contains the response from method RecommendationsClient.ResetAllFiltersForWebApp.
type RecommendationsClientResetAllFiltersForWebAppResponse struct {
	// placeholder for future response values
}

// RecommendationsClientResetAllFiltersResponse contains the response from method RecommendationsClient.ResetAllFilters.
type RecommendationsClientResetAllFiltersResponse struct {
	// placeholder for future response values
}

// WebAppsClientAddPremierAddOnResponse contains the response from method WebAppsClient.AddPremierAddOn.
type WebAppsClientAddPremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientAddPremierAddOnSlotResponse contains the response from method WebAppsClient.AddPremierAddOnSlot.
type WebAppsClientAddPremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientAnalyzeCustomHostnameResponse contains the response from method WebAppsClient.AnalyzeCustomHostname.
type WebAppsClientAnalyzeCustomHostnameResponse struct {
	CustomHostnameAnalysisResult
}

// WebAppsClientAnalyzeCustomHostnameSlotResponse contains the response from method WebAppsClient.AnalyzeCustomHostnameSlot.
type WebAppsClientAnalyzeCustomHostnameSlotResponse struct {
	CustomHostnameAnalysisResult
}

// WebAppsClientApplySlotConfigToProductionResponse contains the response from method WebAppsClient.ApplySlotConfigToProduction.
type WebAppsClientApplySlotConfigToProductionResponse struct {
	// placeholder for future response values
}

// WebAppsClientApplySlotConfigurationSlotResponse contains the response from method WebAppsClient.ApplySlotConfigurationSlot.
type WebAppsClientApplySlotConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientBackupResponse contains the response from method WebAppsClient.Backup.
type WebAppsClientBackupResponse struct {
	BackupItem
}

// WebAppsClientBackupSlotResponse contains the response from method WebAppsClient.BackupSlot.
type WebAppsClientBackupSlotResponse struct {
	BackupItem
}

// WebAppsClientCreateDeploymentResponse contains the response from method WebAppsClient.CreateDeployment.
type WebAppsClientCreateDeploymentResponse struct {
	Deployment
}

// WebAppsClientCreateDeploymentSlotResponse contains the response from method WebAppsClient.CreateDeploymentSlot.
type WebAppsClientCreateDeploymentSlotResponse struct {
	Deployment
}

// WebAppsClientCreateFunctionResponse contains the response from method WebAppsClient.BeginCreateFunction.
type WebAppsClientCreateFunctionResponse struct {
	FunctionEnvelope
}

// WebAppsClientCreateInstanceFunctionSlotResponse contains the response from method WebAppsClient.BeginCreateInstanceFunctionSlot.
type WebAppsClientCreateInstanceFunctionSlotResponse struct {
	FunctionEnvelope
}

// WebAppsClientCreateInstanceMSDeployOperationResponse contains the response from method WebAppsClient.BeginCreateInstanceMSDeployOperation.
type WebAppsClientCreateInstanceMSDeployOperationResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateInstanceMSDeployOperationSlotResponse contains the response from method WebAppsClient.BeginCreateInstanceMSDeployOperationSlot.
type WebAppsClientCreateInstanceMSDeployOperationSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateMSDeployOperationResponse contains the response from method WebAppsClient.BeginCreateMSDeployOperation.
type WebAppsClientCreateMSDeployOperationResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateMSDeployOperationSlotResponse contains the response from method WebAppsClient.BeginCreateMSDeployOperationSlot.
type WebAppsClientCreateMSDeployOperationSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientCreateOrUpdateConfigurationResponse contains the response from method WebAppsClient.CreateOrUpdateConfiguration.
type WebAppsClientCreateOrUpdateConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientCreateOrUpdateConfigurationSlotResponse contains the response from method WebAppsClient.CreateOrUpdateConfigurationSlot.
type WebAppsClientCreateOrUpdateConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientCreateOrUpdateDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.CreateOrUpdateDomainOwnershipIdentifier.
type WebAppsClientCreateOrUpdateDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientCreateOrUpdateDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.CreateOrUpdateDomainOwnershipIdentifierSlot.
type WebAppsClientCreateOrUpdateDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientCreateOrUpdateFunctionSecretResponse contains the response from method WebAppsClient.CreateOrUpdateFunctionSecret.
type WebAppsClientCreateOrUpdateFunctionSecretResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateFunctionSecretSlotResponse contains the response from method WebAppsClient.CreateOrUpdateFunctionSecretSlot.
type WebAppsClientCreateOrUpdateFunctionSecretSlotResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHostNameBindingResponse contains the response from method WebAppsClient.CreateOrUpdateHostNameBinding.
type WebAppsClientCreateOrUpdateHostNameBindingResponse struct {
	HostNameBinding
}

// WebAppsClientCreateOrUpdateHostNameBindingSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHostNameBindingSlot.
type WebAppsClientCreateOrUpdateHostNameBindingSlotResponse struct {
	HostNameBinding
}

// WebAppsClientCreateOrUpdateHostSecretResponse contains the response from method WebAppsClient.CreateOrUpdateHostSecret.
type WebAppsClientCreateOrUpdateHostSecretResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHostSecretSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHostSecretSlot.
type WebAppsClientCreateOrUpdateHostSecretSlotResponse struct {
	KeyInfo
}

// WebAppsClientCreateOrUpdateHybridConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateHybridConnection.
type WebAppsClientCreateOrUpdateHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientCreateOrUpdateHybridConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateHybridConnectionSlot.
type WebAppsClientCreateOrUpdateHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientCreateOrUpdatePublicCertificateResponse contains the response from method WebAppsClient.CreateOrUpdatePublicCertificate.
type WebAppsClientCreateOrUpdatePublicCertificateResponse struct {
	PublicCertificate
}

// WebAppsClientCreateOrUpdatePublicCertificateSlotResponse contains the response from method WebAppsClient.CreateOrUpdatePublicCertificateSlot.
type WebAppsClientCreateOrUpdatePublicCertificateSlotResponse struct {
	PublicCertificate
}

// WebAppsClientCreateOrUpdateRelayServiceConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateRelayServiceConnection.
type WebAppsClientCreateOrUpdateRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientCreateOrUpdateRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateRelayServiceConnectionSlot.
type WebAppsClientCreateOrUpdateRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientCreateOrUpdateResponse contains the response from method WebAppsClient.BeginCreateOrUpdate.
type WebAppsClientCreateOrUpdateResponse struct {
	Site
}

// WebAppsClientCreateOrUpdateSlotResponse contains the response from method WebAppsClient.BeginCreateOrUpdateSlot.
type WebAppsClientCreateOrUpdateSlotResponse struct {
	Site
}

// WebAppsClientCreateOrUpdateSourceControlResponse contains the response from method WebAppsClient.BeginCreateOrUpdateSourceControl.
type WebAppsClientCreateOrUpdateSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientCreateOrUpdateSourceControlSlotResponse contains the response from method WebAppsClient.BeginCreateOrUpdateSourceControlSlot.
type WebAppsClientCreateOrUpdateSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateSwiftVirtualNetworkConnection.
type WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateSwiftVirtualNetworkConnectionSlot.
type WebAppsClientCreateOrUpdateSwiftVirtualNetworkConnectionSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientCreateOrUpdateVnetConnectionGatewayResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionGateway.
type WebAppsClientCreateOrUpdateVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientCreateOrUpdateVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionGatewaySlot.
type WebAppsClientCreateOrUpdateVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientCreateOrUpdateVnetConnectionResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnection.
type WebAppsClientCreateOrUpdateVnetConnectionResponse struct {
	VnetInfo
}

// WebAppsClientCreateOrUpdateVnetConnectionSlotResponse contains the response from method WebAppsClient.CreateOrUpdateVnetConnectionSlot.
type WebAppsClientCreateOrUpdateVnetConnectionSlotResponse struct {
	VnetInfo
}

// WebAppsClientDeleteBackupConfigurationResponse contains the response from method WebAppsClient.DeleteBackupConfiguration.
type WebAppsClientDeleteBackupConfigurationResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupConfigurationSlotResponse contains the response from method WebAppsClient.DeleteBackupConfigurationSlot.
type WebAppsClientDeleteBackupConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupResponse contains the response from method WebAppsClient.DeleteBackup.
type WebAppsClientDeleteBackupResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteBackupSlotResponse contains the response from method WebAppsClient.DeleteBackupSlot.
type WebAppsClientDeleteBackupSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteContinuousWebJobResponse contains the response from method WebAppsClient.DeleteContinuousWebJob.
type WebAppsClientDeleteContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteContinuousWebJobSlotResponse contains the response from method WebAppsClient.DeleteContinuousWebJobSlot.
type WebAppsClientDeleteContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDeploymentResponse contains the response from method WebAppsClient.DeleteDeployment.
type WebAppsClientDeleteDeploymentResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDeploymentSlotResponse contains the response from method WebAppsClient.DeleteDeploymentSlot.
type WebAppsClientDeleteDeploymentSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.DeleteDomainOwnershipIdentifier.
type WebAppsClientDeleteDomainOwnershipIdentifierResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.DeleteDomainOwnershipIdentifierSlot.
type WebAppsClientDeleteDomainOwnershipIdentifierSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionResponse contains the response from method WebAppsClient.DeleteFunction.
type WebAppsClientDeleteFunctionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionSecretResponse contains the response from method WebAppsClient.DeleteFunctionSecret.
type WebAppsClientDeleteFunctionSecretResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteFunctionSecretSlotResponse contains the response from method WebAppsClient.DeleteFunctionSecretSlot.
type WebAppsClientDeleteFunctionSecretSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostNameBindingResponse contains the response from method WebAppsClient.DeleteHostNameBinding.
type WebAppsClientDeleteHostNameBindingResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostNameBindingSlotResponse contains the response from method WebAppsClient.DeleteHostNameBindingSlot.
type WebAppsClientDeleteHostNameBindingSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostSecretResponse contains the response from method WebAppsClient.DeleteHostSecret.
type WebAppsClientDeleteHostSecretResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHostSecretSlotResponse contains the response from method WebAppsClient.DeleteHostSecretSlot.
type WebAppsClientDeleteHostSecretSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHybridConnectionResponse contains the response from method WebAppsClient.DeleteHybridConnection.
type WebAppsClientDeleteHybridConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteHybridConnectionSlotResponse contains the response from method WebAppsClient.DeleteHybridConnectionSlot.
type WebAppsClientDeleteHybridConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceFunctionSlotResponse contains the response from method WebAppsClient.DeleteInstanceFunctionSlot.
type WebAppsClientDeleteInstanceFunctionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceProcessResponse contains the response from method WebAppsClient.DeleteInstanceProcess.
type WebAppsClientDeleteInstanceProcessResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteInstanceProcessSlotResponse contains the response from method WebAppsClient.DeleteInstanceProcessSlot.
type WebAppsClientDeleteInstanceProcessSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePremierAddOnResponse contains the response from method WebAppsClient.DeletePremierAddOn.
type WebAppsClientDeletePremierAddOnResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePremierAddOnSlotResponse contains the response from method WebAppsClient.DeletePremierAddOnSlot.
type WebAppsClientDeletePremierAddOnSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteProcessResponse contains the response from method WebAppsClient.DeleteProcess.
type WebAppsClientDeleteProcessResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteProcessSlotResponse contains the response from method WebAppsClient.DeleteProcessSlot.
type WebAppsClientDeleteProcessSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePublicCertificateResponse contains the response from method WebAppsClient.DeletePublicCertificate.
type WebAppsClientDeletePublicCertificateResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeletePublicCertificateSlotResponse contains the response from method WebAppsClient.DeletePublicCertificateSlot.
type WebAppsClientDeletePublicCertificateSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteRelayServiceConnectionResponse contains the response from method WebAppsClient.DeleteRelayServiceConnection.
type WebAppsClientDeleteRelayServiceConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.DeleteRelayServiceConnectionSlot.
type WebAppsClientDeleteRelayServiceConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteResponse contains the response from method WebAppsClient.Delete.
type WebAppsClientDeleteResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSiteExtensionResponse contains the response from method WebAppsClient.DeleteSiteExtension.
type WebAppsClientDeleteSiteExtensionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSiteExtensionSlotResponse contains the response from method WebAppsClient.DeleteSiteExtensionSlot.
type WebAppsClientDeleteSiteExtensionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSlotResponse contains the response from method WebAppsClient.DeleteSlot.
type WebAppsClientDeleteSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSourceControlResponse contains the response from method WebAppsClient.DeleteSourceControl.
type WebAppsClientDeleteSourceControlResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSourceControlSlotResponse contains the response from method WebAppsClient.DeleteSourceControlSlot.
type WebAppsClientDeleteSourceControlSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSwiftVirtualNetworkResponse contains the response from method WebAppsClient.DeleteSwiftVirtualNetwork.
type WebAppsClientDeleteSwiftVirtualNetworkResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteSwiftVirtualNetworkSlotResponse contains the response from method WebAppsClient.DeleteSwiftVirtualNetworkSlot.
type WebAppsClientDeleteSwiftVirtualNetworkSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteTriggeredWebJobResponse contains the response from method WebAppsClient.DeleteTriggeredWebJob.
type WebAppsClientDeleteTriggeredWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteTriggeredWebJobSlotResponse contains the response from method WebAppsClient.DeleteTriggeredWebJobSlot.
type WebAppsClientDeleteTriggeredWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteVnetConnectionResponse contains the response from method WebAppsClient.DeleteVnetConnection.
type WebAppsClientDeleteVnetConnectionResponse struct {
	// placeholder for future response values
}

// WebAppsClientDeleteVnetConnectionSlotResponse contains the response from method WebAppsClient.DeleteVnetConnectionSlot.
type WebAppsClientDeleteVnetConnectionSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientDiscoverBackupResponse contains the response from method WebAppsClient.DiscoverBackup.
type WebAppsClientDiscoverBackupResponse struct {
	RestoreRequest
}

// WebAppsClientDiscoverBackupSlotResponse contains the response from method WebAppsClient.DiscoverBackupSlot.
type WebAppsClientDiscoverBackupSlotResponse struct {
	RestoreRequest
}

// WebAppsClientGenerateNewSitePublishingPasswordResponse contains the response from method WebAppsClient.GenerateNewSitePublishingPassword.
type WebAppsClientGenerateNewSitePublishingPasswordResponse struct {
	// placeholder for future response values
}

// WebAppsClientGenerateNewSitePublishingPasswordSlotResponse contains the response from method WebAppsClient.GenerateNewSitePublishingPasswordSlot.
type WebAppsClientGenerateNewSitePublishingPasswordSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientGetAuthSettingsResponse contains the response from method WebAppsClient.GetAuthSettings.
type WebAppsClientGetAuthSettingsResponse struct {
	SiteAuthSettings
}

// WebAppsClientGetAuthSettingsSlotResponse contains the response from method WebAppsClient.GetAuthSettingsSlot.
type WebAppsClientGetAuthSettingsSlotResponse struct {
	SiteAuthSettings
}

// WebAppsClientGetBackupConfigurationResponse contains the response from method WebAppsClient.GetBackupConfiguration.
type WebAppsClientGetBackupConfigurationResponse struct {
	BackupRequest
}

// WebAppsClientGetBackupConfigurationSlotResponse contains the response from method WebAppsClient.GetBackupConfigurationSlot.
type WebAppsClientGetBackupConfigurationSlotResponse struct {
	BackupRequest
}

// WebAppsClientGetBackupStatusResponse contains the response from method WebAppsClient.GetBackupStatus.
type WebAppsClientGetBackupStatusResponse struct {
	BackupItem
}

// WebAppsClientGetBackupStatusSlotResponse contains the response from method WebAppsClient.GetBackupStatusSlot.
type WebAppsClientGetBackupStatusSlotResponse struct {
	BackupItem
}

// WebAppsClientGetConfigurationResponse contains the response from method WebAppsClient.GetConfiguration.
type WebAppsClientGetConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSlotResponse contains the response from method WebAppsClient.GetConfigurationSlot.
type WebAppsClientGetConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSnapshotResponse contains the response from method WebAppsClient.GetConfigurationSnapshot.
type WebAppsClientGetConfigurationSnapshotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetConfigurationSnapshotSlotResponse contains the response from method WebAppsClient.GetConfigurationSnapshotSlot.
type WebAppsClientGetConfigurationSnapshotSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientGetContainerLogsZipResponse contains the response from method WebAppsClient.GetContainerLogsZip.
type WebAppsClientGetContainerLogsZipResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetContainerLogsZipSlotResponse contains the response from method WebAppsClient.GetContainerLogsZipSlot.
type WebAppsClientGetContainerLogsZipSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetContinuousWebJobResponse contains the response from method WebAppsClient.GetContinuousWebJob.
type WebAppsClientGetContinuousWebJobResponse struct {
	ContinuousWebJob
}

// WebAppsClientGetContinuousWebJobSlotResponse contains the response from method WebAppsClient.GetContinuousWebJobSlot.
type WebAppsClientGetContinuousWebJobSlotResponse struct {
	ContinuousWebJob
}

// WebAppsClientGetDeploymentResponse contains the response from method WebAppsClient.GetDeployment.
type WebAppsClientGetDeploymentResponse struct {
	Deployment
}

// WebAppsClientGetDeploymentSlotResponse contains the response from method WebAppsClient.GetDeploymentSlot.
type WebAppsClientGetDeploymentSlotResponse struct {
	Deployment
}

// WebAppsClientGetDiagnosticLogsConfigurationResponse contains the response from method WebAppsClient.GetDiagnosticLogsConfiguration.
type WebAppsClientGetDiagnosticLogsConfigurationResponse struct {
	SiteLogsConfig
}

// WebAppsClientGetDiagnosticLogsConfigurationSlotResponse contains the response from method WebAppsClient.GetDiagnosticLogsConfigurationSlot.
type WebAppsClientGetDiagnosticLogsConfigurationSlotResponse struct {
	SiteLogsConfig
}

// WebAppsClientGetDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.GetDomainOwnershipIdentifier.
type WebAppsClientGetDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientGetDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.GetDomainOwnershipIdentifierSlot.
type WebAppsClientGetDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientGetFunctionResponse contains the response from method WebAppsClient.GetFunction.
type WebAppsClientGetFunctionResponse struct {
	FunctionEnvelope
}

// WebAppsClientGetFunctionsAdminTokenResponse contains the response from method WebAppsClient.GetFunctionsAdminToken.
type WebAppsClientGetFunctionsAdminTokenResponse struct {
	Value *string
}

// WebAppsClientGetFunctionsAdminTokenSlotResponse contains the response from method WebAppsClient.GetFunctionsAdminTokenSlot.
type WebAppsClientGetFunctionsAdminTokenSlotResponse struct {
	Value *string
}

// WebAppsClientGetHostNameBindingResponse contains the response from method WebAppsClient.GetHostNameBinding.
type WebAppsClientGetHostNameBindingResponse struct {
	HostNameBinding
}

// WebAppsClientGetHostNameBindingSlotResponse contains the response from method WebAppsClient.GetHostNameBindingSlot.
type WebAppsClientGetHostNameBindingSlotResponse struct {
	HostNameBinding
}

// WebAppsClientGetHybridConnectionResponse contains the response from method WebAppsClient.GetHybridConnection.
type WebAppsClientGetHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientGetHybridConnectionSlotResponse contains the response from method WebAppsClient.GetHybridConnectionSlot.
type WebAppsClientGetHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientGetInstanceFunctionSlotResponse contains the response from method WebAppsClient.GetInstanceFunctionSlot.
type WebAppsClientGetInstanceFunctionSlotResponse struct {
	FunctionEnvelope
}

// WebAppsClientGetInstanceMSDeployLogResponse contains the response from method WebAppsClient.GetInstanceMSDeployLog.
type WebAppsClientGetInstanceMSDeployLogResponse struct {
	MSDeployLog
}

// WebAppsClientGetInstanceMSDeployLogSlotResponse contains the response from method WebAppsClient.GetInstanceMSDeployLogSlot.
type WebAppsClientGetInstanceMSDeployLogSlotResponse struct {
	MSDeployLog
}

// WebAppsClientGetInstanceMsDeployStatusResponse contains the response from method WebAppsClient.GetInstanceMsDeployStatus.
type WebAppsClientGetInstanceMsDeployStatusResponse struct {
	MSDeployStatus
}

// WebAppsClientGetInstanceMsDeployStatusSlotResponse contains the response from method WebAppsClient.GetInstanceMsDeployStatusSlot.
type WebAppsClientGetInstanceMsDeployStatusSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientGetInstanceProcessDumpResponse contains the response from method WebAppsClient.GetInstanceProcessDump.
type WebAppsClientGetInstanceProcessDumpResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetInstanceProcessDumpSlotResponse contains the response from method WebAppsClient.GetInstanceProcessDumpSlot.
type WebAppsClientGetInstanceProcessDumpSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetInstanceProcessModuleResponse contains the response from method WebAppsClient.GetInstanceProcessModule.
type WebAppsClientGetInstanceProcessModuleResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetInstanceProcessModuleSlotResponse contains the response from method WebAppsClient.GetInstanceProcessModuleSlot.
type WebAppsClientGetInstanceProcessModuleSlotResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetInstanceProcessResponse contains the response from method WebAppsClient.GetInstanceProcess.
type WebAppsClientGetInstanceProcessResponse struct {
	ProcessInfo
}

// WebAppsClientGetInstanceProcessSlotResponse contains the response from method WebAppsClient.GetInstanceProcessSlot.
type WebAppsClientGetInstanceProcessSlotResponse struct {
	ProcessInfo
}

// WebAppsClientGetInstanceProcessThreadResponse contains the response from method WebAppsClient.GetInstanceProcessThread.
type WebAppsClientGetInstanceProcessThreadResponse struct {
	ProcessThreadInfo
}

// WebAppsClientGetInstanceProcessThreadSlotResponse contains the response from method WebAppsClient.GetInstanceProcessThreadSlot.
type WebAppsClientGetInstanceProcessThreadSlotResponse struct {
	ProcessThreadInfo
}

// WebAppsClientGetMSDeployLogResponse contains the response from method WebAppsClient.GetMSDeployLog.
type WebAppsClientGetMSDeployLogResponse struct {
	MSDeployLog
}

// WebAppsClientGetMSDeployLogSlotResponse contains the response from method WebAppsClient.GetMSDeployLogSlot.
type WebAppsClientGetMSDeployLogSlotResponse struct {
	MSDeployLog
}

// WebAppsClientGetMSDeployStatusResponse contains the response from method WebAppsClient.GetMSDeployStatus.
type WebAppsClientGetMSDeployStatusResponse struct {
	MSDeployStatus
}

// WebAppsClientGetMSDeployStatusSlotResponse contains the response from method WebAppsClient.GetMSDeployStatusSlot.
type WebAppsClientGetMSDeployStatusSlotResponse struct {
	MSDeployStatus
}

// WebAppsClientGetMigrateMySQLStatusResponse contains the response from method WebAppsClient.GetMigrateMySQLStatus.
type WebAppsClientGetMigrateMySQLStatusResponse struct {
	MigrateMySQLStatus
}

// WebAppsClientGetMigrateMySQLStatusSlotResponse contains the response from method WebAppsClient.GetMigrateMySQLStatusSlot.
type WebAppsClientGetMigrateMySQLStatusSlotResponse struct {
	MigrateMySQLStatus
}

// WebAppsClientGetNetworkTraceOperationResponse contains the response from method WebAppsClient.GetNetworkTraceOperation.
type WebAppsClientGetNetworkTraceOperationResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationSlotResponse contains the response from method WebAppsClient.GetNetworkTraceOperationSlot.
type WebAppsClientGetNetworkTraceOperationSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationSlotV2Response contains the response from method WebAppsClient.GetNetworkTraceOperationSlotV2.
type WebAppsClientGetNetworkTraceOperationSlotV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTraceOperationV2Response contains the response from method WebAppsClient.GetNetworkTraceOperationV2.
type WebAppsClientGetNetworkTraceOperationV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesResponse contains the response from method WebAppsClient.GetNetworkTraces.
type WebAppsClientGetNetworkTracesResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesSlotResponse contains the response from method WebAppsClient.GetNetworkTracesSlot.
type WebAppsClientGetNetworkTracesSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesSlotV2Response contains the response from method WebAppsClient.GetNetworkTracesSlotV2.
type WebAppsClientGetNetworkTracesSlotV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetNetworkTracesV2Response contains the response from method WebAppsClient.GetNetworkTracesV2.
type WebAppsClientGetNetworkTracesV2Response struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// WebAppsClientGetPremierAddOnResponse contains the response from method WebAppsClient.GetPremierAddOn.
type WebAppsClientGetPremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientGetPremierAddOnSlotResponse contains the response from method WebAppsClient.GetPremierAddOnSlot.
type WebAppsClientGetPremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientGetPrivateAccessResponse contains the response from method WebAppsClient.GetPrivateAccess.
type WebAppsClientGetPrivateAccessResponse struct {
	PrivateAccess
}

// WebAppsClientGetPrivateAccessSlotResponse contains the response from method WebAppsClient.GetPrivateAccessSlot.
type WebAppsClientGetPrivateAccessSlotResponse struct {
	PrivateAccess
}

// WebAppsClientGetProcessDumpResponse contains the response from method WebAppsClient.GetProcessDump.
type WebAppsClientGetProcessDumpResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetProcessDumpSlotResponse contains the response from method WebAppsClient.GetProcessDumpSlot.
type WebAppsClientGetProcessDumpSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetProcessModuleResponse contains the response from method WebAppsClient.GetProcessModule.
type WebAppsClientGetProcessModuleResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetProcessModuleSlotResponse contains the response from method WebAppsClient.GetProcessModuleSlot.
type WebAppsClientGetProcessModuleSlotResponse struct {
	ProcessModuleInfo
}

// WebAppsClientGetProcessResponse contains the response from method WebAppsClient.GetProcess.
type WebAppsClientGetProcessResponse struct {
	ProcessInfo
}

// WebAppsClientGetProcessSlotResponse contains the response from method WebAppsClient.GetProcessSlot.
type WebAppsClientGetProcessSlotResponse struct {
	ProcessInfo
}

// WebAppsClientGetProcessThreadResponse contains the response from method WebAppsClient.GetProcessThread.
type WebAppsClientGetProcessThreadResponse struct {
	ProcessThreadInfo
}

// WebAppsClientGetProcessThreadSlotResponse contains the response from method WebAppsClient.GetProcessThreadSlot.
type WebAppsClientGetProcessThreadSlotResponse struct {
	ProcessThreadInfo
}

// WebAppsClientGetPublicCertificateResponse contains the response from method WebAppsClient.GetPublicCertificate.
type WebAppsClientGetPublicCertificateResponse struct {
	PublicCertificate
}

// WebAppsClientGetPublicCertificateSlotResponse contains the response from method WebAppsClient.GetPublicCertificateSlot.
type WebAppsClientGetPublicCertificateSlotResponse struct {
	PublicCertificate
}

// WebAppsClientGetRelayServiceConnectionResponse contains the response from method WebAppsClient.GetRelayServiceConnection.
type WebAppsClientGetRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientGetRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.GetRelayServiceConnectionSlot.
type WebAppsClientGetRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientGetResponse contains the response from method WebAppsClient.Get.
type WebAppsClientGetResponse struct {
	Site
}

// WebAppsClientGetSiteExtensionResponse contains the response from method WebAppsClient.GetSiteExtension.
type WebAppsClientGetSiteExtensionResponse struct {
	SiteExtensionInfo
}

// WebAppsClientGetSiteExtensionSlotResponse contains the response from method WebAppsClient.GetSiteExtensionSlot.
type WebAppsClientGetSiteExtensionSlotResponse struct {
	SiteExtensionInfo
}

// WebAppsClientGetSitePhpErrorLogFlagResponse contains the response from method WebAppsClient.GetSitePhpErrorLogFlag.
type WebAppsClientGetSitePhpErrorLogFlagResponse struct {
	SitePhpErrorLogFlag
}

// WebAppsClientGetSitePhpErrorLogFlagSlotResponse contains the response from method WebAppsClient.GetSitePhpErrorLogFlagSlot.
type WebAppsClientGetSitePhpErrorLogFlagSlotResponse struct {
	SitePhpErrorLogFlag
}

// WebAppsClientGetSlotResponse contains the response from method WebAppsClient.GetSlot.
type WebAppsClientGetSlotResponse struct {
	Site
}

// WebAppsClientGetSourceControlResponse contains the response from method WebAppsClient.GetSourceControl.
type WebAppsClientGetSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientGetSourceControlSlotResponse contains the response from method WebAppsClient.GetSourceControlSlot.
type WebAppsClientGetSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientGetSwiftVirtualNetworkConnectionResponse contains the response from method WebAppsClient.GetSwiftVirtualNetworkConnection.
type WebAppsClientGetSwiftVirtualNetworkConnectionResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientGetSwiftVirtualNetworkConnectionSlotResponse contains the response from method WebAppsClient.GetSwiftVirtualNetworkConnectionSlot.
type WebAppsClientGetSwiftVirtualNetworkConnectionSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientGetTriggeredWebJobHistoryResponse contains the response from method WebAppsClient.GetTriggeredWebJobHistory.
type WebAppsClientGetTriggeredWebJobHistoryResponse struct {
	TriggeredJobHistory
}

// WebAppsClientGetTriggeredWebJobHistorySlotResponse contains the response from method WebAppsClient.GetTriggeredWebJobHistorySlot.
type WebAppsClientGetTriggeredWebJobHistorySlotResponse struct {
	TriggeredJobHistory
}

// WebAppsClientGetTriggeredWebJobResponse contains the response from method WebAppsClient.GetTriggeredWebJob.
type WebAppsClientGetTriggeredWebJobResponse struct {
	TriggeredWebJob
}

// WebAppsClientGetTriggeredWebJobSlotResponse contains the response from method WebAppsClient.GetTriggeredWebJobSlot.
type WebAppsClientGetTriggeredWebJobSlotResponse struct {
	TriggeredWebJob
}

// WebAppsClientGetVnetConnectionGatewayResponse contains the response from method WebAppsClient.GetVnetConnectionGateway.
type WebAppsClientGetVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientGetVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.GetVnetConnectionGatewaySlot.
type WebAppsClientGetVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientGetVnetConnectionResponse contains the response from method WebAppsClient.GetVnetConnection.
type WebAppsClientGetVnetConnectionResponse struct {
	VnetInfo
}

// WebAppsClientGetVnetConnectionSlotResponse contains the response from method WebAppsClient.GetVnetConnectionSlot.
type WebAppsClientGetVnetConnectionSlotResponse struct {
	VnetInfo
}

// WebAppsClientGetWebJobResponse contains the response from method WebAppsClient.GetWebJob.
type WebAppsClientGetWebJobResponse struct {
	WebJob
}

// WebAppsClientGetWebJobSlotResponse contains the response from method WebAppsClient.GetWebJobSlot.
type WebAppsClientGetWebJobSlotResponse struct {
	WebJob
}

// WebAppsClientGetWebSiteContainerLogsResponse contains the response from method WebAppsClient.GetWebSiteContainerLogs.
type WebAppsClientGetWebSiteContainerLogsResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientGetWebSiteContainerLogsSlotResponse contains the response from method WebAppsClient.GetWebSiteContainerLogsSlot.
type WebAppsClientGetWebSiteContainerLogsSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientInstallSiteExtensionResponse contains the response from method WebAppsClient.BeginInstallSiteExtension.
type WebAppsClientInstallSiteExtensionResponse struct {
	SiteExtensionInfo
}

// WebAppsClientInstallSiteExtensionSlotResponse contains the response from method WebAppsClient.BeginInstallSiteExtensionSlot.
type WebAppsClientInstallSiteExtensionSlotResponse struct {
	SiteExtensionInfo
}

// WebAppsClientIsCloneableResponse contains the response from method WebAppsClient.IsCloneable.
type WebAppsClientIsCloneableResponse struct {
	SiteCloneability
}

// WebAppsClientIsCloneableSlotResponse contains the response from method WebAppsClient.IsCloneableSlot.
type WebAppsClientIsCloneableSlotResponse struct {
	SiteCloneability
}

// WebAppsClientListApplicationSettingsResponse contains the response from method WebAppsClient.ListApplicationSettings.
type WebAppsClientListApplicationSettingsResponse struct {
	StringDictionary
}

// WebAppsClientListApplicationSettingsSlotResponse contains the response from method WebAppsClient.ListApplicationSettingsSlot.
type WebAppsClientListApplicationSettingsSlotResponse struct {
	StringDictionary
}

// WebAppsClientListAzureStorageAccountsResponse contains the response from method WebAppsClient.ListAzureStorageAccounts.
type WebAppsClientListAzureStorageAccountsResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientListAzureStorageAccountsSlotResponse contains the response from method WebAppsClient.ListAzureStorageAccountsSlot.
type WebAppsClientListAzureStorageAccountsSlotResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientListBackupStatusSecretsResponse contains the response from method WebAppsClient.ListBackupStatusSecrets.
type WebAppsClientListBackupStatusSecretsResponse struct {
	BackupItem
}

// WebAppsClientListBackupStatusSecretsSlotResponse contains the response from method WebAppsClient.ListBackupStatusSecretsSlot.
type WebAppsClientListBackupStatusSecretsSlotResponse struct {
	BackupItem
}

// WebAppsClientListBackupsResponse contains the response from method WebAppsClient.NewListBackupsPager.
type WebAppsClientListBackupsResponse struct {
	BackupItemCollection
}

// WebAppsClientListBackupsSlotResponse contains the response from method WebAppsClient.NewListBackupsSlotPager.
type WebAppsClientListBackupsSlotResponse struct {
	BackupItemCollection
}

// WebAppsClientListByResourceGroupResponse contains the response from method WebAppsClient.NewListByResourceGroupPager.
type WebAppsClientListByResourceGroupResponse struct {
	WebAppCollection
}

// WebAppsClientListConfigurationSnapshotInfoResponse contains the response from method WebAppsClient.NewListConfigurationSnapshotInfoPager.
type WebAppsClientListConfigurationSnapshotInfoResponse struct {
	SiteConfigurationSnapshotInfoCollection
}

// WebAppsClientListConfigurationSnapshotInfoSlotResponse contains the response from method WebAppsClient.NewListConfigurationSnapshotInfoSlotPager.
type WebAppsClientListConfigurationSnapshotInfoSlotResponse struct {
	SiteConfigurationSnapshotInfoCollection
}

// WebAppsClientListConfigurationsResponse contains the response from method WebAppsClient.NewListConfigurationsPager.
type WebAppsClientListConfigurationsResponse struct {
	SiteConfigResourceCollection
}

// WebAppsClientListConfigurationsSlotResponse contains the response from method WebAppsClient.NewListConfigurationsSlotPager.
type WebAppsClientListConfigurationsSlotResponse struct {
	SiteConfigResourceCollection
}

// WebAppsClientListConnectionStringsResponse contains the response from method WebAppsClient.ListConnectionStrings.
type WebAppsClientListConnectionStringsResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientListConnectionStringsSlotResponse contains the response from method WebAppsClient.ListConnectionStringsSlot.
type WebAppsClientListConnectionStringsSlotResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientListContinuousWebJobsResponse contains the response from method WebAppsClient.NewListContinuousWebJobsPager.
type WebAppsClientListContinuousWebJobsResponse struct {
	ContinuousWebJobCollection
}

// WebAppsClientListContinuousWebJobsSlotResponse contains the response from method WebAppsClient.NewListContinuousWebJobsSlotPager.
type WebAppsClientListContinuousWebJobsSlotResponse struct {
	ContinuousWebJobCollection
}

// WebAppsClientListDeploymentLogResponse contains the response from method WebAppsClient.ListDeploymentLog.
type WebAppsClientListDeploymentLogResponse struct {
	Deployment
}

// WebAppsClientListDeploymentLogSlotResponse contains the response from method WebAppsClient.ListDeploymentLogSlot.
type WebAppsClientListDeploymentLogSlotResponse struct {
	Deployment
}

// WebAppsClientListDeploymentsResponse contains the response from method WebAppsClient.NewListDeploymentsPager.
type WebAppsClientListDeploymentsResponse struct {
	DeploymentCollection
}

// WebAppsClientListDeploymentsSlotResponse contains the response from method WebAppsClient.NewListDeploymentsSlotPager.
type WebAppsClientListDeploymentsSlotResponse struct {
	DeploymentCollection
}

// WebAppsClientListDomainOwnershipIdentifiersResponse contains the response from method WebAppsClient.NewListDomainOwnershipIdentifiersPager.
type WebAppsClientListDomainOwnershipIdentifiersResponse struct {
	IdentifierCollection
}

// WebAppsClientListDomainOwnershipIdentifiersSlotResponse contains the response from method WebAppsClient.NewListDomainOwnershipIdentifiersSlotPager.
type WebAppsClientListDomainOwnershipIdentifiersSlotResponse struct {
	IdentifierCollection
}

// WebAppsClientListFunctionKeysResponse contains the response from method WebAppsClient.ListFunctionKeys.
type WebAppsClientListFunctionKeysResponse struct {
	StringDictionary
}

// WebAppsClientListFunctionKeysSlotResponse contains the response from method WebAppsClient.ListFunctionKeysSlot.
type WebAppsClientListFunctionKeysSlotResponse struct {
	StringDictionary
}

// WebAppsClientListFunctionSecretsResponse contains the response from method WebAppsClient.ListFunctionSecrets.
type WebAppsClientListFunctionSecretsResponse struct {
	FunctionSecrets
}

// WebAppsClientListFunctionSecretsSlotResponse contains the response from method WebAppsClient.ListFunctionSecretsSlot.
type WebAppsClientListFunctionSecretsSlotResponse struct {
	FunctionSecrets
}

// WebAppsClientListFunctionsResponse contains the response from method WebAppsClient.NewListFunctionsPager.
type WebAppsClientListFunctionsResponse struct {
	FunctionEnvelopeCollection
}

// WebAppsClientListHostKeysResponse contains the response from method WebAppsClient.ListHostKeys.
type WebAppsClientListHostKeysResponse struct {
	HostKeys
}

// WebAppsClientListHostKeysSlotResponse contains the response from method WebAppsClient.ListHostKeysSlot.
type WebAppsClientListHostKeysSlotResponse struct {
	HostKeys
}

// WebAppsClientListHostNameBindingsResponse contains the response from method WebAppsClient.NewListHostNameBindingsPager.
type WebAppsClientListHostNameBindingsResponse struct {
	HostNameBindingCollection
}

// WebAppsClientListHostNameBindingsSlotResponse contains the response from method WebAppsClient.NewListHostNameBindingsSlotPager.
type WebAppsClientListHostNameBindingsSlotResponse struct {
	HostNameBindingCollection
}

// WebAppsClientListHybridConnectionKeysResponse contains the response from method WebAppsClient.ListHybridConnectionKeys.
type WebAppsClientListHybridConnectionKeysResponse struct {
	HybridConnectionKey
}

// WebAppsClientListHybridConnectionKeysSlotResponse contains the response from method WebAppsClient.ListHybridConnectionKeysSlot.
type WebAppsClientListHybridConnectionKeysSlotResponse struct {
	HybridConnectionKey
}

// WebAppsClientListHybridConnectionsResponse contains the response from method WebAppsClient.ListHybridConnections.
type WebAppsClientListHybridConnectionsResponse struct {
	HybridConnection
}

// WebAppsClientListHybridConnectionsSlotResponse contains the response from method WebAppsClient.ListHybridConnectionsSlot.
type WebAppsClientListHybridConnectionsSlotResponse struct {
	HybridConnection
}

// WebAppsClientListInstanceFunctionsSlotResponse contains the response from method WebAppsClient.NewListInstanceFunctionsSlotPager.
type WebAppsClientListInstanceFunctionsSlotResponse struct {
	FunctionEnvelopeCollection
}

// WebAppsClientListInstanceIdentifiersResponse contains the response from method WebAppsClient.NewListInstanceIdentifiersPager.
type WebAppsClientListInstanceIdentifiersResponse struct {
	WebAppInstanceCollection
}

// WebAppsClientListInstanceIdentifiersSlotResponse contains the response from method WebAppsClient.NewListInstanceIdentifiersSlotPager.
type WebAppsClientListInstanceIdentifiersSlotResponse struct {
	WebAppInstanceCollection
}

// WebAppsClientListInstanceProcessModulesResponse contains the response from method WebAppsClient.NewListInstanceProcessModulesPager.
type WebAppsClientListInstanceProcessModulesResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListInstanceProcessModulesSlotResponse contains the response from method WebAppsClient.NewListInstanceProcessModulesSlotPager.
type WebAppsClientListInstanceProcessModulesSlotResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListInstanceProcessThreadsResponse contains the response from method WebAppsClient.NewListInstanceProcessThreadsPager.
type WebAppsClientListInstanceProcessThreadsResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListInstanceProcessThreadsSlotResponse contains the response from method WebAppsClient.NewListInstanceProcessThreadsSlotPager.
type WebAppsClientListInstanceProcessThreadsSlotResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListInstanceProcessesResponse contains the response from method WebAppsClient.NewListInstanceProcessesPager.
type WebAppsClientListInstanceProcessesResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListInstanceProcessesSlotResponse contains the response from method WebAppsClient.NewListInstanceProcessesSlotPager.
type WebAppsClientListInstanceProcessesSlotResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListMetadataResponse contains the response from method WebAppsClient.ListMetadata.
type WebAppsClientListMetadataResponse struct {
	StringDictionary
}

// WebAppsClientListMetadataSlotResponse contains the response from method WebAppsClient.ListMetadataSlot.
type WebAppsClientListMetadataSlotResponse struct {
	StringDictionary
}

// WebAppsClientListMetricDefinitionsResponse contains the response from method WebAppsClient.NewListMetricDefinitionsPager.
type WebAppsClientListMetricDefinitionsResponse struct {
	ResourceMetricDefinitionCollection
}

// WebAppsClientListMetricDefinitionsSlotResponse contains the response from method WebAppsClient.NewListMetricDefinitionsSlotPager.
type WebAppsClientListMetricDefinitionsSlotResponse struct {
	ResourceMetricDefinitionCollection
}

// WebAppsClientListMetricsResponse contains the response from method WebAppsClient.NewListMetricsPager.
type WebAppsClientListMetricsResponse struct {
	ResourceMetricCollection
}

// WebAppsClientListMetricsSlotResponse contains the response from method WebAppsClient.NewListMetricsSlotPager.
type WebAppsClientListMetricsSlotResponse struct {
	ResourceMetricCollection
}

// WebAppsClientListNetworkFeaturesResponse contains the response from method WebAppsClient.ListNetworkFeatures.
type WebAppsClientListNetworkFeaturesResponse struct {
	NetworkFeatures
}

// WebAppsClientListNetworkFeaturesSlotResponse contains the response from method WebAppsClient.ListNetworkFeaturesSlot.
type WebAppsClientListNetworkFeaturesSlotResponse struct {
	NetworkFeatures
}

// WebAppsClientListPerfMonCountersResponse contains the response from method WebAppsClient.NewListPerfMonCountersPager.
type WebAppsClientListPerfMonCountersResponse struct {
	PerfMonCounterCollection
}

// WebAppsClientListPerfMonCountersSlotResponse contains the response from method WebAppsClient.NewListPerfMonCountersSlotPager.
type WebAppsClientListPerfMonCountersSlotResponse struct {
	PerfMonCounterCollection
}

// WebAppsClientListPremierAddOnsResponse contains the response from method WebAppsClient.ListPremierAddOns.
type WebAppsClientListPremierAddOnsResponse struct {
	PremierAddOn
}

// WebAppsClientListPremierAddOnsSlotResponse contains the response from method WebAppsClient.ListPremierAddOnsSlot.
type WebAppsClientListPremierAddOnsSlotResponse struct {
	PremierAddOn
}

// WebAppsClientListProcessModulesResponse contains the response from method WebAppsClient.NewListProcessModulesPager.
type WebAppsClientListProcessModulesResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListProcessModulesSlotResponse contains the response from method WebAppsClient.NewListProcessModulesSlotPager.
type WebAppsClientListProcessModulesSlotResponse struct {
	ProcessModuleInfoCollection
}

// WebAppsClientListProcessThreadsResponse contains the response from method WebAppsClient.NewListProcessThreadsPager.
type WebAppsClientListProcessThreadsResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListProcessThreadsSlotResponse contains the response from method WebAppsClient.NewListProcessThreadsSlotPager.
type WebAppsClientListProcessThreadsSlotResponse struct {
	ProcessThreadInfoCollection
}

// WebAppsClientListProcessesResponse contains the response from method WebAppsClient.NewListProcessesPager.
type WebAppsClientListProcessesResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListProcessesSlotResponse contains the response from method WebAppsClient.NewListProcessesSlotPager.
type WebAppsClientListProcessesSlotResponse struct {
	ProcessInfoCollection
}

// WebAppsClientListPublicCertificatesResponse contains the response from method WebAppsClient.NewListPublicCertificatesPager.
type WebAppsClientListPublicCertificatesResponse struct {
	PublicCertificateCollection
}

// WebAppsClientListPublicCertificatesSlotResponse contains the response from method WebAppsClient.NewListPublicCertificatesSlotPager.
type WebAppsClientListPublicCertificatesSlotResponse struct {
	PublicCertificateCollection
}

// WebAppsClientListPublishingCredentialsResponse contains the response from method WebAppsClient.BeginListPublishingCredentials.
type WebAppsClientListPublishingCredentialsResponse struct {
	User
}

// WebAppsClientListPublishingCredentialsSlotResponse contains the response from method WebAppsClient.BeginListPublishingCredentialsSlot.
type WebAppsClientListPublishingCredentialsSlotResponse struct {
	User
}

// WebAppsClientListPublishingProfileXMLWithSecretsResponse contains the response from method WebAppsClient.ListPublishingProfileXMLWithSecrets.
type WebAppsClientListPublishingProfileXMLWithSecretsResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientListPublishingProfileXMLWithSecretsSlotResponse contains the response from method WebAppsClient.ListPublishingProfileXMLWithSecretsSlot.
type WebAppsClientListPublishingProfileXMLWithSecretsSlotResponse struct {
	// Body contains the streaming response.
	Body io.ReadCloser
}

// WebAppsClientListRelayServiceConnectionsResponse contains the response from method WebAppsClient.ListRelayServiceConnections.
type WebAppsClientListRelayServiceConnectionsResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientListRelayServiceConnectionsSlotResponse contains the response from method WebAppsClient.ListRelayServiceConnectionsSlot.
type WebAppsClientListRelayServiceConnectionsSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientListResponse contains the response from method WebAppsClient.NewListPager.
type WebAppsClientListResponse struct {
	WebAppCollection
}

// WebAppsClientListSiteExtensionsResponse contains the response from method WebAppsClient.NewListSiteExtensionsPager.
type WebAppsClientListSiteExtensionsResponse struct {
	SiteExtensionInfoCollection
}

// WebAppsClientListSiteExtensionsSlotResponse contains the response from method WebAppsClient.NewListSiteExtensionsSlotPager.
type WebAppsClientListSiteExtensionsSlotResponse struct {
	SiteExtensionInfoCollection
}

// WebAppsClientListSitePushSettingsResponse contains the response from method WebAppsClient.ListSitePushSettings.
type WebAppsClientListSitePushSettingsResponse struct {
	PushSettings
}

// WebAppsClientListSitePushSettingsSlotResponse contains the response from method WebAppsClient.ListSitePushSettingsSlot.
type WebAppsClientListSitePushSettingsSlotResponse struct {
	PushSettings
}

// WebAppsClientListSlotConfigurationNamesResponse contains the response from method WebAppsClient.ListSlotConfigurationNames.
type WebAppsClientListSlotConfigurationNamesResponse struct {
	SlotConfigNamesResource
}

// WebAppsClientListSlotDifferencesFromProductionResponse contains the response from method WebAppsClient.NewListSlotDifferencesFromProductionPager.
type WebAppsClientListSlotDifferencesFromProductionResponse struct {
	SlotDifferenceCollection
}

// WebAppsClientListSlotDifferencesSlotResponse contains the response from method WebAppsClient.NewListSlotDifferencesSlotPager.
type WebAppsClientListSlotDifferencesSlotResponse struct {
	SlotDifferenceCollection
}

// WebAppsClientListSlotsResponse contains the response from method WebAppsClient.NewListSlotsPager.
type WebAppsClientListSlotsResponse struct {
	WebAppCollection
}

// WebAppsClientListSnapshotsFromDRSecondaryResponse contains the response from method WebAppsClient.NewListSnapshotsFromDRSecondaryPager.
type WebAppsClientListSnapshotsFromDRSecondaryResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsFromDRSecondarySlotResponse contains the response from method WebAppsClient.NewListSnapshotsFromDRSecondarySlotPager.
type WebAppsClientListSnapshotsFromDRSecondarySlotResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsResponse contains the response from method WebAppsClient.NewListSnapshotsPager.
type WebAppsClientListSnapshotsResponse struct {
	SnapshotCollection
}

// WebAppsClientListSnapshotsSlotResponse contains the response from method WebAppsClient.NewListSnapshotsSlotPager.
type WebAppsClientListSnapshotsSlotResponse struct {
	SnapshotCollection
}

// WebAppsClientListSyncFunctionTriggersResponse contains the response from method WebAppsClient.ListSyncFunctionTriggers.
type WebAppsClientListSyncFunctionTriggersResponse struct {
	FunctionSecrets
}

// WebAppsClientListSyncFunctionTriggersSlotResponse contains the response from method WebAppsClient.ListSyncFunctionTriggersSlot.
type WebAppsClientListSyncFunctionTriggersSlotResponse struct {
	FunctionSecrets
}

// WebAppsClientListSyncStatusResponse contains the response from method WebAppsClient.ListSyncStatus.
type WebAppsClientListSyncStatusResponse struct {
	// placeholder for future response values
}

// WebAppsClientListSyncStatusSlotResponse contains the response from method WebAppsClient.ListSyncStatusSlot.
type WebAppsClientListSyncStatusSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientListTriggeredWebJobHistoryResponse contains the response from method WebAppsClient.NewListTriggeredWebJobHistoryPager.
type WebAppsClientListTriggeredWebJobHistoryResponse struct {
	TriggeredJobHistoryCollection
}

// WebAppsClientListTriggeredWebJobHistorySlotResponse contains the response from method WebAppsClient.NewListTriggeredWebJobHistorySlotPager.
type WebAppsClientListTriggeredWebJobHistorySlotResponse struct {
	TriggeredJobHistoryCollection
}

// WebAppsClientListTriggeredWebJobsResponse contains the response from method WebAppsClient.NewListTriggeredWebJobsPager.
type WebAppsClientListTriggeredWebJobsResponse struct {
	TriggeredWebJobCollection
}

// WebAppsClientListTriggeredWebJobsSlotResponse contains the response from method WebAppsClient.NewListTriggeredWebJobsSlotPager.
type WebAppsClientListTriggeredWebJobsSlotResponse struct {
	TriggeredWebJobCollection
}

// WebAppsClientListUsagesResponse contains the response from method WebAppsClient.NewListUsagesPager.
type WebAppsClientListUsagesResponse struct {
	CsmUsageQuotaCollection
}

// WebAppsClientListUsagesSlotResponse contains the response from method WebAppsClient.NewListUsagesSlotPager.
type WebAppsClientListUsagesSlotResponse struct {
	CsmUsageQuotaCollection
}

// WebAppsClientListVnetConnectionsResponse contains the response from method WebAppsClient.ListVnetConnections.
type WebAppsClientListVnetConnectionsResponse struct {
	// Array of VnetInfo
	VnetInfoArray []*VnetInfo
}

// WebAppsClientListVnetConnectionsSlotResponse contains the response from method WebAppsClient.ListVnetConnectionsSlot.
type WebAppsClientListVnetConnectionsSlotResponse struct {
	// Array of VnetInfo
	VnetInfoArray []*VnetInfo
}

// WebAppsClientListWebJobsResponse contains the response from method WebAppsClient.NewListWebJobsPager.
type WebAppsClientListWebJobsResponse struct {
	WebJobCollection
}

// WebAppsClientListWebJobsSlotResponse contains the response from method WebAppsClient.NewListWebJobsSlotPager.
type WebAppsClientListWebJobsSlotResponse struct {
	WebJobCollection
}

// WebAppsClientMigrateMySQLResponse contains the response from method WebAppsClient.BeginMigrateMySQL.
type WebAppsClientMigrateMySQLResponse struct {
	Operation
}

// WebAppsClientMigrateStorageResponse contains the response from method WebAppsClient.BeginMigrateStorage.
type WebAppsClientMigrateStorageResponse struct {
	StorageMigrationResponse
}

// WebAppsClientPutPrivateAccessVnetResponse contains the response from method WebAppsClient.PutPrivateAccessVnet.
type WebAppsClientPutPrivateAccessVnetResponse struct {
	PrivateAccess
}

// WebAppsClientPutPrivateAccessVnetSlotResponse contains the response from method WebAppsClient.PutPrivateAccessVnetSlot.
type WebAppsClientPutPrivateAccessVnetSlotResponse struct {
	PrivateAccess
}

// WebAppsClientRecoverSiteConfigurationSnapshotResponse contains the response from method WebAppsClient.RecoverSiteConfigurationSnapshot.
type WebAppsClientRecoverSiteConfigurationSnapshotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRecoverSiteConfigurationSnapshotSlotResponse contains the response from method WebAppsClient.RecoverSiteConfigurationSnapshotSlot.
type WebAppsClientRecoverSiteConfigurationSnapshotSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientResetProductionSlotConfigResponse contains the response from method WebAppsClient.ResetProductionSlotConfig.
type WebAppsClientResetProductionSlotConfigResponse struct {
	// placeholder for future response values
}

// WebAppsClientResetSlotConfigurationSlotResponse contains the response from method WebAppsClient.ResetSlotConfigurationSlot.
type WebAppsClientResetSlotConfigurationSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestartResponse contains the response from method WebAppsClient.Restart.
type WebAppsClientRestartResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestartSlotResponse contains the response from method WebAppsClient.RestartSlot.
type WebAppsClientRestartSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromBackupBlobResponse contains the response from method WebAppsClient.BeginRestoreFromBackupBlob.
type WebAppsClientRestoreFromBackupBlobResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromBackupBlobSlotResponse contains the response from method WebAppsClient.BeginRestoreFromBackupBlobSlot.
type WebAppsClientRestoreFromBackupBlobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromDeletedAppResponse contains the response from method WebAppsClient.BeginRestoreFromDeletedApp.
type WebAppsClientRestoreFromDeletedAppResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreFromDeletedAppSlotResponse contains the response from method WebAppsClient.BeginRestoreFromDeletedAppSlot.
type WebAppsClientRestoreFromDeletedAppSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreResponse contains the response from method WebAppsClient.BeginRestore.
type WebAppsClientRestoreResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSlotResponse contains the response from method WebAppsClient.BeginRestoreSlot.
type WebAppsClientRestoreSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSnapshotResponse contains the response from method WebAppsClient.BeginRestoreSnapshot.
type WebAppsClientRestoreSnapshotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRestoreSnapshotSlotResponse contains the response from method WebAppsClient.BeginRestoreSnapshotSlot.
type WebAppsClientRestoreSnapshotSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientRunTriggeredWebJobResponse contains the response from method WebAppsClient.RunTriggeredWebJob.
type WebAppsClientRunTriggeredWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientRunTriggeredWebJobSlotResponse contains the response from method WebAppsClient.RunTriggeredWebJobSlot.
type WebAppsClientRunTriggeredWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartContinuousWebJobResponse contains the response from method WebAppsClient.StartContinuousWebJob.
type WebAppsClientStartContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartContinuousWebJobSlotResponse contains the response from method WebAppsClient.StartContinuousWebJobSlot.
type WebAppsClientStartContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartNetworkTraceResponse contains the response from method WebAppsClient.BeginStartNetworkTrace.
type WebAppsClientStartNetworkTraceResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartNetworkTraceResponse.
func (w *WebAppsClientStartNetworkTraceResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartNetworkTraceSlotResponse contains the response from method WebAppsClient.BeginStartNetworkTraceSlot.
type WebAppsClientStartNetworkTraceSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartNetworkTraceSlotResponse.
func (w *WebAppsClientStartNetworkTraceSlotResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartResponse contains the response from method WebAppsClient.Start.
type WebAppsClientStartResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartSlotResponse contains the response from method WebAppsClient.StartSlot.
type WebAppsClientStartSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStartWebSiteNetworkTraceOperationResponse contains the response from method WebAppsClient.BeginStartWebSiteNetworkTraceOperation.
type WebAppsClientStartWebSiteNetworkTraceOperationResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartWebSiteNetworkTraceOperationResponse.
func (w *WebAppsClientStartWebSiteNetworkTraceOperationResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse contains the response from method WebAppsClient.BeginStartWebSiteNetworkTraceOperationSlot.
type WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse struct {
	// Array of NetworkTrace
	NetworkTraceArray []*NetworkTrace
}

// UnmarshalJSON implements the json.Unmarshaller interface for type WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse.
func (w *WebAppsClientStartWebSiteNetworkTraceOperationSlotResponse) UnmarshalJSON(data []byte) error {
	return json.Unmarshal(data, &w.NetworkTraceArray)
}

// WebAppsClientStartWebSiteNetworkTraceResponse contains the response from method WebAppsClient.StartWebSiteNetworkTrace.
type WebAppsClientStartWebSiteNetworkTraceResponse struct {
	Value *string
}

// WebAppsClientStartWebSiteNetworkTraceSlotResponse contains the response from method WebAppsClient.StartWebSiteNetworkTraceSlot.
type WebAppsClientStartWebSiteNetworkTraceSlotResponse struct {
	Value *string
}

// WebAppsClientStopContinuousWebJobResponse contains the response from method WebAppsClient.StopContinuousWebJob.
type WebAppsClientStopContinuousWebJobResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopContinuousWebJobSlotResponse contains the response from method WebAppsClient.StopContinuousWebJobSlot.
type WebAppsClientStopContinuousWebJobSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopNetworkTraceResponse contains the response from method WebAppsClient.StopNetworkTrace.
type WebAppsClientStopNetworkTraceResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopNetworkTraceSlotResponse contains the response from method WebAppsClient.StopNetworkTraceSlot.
type WebAppsClientStopNetworkTraceSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopResponse contains the response from method WebAppsClient.Stop.
type WebAppsClientStopResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopSlotResponse contains the response from method WebAppsClient.StopSlot.
type WebAppsClientStopSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopWebSiteNetworkTraceResponse contains the response from method WebAppsClient.StopWebSiteNetworkTrace.
type WebAppsClientStopWebSiteNetworkTraceResponse struct {
	// placeholder for future response values
}

// WebAppsClientStopWebSiteNetworkTraceSlotResponse contains the response from method WebAppsClient.StopWebSiteNetworkTraceSlot.
type WebAppsClientStopWebSiteNetworkTraceSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSwapSlotResponse contains the response from method WebAppsClient.BeginSwapSlot.
type WebAppsClientSwapSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSwapSlotWithProductionResponse contains the response from method WebAppsClient.BeginSwapSlotWithProduction.
type WebAppsClientSwapSlotWithProductionResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionTriggersResponse contains the response from method WebAppsClient.SyncFunctionTriggers.
type WebAppsClientSyncFunctionTriggersResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionTriggersSlotResponse contains the response from method WebAppsClient.SyncFunctionTriggersSlot.
type WebAppsClientSyncFunctionTriggersSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionsResponse contains the response from method WebAppsClient.SyncFunctions.
type WebAppsClientSyncFunctionsResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncFunctionsSlotResponse contains the response from method WebAppsClient.SyncFunctionsSlot.
type WebAppsClientSyncFunctionsSlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncRepositoryResponse contains the response from method WebAppsClient.SyncRepository.
type WebAppsClientSyncRepositoryResponse struct {
	// placeholder for future response values
}

// WebAppsClientSyncRepositorySlotResponse contains the response from method WebAppsClient.SyncRepositorySlot.
type WebAppsClientSyncRepositorySlotResponse struct {
	// placeholder for future response values
}

// WebAppsClientUpdateApplicationSettingsResponse contains the response from method WebAppsClient.UpdateApplicationSettings.
type WebAppsClientUpdateApplicationSettingsResponse struct {
	StringDictionary
}

// WebAppsClientUpdateApplicationSettingsSlotResponse contains the response from method WebAppsClient.UpdateApplicationSettingsSlot.
type WebAppsClientUpdateApplicationSettingsSlotResponse struct {
	StringDictionary
}

// WebAppsClientUpdateAuthSettingsResponse contains the response from method WebAppsClient.UpdateAuthSettings.
type WebAppsClientUpdateAuthSettingsResponse struct {
	SiteAuthSettings
}

// WebAppsClientUpdateAuthSettingsSlotResponse contains the response from method WebAppsClient.UpdateAuthSettingsSlot.
type WebAppsClientUpdateAuthSettingsSlotResponse struct {
	SiteAuthSettings
}

// WebAppsClientUpdateAzureStorageAccountsResponse contains the response from method WebAppsClient.UpdateAzureStorageAccounts.
type WebAppsClientUpdateAzureStorageAccountsResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientUpdateAzureStorageAccountsSlotResponse contains the response from method WebAppsClient.UpdateAzureStorageAccountsSlot.
type WebAppsClientUpdateAzureStorageAccountsSlotResponse struct {
	AzureStoragePropertyDictionaryResource
}

// WebAppsClientUpdateBackupConfigurationResponse contains the response from method WebAppsClient.UpdateBackupConfiguration.
type WebAppsClientUpdateBackupConfigurationResponse struct {
	BackupRequest
}

// WebAppsClientUpdateBackupConfigurationSlotResponse contains the response from method WebAppsClient.UpdateBackupConfigurationSlot.
type WebAppsClientUpdateBackupConfigurationSlotResponse struct {
	BackupRequest
}

// WebAppsClientUpdateConfigurationResponse contains the response from method WebAppsClient.UpdateConfiguration.
type WebAppsClientUpdateConfigurationResponse struct {
	SiteConfigResource
}

// WebAppsClientUpdateConfigurationSlotResponse contains the response from method WebAppsClient.UpdateConfigurationSlot.
type WebAppsClientUpdateConfigurationSlotResponse struct {
	SiteConfigResource
}

// WebAppsClientUpdateConnectionStringsResponse contains the response from method WebAppsClient.UpdateConnectionStrings.
type WebAppsClientUpdateConnectionStringsResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientUpdateConnectionStringsSlotResponse contains the response from method WebAppsClient.UpdateConnectionStringsSlot.
type WebAppsClientUpdateConnectionStringsSlotResponse struct {
	ConnectionStringDictionary
}

// WebAppsClientUpdateDiagnosticLogsConfigResponse contains the response from method WebAppsClient.UpdateDiagnosticLogsConfig.
type WebAppsClientUpdateDiagnosticLogsConfigResponse struct {
	SiteLogsConfig
}

// WebAppsClientUpdateDiagnosticLogsConfigSlotResponse contains the response from method WebAppsClient.UpdateDiagnosticLogsConfigSlot.
type WebAppsClientUpdateDiagnosticLogsConfigSlotResponse struct {
	SiteLogsConfig
}

// WebAppsClientUpdateDomainOwnershipIdentifierResponse contains the response from method WebAppsClient.UpdateDomainOwnershipIdentifier.
type WebAppsClientUpdateDomainOwnershipIdentifierResponse struct {
	Identifier
}

// WebAppsClientUpdateDomainOwnershipIdentifierSlotResponse contains the response from method WebAppsClient.UpdateDomainOwnershipIdentifierSlot.
type WebAppsClientUpdateDomainOwnershipIdentifierSlotResponse struct {
	Identifier
}

// WebAppsClientUpdateHybridConnectionResponse contains the response from method WebAppsClient.UpdateHybridConnection.
type WebAppsClientUpdateHybridConnectionResponse struct {
	HybridConnection
}

// WebAppsClientUpdateHybridConnectionSlotResponse contains the response from method WebAppsClient.UpdateHybridConnectionSlot.
type WebAppsClientUpdateHybridConnectionSlotResponse struct {
	HybridConnection
}

// WebAppsClientUpdateMetadataResponse contains the response from method WebAppsClient.UpdateMetadata.
type WebAppsClientUpdateMetadataResponse struct {
	StringDictionary
}

// WebAppsClientUpdateMetadataSlotResponse contains the response from method WebAppsClient.UpdateMetadataSlot.
type WebAppsClientUpdateMetadataSlotResponse struct {
	StringDictionary
}

// WebAppsClientUpdatePremierAddOnResponse contains the response from method WebAppsClient.UpdatePremierAddOn.
type WebAppsClientUpdatePremierAddOnResponse struct {
	PremierAddOn
}

// WebAppsClientUpdatePremierAddOnSlotResponse contains the response from method WebAppsClient.UpdatePremierAddOnSlot.
type WebAppsClientUpdatePremierAddOnSlotResponse struct {
	PremierAddOn
}

// WebAppsClientUpdateRelayServiceConnectionResponse contains the response from method WebAppsClient.UpdateRelayServiceConnection.
type WebAppsClientUpdateRelayServiceConnectionResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientUpdateRelayServiceConnectionSlotResponse contains the response from method WebAppsClient.UpdateRelayServiceConnectionSlot.
type WebAppsClientUpdateRelayServiceConnectionSlotResponse struct {
	RelayServiceConnectionEntity
}

// WebAppsClientUpdateResponse contains the response from method WebAppsClient.Update.
type WebAppsClientUpdateResponse struct {
	Site
}

// WebAppsClientUpdateSitePushSettingsResponse contains the response from method WebAppsClient.UpdateSitePushSettings.
type WebAppsClientUpdateSitePushSettingsResponse struct {
	PushSettings
}

// WebAppsClientUpdateSitePushSettingsSlotResponse contains the response from method WebAppsClient.UpdateSitePushSettingsSlot.
type WebAppsClientUpdateSitePushSettingsSlotResponse struct {
	PushSettings
}

// WebAppsClientUpdateSlotConfigurationNamesResponse contains the response from method WebAppsClient.UpdateSlotConfigurationNames.
type WebAppsClientUpdateSlotConfigurationNamesResponse struct {
	SlotConfigNamesResource
}

// WebAppsClientUpdateSlotResponse contains the response from method WebAppsClient.UpdateSlot.
type WebAppsClientUpdateSlotResponse struct {
	Site
}

// WebAppsClientUpdateSourceControlResponse contains the response from method WebAppsClient.UpdateSourceControl.
type WebAppsClientUpdateSourceControlResponse struct {
	SiteSourceControl
}

// WebAppsClientUpdateSourceControlSlotResponse contains the response from method WebAppsClient.UpdateSourceControlSlot.
type WebAppsClientUpdateSourceControlSlotResponse struct {
	SiteSourceControl
}

// WebAppsClientUpdateSwiftVirtualNetworkConnectionResponse contains the response from method WebAppsClient.UpdateSwiftVirtualNetworkConnection.
type WebAppsClientUpdateSwiftVirtualNetworkConnectionResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientUpdateSwiftVirtualNetworkConnectionSlotResponse contains the response from method WebAppsClient.UpdateSwiftVirtualNetworkConnectionSlot.
type WebAppsClientUpdateSwiftVirtualNetworkConnectionSlotResponse struct {
	SwiftVirtualNetwork
}

// WebAppsClientUpdateVnetConnectionGatewayResponse contains the response from method WebAppsClient.UpdateVnetConnectionGateway.
type WebAppsClientUpdateVnetConnectionGatewayResponse struct {
	VnetGateway
}

// WebAppsClientUpdateVnetConnectionGatewaySlotResponse contains the response from method WebAppsClient.UpdateVnetConnectionGatewaySlot.
type WebAppsClientUpdateVnetConnectionGatewaySlotResponse struct {
	VnetGateway
}

// WebAppsClientUpdateVnetConnectionResponse contains the response from method WebAppsClient.UpdateVnetConnection.
type WebAppsClientUpdateVnetConnectionResponse struct {
	VnetInfo
}

// WebAppsClientUpdateVnetConnectionSlotResponse contains the response from method WebAppsClient.UpdateVnetConnectionSlot.
type WebAppsClientUpdateVnetConnectionSlotResponse struct {
	VnetInfo
}

// WebSiteManagementClientCheckNameAvailabilityResponse contains the response from method WebSiteManagementClient.CheckNameAvailability.
type WebSiteManagementClientCheckNameAvailabilityResponse struct {
	ResourceNameAvailability
}

// WebSiteManagementClientGetPublishingUserResponse contains the response from method WebSiteManagementClient.GetPublishingUser.
type WebSiteManagementClientGetPublishingUserResponse struct {
	User
}

// WebSiteManagementClientGetSourceControlResponse contains the response from method WebSiteManagementClient.GetSourceControl.
type WebSiteManagementClientGetSourceControlResponse struct {
	SourceControl
}

// WebSiteManagementClientGetSubscriptionDeploymentLocationsResponse contains the response from method WebSiteManagementClient.GetSubscriptionDeploymentLocations.
type WebSiteManagementClientGetSubscriptionDeploymentLocationsResponse struct {
	DeploymentLocations
}

// WebSiteManagementClientListBillingMetersResponse contains the response from method WebSiteManagementClient.NewListBillingMetersPager.
type WebSiteManagementClientListBillingMetersResponse struct {
	BillingMeterCollection
}

// WebSiteManagementClientListGeoRegionsResponse contains the response from method WebSiteManagementClient.NewListGeoRegionsPager.
type WebSiteManagementClientListGeoRegionsResponse struct {
	GeoRegionCollection
}

// WebSiteManagementClientListPremierAddOnOffersResponse contains the response from method WebSiteManagementClient.NewListPremierAddOnOffersPager.
type WebSiteManagementClientListPremierAddOnOffersResponse struct {
	PremierAddOnOfferCollection
}

// WebSiteManagementClientListSKUsResponse contains the response from method WebSiteManagementClient.ListSKUs.
type WebSiteManagementClientListSKUsResponse struct {
	SKUInfos
}

// WebSiteManagementClientListSiteIdentifiersAssignedToHostNameResponse contains the response from method WebSiteManagementClient.NewListSiteIdentifiersAssignedToHostNamePager.
type WebSiteManagementClientListSiteIdentifiersAssignedToHostNameResponse struct {
	IdentifierCollection
}

// WebSiteManagementClientListSourceControlsResponse contains the response from method WebSiteManagementClient.NewListSourceControlsPager.
type WebSiteManagementClientListSourceControlsResponse struct {
	SourceControlCollection
}

// WebSiteManagementClientMoveResponse contains the response from method WebSiteManagementClient.Move.
type WebSiteManagementClientMoveResponse struct {
	// placeholder for future response values
}

// WebSiteManagementClientUpdatePublishingUserResponse contains the response from method WebSiteManagementClient.UpdatePublishingUser.
type WebSiteManagementClientUpdatePublishingUserResponse struct {
	User
}

// WebSiteManagementClientUpdateSourceControlResponse contains the response from method WebSiteManagementClient.UpdateSourceControl.
type WebSiteManagementClientUpdateSourceControlResponse struct {
	SourceControl
}

// WebSiteManagementClientValidateContainerSettingsResponse contains the response from method WebSiteManagementClient.ValidateContainerSettings.
type WebSiteManagementClientValidateContainerSettingsResponse struct {
	// Anything
	Interface any
}

// WebSiteManagementClientValidateMoveResponse contains the response from method WebSiteManagementClient.ValidateMove.
type WebSiteManagementClientValidateMoveResponse struct {
	// placeholder for future response values
}

// WebSiteManagementClientValidateResponse contains the response from method WebSiteManagementClient.Validate.
type WebSiteManagementClientValidateResponse struct {
	ValidateResponse
}

// WebSiteManagementClientVerifyHostingEnvironmentVnetResponse contains the response from method WebSiteManagementClient.VerifyHostingEnvironmentVnet.
type WebSiteManagementClientVerifyHostingEnvironmentVnetResponse struct {
	VnetValidationFailureDetails
}
