//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package azopenai

// AzureChatExtensionConfigurationClassification provides polymorphic access to related types.
// Call the interface's GetAzureChatExtensionConfiguration() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *AzureChatExtensionConfiguration, *AzureCosmosDBChatExtensionConfiguration, *AzureSearchChatExtensionConfiguration, *ElasticsearchChatExtensionConfiguration,
// - *MongoDBChatExtensionConfiguration, *PineconeChatExtensionConfiguration
type AzureChatExtensionConfigurationClassification interface {
	// GetAzureChatExtensionConfiguration returns the AzureChatExtensionConfiguration content of the underlying type.
	GetAzureChatExtensionConfiguration() *AzureChatExtensionConfiguration
}

// ChatCompletionRequestMessageContentPartClassification provides polymorphic access to related types.
// Call the interface's GetChatCompletionRequestMessageContentPart() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatCompletionRequestMessageContentPart, *ChatCompletionRequestMessageContentPartImage, *ChatCompletionRequestMessageContentPartText
type ChatCompletionRequestMessageContentPartClassification interface {
	// GetChatCompletionRequestMessageContentPart returns the ChatCompletionRequestMessageContentPart content of the underlying type.
	GetChatCompletionRequestMessageContentPart() *ChatCompletionRequestMessageContentPart
}

// ChatCompletionsNamedToolSelectionClassification provides polymorphic access to related types.
// Call the interface's GetChatCompletionsNamedToolSelection() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatCompletionsNamedFunctionToolSelection, *ChatCompletionsNamedToolSelection
type ChatCompletionsNamedToolSelectionClassification interface {
	// GetChatCompletionsNamedToolSelection returns the ChatCompletionsNamedToolSelection content of the underlying type.
	GetChatCompletionsNamedToolSelection() *ChatCompletionsNamedToolSelection
}

// ChatCompletionsResponseFormatClassification provides polymorphic access to related types.
// Call the interface's GetChatCompletionsResponseFormat() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatCompletionsJSONResponseFormat, *ChatCompletionsJSONSchemaResponseFormat, *ChatCompletionsResponseFormat, *ChatCompletionsTextResponseFormat
type ChatCompletionsResponseFormatClassification interface {
	// GetChatCompletionsResponseFormat returns the ChatCompletionsResponseFormat content of the underlying type.
	GetChatCompletionsResponseFormat() *ChatCompletionsResponseFormat
}

// ChatCompletionsToolCallClassification provides polymorphic access to related types.
// Call the interface's GetChatCompletionsToolCall() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatCompletionsFunctionToolCall, *ChatCompletionsToolCall
type ChatCompletionsToolCallClassification interface {
	// GetChatCompletionsToolCall returns the ChatCompletionsToolCall content of the underlying type.
	GetChatCompletionsToolCall() *ChatCompletionsToolCall
}

// ChatCompletionsToolDefinitionClassification provides polymorphic access to related types.
// Call the interface's GetChatCompletionsToolDefinition() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatCompletionsFunctionToolDefinition, *ChatCompletionsToolDefinition
type ChatCompletionsToolDefinitionClassification interface {
	// GetChatCompletionsToolDefinition returns the ChatCompletionsToolDefinition content of the underlying type.
	GetChatCompletionsToolDefinition() *ChatCompletionsToolDefinition
}

// ChatFinishDetailsClassification provides polymorphic access to related types.
// Call the interface's GetChatFinishDetails() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatFinishDetails, *MaxTokensFinishDetails, *StopFinishDetails
type ChatFinishDetailsClassification interface {
	// GetChatFinishDetails returns the ChatFinishDetails content of the underlying type.
	GetChatFinishDetails() *ChatFinishDetails
}

// ChatMessageContentItemClassification provides polymorphic access to related types.
// Call the interface's GetChatMessageContentItem() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatMessageContentItem, *ChatMessageImageContentItem, *ChatMessageRefusalContentItem, *ChatMessageTextContentItem
type ChatMessageContentItemClassification interface {
	// GetChatMessageContentItem returns the ChatMessageContentItem content of the underlying type.
	GetChatMessageContentItem() *ChatMessageContentItem
}

// ChatRequestMessageClassification provides polymorphic access to related types.
// Call the interface's GetChatRequestMessage() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *ChatRequestAssistantMessage, *ChatRequestFunctionMessage, *ChatRequestMessage, *ChatRequestSystemMessage, *ChatRequestToolMessage,
// - *ChatRequestUserMessage
type ChatRequestMessageClassification interface {
	// GetChatRequestMessage returns the ChatRequestMessage content of the underlying type.
	GetChatRequestMessage() *ChatRequestMessage
}

// OnYourDataAuthenticationOptionsClassification provides polymorphic access to related types.
// Call the interface's GetOnYourDataAuthenticationOptions() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *OnYourDataAPIKeyAuthenticationOptions, *OnYourDataAccessTokenAuthenticationOptions, *OnYourDataAuthenticationOptions,
// - *OnYourDataConnectionStringAuthenticationOptions, *OnYourDataEncodedAPIKeyAuthenticationOptions, *OnYourDataKeyAndKeyIDAuthenticationOptions,
// - *OnYourDataSystemAssignedManagedIdentityAuthenticationOptions, *OnYourDataUserAssignedManagedIdentityAuthenticationOptions,
// - *OnYourDataUsernameAndPasswordAuthenticationOptions
type OnYourDataAuthenticationOptionsClassification interface {
	// GetOnYourDataAuthenticationOptions returns the OnYourDataAuthenticationOptions content of the underlying type.
	GetOnYourDataAuthenticationOptions() *OnYourDataAuthenticationOptions
}

// OnYourDataVectorSearchAuthenticationOptionsClassification provides polymorphic access to related types.
// Call the interface's GetOnYourDataVectorSearchAuthenticationOptions() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *OnYourDataVectorSearchAPIKeyAuthenticationOptions, *OnYourDataVectorSearchAccessTokenAuthenticationOptions, *OnYourDataVectorSearchAuthenticationOptions
type OnYourDataVectorSearchAuthenticationOptionsClassification interface {
	// GetOnYourDataVectorSearchAuthenticationOptions returns the OnYourDataVectorSearchAuthenticationOptions content of the underlying type.
	GetOnYourDataVectorSearchAuthenticationOptions() *OnYourDataVectorSearchAuthenticationOptions
}

// OnYourDataVectorizationSourceClassification provides polymorphic access to related types.
// Call the interface's GetOnYourDataVectorizationSource() method to access the common type.
// Use a type switch to determine the concrete type.  The possible types are:
// - *OnYourDataDeploymentNameVectorizationSource, *OnYourDataEndpointVectorizationSource, *OnYourDataIntegratedVectorizationSource,
// - *OnYourDataModelIDVectorizationSource, *OnYourDataVectorizationSource
type OnYourDataVectorizationSourceClassification interface {
	// GetOnYourDataVectorizationSource returns the OnYourDataVectorizationSource content of the underlying type.
	GetOnYourDataVectorizationSource() *OnYourDataVectorizationSource
}
