//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package azopenaiassistants

// CancelRunResponse contains the response from method Client.CancelRun.
type CancelRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// CancelVectorStoreFileBatchResponse contains the response from method Client.CancelVectorStoreFileBatch.
type CancelVectorStoreFileBatchResponse struct {
	// A batch of files attached to a vector store.
	VectorStoreFileBatch
}

// CreateAssistantResponse contains the response from method Client.CreateAssistant.
type CreateAssistantResponse struct {
	// Represents an assistant that can call the model and use tools.
	Assistant
}

// CreateMessageResponse contains the response from method Client.CreateMessage.
type CreateMessageResponse struct {
	// A single, existing message within an assistant thread.
	ThreadMessage
}

// CreateRunResponse contains the response from method Client.CreateRun.
type CreateRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// CreateThreadAndRunResponse contains the response from method Client.CreateThreadAndRun.
type CreateThreadAndRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// CreateThreadResponse contains the response from method Client.CreateThread.
type CreateThreadResponse struct {
	// Information about a single thread associated with an assistant.
	AssistantThread
}

// CreateVectorStoreFileBatchResponse contains the response from method Client.CreateVectorStoreFileBatch.
type CreateVectorStoreFileBatchResponse struct {
	// A batch of files attached to a vector store.
	VectorStoreFileBatch
}

// CreateVectorStoreFileResponse contains the response from method Client.CreateVectorStoreFile.
type CreateVectorStoreFileResponse struct {
	// Description of a file attached to a vector store.
	VectorStoreFile
}

// CreateVectorStoreResponse contains the response from method Client.CreateVectorStore.
type CreateVectorStoreResponse struct {
	// A vector store is a collection of processed files can be used by the `file_search` tool.
	VectorStore
}

// DeleteAssistantResponse contains the response from method Client.DeleteAssistant.
type DeleteAssistantResponse struct {
	// The status of an assistant deletion operation.
	AssistantDeletionStatus
}

// DeleteFileResponse contains the response from method Client.DeleteFile.
type DeleteFileResponse struct {
	// A status response from a file deletion operation.
	FileDeletionStatus
}

// DeleteThreadResponse contains the response from method Client.DeleteThread.
type DeleteThreadResponse struct {
	// The status of a thread deletion operation.
	ThreadDeletionStatus
}

// DeleteVectorStoreFileResponse contains the response from method Client.DeleteVectorStoreFile.
type DeleteVectorStoreFileResponse struct {
	// Response object for deleting a vector store file relationship.
	VectorStoreFileDeletionStatus
}

// DeleteVectorStoreResponse contains the response from method Client.DeleteVectorStore.
type DeleteVectorStoreResponse struct {
	// Response object for deleting a vector store.
	VectorStoreDeletionStatus
}

// GetAssistantResponse contains the response from method Client.GetAssistant.
type GetAssistantResponse struct {
	// Represents an assistant that can call the model and use tools.
	Assistant
}

// GetFileResponse contains the response from method Client.GetFile.
type GetFileResponse struct {
	// Represents an assistant that can call the model and use tools.
	OpenAIFile
}

// GetMessageResponse contains the response from method Client.GetMessage.
type GetMessageResponse struct {
	// A single, existing message within an assistant thread.
	ThreadMessage
}

// GetRunResponse contains the response from method Client.GetRun.
type GetRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// GetRunStepResponse contains the response from method Client.GetRunStep.
type GetRunStepResponse struct {
	// Detailed information about a single step of an assistant thread run.
	RunStep
}

// GetThreadResponse contains the response from method Client.GetThread.
type GetThreadResponse struct {
	// Information about a single thread associated with an assistant.
	AssistantThread
}

// GetVectorStoreFileBatchResponse contains the response from method Client.GetVectorStoreFileBatch.
type GetVectorStoreFileBatchResponse struct {
	// A batch of files attached to a vector store.
	VectorStoreFileBatch
}

// GetVectorStoreFileResponse contains the response from method Client.GetVectorStoreFile.
type GetVectorStoreFileResponse struct {
	// Description of a file attached to a vector store.
	VectorStoreFile
}

// GetVectorStoreResponse contains the response from method Client.GetVectorStore.
type GetVectorStoreResponse struct {
	// A vector store is a collection of processed files can be used by the `file_search` tool.
	VectorStore
}

// ListAssistantsResponse contains the response from method Client.ListAssistants.
type ListAssistantsResponse struct {
	// The response data for a requested list of items.
	AssistantsPage
}

// ListFilesResponse contains the response from method Client.ListFiles.
type ListFilesResponse struct {
	// The response data from a file list operation.
	FileListResponse
}

// ListMessagesResponse contains the response from method Client.ListMessages.
type ListMessagesResponse struct {
	// The response data for a requested list of items.
	ThreadMessagesPage
}

// ListRunStepsResponse contains the response from method Client.ListRunSteps.
type ListRunStepsResponse struct {
	// The response data for a requested list of items.
	ThreadRunStepsPage
}

// ListRunsResponse contains the response from method Client.ListRuns.
type ListRunsResponse struct {
	// The response data for a requested list of items.
	ThreadRunsPage
}

// ListVectorStoreFileBatchFilesResponse contains the response from method Client.ListVectorStoreFileBatchFiles.
type ListVectorStoreFileBatchFilesResponse struct {
	// The response data for a requested list of items.
	VectorStoreFileBatchesPage
}

// ListVectorStoreFilesResponse contains the response from method Client.ListVectorStoreFiles.
type ListVectorStoreFilesResponse struct {
	// The response data for a requested list of items.
	VectorStoreFilesPage
}

// ListVectorStoresResponse contains the response from method Client.ListVectorStores.
type ListVectorStoresResponse struct {
	// The response data for a requested list of items.
	VectorStoresPage
}

// ModifyVectorStoreResponse contains the response from method Client.ModifyVectorStore.
type ModifyVectorStoreResponse struct {
	// A vector store is a collection of processed files can be used by the `file_search` tool.
	VectorStore
}

// SubmitToolOutputsToRunResponse contains the response from method Client.SubmitToolOutputsToRun.
type SubmitToolOutputsToRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// UpdateAssistantResponse contains the response from method Client.UpdateAssistant.
type UpdateAssistantResponse struct {
	// Represents an assistant that can call the model and use tools.
	Assistant
}

// UpdateMessageResponse contains the response from method Client.UpdateMessage.
type UpdateMessageResponse struct {
	// A single, existing message within an assistant thread.
	ThreadMessage
}

// UpdateRunResponse contains the response from method Client.UpdateRun.
type UpdateRunResponse struct {
	// Data representing a single evaluation run of an assistant thread.
	ThreadRun
}

// UpdateThreadResponse contains the response from method Client.UpdateThread.
type UpdateThreadResponse struct {
	// Information about a single thread associated with an assistant.
	AssistantThread
}

// UploadFileResponse contains the response from method Client.UploadFile.
type UploadFileResponse struct {
	// Represents an assistant that can call the model and use tools.
	OpenAIFile
}
