//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.

package azsystemevents

const (
	TypeAVSClusterCreated                                             = "Microsoft.AVS.ClusterCreated"                                                         // maps to AVSClusterCreatedEventData
	TypeAVSClusterDeleted                                             = "Microsoft.AVS.ClusterDeleted"                                                         // maps to AVSClusterDeletedEventData
	TypeAVSClusterFailed                                              = "Microsoft.AVS.ClusterFailed"                                                          // maps to AVSClusterFailedEventData
	TypeAVSClusterUpdated                                             = "Microsoft.AVS.ClusterUpdated"                                                         // maps to AVSClusterUpdatedEventData
	TypeAVSClusterUpdating                                            = "Microsoft.AVS.ClusterUpdating"                                                        // maps to AVSClusterUpdatingEventData
	TypeAVSPrivateCloudFailed                                         = "Microsoft.AVS.PrivateCloudFailed"                                                     // maps to AVSPrivateCloudFailedEventData
	TypeAVSPrivateCloudUpdated                                        = "Microsoft.AVS.PrivateCloudUpdated"                                                    // maps to AVSPrivateCloudUpdatedEventData
	TypeAVSPrivateCloudUpdating                                       = "Microsoft.AVS.PrivateCloudUpdating"                                                   // maps to AVSPrivateCloudUpdatingEventData
	TypeAVSScriptExecutionCancelled                                   = "Microsoft.AVS.ScriptExecutionCancelled"                                               // maps to AVSScriptExecutionCancelledEventData
	TypeAVSScriptExecutionFailed                                      = "Microsoft.AVS.ScriptExecutionFailed"                                                  // maps to AVSScriptExecutionFailedEventData
	TypeAVSScriptExecutionFinished                                    = "Microsoft.AVS.ScriptExecutionFinished"                                                // maps to AVSScriptExecutionFinishedEventData
	TypeAVSScriptExecutionStarted                                     = "Microsoft.AVS.ScriptExecutionStarted"                                                 // maps to AVSScriptExecutionStartedEventData
	TypeAPICenterAPIDefinitionAdded                                   = "Microsoft.ApiCenter.ApiDefinitionAdded"                                               // maps to APICenterAPIDefinitionAddedEventData
	TypeAPICenterAPIDefinitionUpdated                                 = "Microsoft.ApiCenter.ApiDefinitionUpdated"                                             // maps to APICenterAPIDefinitionUpdatedEventData
	TypeAPIManagementAPICreated                                       = "Microsoft.ApiManagement.APICreated"                                                   // maps to APIManagementAPICreatedEventData
	TypeAPIManagementAPIDeleted                                       = "Microsoft.ApiManagement.APIDeleted"                                                   // maps to APIManagementAPIDeletedEventData
	TypeAPIManagementAPIReleaseCreated                                = "Microsoft.ApiManagement.APIReleaseCreated"                                            // maps to APIManagementAPIReleaseCreatedEventData
	TypeAPIManagementAPIReleaseDeleted                                = "Microsoft.ApiManagement.APIReleaseDeleted"                                            // maps to APIManagementAPIReleaseDeletedEventData
	TypeAPIManagementAPIReleaseUpdated                                = "Microsoft.ApiManagement.APIReleaseUpdated"                                            // maps to APIManagementAPIReleaseUpdatedEventData
	TypeAPIManagementAPIUpdated                                       = "Microsoft.ApiManagement.APIUpdated"                                                   // maps to APIManagementAPIUpdatedEventData
	TypeAPIManagementGatewayAPIAdded                                  = "Microsoft.ApiManagement.GatewayAPIAdded"                                              // maps to APIManagementGatewayAPIAddedEventData
	TypeAPIManagementGatewayAPIRemoved                                = "Microsoft.ApiManagement.GatewayAPIRemoved"                                            // maps to APIManagementGatewayAPIRemovedEventData
	TypeAPIManagementGatewayCertificateAuthorityCreated               = "Microsoft.ApiManagement.GatewayCertificateAuthorityCreated"                           // maps to APIManagementGatewayCertificateAuthorityCreatedEventData
	TypeAPIManagementGatewayCertificateAuthorityDeleted               = "Microsoft.ApiManagement.GatewayCertificateAuthorityDeleted"                           // maps to APIManagementGatewayCertificateAuthorityDeletedEventData
	TypeAPIManagementGatewayCertificateAuthorityUpdated               = "Microsoft.ApiManagement.GatewayCertificateAuthorityUpdated"                           // maps to APIManagementGatewayCertificateAuthorityUpdatedEventData
	TypeAPIManagementGatewayCreated                                   = "Microsoft.ApiManagement.GatewayCreated"                                               // maps to APIManagementGatewayCreatedEventData
	TypeAPIManagementGatewayDeleted                                   = "Microsoft.ApiManagement.GatewayDeleted"                                               // maps to APIManagementGatewayDeletedEventData
	TypeAPIManagementGatewayHostnameConfigurationCreated              = "Microsoft.ApiManagement.GatewayHostnameConfigurationCreated"                          // maps to APIManagementGatewayHostnameConfigurationCreatedEventData
	TypeAPIManagementGatewayHostnameConfigurationDeleted              = "Microsoft.ApiManagement.GatewayHostnameConfigurationDeleted"                          // maps to APIManagementGatewayHostnameConfigurationDeletedEventData
	TypeAPIManagementGatewayHostnameConfigurationUpdated              = "Microsoft.ApiManagement.GatewayHostnameConfigurationUpdated"                          // maps to APIManagementGatewayHostnameConfigurationUpdatedEventData
	TypeAPIManagementGatewayUpdated                                   = "Microsoft.ApiManagement.GatewayUpdated"                                               // maps to APIManagementGatewayUpdatedEventData
	TypeAPIManagementProductCreated                                   = "Microsoft.ApiManagement.ProductCreated"                                               // maps to APIManagementProductCreatedEventData
	TypeAPIManagementProductDeleted                                   = "Microsoft.ApiManagement.ProductDeleted"                                               // maps to APIManagementProductDeletedEventData
	TypeAPIManagementProductUpdated                                   = "Microsoft.ApiManagement.ProductUpdated"                                               // maps to APIManagementProductUpdatedEventData
	TypeAPIManagementSubscriptionCreated                              = "Microsoft.ApiManagement.SubscriptionCreated"                                          // maps to APIManagementSubscriptionCreatedEventData
	TypeAPIManagementSubscriptionDeleted                              = "Microsoft.ApiManagement.SubscriptionDeleted"                                          // maps to APIManagementSubscriptionDeletedEventData
	TypeAPIManagementSubscriptionUpdated                              = "Microsoft.ApiManagement.SubscriptionUpdated"                                          // maps to APIManagementSubscriptionUpdatedEventData
	TypeAPIManagementUserCreated                                      = "Microsoft.ApiManagement.UserCreated"                                                  // maps to APIManagementUserCreatedEventData
	TypeAPIManagementUserDeleted                                      = "Microsoft.ApiManagement.UserDeleted"                                                  // maps to APIManagementUserDeletedEventData
	TypeAPIManagementUserUpdated                                      = "Microsoft.ApiManagement.UserUpdated"                                                  // maps to APIManagementUserUpdatedEventData
	TypeAppConfigurationKeyValueDeleted                               = "Microsoft.AppConfiguration.KeyValueDeleted"                                           // maps to AppConfigurationKeyValueDeletedEventData
	TypeAppConfigurationKeyValueModified                              = "Microsoft.AppConfiguration.KeyValueModified"                                          // maps to AppConfigurationKeyValueModifiedEventData
	TypeAppConfigurationSnapshotCreated                               = "Microsoft.AppConfiguration.SnapshotCreated"                                           // maps to AppConfigurationSnapshotCreatedEventData
	TypeAppConfigurationSnapshotModified                              = "Microsoft.AppConfiguration.SnapshotModified"                                          // maps to AppConfigurationSnapshotModifiedEventData
	TypeRedisExportRDBCompleted                                       = "Microsoft.Cache.ExportRDBCompleted"                                                   // maps to RedisExportRDBCompletedEventData
	TypeRedisImportRDBCompleted                                       = "Microsoft.Cache.ImportRDBCompleted"                                                   // maps to RedisImportRDBCompletedEventData
	TypeRedisPatchingCompleted                                        = "Microsoft.Cache.PatchingCompleted"                                                    // maps to RedisPatchingCompletedEventData
	TypeRedisScalingCompleted                                         = "Microsoft.Cache.ScalingCompleted"                                                     // maps to RedisScalingCompletedEventData
	TypeACSMessageDeliveryStatusUpdated                               = "Microsoft.Communication.AdvancedMessageDeliveryStatusUpdated"                         // maps to ACSMessageDeliveryStatusUpdatedEventData
	TypeACSMessageReceived                                            = "Microsoft.Communication.AdvancedMessageReceived"                                      // maps to ACSMessageReceivedEventData
	TypeACSChatMessageDeleted                                         = "Microsoft.Communication.ChatMessageDeleted"                                           // maps to ACSChatMessageDeletedEventData
	TypeACSChatMessageDeletedInThread                                 = "Microsoft.Communication.ChatMessageDeletedInThread"                                   // maps to ACSChatMessageDeletedInThreadEventData
	TypeACSChatMessageEdited                                          = "Microsoft.Communication.ChatMessageEdited"                                            // maps to ACSChatMessageEditedEventData
	TypeACSChatMessageEditedInThread                                  = "Microsoft.Communication.ChatMessageEditedInThread"                                    // maps to ACSChatMessageEditedInThreadEventData
	TypeACSChatMessageReceived                                        = "Microsoft.Communication.ChatMessageReceived"                                          // maps to ACSChatMessageReceivedEventData
	TypeACSChatMessageReceivedInThread                                = "Microsoft.Communication.ChatMessageReceivedInThread"                                  // maps to ACSChatMessageReceivedInThreadEventData
	TypeACSChatParticipantAddedToThreadWithUser                       = "Microsoft.Communication.ChatParticipantAddedToThreadWithUser"                         // maps to ACSChatParticipantAddedToThreadWithUserEventData
	TypeACSChatParticipantRemovedFromThreadWithUser                   = "Microsoft.Communication.ChatParticipantRemovedFromThreadWithUser"                     // maps to ACSChatParticipantRemovedFromThreadWithUserEventData
	TypeACSChatThreadCreated                                          = "Microsoft.Communication.ChatThreadCreated"                                            // maps to ACSChatThreadCreatedEventData
	TypeACSChatThreadCreatedWithUser                                  = "Microsoft.Communication.ChatThreadCreatedWithUser"                                    // maps to ACSChatThreadCreatedWithUserEventData
	TypeACSChatThreadDeleted                                          = "Microsoft.Communication.ChatThreadDeleted"                                            // maps to ACSChatThreadDeletedEventData
	TypeACSChatParticipantAddedToThread                               = "Microsoft.Communication.ChatThreadParticipantAdded"                                   // maps to ACSChatParticipantAddedToThreadEventData
	TypeACSChatParticipantRemovedFromThread                           = "Microsoft.Communication.ChatThreadParticipantRemoved"                                 // maps to ACSChatParticipantRemovedFromThreadEventData
	TypeACSChatThreadPropertiesUpdated                                = "Microsoft.Communication.ChatThreadPropertiesUpdated"                                  // maps to ACSChatThreadPropertiesUpdatedEventData
	TypeACSChatThreadPropertiesUpdatedPerUser                         = "Microsoft.Communication.ChatThreadPropertiesUpdatedPerUser"                           // maps to ACSChatThreadPropertiesUpdatedPerUserEventData
	TypeACSChatThreadWithUserDeleted                                  = "Microsoft.Communication.ChatThreadWithUserDeleted"                                    // maps to ACSChatThreadWithUserDeletedEventData
	TypeACSEmailDeliveryReportReceived                                = "Microsoft.Communication.EmailDeliveryReportReceived"                                  // maps to ACSEmailDeliveryReportReceivedEventData
	TypeACSEmailEngagementTrackingReportReceived                      = "Microsoft.Communication.EmailEngagementTrackingReportReceived"                        // maps to ACSEmailEngagementTrackingReportReceivedEventData
	TypeACSIncomingCall                                               = "Microsoft.Communication.IncomingCall"                                                 // maps to ACSIncomingCallEventData
	TypeACSRecordingFileStatusUpdated                                 = "Microsoft.Communication.RecordingFileStatusUpdated"                                   // maps to ACSRecordingFileStatusUpdatedEventData
	TypeACSRouterJobCancelled                                         = "Microsoft.Communication.RouterJobCancelled"                                           // maps to ACSRouterJobCancelledEventData
	TypeACSRouterJobClassificationFailed                              = "Microsoft.Communication.RouterJobClassificationFailed"                                // maps to ACSRouterJobClassificationFailedEventData
	TypeACSRouterJobClassified                                        = "Microsoft.Communication.RouterJobClassified"                                          // maps to ACSRouterJobClassifiedEventData
	TypeACSRouterJobClosed                                            = "Microsoft.Communication.RouterJobClosed"                                              // maps to ACSRouterJobClosedEventData
	TypeACSRouterJobCompleted                                         = "Microsoft.Communication.RouterJobCompleted"                                           // maps to ACSRouterJobCompletedEventData
	TypeACSRouterJobDeleted                                           = "Microsoft.Communication.RouterJobDeleted"                                             // maps to ACSRouterJobDeletedEventData
	TypeACSRouterJobExceptionTriggered                                = "Microsoft.Communication.RouterJobExceptionTriggered"                                  // maps to ACSRouterJobExceptionTriggeredEventData
	TypeACSRouterJobQueued                                            = "Microsoft.Communication.RouterJobQueued"                                              // maps to ACSRouterJobQueuedEventData
	TypeACSRouterJobReceived                                          = "Microsoft.Communication.RouterJobReceived"                                            // maps to ACSRouterJobReceivedEventData
	TypeACSRouterJobSchedulingFailed                                  = "Microsoft.Communication.RouterJobSchedulingFailed"                                    // maps to ACSRouterJobSchedulingFailedEventData
	TypeACSRouterJobUnassigned                                        = "Microsoft.Communication.RouterJobUnassigned"                                          // maps to ACSRouterJobUnassignedEventData
	TypeACSRouterJobWaitingForActivation                              = "Microsoft.Communication.RouterJobWaitingForActivation"                                // maps to ACSRouterJobWaitingForActivationEventData
	TypeACSRouterJobWorkerSelectorsExpired                            = "Microsoft.Communication.RouterJobWorkerSelectorsExpired"                              // maps to ACSRouterJobWorkerSelectorsExpiredEventData
	TypeACSRouterWorkerDeleted                                        = "Microsoft.Communication.RouterWorkerDeleted"                                          // maps to ACSRouterWorkerDeletedEventData
	TypeACSRouterWorkerDeregistered                                   = "Microsoft.Communication.RouterWorkerDeregistered"                                     // maps to ACSRouterWorkerDeregisteredEventData
	TypeACSRouterWorkerOfferAccepted                                  = "Microsoft.Communication.RouterWorkerOfferAccepted"                                    // maps to ACSRouterWorkerOfferAcceptedEventData
	TypeACSRouterWorkerOfferDeclined                                  = "Microsoft.Communication.RouterWorkerOfferDeclined"                                    // maps to ACSRouterWorkerOfferDeclinedEventData
	TypeACSRouterWorkerOfferExpired                                   = "Microsoft.Communication.RouterWorkerOfferExpired"                                     // maps to ACSRouterWorkerOfferExpiredEventData
	TypeACSRouterWorkerOfferIssued                                    = "Microsoft.Communication.RouterWorkerOfferIssued"                                      // maps to ACSRouterWorkerOfferIssuedEventData
	TypeACSRouterWorkerOfferRevoked                                   = "Microsoft.Communication.RouterWorkerOfferRevoked"                                     // maps to ACSRouterWorkerOfferRevokedEventData
	TypeACSRouterWorkerRegistered                                     = "Microsoft.Communication.RouterWorkerRegistered"                                       // maps to ACSRouterWorkerRegisteredEventData
	TypeACSRouterWorkerUpdated                                        = "Microsoft.Communication.RouterWorkerUpdated"                                          // maps to ACSRouterWorkerUpdatedEventData
	TypeACSSMSDeliveryReportReceived                                  = "Microsoft.Communication.SMSDeliveryReportReceived"                                    // maps to ACSSMSDeliveryReportReceivedEventData
	TypeACSSMSReceived                                                = "Microsoft.Communication.SMSReceived"                                                  // maps to ACSSMSReceivedEventData
	TypeACSUserDisconnected                                           = "Microsoft.Communication.UserDisconnected"                                             // maps to ACSUserDisconnectedEventData
	TypeContainerRegistryChartDeleted                                 = "Microsoft.ContainerRegistry.ChartDeleted"                                             // maps to ContainerRegistryChartDeletedEventData
	TypeContainerRegistryChartPushed                                  = "Microsoft.ContainerRegistry.ChartPushed"                                              // maps to ContainerRegistryChartPushedEventData
	TypeContainerRegistryImageDeleted                                 = "Microsoft.ContainerRegistry.ImageDeleted"                                             // maps to ContainerRegistryImageDeletedEventData
	TypeContainerRegistryImagePushed                                  = "Microsoft.ContainerRegistry.ImagePushed"                                              // maps to ContainerRegistryImagePushedEventData
	TypeContainerServiceClusterSupportEnded                           = "Microsoft.ContainerService.ClusterSupportEnded"                                       // maps to ContainerServiceClusterSupportEndedEventData
	TypeContainerServiceClusterSupportEnding                          = "Microsoft.ContainerService.ClusterSupportEnding"                                      // maps to ContainerServiceClusterSupportEndingEventData
	TypeContainerServiceNewKubernetesVersionAvailable                 = "Microsoft.ContainerService.NewKubernetesVersionAvailable"                             // maps to ContainerServiceNewKubernetesVersionAvailableEventData
	TypeContainerServiceNodePoolRollingFailed                         = "Microsoft.ContainerService.NodePoolRollingFailed"                                     // maps to ContainerServiceNodePoolRollingFailedEventData
	TypeContainerServiceNodePoolRollingStarted                        = "Microsoft.ContainerService.NodePoolRollingStarted"                                    // maps to ContainerServiceNodePoolRollingStartedEventData
	TypeContainerServiceNodePoolRollingSucceeded                      = "Microsoft.ContainerService.NodePoolRollingSucceeded"                                  // maps to ContainerServiceNodePoolRollingSucceededEventData
	TypeDataBoxCopyCompleted                                          = "Microsoft.DataBox.CopyCompleted"                                                      // maps to DataBoxCopyCompletedEventData
	TypeDataBoxCopyStarted                                            = "Microsoft.DataBox.CopyStarted"                                                        // maps to DataBoxCopyStartedEventData
	TypeDataBoxOrderCompleted                                         = "Microsoft.DataBox.OrderCompleted"                                                     // maps to DataBoxOrderCompletedEventData
	TypeIOTHubDeviceConnected                                         = "Microsoft.Devices.DeviceConnected"                                                    // maps to IOTHubDeviceConnectedEventData
	TypeIOTHubDeviceCreated                                           = "Microsoft.Devices.DeviceCreated"                                                      // maps to IOTHubDeviceCreatedEventData
	TypeIOTHubDeviceDeleted                                           = "Microsoft.Devices.DeviceDeleted"                                                      // maps to IOTHubDeviceDeletedEventData
	TypeIOTHubDeviceDisconnected                                      = "Microsoft.Devices.DeviceDisconnected"                                                 // maps to IOTHubDeviceDisconnectedEventData
	TypeIOTHubDeviceTelemetry                                         = "Microsoft.Devices.DeviceTelemetry"                                                    // maps to IOTHubDeviceTelemetryEventData
	TypeEventGridMQTTClientCreatedOrUpdated                           = "Microsoft.EventGrid.MQTTClientCreatedOrUpdated"                                       // maps to EventGridMQTTClientCreatedOrUpdatedEventData
	TypeEventGridMQTTClientDeleted                                    = "Microsoft.EventGrid.MQTTClientDeleted"                                                // maps to EventGridMQTTClientDeletedEventData
	TypeEventGridMQTTClientSessionConnected                           = "Microsoft.EventGrid.MQTTClientSessionConnected"                                       // maps to EventGridMQTTClientSessionConnectedEventData
	TypeEventGridMQTTClientSessionDisconnected                        = "Microsoft.EventGrid.MQTTClientSessionDisconnected"                                    // maps to EventGridMQTTClientSessionDisconnectedEventData
	TypeSubscriptionDeleted                                           = "Microsoft.EventGrid.SubscriptionDeletedEvent"                                         // maps to SubscriptionDeletedEventData
	TypeSubscriptionValidation                                        = "Microsoft.EventGrid.SubscriptionValidationEvent"                                      // maps to SubscriptionValidationEventData
	TypeEventHubCaptureFileCreated                                    = "Microsoft.EventHub.CaptureFileCreated"                                                // maps to EventHubCaptureFileCreatedEventData
	TypeHealthcareDicomImageCreated                                   = "Microsoft.HealthcareApis.DicomImageCreated"                                           // maps to HealthcareDicomImageCreatedEventData
	TypeHealthcareDicomImageDeleted                                   = "Microsoft.HealthcareApis.DicomImageDeleted"                                           // maps to HealthcareDicomImageDeletedEventData
	TypeHealthcareDicomImageUpdated                                   = "Microsoft.HealthcareApis.DicomImageUpdated"                                           // maps to HealthcareDicomImageUpdatedEventData
	TypeHealthcareFHIRResourceCreated                                 = "Microsoft.HealthcareApis.FhirResourceCreated"                                         // maps to HealthcareFHIRResourceCreatedEventData
	TypeHealthcareFHIRResourceDeleted                                 = "Microsoft.HealthcareApis.FhirResourceDeleted"                                         // maps to HealthcareFHIRResourceDeletedEventData
	TypeHealthcareFHIRResourceUpdated                                 = "Microsoft.HealthcareApis.FhirResourceUpdated"                                         // maps to HealthcareFHIRResourceUpdatedEventData
	TypeKeyVaultCertificateExpired                                    = "Microsoft.KeyVault.CertificateExpired"                                                // maps to KeyVaultCertificateExpiredEventData
	TypeKeyVaultCertificateNearExpiry                                 = "Microsoft.KeyVault.CertificateNearExpiry"                                             // maps to KeyVaultCertificateNearExpiryEventData
	TypeKeyVaultCertificateNewVersionCreated                          = "Microsoft.KeyVault.CertificateNewVersionCreated"                                      // maps to KeyVaultCertificateNewVersionCreatedEventData
	TypeKeyVaultKeyExpired                                            = "Microsoft.KeyVault.KeyExpired"                                                        // maps to KeyVaultKeyExpiredEventData
	TypeKeyVaultKeyNearExpiry                                         = "Microsoft.KeyVault.KeyNearExpiry"                                                     // maps to KeyVaultKeyNearExpiryEventData
	TypeKeyVaultKeyNewVersionCreated                                  = "Microsoft.KeyVault.KeyNewVersionCreated"                                              // maps to KeyVaultKeyNewVersionCreatedEventData
	TypeKeyVaultSecretExpired                                         = "Microsoft.KeyVault.SecretExpired"                                                     // maps to KeyVaultSecretExpiredEventData
	TypeKeyVaultSecretNearExpiry                                      = "Microsoft.KeyVault.SecretNearExpiry"                                                  // maps to KeyVaultSecretNearExpiryEventData
	TypeKeyVaultSecretNewVersionCreated                               = "Microsoft.KeyVault.SecretNewVersionCreated"                                           // maps to KeyVaultSecretNewVersionCreatedEventData
	TypeKeyVaultAccessPolicyChanged                                   = "Microsoft.KeyVault.VaultAccessPolicyChanged"                                          // maps to KeyVaultAccessPolicyChangedEventData
	TypeMachineLearningServicesDatasetDriftDetected                   = "Microsoft.MachineLearningServices.DatasetDriftDetected"                               // maps to MachineLearningServicesDatasetDriftDetectedEventData
	TypeMachineLearningServicesModelDeployed                          = "Microsoft.MachineLearningServices.ModelDeployed"                                      // maps to MachineLearningServicesModelDeployedEventData
	TypeMachineLearningServicesModelRegistered                        = "Microsoft.MachineLearningServices.ModelRegistered"                                    // maps to MachineLearningServicesModelRegisteredEventData
	TypeMachineLearningServicesRunCompleted                           = "Microsoft.MachineLearningServices.RunCompleted"                                       // maps to MachineLearningServicesRunCompletedEventData
	TypeMachineLearningServicesRunStatusChanged                       = "Microsoft.MachineLearningServices.RunStatusChanged"                                   // maps to MachineLearningServicesRunStatusChangedEventData
	TypeMapsGeofenceEntered                                           = "Microsoft.Maps.GeofenceEntered"                                                       // maps to MapsGeofenceEnteredEventData
	TypeMapsGeofenceExited                                            = "Microsoft.Maps.GeofenceExited"                                                        // maps to MapsGeofenceExitedEventData
	TypeMapsGeofenceResult                                            = "Microsoft.Maps.GeofenceResult"                                                        // maps to MapsGeofenceResultEventData
	TypePolicyInsightsPolicyStateChanged                              = "Microsoft.PolicyInsights.PolicyStateChanged"                                          // maps to PolicyInsightsPolicyStateChangedEventData
	TypePolicyInsightsPolicyStateCreated                              = "Microsoft.PolicyInsights.PolicyStateCreated"                                          // maps to PolicyInsightsPolicyStateCreatedEventData
	TypePolicyInsightsPolicyStateDeleted                              = "Microsoft.PolicyInsights.PolicyStateDeleted"                                          // maps to PolicyInsightsPolicyStateDeletedEventData
	TypeResourceNotificationsContainerServiceEventResourcesScheduled  = "Microsoft.ResourceNotifications.ContainerServiceEventResources.ScheduledEventEmitted" // maps to ResourceNotificationsContainerServiceEventResourcesScheduledEventData
	TypeResourceNotificationsHealthResourcesAvailabilityStatusChanged = "Microsoft.ResourceNotifications.HealthResources.AvailabilityStatusChanged"            // maps to ResourceNotificationsHealthResourcesAvailabilityStatusChangedEventData
	TypeResourceNotificationsHealthResourcesAnnotated                 = "Microsoft.ResourceNotifications.HealthResources.ResourceAnnotated"                    // maps to ResourceNotificationsHealthResourcesAnnotatedEventData
	TypeResourceNotificationsResourceManagementCreatedOrUpdated       = "Microsoft.ResourceNotifications.Resources.CreatedOrUpdated"                           // maps to ResourceNotificationsResourceManagementCreatedOrUpdatedEventData
	TypeResourceNotificationsResourceManagementDeleted                = "Microsoft.ResourceNotifications.Resources.Deleted"                                    // maps to ResourceNotificationsResourceManagementDeletedEventData
	TypeResourceActionCancel                                          = "Microsoft.Resources.ResourceActionCancel"                                             // maps to ResourceActionCancelEventData
	TypeResourceActionFailure                                         = "Microsoft.Resources.ResourceActionFailure"                                            // maps to ResourceActionFailureEventData
	TypeResourceActionSuccess                                         = "Microsoft.Resources.ResourceActionSuccess"                                            // maps to ResourceActionSuccessEventData
	TypeResourceDeleteCancel                                          = "Microsoft.Resources.ResourceDeleteCancel"                                             // maps to ResourceDeleteCancelEventData
	TypeResourceDeleteFailure                                         = "Microsoft.Resources.ResourceDeleteFailure"                                            // maps to ResourceDeleteFailureEventData
	TypeResourceDeleteSuccess                                         = "Microsoft.Resources.ResourceDeleteSuccess"                                            // maps to ResourceDeleteSuccessEventData
	TypeResourceWriteCancel                                           = "Microsoft.Resources.ResourceWriteCancel"                                              // maps to ResourceWriteCancelEventData
	TypeResourceWriteFailure                                          = "Microsoft.Resources.ResourceWriteFailure"                                             // maps to ResourceWriteFailureEventData
	TypeResourceWriteSuccess                                          = "Microsoft.Resources.ResourceWriteSuccess"                                             // maps to ResourceWriteSuccessEventData
	TypeServiceBusActiveMessagesAvailablePeriodicNotifications        = "Microsoft.ServiceBus.ActiveMessagesAvailablePeriodicNotifications"                    // maps to ServiceBusActiveMessagesAvailablePeriodicNotificationsEventData
	TypeServiceBusActiveMessagesAvailableWithNoListeners              = "Microsoft.ServiceBus.ActiveMessagesAvailableWithNoListeners"                          // maps to ServiceBusActiveMessagesAvailableWithNoListenersEventData
	TypeServiceBusDeadletterMessagesAvailablePeriodicNotifications    = "Microsoft.ServiceBus.DeadletterMessagesAvailablePeriodicNotifications"                // maps to ServiceBusDeadletterMessagesAvailablePeriodicNotificationsEventData
	TypeServiceBusDeadletterMessagesAvailableWithNoListeners          = "Microsoft.ServiceBus.DeadletterMessagesAvailableWithNoListeners"                      // maps to ServiceBusDeadletterMessagesAvailableWithNoListenersEventData
	TypeSignalRServiceClientConnectionConnected                       = "Microsoft.SignalRService.ClientConnectionConnected"                                   // maps to SignalRServiceClientConnectionConnectedEventData
	TypeSignalRServiceClientConnectionDisconnected                    = "Microsoft.SignalRService.ClientConnectionDisconnected"                                // maps to SignalRServiceClientConnectionDisconnectedEventData
	TypeStorageAsyncOperationInitiated                                = "Microsoft.Storage.AsyncOperationInitiated"                                            // maps to StorageAsyncOperationInitiatedEventData
	TypeStorageBlobCreated                                            = "Microsoft.Storage.BlobCreated"                                                        // maps to StorageBlobCreatedEventData
	TypeStorageBlobDeleted                                            = "Microsoft.Storage.BlobDeleted"                                                        // maps to StorageBlobDeletedEventData
	TypeStorageBlobInventoryPolicyCompleted                           = "Microsoft.Storage.BlobInventoryPolicyCompleted"                                       // maps to StorageBlobInventoryPolicyCompletedEventData
	TypeStorageBlobRenamed                                            = "Microsoft.Storage.BlobRenamed"                                                        // maps to StorageBlobRenamedEventData
	TypeStorageBlobTierChanged                                        = "Microsoft.Storage.BlobTierChanged"                                                    // maps to StorageBlobTierChangedEventData
	TypeStorageDirectoryCreated                                       = "Microsoft.Storage.DirectoryCreated"                                                   // maps to StorageDirectoryCreatedEventData
	TypeStorageDirectoryDeleted                                       = "Microsoft.Storage.DirectoryDeleted"                                                   // maps to StorageDirectoryDeletedEventData
	TypeStorageDirectoryRenamed                                       = "Microsoft.Storage.DirectoryRenamed"                                                   // maps to StorageDirectoryRenamedEventData
	TypeStorageLifecyclePolicyCompleted                               = "Microsoft.Storage.LifecyclePolicyCompleted"                                           // maps to StorageLifecyclePolicyCompletedEventData
	TypeStorageTaskAssignmentCompleted                                = "Microsoft.Storage.StorageTaskAssignmentCompleted"                                     // maps to StorageTaskAssignmentCompletedEventData
	TypeStorageTaskAssignmentQueued                                   = "Microsoft.Storage.StorageTaskAssignmentQueued"                                        // maps to StorageTaskAssignmentQueuedEventData
	TypeStorageTaskCompleted                                          = "Microsoft.Storage.StorageTaskCompleted"                                               // maps to StorageTaskCompletedEventData
	TypeStorageTaskQueued                                             = "Microsoft.Storage.StorageTaskQueued"                                                  // maps to StorageTaskQueuedEventData
	TypeWebAppServicePlanUpdated                                      = "Microsoft.Web.AppServicePlanUpdated"                                                  // maps to WebAppServicePlanUpdatedEventData
	TypeWebAppUpdated                                                 = "Microsoft.Web.AppUpdated"                                                             // maps to WebAppUpdatedEventData
	TypeWebBackupOperationCompleted                                   = "Microsoft.Web.BackupOperationCompleted"                                               // maps to WebBackupOperationCompletedEventData
	TypeWebBackupOperationFailed                                      = "Microsoft.Web.BackupOperationFailed"                                                  // maps to WebBackupOperationFailedEventData
	TypeWebBackupOperationStarted                                     = "Microsoft.Web.BackupOperationStarted"                                                 // maps to WebBackupOperationStartedEventData
	TypeWebRestoreOperationCompleted                                  = "Microsoft.Web.RestoreOperationCompleted"                                              // maps to WebRestoreOperationCompletedEventData
	TypeWebRestoreOperationFailed                                     = "Microsoft.Web.RestoreOperationFailed"                                                 // maps to WebRestoreOperationFailedEventData
	TypeWebRestoreOperationStarted                                    = "Microsoft.Web.RestoreOperationStarted"                                                // maps to WebRestoreOperationStartedEventData
	TypeWebSlotSwapCompleted                                          = "Microsoft.Web.SlotSwapCompleted"                                                      // maps to WebSlotSwapCompletedEventData
	TypeWebSlotSwapFailed                                             = "Microsoft.Web.SlotSwapFailed"                                                         // maps to WebSlotSwapFailedEventData
	TypeWebSlotSwapStarted                                            = "Microsoft.Web.SlotSwapStarted"                                                        // maps to WebSlotSwapStartedEventData
	TypeWebSlotSwapWithPreviewCancelled                               = "Microsoft.Web.SlotSwapWithPreviewCancelled"                                           // maps to WebSlotSwapWithPreviewCancelledEventData
	TypeWebSlotSwapWithPreviewStarted                                 = "Microsoft.Web.SlotSwapWithPreviewStarted"                                             // maps to WebSlotSwapWithPreviewStartedEventData
)
