//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armadvisor

// ConfigurationsClientCreateInResourceGroupResponse contains the response from method ConfigurationsClient.CreateInResourceGroup.
type ConfigurationsClientCreateInResourceGroupResponse struct {
	// The Advisor configuration data structure.
	ConfigData
}

// ConfigurationsClientCreateInSubscriptionResponse contains the response from method ConfigurationsClient.CreateInSubscription.
type ConfigurationsClientCreateInSubscriptionResponse struct {
	// The Advisor configuration data structure.
	ConfigData
}

// ConfigurationsClientListByResourceGroupResponse contains the response from method ConfigurationsClient.NewListByResourceGroupPager.
type ConfigurationsClientListByResourceGroupResponse struct {
	// The list of Advisor configurations.
	ConfigurationListResult
}

// ConfigurationsClientListBySubscriptionResponse contains the response from method ConfigurationsClient.NewListBySubscriptionPager.
type ConfigurationsClientListBySubscriptionResponse struct {
	// The list of Advisor configurations.
	ConfigurationListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// The list of Advisor operations.
	OperationEntityListResult
}

// RecommendationMetadataClientGetResponse contains the response from method RecommendationMetadataClient.Get.
type RecommendationMetadataClientGetResponse struct {
	// The metadata entity contract.
	MetadataEntity
}

// RecommendationMetadataClientListResponse contains the response from method RecommendationMetadataClient.NewListPager.
type RecommendationMetadataClientListResponse struct {
	// The list of metadata entities
	MetadataEntityListResult
}

// RecommendationsClientGenerateResponse contains the response from method RecommendationsClient.Generate.
type RecommendationsClientGenerateResponse struct {
	// Location contains the information returned from the Location header response.
	Location *string

	// RetryAfter contains the information returned from the Retry-After header response.
	RetryAfter *string
}

// RecommendationsClientGetGenerateStatusResponse contains the response from method RecommendationsClient.GetGenerateStatus.
type RecommendationsClientGetGenerateStatusResponse struct {
	// placeholder for future response values
}

// RecommendationsClientGetResponse contains the response from method RecommendationsClient.Get.
type RecommendationsClientGetResponse struct {
	// Advisor Recommendation.
	ResourceRecommendationBase
}

// RecommendationsClientListResponse contains the response from method RecommendationsClient.NewListPager.
type RecommendationsClientListResponse struct {
	// The list of Advisor recommendations.
	ResourceRecommendationBaseListResult
}

// SuppressionsClientCreateResponse contains the response from method SuppressionsClient.Create.
type SuppressionsClientCreateResponse struct {
	// The details of the snoozed or dismissed rule; for example, the duration, name, and GUID associated with the rule.
	SuppressionContract
}

// SuppressionsClientDeleteResponse contains the response from method SuppressionsClient.Delete.
type SuppressionsClientDeleteResponse struct {
	// placeholder for future response values
}

// SuppressionsClientGetResponse contains the response from method SuppressionsClient.Get.
type SuppressionsClientGetResponse struct {
	// The details of the snoozed or dismissed rule; for example, the duration, name, and GUID associated with the rule.
	SuppressionContract
}

// SuppressionsClientListResponse contains the response from method SuppressionsClient.NewListPager.
type SuppressionsClientListResponse struct {
	// The list of Advisor suppressions.
	SuppressionContractListResult
}
