//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armappconfiguration

// ConfigurationStoresClientCreateResponse contains the response from method ConfigurationStoresClient.BeginCreate.
type ConfigurationStoresClientCreateResponse struct {
	// The configuration store along with all resource properties. The Configuration Store will have all information to begin
	// utilizing it.
	ConfigurationStore
}

// ConfigurationStoresClientDeleteResponse contains the response from method ConfigurationStoresClient.BeginDelete.
type ConfigurationStoresClientDeleteResponse struct {
	// placeholder for future response values
}

// ConfigurationStoresClientGetDeletedResponse contains the response from method ConfigurationStoresClient.GetDeleted.
type ConfigurationStoresClientGetDeletedResponse struct {
	// Deleted configuration store information with extended details.
	DeletedConfigurationStore
}

// ConfigurationStoresClientGetResponse contains the response from method ConfigurationStoresClient.Get.
type ConfigurationStoresClientGetResponse struct {
	// The configuration store along with all resource properties. The Configuration Store will have all information to begin
	// utilizing it.
	ConfigurationStore
}

// ConfigurationStoresClientListByResourceGroupResponse contains the response from method ConfigurationStoresClient.NewListByResourceGroupPager.
type ConfigurationStoresClientListByResourceGroupResponse struct {
	// The result of a request to list configuration stores.
	ConfigurationStoreListResult
}

// ConfigurationStoresClientListDeletedResponse contains the response from method ConfigurationStoresClient.NewListDeletedPager.
type ConfigurationStoresClientListDeletedResponse struct {
	// List of deleted configuration stores
	DeletedConfigurationStoreListResult
}

// ConfigurationStoresClientListKeysResponse contains the response from method ConfigurationStoresClient.NewListKeysPager.
type ConfigurationStoresClientListKeysResponse struct {
	// The result of a request to list API keys.
	APIKeyListResult
}

// ConfigurationStoresClientListResponse contains the response from method ConfigurationStoresClient.NewListPager.
type ConfigurationStoresClientListResponse struct {
	// The result of a request to list configuration stores.
	ConfigurationStoreListResult
}

// ConfigurationStoresClientPurgeDeletedResponse contains the response from method ConfigurationStoresClient.BeginPurgeDeleted.
type ConfigurationStoresClientPurgeDeletedResponse struct {
	// placeholder for future response values
}

// ConfigurationStoresClientRegenerateKeyResponse contains the response from method ConfigurationStoresClient.RegenerateKey.
type ConfigurationStoresClientRegenerateKeyResponse struct {
	// An API key used for authenticating with a configuration store endpoint.
	APIKey
}

// ConfigurationStoresClientUpdateResponse contains the response from method ConfigurationStoresClient.BeginUpdate.
type ConfigurationStoresClientUpdateResponse struct {
	// The configuration store along with all resource properties. The Configuration Store will have all information to begin
	// utilizing it.
	ConfigurationStore
}

// KeyValuesClientCreateOrUpdateResponse contains the response from method KeyValuesClient.CreateOrUpdate.
type KeyValuesClientCreateOrUpdateResponse struct {
	// The key-value resource along with all resource properties.
	KeyValue
}

// KeyValuesClientDeleteResponse contains the response from method KeyValuesClient.BeginDelete.
type KeyValuesClientDeleteResponse struct {
	// placeholder for future response values
}

// KeyValuesClientGetResponse contains the response from method KeyValuesClient.Get.
type KeyValuesClientGetResponse struct {
	// The key-value resource along with all resource properties.
	KeyValue
}

// OperationsClientCheckNameAvailabilityResponse contains the response from method OperationsClient.CheckNameAvailability.
type OperationsClientCheckNameAvailabilityResponse struct {
	// The result of a request to check the availability of a resource name.
	NameAvailabilityStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// The result of a request to list configuration store operations.
	OperationDefinitionListResult
}

// OperationsClientRegionalCheckNameAvailabilityResponse contains the response from method OperationsClient.RegionalCheckNameAvailability.
type OperationsClientRegionalCheckNameAvailabilityResponse struct {
	// The result of a request to check the availability of a resource name.
	NameAvailabilityStatus
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// A private endpoint connection
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// A private endpoint connection
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByConfigurationStoreResponse contains the response from method PrivateEndpointConnectionsClient.NewListByConfigurationStorePager.
type PrivateEndpointConnectionsClientListByConfigurationStoreResponse struct {
	// A list of private endpoint connections
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A resource that supports private link capabilities.
	PrivateLinkResource
}

// PrivateLinkResourcesClientListByConfigurationStoreResponse contains the response from method PrivateLinkResourcesClient.NewListByConfigurationStorePager.
type PrivateLinkResourcesClientListByConfigurationStoreResponse struct {
	// A list of private link resources.
	PrivateLinkResourceListResult
}

// ReplicasClientCreateResponse contains the response from method ReplicasClient.BeginCreate.
type ReplicasClientCreateResponse struct {
	// The replica resource.
	Replica
}

// ReplicasClientDeleteResponse contains the response from method ReplicasClient.BeginDelete.
type ReplicasClientDeleteResponse struct {
	// placeholder for future response values
}

// ReplicasClientGetResponse contains the response from method ReplicasClient.Get.
type ReplicasClientGetResponse struct {
	// The replica resource.
	Replica
}

// ReplicasClientListByConfigurationStoreResponse contains the response from method ReplicasClient.NewListByConfigurationStorePager.
type ReplicasClientListByConfigurationStoreResponse struct {
	// The result of a request to list replicas.
	ReplicaListResult
}

// SnapshotsClientCreateResponse contains the response from method SnapshotsClient.BeginCreate.
type SnapshotsClientCreateResponse struct {
	// The snapshot resource.
	Snapshot
}

// SnapshotsClientGetResponse contains the response from method SnapshotsClient.Get.
type SnapshotsClientGetResponse struct {
	// The snapshot resource.
	Snapshot
}
