//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armappplatform

// APIPortalCustomDomainsClientCreateOrUpdateResponse contains the response from method APIPortalCustomDomainsClient.BeginCreateOrUpdate.
type APIPortalCustomDomainsClientCreateOrUpdateResponse struct {
	// Custom domain of the API portal
	APIPortalCustomDomainResource
}

// APIPortalCustomDomainsClientDeleteResponse contains the response from method APIPortalCustomDomainsClient.BeginDelete.
type APIPortalCustomDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// APIPortalCustomDomainsClientGetResponse contains the response from method APIPortalCustomDomainsClient.Get.
type APIPortalCustomDomainsClientGetResponse struct {
	// Custom domain of the API portal
	APIPortalCustomDomainResource
}

// APIPortalCustomDomainsClientListResponse contains the response from method APIPortalCustomDomainsClient.NewListPager.
type APIPortalCustomDomainsClientListResponse struct {
	// Object that includes an array of API portal custom domain resources and a possible link for next set
	APIPortalCustomDomainResourceCollection
}

// APIPortalsClientCreateOrUpdateResponse contains the response from method APIPortalsClient.BeginCreateOrUpdate.
type APIPortalsClientCreateOrUpdateResponse struct {
	// API portal resource
	APIPortalResource
}

// APIPortalsClientDeleteResponse contains the response from method APIPortalsClient.BeginDelete.
type APIPortalsClientDeleteResponse struct {
	// placeholder for future response values
}

// APIPortalsClientGetResponse contains the response from method APIPortalsClient.Get.
type APIPortalsClientGetResponse struct {
	// API portal resource
	APIPortalResource
}

// APIPortalsClientListResponse contains the response from method APIPortalsClient.NewListPager.
type APIPortalsClientListResponse struct {
	// Object that includes an array of API portal resources and a possible link for next set
	APIPortalResourceCollection
}

// APIPortalsClientValidateDomainResponse contains the response from method APIPortalsClient.ValidateDomain.
type APIPortalsClientValidateDomainResponse struct {
	// Validation result for custom domain.
	CustomDomainValidateResult
}

// ApmsClientCreateOrUpdateResponse contains the response from method ApmsClient.BeginCreateOrUpdate.
type ApmsClientCreateOrUpdateResponse struct {
	// APM Resource object
	ApmResource
}

// ApmsClientDeleteResponse contains the response from method ApmsClient.BeginDelete.
type ApmsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApmsClientGetResponse contains the response from method ApmsClient.Get.
type ApmsClientGetResponse struct {
	// APM Resource object
	ApmResource
}

// ApmsClientListResponse contains the response from method ApmsClient.NewListPager.
type ApmsClientListResponse struct {
	// Object that includes an array of APM resources and a possible link for next set
	ApmResourceCollection
}

// ApmsClientListSecretKeysResponse contains the response from method ApmsClient.ListSecretKeys.
type ApmsClientListSecretKeysResponse struct {
	// Keys of APM sensitive properties
	ApmSecretKeys
}

// ApplicationAcceleratorsClientCreateOrUpdateResponse contains the response from method ApplicationAcceleratorsClient.BeginCreateOrUpdate.
type ApplicationAcceleratorsClientCreateOrUpdateResponse struct {
	// Application accelerator resource
	ApplicationAcceleratorResource
}

// ApplicationAcceleratorsClientDeleteResponse contains the response from method ApplicationAcceleratorsClient.BeginDelete.
type ApplicationAcceleratorsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationAcceleratorsClientGetResponse contains the response from method ApplicationAcceleratorsClient.Get.
type ApplicationAcceleratorsClientGetResponse struct {
	// Application accelerator resource
	ApplicationAcceleratorResource
}

// ApplicationAcceleratorsClientListResponse contains the response from method ApplicationAcceleratorsClient.NewListPager.
type ApplicationAcceleratorsClientListResponse struct {
	// Object that includes an array of application accelerator resources and a possible link for next set
	ApplicationAcceleratorResourceCollection
}

// ApplicationLiveViewsClientCreateOrUpdateResponse contains the response from method ApplicationLiveViewsClient.BeginCreateOrUpdate.
type ApplicationLiveViewsClientCreateOrUpdateResponse struct {
	// Application Live View resource
	ApplicationLiveViewResource
}

// ApplicationLiveViewsClientDeleteResponse contains the response from method ApplicationLiveViewsClient.BeginDelete.
type ApplicationLiveViewsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationLiveViewsClientGetResponse contains the response from method ApplicationLiveViewsClient.Get.
type ApplicationLiveViewsClientGetResponse struct {
	// Application Live View resource
	ApplicationLiveViewResource
}

// ApplicationLiveViewsClientListResponse contains the response from method ApplicationLiveViewsClient.NewListPager.
type ApplicationLiveViewsClientListResponse struct {
	// Object that includes an array of Application Live View resources and a possible link for next set
	ApplicationLiveViewResourceCollection
}

// AppsClientCreateOrUpdateResponse contains the response from method AppsClient.BeginCreateOrUpdate.
type AppsClientCreateOrUpdateResponse struct {
	// App resource payload
	AppResource
}

// AppsClientDeleteResponse contains the response from method AppsClient.BeginDelete.
type AppsClientDeleteResponse struct {
	// placeholder for future response values
}

// AppsClientGetResourceUploadURLResponse contains the response from method AppsClient.GetResourceUploadURL.
type AppsClientGetResourceUploadURLResponse struct {
	// Resource upload definition payload
	ResourceUploadDefinition
}

// AppsClientGetResponse contains the response from method AppsClient.Get.
type AppsClientGetResponse struct {
	// App resource payload
	AppResource
}

// AppsClientListResponse contains the response from method AppsClient.NewListPager.
type AppsClientListResponse struct {
	// Object that includes an array of App resources and a possible link for next set
	AppResourceCollection
}

// AppsClientSetActiveDeploymentsResponse contains the response from method AppsClient.BeginSetActiveDeployments.
type AppsClientSetActiveDeploymentsResponse struct {
	// App resource payload
	AppResource
}

// AppsClientUpdateResponse contains the response from method AppsClient.BeginUpdate.
type AppsClientUpdateResponse struct {
	// App resource payload
	AppResource
}

// AppsClientValidateDomainResponse contains the response from method AppsClient.ValidateDomain.
type AppsClientValidateDomainResponse struct {
	// Validation result for custom domain.
	CustomDomainValidateResult
}

// BindingsClientCreateOrUpdateResponse contains the response from method BindingsClient.BeginCreateOrUpdate.
type BindingsClientCreateOrUpdateResponse struct {
	// Binding resource payload
	BindingResource
}

// BindingsClientDeleteResponse contains the response from method BindingsClient.BeginDelete.
type BindingsClientDeleteResponse struct {
	// placeholder for future response values
}

// BindingsClientGetResponse contains the response from method BindingsClient.Get.
type BindingsClientGetResponse struct {
	// Binding resource payload
	BindingResource
}

// BindingsClientListResponse contains the response from method BindingsClient.NewListPager.
type BindingsClientListResponse struct {
	// Object that includes an array of Binding resources and a possible link for next set
	BindingResourceCollection
}

// BindingsClientUpdateResponse contains the response from method BindingsClient.BeginUpdate.
type BindingsClientUpdateResponse struct {
	// Binding resource payload
	BindingResource
}

// BuildServiceAgentPoolClientGetResponse contains the response from method BuildServiceAgentPoolClient.Get.
type BuildServiceAgentPoolClientGetResponse struct {
	// The build service agent pool resource
	BuildServiceAgentPoolResource
}

// BuildServiceAgentPoolClientListResponse contains the response from method BuildServiceAgentPoolClient.NewListPager.
type BuildServiceAgentPoolClientListResponse struct {
	// Object that includes an array of build service agent pool resources and a possible link for next set
	BuildServiceAgentPoolResourceCollection
}

// BuildServiceAgentPoolClientUpdatePutResponse contains the response from method BuildServiceAgentPoolClient.BeginUpdatePut.
type BuildServiceAgentPoolClientUpdatePutResponse struct {
	// The build service agent pool resource
	BuildServiceAgentPoolResource
}

// BuildServiceBuilderClientCreateOrUpdateResponse contains the response from method BuildServiceBuilderClient.BeginCreateOrUpdate.
type BuildServiceBuilderClientCreateOrUpdateResponse struct {
	// KPack Builder resource
	BuilderResource
}

// BuildServiceBuilderClientDeleteResponse contains the response from method BuildServiceBuilderClient.BeginDelete.
type BuildServiceBuilderClientDeleteResponse struct {
	// placeholder for future response values
}

// BuildServiceBuilderClientGetResponse contains the response from method BuildServiceBuilderClient.Get.
type BuildServiceBuilderClientGetResponse struct {
	// KPack Builder resource
	BuilderResource
}

// BuildServiceBuilderClientListDeploymentsResponse contains the response from method BuildServiceBuilderClient.ListDeployments.
type BuildServiceBuilderClientListDeploymentsResponse struct {
	// A list of deployments resource ids.
	DeploymentList
}

// BuildServiceBuilderClientListResponse contains the response from method BuildServiceBuilderClient.NewListPager.
type BuildServiceBuilderClientListResponse struct {
	// Object that includes an array of Builder resources and a possible link for next set
	BuilderResourceCollection
}

// BuildServiceClientCreateOrUpdateBuildResponse contains the response from method BuildServiceClient.CreateOrUpdateBuild.
type BuildServiceClientCreateOrUpdateBuildResponse struct {
	// Build resource payload
	Build
}

// BuildServiceClientCreateOrUpdateResponse contains the response from method BuildServiceClient.BeginCreateOrUpdate.
type BuildServiceClientCreateOrUpdateResponse struct {
	// Build service resource payload
	BuildService
}

// BuildServiceClientDeleteBuildResponse contains the response from method BuildServiceClient.BeginDeleteBuild.
type BuildServiceClientDeleteBuildResponse struct {
	// placeholder for future response values
}

// BuildServiceClientGetBuildResponse contains the response from method BuildServiceClient.GetBuild.
type BuildServiceClientGetBuildResponse struct {
	// Build resource payload
	Build
}

// BuildServiceClientGetBuildResultLogResponse contains the response from method BuildServiceClient.GetBuildResultLog.
type BuildServiceClientGetBuildResultLogResponse struct {
	// Build result log resource properties payload
	BuildResultLog
}

// BuildServiceClientGetBuildResultResponse contains the response from method BuildServiceClient.GetBuildResult.
type BuildServiceClientGetBuildResultResponse struct {
	// Build result resource payload
	BuildResult
}

// BuildServiceClientGetBuildServiceResponse contains the response from method BuildServiceClient.GetBuildService.
type BuildServiceClientGetBuildServiceResponse struct {
	// Build service resource payload
	BuildService
}

// BuildServiceClientGetResourceUploadURLResponse contains the response from method BuildServiceClient.GetResourceUploadURL.
type BuildServiceClientGetResourceUploadURLResponse struct {
	// Resource upload definition payload
	ResourceUploadDefinition
}

// BuildServiceClientGetSupportedBuildpackResponse contains the response from method BuildServiceClient.GetSupportedBuildpack.
type BuildServiceClientGetSupportedBuildpackResponse struct {
	// Supported buildpack resource payload
	SupportedBuildpackResource
}

// BuildServiceClientGetSupportedStackResponse contains the response from method BuildServiceClient.GetSupportedStack.
type BuildServiceClientGetSupportedStackResponse struct {
	// Supported stack resource payload
	SupportedStackResource
}

// BuildServiceClientListBuildResultsResponse contains the response from method BuildServiceClient.NewListBuildResultsPager.
type BuildServiceClientListBuildResultsResponse struct {
	// Object that includes an array of Build result resources and a possible link for next set
	BuildResultCollection
}

// BuildServiceClientListBuildServicesResponse contains the response from method BuildServiceClient.NewListBuildServicesPager.
type BuildServiceClientListBuildServicesResponse struct {
	// Object that includes an array of Build service resources and a possible link for next set
	BuildServiceCollection
}

// BuildServiceClientListBuildsResponse contains the response from method BuildServiceClient.NewListBuildsPager.
type BuildServiceClientListBuildsResponse struct {
	// Object that includes an array of Build resources and a possible link for next set
	BuildCollection
}

// BuildServiceClientListSupportedBuildpacksResponse contains the response from method BuildServiceClient.ListSupportedBuildpacks.
type BuildServiceClientListSupportedBuildpacksResponse struct {
	// Object that includes an array of supported buildpacks resources and a possible link for next set
	SupportedBuildpacksCollection
}

// BuildServiceClientListSupportedStacksResponse contains the response from method BuildServiceClient.ListSupportedStacks.
type BuildServiceClientListSupportedStacksResponse struct {
	// Object that includes an array of supported stacks resources and a possible link for next set
	SupportedStacksCollection
}

// BuildpackBindingClientCreateOrUpdateResponse contains the response from method BuildpackBindingClient.BeginCreateOrUpdate.
type BuildpackBindingClientCreateOrUpdateResponse struct {
	// Buildpack Binding Resource object
	BuildpackBindingResource
}

// BuildpackBindingClientDeleteResponse contains the response from method BuildpackBindingClient.BeginDelete.
type BuildpackBindingClientDeleteResponse struct {
	// placeholder for future response values
}

// BuildpackBindingClientGetResponse contains the response from method BuildpackBindingClient.Get.
type BuildpackBindingClientGetResponse struct {
	// Buildpack Binding Resource object
	BuildpackBindingResource
}

// BuildpackBindingClientListForClusterResponse contains the response from method BuildpackBindingClient.NewListForClusterPager.
type BuildpackBindingClientListForClusterResponse struct {
	// Object that includes an array of BuildpackBinding resources and a possible link for next set
	BuildpackBindingResourceCollection
}

// BuildpackBindingClientListResponse contains the response from method BuildpackBindingClient.NewListPager.
type BuildpackBindingClientListResponse struct {
	// Object that includes an array of BuildpackBinding resources and a possible link for next set
	BuildpackBindingResourceCollection
}

// CertificatesClientCreateOrUpdateResponse contains the response from method CertificatesClient.BeginCreateOrUpdate.
type CertificatesClientCreateOrUpdateResponse struct {
	// Certificate resource payload.
	CertificateResource
}

// CertificatesClientDeleteResponse contains the response from method CertificatesClient.BeginDelete.
type CertificatesClientDeleteResponse struct {
	// placeholder for future response values
}

// CertificatesClientGetResponse contains the response from method CertificatesClient.Get.
type CertificatesClientGetResponse struct {
	// Certificate resource payload.
	CertificateResource
}

// CertificatesClientListResponse contains the response from method CertificatesClient.NewListPager.
type CertificatesClientListResponse struct {
	// Collection compose of certificate resources list and a possible link for next page.
	CertificateResourceCollection
}

// ConfigServersClientGetResponse contains the response from method ConfigServersClient.Get.
type ConfigServersClientGetResponse struct {
	// Config Server resource
	ConfigServerResource
}

// ConfigServersClientUpdatePatchResponse contains the response from method ConfigServersClient.BeginUpdatePatch.
type ConfigServersClientUpdatePatchResponse struct {
	// Config Server resource
	ConfigServerResource
}

// ConfigServersClientUpdatePutResponse contains the response from method ConfigServersClient.BeginUpdatePut.
type ConfigServersClientUpdatePutResponse struct {
	// Config Server resource
	ConfigServerResource
}

// ConfigServersClientValidateResponse contains the response from method ConfigServersClient.BeginValidate.
type ConfigServersClientValidateResponse struct {
	// Validation result for config server settings
	ConfigServerSettingsValidateResult
}

// ConfigurationServicesClientCreateOrUpdateResponse contains the response from method ConfigurationServicesClient.BeginCreateOrUpdate.
type ConfigurationServicesClientCreateOrUpdateResponse struct {
	// Application Configuration Service resource
	ConfigurationServiceResource
}

// ConfigurationServicesClientDeleteResponse contains the response from method ConfigurationServicesClient.BeginDelete.
type ConfigurationServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// ConfigurationServicesClientGetResponse contains the response from method ConfigurationServicesClient.Get.
type ConfigurationServicesClientGetResponse struct {
	// Application Configuration Service resource
	ConfigurationServiceResource
}

// ConfigurationServicesClientListResponse contains the response from method ConfigurationServicesClient.NewListPager.
type ConfigurationServicesClientListResponse struct {
	// Object that includes an array of configuration service resources and a possible link for next set
	ConfigurationServiceResourceCollection
}

// ConfigurationServicesClientValidateResourceResponse contains the response from method ConfigurationServicesClient.BeginValidateResource.
type ConfigurationServicesClientValidateResourceResponse struct {
	// Validation result for configuration service settings
	ConfigurationServiceSettingsValidateResult
}

// ConfigurationServicesClientValidateResponse contains the response from method ConfigurationServicesClient.BeginValidate.
type ConfigurationServicesClientValidateResponse struct {
	// Validation result for configuration service settings
	ConfigurationServiceSettingsValidateResult
}

// ContainerRegistriesClientCreateOrUpdateResponse contains the response from method ContainerRegistriesClient.BeginCreateOrUpdate.
type ContainerRegistriesClientCreateOrUpdateResponse struct {
	// Container registry resource payload.
	ContainerRegistryResource
}

// ContainerRegistriesClientDeleteResponse contains the response from method ContainerRegistriesClient.BeginDelete.
type ContainerRegistriesClientDeleteResponse struct {
	// placeholder for future response values
}

// ContainerRegistriesClientGetResponse contains the response from method ContainerRegistriesClient.Get.
type ContainerRegistriesClientGetResponse struct {
	// Container registry resource payload.
	ContainerRegistryResource
}

// ContainerRegistriesClientListResponse contains the response from method ContainerRegistriesClient.NewListPager.
type ContainerRegistriesClientListResponse struct {
	// Collection compose of container registry resources list and a possible link for next page.
	ContainerRegistryResourceCollection
}

// ContainerRegistriesClientValidateResponse contains the response from method ContainerRegistriesClient.BeginValidate.
type ContainerRegistriesClientValidateResponse struct {
	// Validation result for container registry properties
	ContainerRegistryValidateResult
}

// CustomDomainsClientCreateOrUpdateResponse contains the response from method CustomDomainsClient.BeginCreateOrUpdate.
type CustomDomainsClientCreateOrUpdateResponse struct {
	// Custom domain resource payload.
	CustomDomainResource
}

// CustomDomainsClientDeleteResponse contains the response from method CustomDomainsClient.BeginDelete.
type CustomDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomDomainsClientGetResponse contains the response from method CustomDomainsClient.Get.
type CustomDomainsClientGetResponse struct {
	// Custom domain resource payload.
	CustomDomainResource
}

// CustomDomainsClientListResponse contains the response from method CustomDomainsClient.NewListPager.
type CustomDomainsClientListResponse struct {
	// Collection compose of a custom domain resources list and a possible link for next page.
	CustomDomainResourceCollection
}

// CustomDomainsClientUpdateResponse contains the response from method CustomDomainsClient.BeginUpdate.
type CustomDomainsClientUpdateResponse struct {
	// Custom domain resource payload.
	CustomDomainResource
}

// CustomizedAcceleratorsClientCreateOrUpdateResponse contains the response from method CustomizedAcceleratorsClient.BeginCreateOrUpdate.
type CustomizedAcceleratorsClientCreateOrUpdateResponse struct {
	// Customized accelerator resource
	CustomizedAcceleratorResource
}

// CustomizedAcceleratorsClientDeleteResponse contains the response from method CustomizedAcceleratorsClient.BeginDelete.
type CustomizedAcceleratorsClientDeleteResponse struct {
	// placeholder for future response values
}

// CustomizedAcceleratorsClientGetResponse contains the response from method CustomizedAcceleratorsClient.Get.
type CustomizedAcceleratorsClientGetResponse struct {
	// Customized accelerator resource
	CustomizedAcceleratorResource
}

// CustomizedAcceleratorsClientListResponse contains the response from method CustomizedAcceleratorsClient.NewListPager.
type CustomizedAcceleratorsClientListResponse struct {
	CustomizedAcceleratorResourceCollection
}

// CustomizedAcceleratorsClientValidateResponse contains the response from method CustomizedAcceleratorsClient.BeginValidate.
type CustomizedAcceleratorsClientValidateResponse struct {
	// Validation result for customized accelerator properties
	CustomizedAcceleratorValidateResult
}

// DeploymentsClientCreateOrUpdateResponse contains the response from method DeploymentsClient.BeginCreateOrUpdate.
type DeploymentsClientCreateOrUpdateResponse struct {
	// Deployment resource payload
	DeploymentResource
}

// DeploymentsClientDeleteResponse contains the response from method DeploymentsClient.BeginDelete.
type DeploymentsClientDeleteResponse struct {
	// placeholder for future response values
}

// DeploymentsClientDisableRemoteDebuggingResponse contains the response from method DeploymentsClient.BeginDisableRemoteDebugging.
type DeploymentsClientDisableRemoteDebuggingResponse struct {
	// Remote debugging config.
	RemoteDebugging
}

// DeploymentsClientEnableRemoteDebuggingResponse contains the response from method DeploymentsClient.BeginEnableRemoteDebugging.
type DeploymentsClientEnableRemoteDebuggingResponse struct {
	// Remote debugging config.
	RemoteDebugging
}

// DeploymentsClientGenerateHeapDumpResponse contains the response from method DeploymentsClient.BeginGenerateHeapDump.
type DeploymentsClientGenerateHeapDumpResponse struct {
	// placeholder for future response values
}

// DeploymentsClientGenerateThreadDumpResponse contains the response from method DeploymentsClient.BeginGenerateThreadDump.
type DeploymentsClientGenerateThreadDumpResponse struct {
	// placeholder for future response values
}

// DeploymentsClientGetLogFileURLResponse contains the response from method DeploymentsClient.GetLogFileURL.
type DeploymentsClientGetLogFileURLResponse struct {
	// Log file URL payload
	LogFileURLResponse
}

// DeploymentsClientGetRemoteDebuggingConfigResponse contains the response from method DeploymentsClient.GetRemoteDebuggingConfig.
type DeploymentsClientGetRemoteDebuggingConfigResponse struct {
	// Remote debugging config.
	RemoteDebugging
}

// DeploymentsClientGetResponse contains the response from method DeploymentsClient.Get.
type DeploymentsClientGetResponse struct {
	// Deployment resource payload
	DeploymentResource
}

// DeploymentsClientListForClusterResponse contains the response from method DeploymentsClient.NewListForClusterPager.
type DeploymentsClientListForClusterResponse struct {
	// Object that includes an array of App resources and a possible link for next set
	DeploymentResourceCollection
}

// DeploymentsClientListResponse contains the response from method DeploymentsClient.NewListPager.
type DeploymentsClientListResponse struct {
	// Object that includes an array of App resources and a possible link for next set
	DeploymentResourceCollection
}

// DeploymentsClientRestartResponse contains the response from method DeploymentsClient.BeginRestart.
type DeploymentsClientRestartResponse struct {
	// placeholder for future response values
}

// DeploymentsClientStartJFRResponse contains the response from method DeploymentsClient.BeginStartJFR.
type DeploymentsClientStartJFRResponse struct {
	// placeholder for future response values
}

// DeploymentsClientStartResponse contains the response from method DeploymentsClient.BeginStart.
type DeploymentsClientStartResponse struct {
	// placeholder for future response values
}

// DeploymentsClientStopResponse contains the response from method DeploymentsClient.BeginStop.
type DeploymentsClientStopResponse struct {
	// placeholder for future response values
}

// DeploymentsClientUpdateResponse contains the response from method DeploymentsClient.BeginUpdate.
type DeploymentsClientUpdateResponse struct {
	// Deployment resource payload
	DeploymentResource
}

// DevToolPortalsClientCreateOrUpdateResponse contains the response from method DevToolPortalsClient.BeginCreateOrUpdate.
type DevToolPortalsClientCreateOrUpdateResponse struct {
	// Dev Tool Portal resource
	DevToolPortalResource
}

// DevToolPortalsClientDeleteResponse contains the response from method DevToolPortalsClient.BeginDelete.
type DevToolPortalsClientDeleteResponse struct {
	// placeholder for future response values
}

// DevToolPortalsClientGetResponse contains the response from method DevToolPortalsClient.Get.
type DevToolPortalsClientGetResponse struct {
	// Dev Tool Portal resource
	DevToolPortalResource
}

// DevToolPortalsClientListResponse contains the response from method DevToolPortalsClient.NewListPager.
type DevToolPortalsClientListResponse struct {
	// Object that includes an array of Dev Tool Portal resources and a possible link for next set
	DevToolPortalResourceCollection
}

// GatewayCustomDomainsClientCreateOrUpdateResponse contains the response from method GatewayCustomDomainsClient.BeginCreateOrUpdate.
type GatewayCustomDomainsClientCreateOrUpdateResponse struct {
	// Custom domain of the Spring Cloud Gateway
	GatewayCustomDomainResource
}

// GatewayCustomDomainsClientDeleteResponse contains the response from method GatewayCustomDomainsClient.BeginDelete.
type GatewayCustomDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// GatewayCustomDomainsClientGetResponse contains the response from method GatewayCustomDomainsClient.Get.
type GatewayCustomDomainsClientGetResponse struct {
	// Custom domain of the Spring Cloud Gateway
	GatewayCustomDomainResource
}

// GatewayCustomDomainsClientListResponse contains the response from method GatewayCustomDomainsClient.NewListPager.
type GatewayCustomDomainsClientListResponse struct {
	// Object that includes an array of Spring Cloud Gateway custom domain resources and a possible link for next set
	GatewayCustomDomainResourceCollection
}

// GatewayRouteConfigsClientCreateOrUpdateResponse contains the response from method GatewayRouteConfigsClient.BeginCreateOrUpdate.
type GatewayRouteConfigsClientCreateOrUpdateResponse struct {
	// Spring Cloud Gateway route config resource
	GatewayRouteConfigResource
}

// GatewayRouteConfigsClientDeleteResponse contains the response from method GatewayRouteConfigsClient.BeginDelete.
type GatewayRouteConfigsClientDeleteResponse struct {
	// placeholder for future response values
}

// GatewayRouteConfigsClientGetResponse contains the response from method GatewayRouteConfigsClient.Get.
type GatewayRouteConfigsClientGetResponse struct {
	// Spring Cloud Gateway route config resource
	GatewayRouteConfigResource
}

// GatewayRouteConfigsClientListResponse contains the response from method GatewayRouteConfigsClient.NewListPager.
type GatewayRouteConfigsClientListResponse struct {
	// Object that includes an array of Spring Cloud Gateway route config resources and a possible link for next set
	GatewayRouteConfigResourceCollection
}

// GatewaysClientCreateOrUpdateResponse contains the response from method GatewaysClient.BeginCreateOrUpdate.
type GatewaysClientCreateOrUpdateResponse struct {
	// Spring Cloud Gateway resource
	GatewayResource
}

// GatewaysClientDeleteResponse contains the response from method GatewaysClient.BeginDelete.
type GatewaysClientDeleteResponse struct {
	// placeholder for future response values
}

// GatewaysClientGetResponse contains the response from method GatewaysClient.Get.
type GatewaysClientGetResponse struct {
	// Spring Cloud Gateway resource
	GatewayResource
}

// GatewaysClientListEnvSecretsResponse contains the response from method GatewaysClient.ListEnvSecrets.
type GatewaysClientListEnvSecretsResponse struct {
	// Sensitive properties for Spring Cloud Gateway
	Value map[string]*string
}

// GatewaysClientListResponse contains the response from method GatewaysClient.NewListPager.
type GatewaysClientListResponse struct {
	// Object that includes an array of gateway resources and a possible link for next set
	GatewayResourceCollection
}

// GatewaysClientRestartResponse contains the response from method GatewaysClient.BeginRestart.
type GatewaysClientRestartResponse struct {
	// placeholder for future response values
}

// GatewaysClientValidateDomainResponse contains the response from method GatewaysClient.ValidateDomain.
type GatewaysClientValidateDomainResponse struct {
	// Validation result for custom domain.
	CustomDomainValidateResult
}

// MonitoringSettingsClientGetResponse contains the response from method MonitoringSettingsClient.Get.
type MonitoringSettingsClientGetResponse struct {
	// Monitoring Setting resource
	MonitoringSettingResource
}

// MonitoringSettingsClientUpdatePatchResponse contains the response from method MonitoringSettingsClient.BeginUpdatePatch.
type MonitoringSettingsClientUpdatePatchResponse struct {
	// Monitoring Setting resource
	MonitoringSettingResource
}

// MonitoringSettingsClientUpdatePutResponse contains the response from method MonitoringSettingsClient.BeginUpdatePut.
type MonitoringSettingsClientUpdatePutResponse struct {
	// Monitoring Setting resource
	MonitoringSettingResource
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Available operations of the service
	AvailableOperations
}

// PredefinedAcceleratorsClientDisableResponse contains the response from method PredefinedAcceleratorsClient.BeginDisable.
type PredefinedAcceleratorsClientDisableResponse struct {
	// placeholder for future response values
}

// PredefinedAcceleratorsClientEnableResponse contains the response from method PredefinedAcceleratorsClient.BeginEnable.
type PredefinedAcceleratorsClientEnableResponse struct {
	// placeholder for future response values
}

// PredefinedAcceleratorsClientGetResponse contains the response from method PredefinedAcceleratorsClient.Get.
type PredefinedAcceleratorsClientGetResponse struct {
	// Predefined accelerator resource
	PredefinedAcceleratorResource
}

// PredefinedAcceleratorsClientListResponse contains the response from method PredefinedAcceleratorsClient.NewListPager.
type PredefinedAcceleratorsClientListResponse struct {
	PredefinedAcceleratorResourceCollection
}

// RuntimeVersionsClientListRuntimeVersionsResponse contains the response from method RuntimeVersionsClient.ListRuntimeVersions.
type RuntimeVersionsClientListRuntimeVersionsResponse struct {
	AvailableRuntimeVersions
}

// SKUsClientListResponse contains the response from method SKUsClient.NewListPager.
type SKUsClientListResponse struct {
	// Object that includes an array of Azure Spring Apps SKU and a possible link for next set
	ResourceSKUCollection
}

// ServiceRegistriesClientCreateOrUpdateResponse contains the response from method ServiceRegistriesClient.BeginCreateOrUpdate.
type ServiceRegistriesClientCreateOrUpdateResponse struct {
	// Service Registry resource
	ServiceRegistryResource
}

// ServiceRegistriesClientDeleteResponse contains the response from method ServiceRegistriesClient.BeginDelete.
type ServiceRegistriesClientDeleteResponse struct {
	// placeholder for future response values
}

// ServiceRegistriesClientGetResponse contains the response from method ServiceRegistriesClient.Get.
type ServiceRegistriesClientGetResponse struct {
	// Service Registry resource
	ServiceRegistryResource
}

// ServiceRegistriesClientListResponse contains the response from method ServiceRegistriesClient.NewListPager.
type ServiceRegistriesClientListResponse struct {
	// Object that includes an array of Service Registry resources and a possible link for next set
	ServiceRegistryResourceCollection
}

// ServicesClientCheckNameAvailabilityResponse contains the response from method ServicesClient.CheckNameAvailability.
type ServicesClientCheckNameAvailabilityResponse struct {
	// Name availability result payload
	NameAvailability
}

// ServicesClientCreateOrUpdateResponse contains the response from method ServicesClient.BeginCreateOrUpdate.
type ServicesClientCreateOrUpdateResponse struct {
	// Service resource
	ServiceResource
}

// ServicesClientDeleteResponse contains the response from method ServicesClient.BeginDelete.
type ServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// ServicesClientDisableApmGloballyResponse contains the response from method ServicesClient.BeginDisableApmGlobally.
type ServicesClientDisableApmGloballyResponse struct {
	// placeholder for future response values
}

// ServicesClientDisableTestEndpointResponse contains the response from method ServicesClient.DisableTestEndpoint.
type ServicesClientDisableTestEndpointResponse struct {
	// placeholder for future response values
}

// ServicesClientEnableApmGloballyResponse contains the response from method ServicesClient.BeginEnableApmGlobally.
type ServicesClientEnableApmGloballyResponse struct {
	// placeholder for future response values
}

// ServicesClientEnableTestEndpointResponse contains the response from method ServicesClient.EnableTestEndpoint.
type ServicesClientEnableTestEndpointResponse struct {
	// Test keys payload
	TestKeys
}

// ServicesClientFlushVnetDNSSettingResponse contains the response from method ServicesClient.BeginFlushVnetDNSSetting.
type ServicesClientFlushVnetDNSSettingResponse struct {
	// placeholder for future response values
}

// ServicesClientGetResponse contains the response from method ServicesClient.Get.
type ServicesClientGetResponse struct {
	// Service resource
	ServiceResource
}

// ServicesClientListBySubscriptionResponse contains the response from method ServicesClient.NewListBySubscriptionPager.
type ServicesClientListBySubscriptionResponse struct {
	// Object that includes an array of Service resources and a possible link for next set
	ServiceResourceList
}

// ServicesClientListGloballyEnabledApmsResponse contains the response from method ServicesClient.ListGloballyEnabledApms.
type ServicesClientListGloballyEnabledApmsResponse struct {
	// Globally enabled APMs payload
	GloballyEnabledApms
}

// ServicesClientListResponse contains the response from method ServicesClient.NewListPager.
type ServicesClientListResponse struct {
	// Object that includes an array of Service resources and a possible link for next set
	ServiceResourceList
}

// ServicesClientListSupportedApmTypesResponse contains the response from method ServicesClient.NewListSupportedApmTypesPager.
type ServicesClientListSupportedApmTypesResponse struct {
	// Supported APM types payload
	SupportedApmTypes
}

// ServicesClientListSupportedServerVersionsResponse contains the response from method ServicesClient.NewListSupportedServerVersionsPager.
type ServicesClientListSupportedServerVersionsResponse struct {
	// Supported server versions.
	SupportedServerVersions
}

// ServicesClientListTestKeysResponse contains the response from method ServicesClient.ListTestKeys.
type ServicesClientListTestKeysResponse struct {
	// Test keys payload
	TestKeys
}

// ServicesClientRegenerateTestKeyResponse contains the response from method ServicesClient.RegenerateTestKey.
type ServicesClientRegenerateTestKeyResponse struct {
	// Test keys payload
	TestKeys
}

// ServicesClientStartResponse contains the response from method ServicesClient.BeginStart.
type ServicesClientStartResponse struct {
	// placeholder for future response values
}

// ServicesClientStopResponse contains the response from method ServicesClient.BeginStop.
type ServicesClientStopResponse struct {
	// placeholder for future response values
}

// ServicesClientUpdateResponse contains the response from method ServicesClient.BeginUpdate.
type ServicesClientUpdateResponse struct {
	// Service resource
	ServiceResource
}

// StoragesClientCreateOrUpdateResponse contains the response from method StoragesClient.BeginCreateOrUpdate.
type StoragesClientCreateOrUpdateResponse struct {
	// Storage resource payload.
	StorageResource
}

// StoragesClientDeleteResponse contains the response from method StoragesClient.BeginDelete.
type StoragesClientDeleteResponse struct {
	// placeholder for future response values
}

// StoragesClientGetResponse contains the response from method StoragesClient.Get.
type StoragesClientGetResponse struct {
	// Storage resource payload.
	StorageResource
}

// StoragesClientListResponse contains the response from method StoragesClient.NewListPager.
type StoragesClientListResponse struct {
	// Collection compose of storage resources list and a possible link for next page.
	StorageResourceCollection
}
