//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armavs

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The ID of the target subscription. The value must be an UUID.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewAddonsClient creates a new instance of AddonsClient.
func (c *ClientFactory) NewAddonsClient() *AddonsClient {
	return &AddonsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewAuthorizationsClient creates a new instance of AuthorizationsClient.
func (c *ClientFactory) NewAuthorizationsClient() *AuthorizationsClient {
	return &AuthorizationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCloudLinksClient creates a new instance of CloudLinksClient.
func (c *ClientFactory) NewCloudLinksClient() *CloudLinksClient {
	return &CloudLinksClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewClustersClient creates a new instance of ClustersClient.
func (c *ClientFactory) NewClustersClient() *ClustersClient {
	return &ClustersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDatastoresClient creates a new instance of DatastoresClient.
func (c *ClientFactory) NewDatastoresClient() *DatastoresClient {
	return &DatastoresClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewGlobalReachConnectionsClient creates a new instance of GlobalReachConnectionsClient.
func (c *ClientFactory) NewGlobalReachConnectionsClient() *GlobalReachConnectionsClient {
	return &GlobalReachConnectionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewHcxEnterpriseSitesClient creates a new instance of HcxEnterpriseSitesClient.
func (c *ClientFactory) NewHcxEnterpriseSitesClient() *HcxEnterpriseSitesClient {
	return &HcxEnterpriseSitesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewIscsiPathsClient creates a new instance of IscsiPathsClient.
func (c *ClientFactory) NewIscsiPathsClient() *IscsiPathsClient {
	return &IscsiPathsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLocationsClient creates a new instance of LocationsClient.
func (c *ClientFactory) NewLocationsClient() *LocationsClient {
	return &LocationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewPlacementPoliciesClient creates a new instance of PlacementPoliciesClient.
func (c *ClientFactory) NewPlacementPoliciesClient() *PlacementPoliciesClient {
	return &PlacementPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewPrivateCloudsClient creates a new instance of PrivateCloudsClient.
func (c *ClientFactory) NewPrivateCloudsClient() *PrivateCloudsClient {
	return &PrivateCloudsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewScriptCmdletsClient creates a new instance of ScriptCmdletsClient.
func (c *ClientFactory) NewScriptCmdletsClient() *ScriptCmdletsClient {
	return &ScriptCmdletsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewScriptExecutionsClient creates a new instance of ScriptExecutionsClient.
func (c *ClientFactory) NewScriptExecutionsClient() *ScriptExecutionsClient {
	return &ScriptExecutionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewScriptPackagesClient creates a new instance of ScriptPackagesClient.
func (c *ClientFactory) NewScriptPackagesClient() *ScriptPackagesClient {
	return &ScriptPackagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVirtualMachinesClient creates a new instance of VirtualMachinesClient.
func (c *ClientFactory) NewVirtualMachinesClient() *VirtualMachinesClient {
	return &VirtualMachinesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewWorkloadNetworksClient creates a new instance of WorkloadNetworksClient.
func (c *ClientFactory) NewWorkloadNetworksClient() *WorkloadNetworksClient {
	return &WorkloadNetworksClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
