//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armazurestackhci

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The ID of the target subscription. The value must be an UUID.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewArcSettingsClient creates a new instance of ArcSettingsClient.
func (c *ClientFactory) NewArcSettingsClient() *ArcSettingsClient {
	return &ArcSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewClustersClient creates a new instance of ClustersClient.
func (c *ClientFactory) NewClustersClient() *ClustersClient {
	return &ClustersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDeploymentSettingsClient creates a new instance of DeploymentSettingsClient.
func (c *ClientFactory) NewDeploymentSettingsClient() *DeploymentSettingsClient {
	return &DeploymentSettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewEdgeDevicesClient creates a new instance of EdgeDevicesClient.
func (c *ClientFactory) NewEdgeDevicesClient() *EdgeDevicesClient {
	return &EdgeDevicesClient{
		internal: c.internal,
	}
}

// NewExtensionsClient creates a new instance of ExtensionsClient.
func (c *ClientFactory) NewExtensionsClient() *ExtensionsClient {
	return &ExtensionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOffersClient creates a new instance of OffersClient.
func (c *ClientFactory) NewOffersClient() *OffersClient {
	return &OffersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewPublishersClient creates a new instance of PublishersClient.
func (c *ClientFactory) NewPublishersClient() *PublishersClient {
	return &PublishersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSKUsClient creates a new instance of SKUsClient.
func (c *ClientFactory) NewSKUsClient() *SKUsClient {
	return &SKUsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewSecuritySettingsClient creates a new instance of SecuritySettingsClient.
func (c *ClientFactory) NewSecuritySettingsClient() *SecuritySettingsClient {
	return &SecuritySettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUpdateRunsClient creates a new instance of UpdateRunsClient.
func (c *ClientFactory) NewUpdateRunsClient() *UpdateRunsClient {
	return &UpdateRunsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUpdateSummariesClient creates a new instance of UpdateSummariesClient.
func (c *ClientFactory) NewUpdateSummariesClient() *UpdateSummariesClient {
	return &UpdateSummariesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUpdatesClient creates a new instance of UpdatesClient.
func (c *ClientFactory) NewUpdatesClient() *UpdatesClient {
	return &UpdatesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
