//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armblockchain

// LocationsClientCheckNameAvailabilityResponse contains the response from method LocationsClient.CheckNameAvailability.
type LocationsClientCheckNameAvailabilityResponse struct {
	// Name availability payload which is exposed in the response of the resource provider.
	NameAvailability
}

// LocationsClientListConsortiumsResponse contains the response from method LocationsClient.ListConsortiums.
type LocationsClientListConsortiumsResponse struct {
	// Collection of the consortium payload.
	ConsortiumCollection
}

// MemberOperationResultsClientGetResponse contains the response from method MemberOperationResultsClient.Get.
type MemberOperationResultsClientGetResponse struct {
	// Operation result payload which is exposed in the response of the resource provider.
	OperationResult
}

// MembersClientCreateResponse contains the response from method MembersClient.BeginCreate.
type MembersClientCreateResponse struct {
	// Payload of the blockchain member which is exposed in the request/response of the resource provider.
	Member
}

// MembersClientDeleteResponse contains the response from method MembersClient.BeginDelete.
type MembersClientDeleteResponse struct {
	// placeholder for future response values
}

// MembersClientGetResponse contains the response from method MembersClient.Get.
type MembersClientGetResponse struct {
	// Payload of the blockchain member which is exposed in the request/response of the resource provider.
	Member
}

// MembersClientListAPIKeysResponse contains the response from method MembersClient.ListAPIKeys.
type MembersClientListAPIKeysResponse struct {
	// Collection of the API key payload which is exposed in the response of the resource provider.
	APIKeyCollection
}

// MembersClientListAllResponse contains the response from method MembersClient.NewListAllPager.
type MembersClientListAllResponse struct {
	// Collection of the blockchain member payload which is exposed in the request/response of the resource provider.
	MemberCollection
}

// MembersClientListConsortiumMembersResponse contains the response from method MembersClient.NewListConsortiumMembersPager.
type MembersClientListConsortiumMembersResponse struct {
	// Collection of consortium payload.
	ConsortiumMemberCollection
}

// MembersClientListRegenerateAPIKeysResponse contains the response from method MembersClient.ListRegenerateAPIKeys.
type MembersClientListRegenerateAPIKeysResponse struct {
	// Collection of the API key payload which is exposed in the response of the resource provider.
	APIKeyCollection
}

// MembersClientListResponse contains the response from method MembersClient.NewListPager.
type MembersClientListResponse struct {
	// Collection of the blockchain member payload which is exposed in the request/response of the resource provider.
	MemberCollection
}

// MembersClientUpdateResponse contains the response from method MembersClient.Update.
type MembersClientUpdateResponse struct {
	// Payload of the blockchain member which is exposed in the request/response of the resource provider.
	Member
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Collection of operation payload which is exposed in the response of the resource provider.
	ResourceProviderOperationCollection
}

// SKUsClientListResponse contains the response from method SKUsClient.List.
type SKUsClientListResponse struct {
	// Collection of the resource type Sku.
	ResourceTypeSKUCollection
}

// TransactionNodesClientCreateResponse contains the response from method TransactionNodesClient.BeginCreate.
type TransactionNodesClientCreateResponse struct {
	// Payload of the transaction node which is the request/response of the resource provider.
	TransactionNode
}

// TransactionNodesClientDeleteResponse contains the response from method TransactionNodesClient.BeginDelete.
type TransactionNodesClientDeleteResponse struct {
	// placeholder for future response values
}

// TransactionNodesClientGetResponse contains the response from method TransactionNodesClient.Get.
type TransactionNodesClientGetResponse struct {
	// Payload of the transaction node which is the request/response of the resource provider.
	TransactionNode
}

// TransactionNodesClientListAPIKeysResponse contains the response from method TransactionNodesClient.ListAPIKeys.
type TransactionNodesClientListAPIKeysResponse struct {
	// Collection of the API key payload which is exposed in the response of the resource provider.
	APIKeyCollection
}

// TransactionNodesClientListRegenerateAPIKeysResponse contains the response from method TransactionNodesClient.ListRegenerateAPIKeys.
type TransactionNodesClientListRegenerateAPIKeysResponse struct {
	// Collection of the API key payload which is exposed in the response of the resource provider.
	APIKeyCollection
}

// TransactionNodesClientListResponse contains the response from method TransactionNodesClient.NewListPager.
type TransactionNodesClientListResponse struct {
	// Collection of transaction node payload which is exposed in the request/response of the resource provider.
	TransactionNodeCollection
}

// TransactionNodesClientUpdateResponse contains the response from method TransactionNodesClient.Update.
type TransactionNodesClientUpdateResponse struct {
	// Payload of the transaction node which is the request/response of the resource provider.
	TransactionNode
}
