//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armcognitiveservices

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The ID of the target subscription.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewAccountsClient creates a new instance of AccountsClient.
func (c *ClientFactory) NewAccountsClient() *AccountsClient {
	return &AccountsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCommitmentPlansClient creates a new instance of CommitmentPlansClient.
func (c *ClientFactory) NewCommitmentPlansClient() *CommitmentPlansClient {
	return &CommitmentPlansClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCommitmentTiersClient creates a new instance of CommitmentTiersClient.
func (c *ClientFactory) NewCommitmentTiersClient() *CommitmentTiersClient {
	return &CommitmentTiersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDefenderForAISettingsClient creates a new instance of DefenderForAISettingsClient.
func (c *ClientFactory) NewDefenderForAISettingsClient() *DefenderForAISettingsClient {
	return &DefenderForAISettingsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDeletedAccountsClient creates a new instance of DeletedAccountsClient.
func (c *ClientFactory) NewDeletedAccountsClient() *DeletedAccountsClient {
	return &DeletedAccountsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDeploymentsClient creates a new instance of DeploymentsClient.
func (c *ClientFactory) NewDeploymentsClient() *DeploymentsClient {
	return &DeploymentsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewEncryptionScopesClient creates a new instance of EncryptionScopesClient.
func (c *ClientFactory) NewEncryptionScopesClient() *EncryptionScopesClient {
	return &EncryptionScopesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewLocationBasedModelCapacitiesClient creates a new instance of LocationBasedModelCapacitiesClient.
func (c *ClientFactory) NewLocationBasedModelCapacitiesClient() *LocationBasedModelCapacitiesClient {
	return &LocationBasedModelCapacitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewManagementClient creates a new instance of ManagementClient.
func (c *ClientFactory) NewManagementClient() *ManagementClient {
	return &ManagementClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewModelCapacitiesClient creates a new instance of ModelCapacitiesClient.
func (c *ClientFactory) NewModelCapacitiesClient() *ModelCapacitiesClient {
	return &ModelCapacitiesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewModelsClient creates a new instance of ModelsClient.
func (c *ClientFactory) NewModelsClient() *ModelsClient {
	return &ModelsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewNetworkSecurityPerimeterConfigurationsClient creates a new instance of NetworkSecurityPerimeterConfigurationsClient.
func (c *ClientFactory) NewNetworkSecurityPerimeterConfigurationsClient() *NetworkSecurityPerimeterConfigurationsClient {
	return &NetworkSecurityPerimeterConfigurationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewPrivateEndpointConnectionsClient creates a new instance of PrivateEndpointConnectionsClient.
func (c *ClientFactory) NewPrivateEndpointConnectionsClient() *PrivateEndpointConnectionsClient {
	return &PrivateEndpointConnectionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewPrivateLinkResourcesClient creates a new instance of PrivateLinkResourcesClient.
func (c *ClientFactory) NewPrivateLinkResourcesClient() *PrivateLinkResourcesClient {
	return &PrivateLinkResourcesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRaiBlocklistItemsClient creates a new instance of RaiBlocklistItemsClient.
func (c *ClientFactory) NewRaiBlocklistItemsClient() *RaiBlocklistItemsClient {
	return &RaiBlocklistItemsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRaiBlocklistsClient creates a new instance of RaiBlocklistsClient.
func (c *ClientFactory) NewRaiBlocklistsClient() *RaiBlocklistsClient {
	return &RaiBlocklistsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRaiContentFiltersClient creates a new instance of RaiContentFiltersClient.
func (c *ClientFactory) NewRaiContentFiltersClient() *RaiContentFiltersClient {
	return &RaiContentFiltersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewRaiPoliciesClient creates a new instance of RaiPoliciesClient.
func (c *ClientFactory) NewRaiPoliciesClient() *RaiPoliciesClient {
	return &RaiPoliciesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewResourceSKUsClient creates a new instance of ResourceSKUsClient.
func (c *ClientFactory) NewResourceSKUsClient() *ResourceSKUsClient {
	return &ResourceSKUsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUsagesClient creates a new instance of UsagesClient.
func (c *ClientFactory) NewUsagesClient() *UsagesClient {
	return &UsagesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
