//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armconfidentialledger

// ClientCheckNameAvailabilityResponse contains the response from method Client.CheckNameAvailability.
type ClientCheckNameAvailabilityResponse struct {
	// The check availability result.
	CheckNameAvailabilityResponse
}

// LedgerClientBackupResponse contains the response from method LedgerClient.BeginBackup.
type LedgerClientBackupResponse struct {
	// Object representing the backup response of a Confidential Ledger Resource.
	BackupResponse
}

// LedgerClientCreateResponse contains the response from method LedgerClient.BeginCreate.
type LedgerClientCreateResponse struct {
	// Confidential Ledger. Contains the properties of Confidential Ledger Resource.
	ConfidentialLedger
}

// LedgerClientDeleteResponse contains the response from method LedgerClient.BeginDelete.
type LedgerClientDeleteResponse struct {
	// placeholder for future response values
}

// LedgerClientGetResponse contains the response from method LedgerClient.Get.
type LedgerClientGetResponse struct {
	// Confidential Ledger. Contains the properties of Confidential Ledger Resource.
	ConfidentialLedger
}

// LedgerClientListByResourceGroupResponse contains the response from method LedgerClient.NewListByResourceGroupPager.
type LedgerClientListByResourceGroupResponse struct {
	// Object that includes an array of Confidential Ledgers and a possible link for next set.
	List
}

// LedgerClientListBySubscriptionResponse contains the response from method LedgerClient.NewListBySubscriptionPager.
type LedgerClientListBySubscriptionResponse struct {
	// Object that includes an array of Confidential Ledgers and a possible link for next set.
	List
}

// LedgerClientRestoreResponse contains the response from method LedgerClient.BeginRestore.
type LedgerClientRestoreResponse struct {
	// Object representing the restore response of a Confidential Ledger Resource.
	RestoreResponse
}

// LedgerClientUpdateResponse contains the response from method LedgerClient.BeginUpdate.
type LedgerClientUpdateResponse struct {
	// Confidential Ledger. Contains the properties of Confidential Ledger Resource.
	ConfidentialLedger
}

// ManagedCCFClientBackupResponse contains the response from method ManagedCCFClient.BeginBackup.
type ManagedCCFClientBackupResponse struct {
	// Object representing the backup response of a Managed CCF Resource.
	ManagedCCFBackupResponse
}

// ManagedCCFClientCreateResponse contains the response from method ManagedCCFClient.BeginCreate.
type ManagedCCFClientCreateResponse struct {
	// Managed CCF. Contains the properties of Managed CCF Resource.
	ManagedCCF
}

// ManagedCCFClientDeleteResponse contains the response from method ManagedCCFClient.BeginDelete.
type ManagedCCFClientDeleteResponse struct {
	// placeholder for future response values
}

// ManagedCCFClientGetResponse contains the response from method ManagedCCFClient.Get.
type ManagedCCFClientGetResponse struct {
	// Managed CCF. Contains the properties of Managed CCF Resource.
	ManagedCCF
}

// ManagedCCFClientListByResourceGroupResponse contains the response from method ManagedCCFClient.NewListByResourceGroupPager.
type ManagedCCFClientListByResourceGroupResponse struct {
	// Object that includes an array of Managed CCF and a possible link for next set.
	ManagedCCFList
}

// ManagedCCFClientListBySubscriptionResponse contains the response from method ManagedCCFClient.NewListBySubscriptionPager.
type ManagedCCFClientListBySubscriptionResponse struct {
	// Object that includes an array of Managed CCF and a possible link for next set.
	ManagedCCFList
}

// ManagedCCFClientRestoreResponse contains the response from method ManagedCCFClient.BeginRestore.
type ManagedCCFClientRestoreResponse struct {
	// Object representing the restore response of a Managed CCF Resource.
	ManagedCCFRestoreResponse
}

// ManagedCCFClientUpdateResponse contains the response from method ManagedCCFClient.BeginUpdate.
type ManagedCCFClientUpdateResponse struct {
	// Managed CCF. Contains the properties of Managed CCF Resource.
	ManagedCCF
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// List containing this Resource Provider's available operations.
	ResourceProviderOperationList
}
