//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armconfluent

// AccessClientCreateRoleBindingResponse contains the response from method AccessClient.CreateRoleBinding.
type AccessClientCreateRoleBindingResponse struct {
	// Details on principal, role name and crn pattern of a role binding
	RoleBindingRecord
}

// AccessClientDeleteRoleBindingResponse contains the response from method AccessClient.DeleteRoleBinding.
type AccessClientDeleteRoleBindingResponse struct {
	// placeholder for future response values
}

// AccessClientInviteUserResponse contains the response from method AccessClient.InviteUser.
type AccessClientInviteUserResponse struct {
	// Record of the invitation
	InvitationRecord
}

// AccessClientListClustersResponse contains the response from method AccessClient.ListClusters.
type AccessClientListClustersResponse struct {
	// Details of the clusters returned on successful response
	AccessListClusterSuccessResponse
}

// AccessClientListEnvironmentsResponse contains the response from method AccessClient.ListEnvironments.
type AccessClientListEnvironmentsResponse struct {
	// Details of the environments returned on successful response
	AccessListEnvironmentsSuccessResponse
}

// AccessClientListInvitationsResponse contains the response from method AccessClient.ListInvitations.
type AccessClientListInvitationsResponse struct {
	// List invitations success response
	AccessListInvitationsSuccessResponse
}

// AccessClientListRoleBindingNameListResponse contains the response from method AccessClient.ListRoleBindingNameList.
type AccessClientListRoleBindingNameListResponse struct {
	// Details of the role binding names returned on successful response
	AccessRoleBindingNameListSuccessResponse
}

// AccessClientListRoleBindingsResponse contains the response from method AccessClient.ListRoleBindings.
type AccessClientListRoleBindingsResponse struct {
	// Details of the role bindings returned on successful response
	AccessListRoleBindingsSuccessResponse
}

// AccessClientListServiceAccountsResponse contains the response from method AccessClient.ListServiceAccounts.
type AccessClientListServiceAccountsResponse struct {
	// List service accounts success response
	AccessListServiceAccountsSuccessResponse
}

// AccessClientListUsersResponse contains the response from method AccessClient.ListUsers.
type AccessClientListUsersResponse struct {
	// List users success response
	AccessListUsersSuccessResponse
}

// MarketplaceAgreementsClientCreateResponse contains the response from method MarketplaceAgreementsClient.Create.
type MarketplaceAgreementsClientCreateResponse struct {
	// Agreement Terms definition
	AgreementResource
}

// MarketplaceAgreementsClientListResponse contains the response from method MarketplaceAgreementsClient.NewListPager.
type MarketplaceAgreementsClientListResponse struct {
	// Response of a list operation.
	AgreementResourceListResponse
}

// OrganizationClientCreateAPIKeyResponse contains the response from method OrganizationClient.CreateAPIKey.
type OrganizationClientCreateAPIKeyResponse struct {
	// Details API key
	APIKeyRecord
}

// OrganizationClientCreateResponse contains the response from method OrganizationClient.BeginCreate.
type OrganizationClientCreateResponse struct {
	// Organization resource.
	OrganizationResource
}

// OrganizationClientDeleteClusterAPIKeyResponse contains the response from method OrganizationClient.DeleteClusterAPIKey.
type OrganizationClientDeleteClusterAPIKeyResponse struct {
	// placeholder for future response values
}

// OrganizationClientDeleteResponse contains the response from method OrganizationClient.BeginDelete.
type OrganizationClientDeleteResponse struct {
	// placeholder for future response values
}

// OrganizationClientGetClusterAPIKeyResponse contains the response from method OrganizationClient.GetClusterAPIKey.
type OrganizationClientGetClusterAPIKeyResponse struct {
	// Details API key
	APIKeyRecord
}

// OrganizationClientGetClusterByIDResponse contains the response from method OrganizationClient.GetClusterByID.
type OrganizationClientGetClusterByIDResponse struct {
	// Details of cluster record
	SCClusterRecord
}

// OrganizationClientGetEnvironmentByIDResponse contains the response from method OrganizationClient.GetEnvironmentByID.
type OrganizationClientGetEnvironmentByIDResponse struct {
	// Details about environment name, metadata and environment id of an environment
	SCEnvironmentRecord
}

// OrganizationClientGetResponse contains the response from method OrganizationClient.Get.
type OrganizationClientGetResponse struct {
	// Organization resource.
	OrganizationResource
}

// OrganizationClientGetSchemaRegistryClusterByIDResponse contains the response from method OrganizationClient.GetSchemaRegistryClusterByID.
type OrganizationClientGetSchemaRegistryClusterByIDResponse struct {
	// Details of schema registry cluster record
	SchemaRegistryClusterRecord
}

// OrganizationClientListByResourceGroupResponse contains the response from method OrganizationClient.NewListByResourceGroupPager.
type OrganizationClientListByResourceGroupResponse struct {
	// The response of a list operation.
	OrganizationResourceListResult
}

// OrganizationClientListBySubscriptionResponse contains the response from method OrganizationClient.NewListBySubscriptionPager.
type OrganizationClientListBySubscriptionResponse struct {
	// The response of a list operation.
	OrganizationResourceListResult
}

// OrganizationClientListClustersResponse contains the response from method OrganizationClient.NewListClustersPager.
type OrganizationClientListClustersResponse struct {
	// Result of GET request to list clusters in the environment of a confluent organization
	ListClustersSuccessResponse
}

// OrganizationClientListEnvironmentsResponse contains the response from method OrganizationClient.NewListEnvironmentsPager.
type OrganizationClientListEnvironmentsResponse struct {
	// Result of GET request to list Confluent operations.
	GetEnvironmentsResponse
}

// OrganizationClientListRegionsResponse contains the response from method OrganizationClient.ListRegions.
type OrganizationClientListRegionsResponse struct {
	// Result of POST request to list regions supported by confluent
	ListRegionsSuccessResponse
}

// OrganizationClientListSchemaRegistryClustersResponse contains the response from method OrganizationClient.NewListSchemaRegistryClustersPager.
type OrganizationClientListSchemaRegistryClustersResponse struct {
	// Result of GET request to list schema registry clusters in the environment of a confluent organization
	ListSchemaRegistryClustersResponse
}

// OrganizationClientUpdateResponse contains the response from method OrganizationClient.Update.
type OrganizationClientUpdateResponse struct {
	// Organization resource.
	OrganizationResource
}

// OrganizationOperationsClientListResponse contains the response from method OrganizationOperationsClient.NewListPager.
type OrganizationOperationsClientListResponse struct {
	// Result of GET request to list Confluent operations.
	OperationListResult
}

// ValidationsClientValidateOrganizationResponse contains the response from method ValidationsClient.ValidateOrganization.
type ValidationsClientValidateOrganizationResponse struct {
	// Organization resource.
	OrganizationResource
}

// ValidationsClientValidateOrganizationV2Response contains the response from method ValidationsClient.ValidateOrganizationV2.
type ValidationsClientValidateOrganizationV2Response struct {
	// Validation response from the provider
	ValidationResponse
}
