//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Code generated by Microsoft (R) AutoRest Code Generator.Changes may cause incorrect behavior and will be lost if the code
// is regenerated.
// Code generated by @autorest/go. DO NOT EDIT.

package armconnectedvmware

// ClustersClientCreateResponse contains the response from method ClustersClient.BeginCreate.
type ClustersClientCreateResponse struct {
	// Define the cluster.
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// Define the cluster.
	Cluster
}

// ClustersClientListByResourceGroupResponse contains the response from method ClustersClient.NewListByResourceGroupPager.
type ClustersClientListByResourceGroupResponse struct {
	// List of Clusters.
	ClustersList
}

// ClustersClientListResponse contains the response from method ClustersClient.NewListPager.
type ClustersClientListResponse struct {
	// List of Clusters.
	ClustersList
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.Update.
type ClustersClientUpdateResponse struct {
	// Define the cluster.
	Cluster
}

// DatastoresClientCreateResponse contains the response from method DatastoresClient.BeginCreate.
type DatastoresClientCreateResponse struct {
	// Define the datastore.
	Datastore
}

// DatastoresClientDeleteResponse contains the response from method DatastoresClient.BeginDelete.
type DatastoresClientDeleteResponse struct {
	// placeholder for future response values
}

// DatastoresClientGetResponse contains the response from method DatastoresClient.Get.
type DatastoresClientGetResponse struct {
	// Define the datastore.
	Datastore
}

// DatastoresClientListByResourceGroupResponse contains the response from method DatastoresClient.NewListByResourceGroupPager.
type DatastoresClientListByResourceGroupResponse struct {
	// List of Datastores.
	DatastoresList
}

// DatastoresClientListResponse contains the response from method DatastoresClient.NewListPager.
type DatastoresClientListResponse struct {
	// List of Datastores.
	DatastoresList
}

// DatastoresClientUpdateResponse contains the response from method DatastoresClient.Update.
type DatastoresClientUpdateResponse struct {
	// Define the datastore.
	Datastore
}

// HostsClientCreateResponse contains the response from method HostsClient.BeginCreate.
type HostsClientCreateResponse struct {
	// Define the host.
	Host
}

// HostsClientDeleteResponse contains the response from method HostsClient.BeginDelete.
type HostsClientDeleteResponse struct {
	// placeholder for future response values
}

// HostsClientGetResponse contains the response from method HostsClient.Get.
type HostsClientGetResponse struct {
	// Define the host.
	Host
}

// HostsClientListByResourceGroupResponse contains the response from method HostsClient.NewListByResourceGroupPager.
type HostsClientListByResourceGroupResponse struct {
	// List of Hosts.
	HostsList
}

// HostsClientListResponse contains the response from method HostsClient.NewListPager.
type HostsClientListResponse struct {
	// List of Hosts.
	HostsList
}

// HostsClientUpdateResponse contains the response from method HostsClient.Update.
type HostsClientUpdateResponse struct {
	// Define the host.
	Host
}

// InventoryItemsClientCreateResponse contains the response from method InventoryItemsClient.Create.
type InventoryItemsClientCreateResponse struct {
	// Defines the inventory item.
	InventoryItem
}

// InventoryItemsClientDeleteResponse contains the response from method InventoryItemsClient.Delete.
type InventoryItemsClientDeleteResponse struct {
	// placeholder for future response values
}

// InventoryItemsClientGetResponse contains the response from method InventoryItemsClient.Get.
type InventoryItemsClientGetResponse struct {
	// Defines the inventory item.
	InventoryItem
}

// InventoryItemsClientListByVCenterResponse contains the response from method InventoryItemsClient.NewListByVCenterPager.
type InventoryItemsClientListByVCenterResponse struct {
	// List of InventoryItems.
	InventoryItemsList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Lists the operations available.
	OperationsList
}

// ResourcePoolsClientCreateResponse contains the response from method ResourcePoolsClient.BeginCreate.
type ResourcePoolsClientCreateResponse struct {
	// Define the resourcePool.
	ResourcePool
}

// ResourcePoolsClientDeleteResponse contains the response from method ResourcePoolsClient.BeginDelete.
type ResourcePoolsClientDeleteResponse struct {
	// placeholder for future response values
}

// ResourcePoolsClientGetResponse contains the response from method ResourcePoolsClient.Get.
type ResourcePoolsClientGetResponse struct {
	// Define the resourcePool.
	ResourcePool
}

// ResourcePoolsClientListByResourceGroupResponse contains the response from method ResourcePoolsClient.NewListByResourceGroupPager.
type ResourcePoolsClientListByResourceGroupResponse struct {
	// List of ResourcePools.
	ResourcePoolsList
}

// ResourcePoolsClientListResponse contains the response from method ResourcePoolsClient.NewListPager.
type ResourcePoolsClientListResponse struct {
	// List of ResourcePools.
	ResourcePoolsList
}

// ResourcePoolsClientUpdateResponse contains the response from method ResourcePoolsClient.Update.
type ResourcePoolsClientUpdateResponse struct {
	// Define the resourcePool.
	ResourcePool
}

// VCentersClientCreateResponse contains the response from method VCentersClient.BeginCreate.
type VCentersClientCreateResponse struct {
	// Defines the vCenter.
	VCenter
}

// VCentersClientDeleteResponse contains the response from method VCentersClient.BeginDelete.
type VCentersClientDeleteResponse struct {
	// placeholder for future response values
}

// VCentersClientGetResponse contains the response from method VCentersClient.Get.
type VCentersClientGetResponse struct {
	// Defines the vCenter.
	VCenter
}

// VCentersClientListByResourceGroupResponse contains the response from method VCentersClient.NewListByResourceGroupPager.
type VCentersClientListByResourceGroupResponse struct {
	// List of VCenters.
	VCentersList
}

// VCentersClientListResponse contains the response from method VCentersClient.NewListPager.
type VCentersClientListResponse struct {
	// List of VCenters.
	VCentersList
}

// VCentersClientUpdateResponse contains the response from method VCentersClient.Update.
type VCentersClientUpdateResponse struct {
	// Defines the vCenter.
	VCenter
}

// VMInstanceGuestAgentsClientCreateResponse contains the response from method VMInstanceGuestAgentsClient.BeginCreate.
type VMInstanceGuestAgentsClientCreateResponse struct {
	// Defines the GuestAgent.
	GuestAgent
}

// VMInstanceGuestAgentsClientDeleteResponse contains the response from method VMInstanceGuestAgentsClient.BeginDelete.
type VMInstanceGuestAgentsClientDeleteResponse struct {
	// placeholder for future response values
}

// VMInstanceGuestAgentsClientGetResponse contains the response from method VMInstanceGuestAgentsClient.Get.
type VMInstanceGuestAgentsClientGetResponse struct {
	// Defines the GuestAgent.
	GuestAgent
}

// VMInstanceGuestAgentsClientListResponse contains the response from method VMInstanceGuestAgentsClient.NewListPager.
type VMInstanceGuestAgentsClientListResponse struct {
	// List of GuestAgent.
	GuestAgentList
}

// VMInstanceHybridIdentityMetadataClientGetResponse contains the response from method VMInstanceHybridIdentityMetadataClient.Get.
type VMInstanceHybridIdentityMetadataClientGetResponse struct {
	// Defines the HybridIdentityMetadata.
	VMInstanceHybridIdentityMetadata
}

// VMInstanceHybridIdentityMetadataClientListResponse contains the response from method VMInstanceHybridIdentityMetadataClient.NewListPager.
type VMInstanceHybridIdentityMetadataClientListResponse struct {
	// List of HybridIdentityMetadata.
	VMInstanceHybridIdentityMetadataList
}

// VirtualMachineInstancesClientCreateOrUpdateResponse contains the response from method VirtualMachineInstancesClient.BeginCreateOrUpdate.
type VirtualMachineInstancesClientCreateOrUpdateResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineInstancesClientDeleteResponse contains the response from method VirtualMachineInstancesClient.BeginDelete.
type VirtualMachineInstancesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientGetResponse contains the response from method VirtualMachineInstancesClient.Get.
type VirtualMachineInstancesClientGetResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineInstancesClientListResponse contains the response from method VirtualMachineInstancesClient.NewListPager.
type VirtualMachineInstancesClientListResponse struct {
	// List of VirtualMachineInstances.
	VirtualMachineInstancesList
}

// VirtualMachineInstancesClientRestartResponse contains the response from method VirtualMachineInstancesClient.BeginRestart.
type VirtualMachineInstancesClientRestartResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientStartResponse contains the response from method VirtualMachineInstancesClient.BeginStart.
type VirtualMachineInstancesClientStartResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientStopResponse contains the response from method VirtualMachineInstancesClient.BeginStop.
type VirtualMachineInstancesClientStopResponse struct {
	// placeholder for future response values
}

// VirtualMachineInstancesClientUpdateResponse contains the response from method VirtualMachineInstancesClient.BeginUpdate.
type VirtualMachineInstancesClientUpdateResponse struct {
	// Define the virtualMachineInstance.
	VirtualMachineInstance
}

// VirtualMachineTemplatesClientCreateResponse contains the response from method VirtualMachineTemplatesClient.BeginCreate.
type VirtualMachineTemplatesClientCreateResponse struct {
	// Define the virtualMachineTemplate.
	VirtualMachineTemplate
}

// VirtualMachineTemplatesClientDeleteResponse contains the response from method VirtualMachineTemplatesClient.BeginDelete.
type VirtualMachineTemplatesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualMachineTemplatesClientGetResponse contains the response from method VirtualMachineTemplatesClient.Get.
type VirtualMachineTemplatesClientGetResponse struct {
	// Define the virtualMachineTemplate.
	VirtualMachineTemplate
}

// VirtualMachineTemplatesClientListByResourceGroupResponse contains the response from method VirtualMachineTemplatesClient.NewListByResourceGroupPager.
type VirtualMachineTemplatesClientListByResourceGroupResponse struct {
	// List of VirtualMachineTemplates.
	VirtualMachineTemplatesList
}

// VirtualMachineTemplatesClientListResponse contains the response from method VirtualMachineTemplatesClient.NewListPager.
type VirtualMachineTemplatesClientListResponse struct {
	// List of VirtualMachineTemplates.
	VirtualMachineTemplatesList
}

// VirtualMachineTemplatesClientUpdateResponse contains the response from method VirtualMachineTemplatesClient.Update.
type VirtualMachineTemplatesClientUpdateResponse struct {
	// Define the virtualMachineTemplate.
	VirtualMachineTemplate
}

// VirtualNetworksClientCreateResponse contains the response from method VirtualNetworksClient.BeginCreate.
type VirtualNetworksClientCreateResponse struct {
	// Define the virtualNetwork.
	VirtualNetwork
}

// VirtualNetworksClientDeleteResponse contains the response from method VirtualNetworksClient.BeginDelete.
type VirtualNetworksClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualNetworksClientGetResponse contains the response from method VirtualNetworksClient.Get.
type VirtualNetworksClientGetResponse struct {
	// Define the virtualNetwork.
	VirtualNetwork
}

// VirtualNetworksClientListByResourceGroupResponse contains the response from method VirtualNetworksClient.NewListByResourceGroupPager.
type VirtualNetworksClientListByResourceGroupResponse struct {
	// List of VirtualNetworks.
	VirtualNetworksList
}

// VirtualNetworksClientListResponse contains the response from method VirtualNetworksClient.NewListPager.
type VirtualNetworksClientListResponse struct {
	// List of VirtualNetworks.
	VirtualNetworksList
}

// VirtualNetworksClientUpdateResponse contains the response from method VirtualNetworksClient.Update.
type VirtualNetworksClientUpdateResponse struct {
	// Define the virtualNetwork.
	VirtualNetwork
}
