//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdashboard

// GrafanaClientCheckEnterpriseDetailsResponse contains the response from method GrafanaClient.CheckEnterpriseDetails.
type GrafanaClientCheckEnterpriseDetailsResponse struct {
	// Enterprise details of a Grafana instance
	EnterpriseDetails
}

// GrafanaClientCreateResponse contains the response from method GrafanaClient.BeginCreate.
type GrafanaClientCreateResponse struct {
	// The grafana resource type.
	ManagedGrafana
}

// GrafanaClientDeleteResponse contains the response from method GrafanaClient.BeginDelete.
type GrafanaClientDeleteResponse struct {
	// placeholder for future response values
}

// GrafanaClientFetchAvailablePluginsResponse contains the response from method GrafanaClient.FetchAvailablePlugins.
type GrafanaClientFetchAvailablePluginsResponse struct {
	GrafanaAvailablePluginListResponse
}

// GrafanaClientGetResponse contains the response from method GrafanaClient.Get.
type GrafanaClientGetResponse struct {
	// The grafana resource type.
	ManagedGrafana
}

// GrafanaClientListByResourceGroupResponse contains the response from method GrafanaClient.NewListByResourceGroupPager.
type GrafanaClientListByResourceGroupResponse struct {
	ManagedGrafanaListResponse
}

// GrafanaClientListResponse contains the response from method GrafanaClient.NewListPager.
type GrafanaClientListResponse struct {
	ManagedGrafanaListResponse
}

// GrafanaClientUpdateResponse contains the response from method GrafanaClient.Update.
type GrafanaClientUpdateResponse struct {
	// The grafana resource type.
	ManagedGrafana

	// AzureAsyncOperation contains the information returned from the Azure-AsyncOperation header response.
	AzureAsyncOperation *string
}

// ManagedPrivateEndpointsClientCreateResponse contains the response from method ManagedPrivateEndpointsClient.BeginCreate.
type ManagedPrivateEndpointsClientCreateResponse struct {
	// The managed private endpoint resource type.
	ManagedPrivateEndpointModel
}

// ManagedPrivateEndpointsClientDeleteResponse contains the response from method ManagedPrivateEndpointsClient.BeginDelete.
type ManagedPrivateEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// ManagedPrivateEndpointsClientGetResponse contains the response from method ManagedPrivateEndpointsClient.Get.
type ManagedPrivateEndpointsClientGetResponse struct {
	// The managed private endpoint resource type.
	ManagedPrivateEndpointModel
}

// ManagedPrivateEndpointsClientListResponse contains the response from method ManagedPrivateEndpointsClient.NewListPager.
type ManagedPrivateEndpointsClientListResponse struct {
	// The list of managed private endpoints of a grafana resource
	ManagedPrivateEndpointModelListResponse
}

// ManagedPrivateEndpointsClientRefreshResponse contains the response from method ManagedPrivateEndpointsClient.BeginRefresh.
type ManagedPrivateEndpointsClientRefreshResponse struct {
	// placeholder for future response values
}

// ManagedPrivateEndpointsClientUpdateResponse contains the response from method ManagedPrivateEndpointsClient.BeginUpdate.
type ManagedPrivateEndpointsClientUpdateResponse struct {
	// The managed private endpoint resource type.
	ManagedPrivateEndpointModel
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientApproveResponse contains the response from method PrivateEndpointConnectionsClient.BeginApprove.
type PrivateEndpointConnectionsClientApproveResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// A private link resource
	PrivateLinkResource
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.NewListPager.
type PrivateLinkResourcesClientListResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}
