//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdatabox

// JobsClientBeginCreateOptions contains the optional parameters for the JobsClient.BeginCreate method.
type JobsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobsClientBeginDeleteOptions contains the optional parameters for the JobsClient.BeginDelete method.
type JobsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobsClientBeginUpdateOptions contains the optional parameters for the JobsClient.BeginUpdate method.
type JobsClientBeginUpdateOptions struct {
	// Defines the If-Match condition. The patch will be performed only if the ETag of the job on the server matches this value.
	IfMatch *string

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobsClientBookShipmentPickUpOptions contains the optional parameters for the JobsClient.BookShipmentPickUp method.
type JobsClientBookShipmentPickUpOptions struct {
	// placeholder for future optional parameters
}

// JobsClientCancelOptions contains the optional parameters for the JobsClient.Cancel method.
type JobsClientCancelOptions struct {
	// placeholder for future optional parameters
}

// JobsClientGetOptions contains the optional parameters for the JobsClient.Get method.
type JobsClientGetOptions struct {
	// $expand is supported on details parameter for job, which provides details on the job stages.
	Expand *string
}

// JobsClientListByResourceGroupOptions contains the optional parameters for the JobsClient.NewListByResourceGroupPager method.
type JobsClientListByResourceGroupOptions struct {
	// $skipToken is supported on Get list of jobs, which provides the next page in the list of jobs.
	SkipToken *string
}

// JobsClientListCredentialsOptions contains the optional parameters for the JobsClient.NewListCredentialsPager method.
type JobsClientListCredentialsOptions struct {
	// placeholder for future optional parameters
}

// JobsClientListOptions contains the optional parameters for the JobsClient.NewListPager method.
type JobsClientListOptions struct {
	// $skipToken is supported on Get list of jobs, which provides the next page in the list of jobs.
	SkipToken *string
}

// JobsClientMarkDevicesShippedOptions contains the optional parameters for the JobsClient.MarkDevicesShipped method.
type JobsClientMarkDevicesShippedOptions struct {
	// placeholder for future optional parameters
}

// ManagementClientMitigateOptions contains the optional parameters for the ManagementClient.Mitigate method.
type ManagementClientMitigateOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientListAvailableSKUsByResourceGroupOptions contains the optional parameters for the ServiceClient.NewListAvailableSKUsByResourceGroupPager
// method.
type ServiceClientListAvailableSKUsByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientRegionConfigurationByResourceGroupOptions contains the optional parameters for the ServiceClient.RegionConfigurationByResourceGroup
// method.
type ServiceClientRegionConfigurationByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientRegionConfigurationOptions contains the optional parameters for the ServiceClient.RegionConfiguration method.
type ServiceClientRegionConfigurationOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientValidateAddressOptions contains the optional parameters for the ServiceClient.ValidateAddress method.
type ServiceClientValidateAddressOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientValidateInputsByResourceGroupOptions contains the optional parameters for the ServiceClient.ValidateInputsByResourceGroup
// method.
type ServiceClientValidateInputsByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ServiceClientValidateInputsOptions contains the optional parameters for the ServiceClient.ValidateInputs method.
type ServiceClientValidateInputsOptions struct {
	// placeholder for future optional parameters
}
