//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/databricks/armdatabricks"
	"net/http"
	"net/url"
	"regexp"
)

// OutboundNetworkDependenciesEndpointsServer is a fake server for instances of the armdatabricks.OutboundNetworkDependenciesEndpointsClient type.
type OutboundNetworkDependenciesEndpointsServer struct {
	// List is the fake for method OutboundNetworkDependenciesEndpointsClient.List
	// HTTP status codes to indicate success: http.StatusOK
	List func(ctx context.Context, resourceGroupName string, workspaceName string, options *armdatabricks.OutboundNetworkDependenciesEndpointsClientListOptions) (resp azfake.Responder[armdatabricks.OutboundNetworkDependenciesEndpointsClientListResponse], errResp azfake.ErrorResponder)
}

// NewOutboundNetworkDependenciesEndpointsServerTransport creates a new instance of OutboundNetworkDependenciesEndpointsServerTransport with the provided implementation.
// The returned OutboundNetworkDependenciesEndpointsServerTransport instance is connected to an instance of armdatabricks.OutboundNetworkDependenciesEndpointsClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewOutboundNetworkDependenciesEndpointsServerTransport(srv *OutboundNetworkDependenciesEndpointsServer) *OutboundNetworkDependenciesEndpointsServerTransport {
	return &OutboundNetworkDependenciesEndpointsServerTransport{srv: srv}
}

// OutboundNetworkDependenciesEndpointsServerTransport connects instances of armdatabricks.OutboundNetworkDependenciesEndpointsClient to instances of OutboundNetworkDependenciesEndpointsServer.
// Don't use this type directly, use NewOutboundNetworkDependenciesEndpointsServerTransport instead.
type OutboundNetworkDependenciesEndpointsServerTransport struct {
	srv *OutboundNetworkDependenciesEndpointsServer
}

// Do implements the policy.Transporter interface for OutboundNetworkDependenciesEndpointsServerTransport.
func (o *OutboundNetworkDependenciesEndpointsServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "OutboundNetworkDependenciesEndpointsClient.List":
		resp, err = o.dispatchList(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (o *OutboundNetworkDependenciesEndpointsServerTransport) dispatchList(req *http.Request) (*http.Response, error) {
	if o.srv.List == nil {
		return nil, &nonRetriableError{errors.New("fake for method List not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Databricks/workspaces/(?P<workspaceName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/outboundNetworkDependenciesEndpoints`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 3 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	workspaceNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("workspaceName")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := o.srv.List(req.Context(), resourceGroupNameParam, workspaceNameParam, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).OutboundEnvironmentEndpointArray, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
