//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdatalakestore

// AccountsClientCheckNameAvailabilityResponse contains the response from method AccountsClient.CheckNameAvailability.
type AccountsClientCheckNameAvailabilityResponse struct {
	// Data Lake Store account name availability result information.
	NameAvailabilityInformation
}

// AccountsClientCreateResponse contains the response from method AccountsClient.BeginCreate.
type AccountsClientCreateResponse struct {
	// Data Lake Store account information.
	Account
}

// AccountsClientDeleteResponse contains the response from method AccountsClient.BeginDelete.
type AccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountsClientEnableKeyVaultResponse contains the response from method AccountsClient.EnableKeyVault.
type AccountsClientEnableKeyVaultResponse struct {
	// placeholder for future response values
}

// AccountsClientGetResponse contains the response from method AccountsClient.Get.
type AccountsClientGetResponse struct {
	// Data Lake Store account information.
	Account
}

// AccountsClientListByResourceGroupResponse contains the response from method AccountsClient.NewListByResourceGroupPager.
type AccountsClientListByResourceGroupResponse struct {
	// Data Lake Store account list information response.
	AccountListResult
}

// AccountsClientListResponse contains the response from method AccountsClient.NewListPager.
type AccountsClientListResponse struct {
	// Data Lake Store account list information response.
	AccountListResult
}

// AccountsClientUpdateResponse contains the response from method AccountsClient.BeginUpdate.
type AccountsClientUpdateResponse struct {
	// Data Lake Store account information.
	Account
}

// FirewallRulesClientCreateOrUpdateResponse contains the response from method FirewallRulesClient.CreateOrUpdate.
type FirewallRulesClientCreateOrUpdateResponse struct {
	// Data Lake Store firewall rule information.
	FirewallRule
}

// FirewallRulesClientDeleteResponse contains the response from method FirewallRulesClient.Delete.
type FirewallRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// FirewallRulesClientGetResponse contains the response from method FirewallRulesClient.Get.
type FirewallRulesClientGetResponse struct {
	// Data Lake Store firewall rule information.
	FirewallRule
}

// FirewallRulesClientListByAccountResponse contains the response from method FirewallRulesClient.NewListByAccountPager.
type FirewallRulesClientListByAccountResponse struct {
	// Data Lake Store firewall rule list information.
	FirewallRuleListResult
}

// FirewallRulesClientUpdateResponse contains the response from method FirewallRulesClient.Update.
type FirewallRulesClientUpdateResponse struct {
	// Data Lake Store firewall rule information.
	FirewallRule
}

// LocationsClientGetCapabilityResponse contains the response from method LocationsClient.GetCapability.
type LocationsClientGetCapabilityResponse struct {
	// Subscription-level properties and limits for Data Lake Store.
	CapabilityInformation
}

// LocationsClientGetUsageResponse contains the response from method LocationsClient.NewGetUsagePager.
type LocationsClientGetUsageResponse struct {
	// The response from the List Usages operation.
	UsageListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.List.
type OperationsClientListResponse struct {
	// The list of available operations for Data Lake Store.
	OperationListResult
}

// TrustedIDProvidersClientCreateOrUpdateResponse contains the response from method TrustedIDProvidersClient.CreateOrUpdate.
type TrustedIDProvidersClientCreateOrUpdateResponse struct {
	// Data Lake Store trusted identity provider information.
	TrustedIDProvider
}

// TrustedIDProvidersClientDeleteResponse contains the response from method TrustedIDProvidersClient.Delete.
type TrustedIDProvidersClientDeleteResponse struct {
	// placeholder for future response values
}

// TrustedIDProvidersClientGetResponse contains the response from method TrustedIDProvidersClient.Get.
type TrustedIDProvidersClientGetResponse struct {
	// Data Lake Store trusted identity provider information.
	TrustedIDProvider
}

// TrustedIDProvidersClientListByAccountResponse contains the response from method TrustedIDProvidersClient.NewListByAccountPager.
type TrustedIDProvidersClientListByAccountResponse struct {
	// Data Lake Store trusted identity provider list information.
	TrustedIDProviderListResult
}

// TrustedIDProvidersClientUpdateResponse contains the response from method TrustedIDProvidersClient.Update.
type TrustedIDProvidersClientUpdateResponse struct {
	// Data Lake Store trusted identity provider information.
	TrustedIDProvider
}

// VirtualNetworkRulesClientCreateOrUpdateResponse contains the response from method VirtualNetworkRulesClient.CreateOrUpdate.
type VirtualNetworkRulesClientCreateOrUpdateResponse struct {
	// Data Lake Store virtual network rule information.
	VirtualNetworkRule
}

// VirtualNetworkRulesClientDeleteResponse contains the response from method VirtualNetworkRulesClient.Delete.
type VirtualNetworkRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// VirtualNetworkRulesClientGetResponse contains the response from method VirtualNetworkRulesClient.Get.
type VirtualNetworkRulesClientGetResponse struct {
	// Data Lake Store virtual network rule information.
	VirtualNetworkRule
}

// VirtualNetworkRulesClientListByAccountResponse contains the response from method VirtualNetworkRulesClient.NewListByAccountPager.
type VirtualNetworkRulesClientListByAccountResponse struct {
	// Data Lake Store virtual network rule list information.
	VirtualNetworkRuleListResult
}

// VirtualNetworkRulesClientUpdateResponse contains the response from method VirtualNetworkRulesClient.Update.
type VirtualNetworkRulesClientUpdateResponse struct {
	// Data Lake Store virtual network rule information.
	VirtualNetworkRule
}
