//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"encoding/json"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/dataprotection/armdataprotection/v3"
)

func unmarshalAzureBackupRestoreRequestClassification(rawMsg json.RawMessage) (armdataprotection.AzureBackupRestoreRequestClassification, error) {
	if rawMsg == nil || string(rawMsg) == "null" {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b armdataprotection.AzureBackupRestoreRequestClassification
	switch m["objectType"] {
	case "AzureBackupRecoveryPointBasedRestoreRequest":
		b = &armdataprotection.AzureBackupRecoveryPointBasedRestoreRequest{}
	case "AzureBackupRecoveryTimeBasedRestoreRequest":
		b = &armdataprotection.AzureBackupRecoveryTimeBasedRestoreRequest{}
	case "AzureBackupRestoreWithRehydrationRequest":
		b = &armdataprotection.AzureBackupRestoreWithRehydrationRequest{}
	default:
		b = &armdataprotection.AzureBackupRestoreRequest{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}

func unmarshalFeatureValidationRequestBaseClassification(rawMsg json.RawMessage) (armdataprotection.FeatureValidationRequestBaseClassification, error) {
	if rawMsg == nil || string(rawMsg) == "null" {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b armdataprotection.FeatureValidationRequestBaseClassification
	switch m["objectType"] {
	case "FeatureValidationRequest":
		b = &armdataprotection.FeatureValidationRequest{}
	default:
		b = &armdataprotection.FeatureValidationRequestBase{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}
