//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdataprotection

// BackupInstancesClientBeginAdhocBackupOptions contains the optional parameters for the BackupInstancesClient.BeginAdhocBackup
// method.
type BackupInstancesClientBeginAdhocBackupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginCreateOrUpdateOptions contains the optional parameters for the BackupInstancesClient.BeginCreateOrUpdate
// method.
type BackupInstancesClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupInstancesClientBeginDeleteOptions contains the optional parameters for the BackupInstancesClient.BeginDelete method.
type BackupInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupInstancesClientBeginResumeBackupsOptions contains the optional parameters for the BackupInstancesClient.BeginResumeBackups
// method.
type BackupInstancesClientBeginResumeBackupsOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginResumeProtectionOptions contains the optional parameters for the BackupInstancesClient.BeginResumeProtection
// method.
type BackupInstancesClientBeginResumeProtectionOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginStopProtectionOptions contains the optional parameters for the BackupInstancesClient.BeginStopProtection
// method.
type BackupInstancesClientBeginStopProtectionOptions struct {
	// Request body for operation
	Parameters *StopProtectionRequest

	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupInstancesClientBeginSuspendBackupsOptions contains the optional parameters for the BackupInstancesClient.BeginSuspendBackups
// method.
type BackupInstancesClientBeginSuspendBackupsOptions struct {
	// Request body for operation
	Parameters *SuspendBackupRequest

	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupInstancesClientBeginSyncBackupInstanceOptions contains the optional parameters for the BackupInstancesClient.BeginSyncBackupInstance
// method.
type BackupInstancesClientBeginSyncBackupInstanceOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginTriggerCrossRegionRestoreOptions contains the optional parameters for the BackupInstancesClient.BeginTriggerCrossRegionRestore
// method.
type BackupInstancesClientBeginTriggerCrossRegionRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginTriggerRehydrateOptions contains the optional parameters for the BackupInstancesClient.BeginTriggerRehydrate
// method.
type BackupInstancesClientBeginTriggerRehydrateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginTriggerRestoreOptions contains the optional parameters for the BackupInstancesClient.BeginTriggerRestore
// method.
type BackupInstancesClientBeginTriggerRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupInstancesClientBeginValidateCrossRegionRestoreOptions contains the optional parameters for the BackupInstancesClient.BeginValidateCrossRegionRestore
// method.
type BackupInstancesClientBeginValidateCrossRegionRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginValidateForBackupOptions contains the optional parameters for the BackupInstancesClient.BeginValidateForBackup
// method.
type BackupInstancesClientBeginValidateForBackupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientBeginValidateForRestoreOptions contains the optional parameters for the BackupInstancesClient.BeginValidateForRestore
// method.
type BackupInstancesClientBeginValidateForRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupInstancesClientGetBackupInstanceOperationResultOptions contains the optional parameters for the BackupInstancesClient.GetBackupInstanceOperationResult
// method.
type BackupInstancesClientGetBackupInstanceOperationResultOptions struct {
	// placeholder for future optional parameters
}

// BackupInstancesClientGetOptions contains the optional parameters for the BackupInstancesClient.Get method.
type BackupInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// BackupInstancesClientListOptions contains the optional parameters for the BackupInstancesClient.NewListPager method.
type BackupInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// BackupInstancesExtensionRoutingClientListOptions contains the optional parameters for the BackupInstancesExtensionRoutingClient.NewListPager
// method.
type BackupInstancesExtensionRoutingClientListOptions struct {
	// placeholder for future optional parameters
}

// BackupPoliciesClientCreateOrUpdateOptions contains the optional parameters for the BackupPoliciesClient.CreateOrUpdate
// method.
type BackupPoliciesClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// BackupPoliciesClientDeleteOptions contains the optional parameters for the BackupPoliciesClient.Delete method.
type BackupPoliciesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// BackupPoliciesClientGetOptions contains the optional parameters for the BackupPoliciesClient.Get method.
type BackupPoliciesClientGetOptions struct {
	// placeholder for future optional parameters
}

// BackupPoliciesClientListOptions contains the optional parameters for the BackupPoliciesClient.NewListPager method.
type BackupPoliciesClientListOptions struct {
	// placeholder for future optional parameters
}

// BackupVaultOperationResultsClientGetOptions contains the optional parameters for the BackupVaultOperationResultsClient.Get
// method.
type BackupVaultOperationResultsClientGetOptions struct {
	// placeholder for future optional parameters
}

// BackupVaultsClientBeginCreateOrUpdateOptions contains the optional parameters for the BackupVaultsClient.BeginCreateOrUpdate
// method.
type BackupVaultsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupVaultsClientBeginDeleteOptions contains the optional parameters for the BackupVaultsClient.BeginDelete method.
type BackupVaultsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// BackupVaultsClientBeginUpdateOptions contains the optional parameters for the BackupVaultsClient.BeginUpdate method.
type BackupVaultsClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken               string
	XMSAuthorizationAuxiliary *string
}

// BackupVaultsClientCheckNameAvailabilityOptions contains the optional parameters for the BackupVaultsClient.CheckNameAvailability
// method.
type BackupVaultsClientCheckNameAvailabilityOptions struct {
	// placeholder for future optional parameters
}

// BackupVaultsClientGetInResourceGroupOptions contains the optional parameters for the BackupVaultsClient.NewGetInResourceGroupPager
// method.
type BackupVaultsClientGetInResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// BackupVaultsClientGetInSubscriptionOptions contains the optional parameters for the BackupVaultsClient.NewGetInSubscriptionPager
// method.
type BackupVaultsClientGetInSubscriptionOptions struct {
	// placeholder for future optional parameters
}

// BackupVaultsClientGetOptions contains the optional parameters for the BackupVaultsClient.Get method.
type BackupVaultsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ClientCheckFeatureSupportOptions contains the optional parameters for the Client.CheckFeatureSupport method.
type ClientCheckFeatureSupportOptions struct {
	// placeholder for future optional parameters
}

// DeletedBackupInstancesClientBeginUndeleteOptions contains the optional parameters for the DeletedBackupInstancesClient.BeginUndelete
// method.
type DeletedBackupInstancesClientBeginUndeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DeletedBackupInstancesClientGetOptions contains the optional parameters for the DeletedBackupInstancesClient.Get method.
type DeletedBackupInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// DeletedBackupInstancesClientListOptions contains the optional parameters for the DeletedBackupInstancesClient.NewListPager
// method.
type DeletedBackupInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// DppResourceGuardProxyClientCreateOrUpdateOptions contains the optional parameters for the DppResourceGuardProxyClient.CreateOrUpdate
// method.
type DppResourceGuardProxyClientCreateOrUpdateOptions struct {
	// placeholder for future optional parameters
}

// DppResourceGuardProxyClientDeleteOptions contains the optional parameters for the DppResourceGuardProxyClient.Delete method.
type DppResourceGuardProxyClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// DppResourceGuardProxyClientGetOptions contains the optional parameters for the DppResourceGuardProxyClient.Get method.
type DppResourceGuardProxyClientGetOptions struct {
	// placeholder for future optional parameters
}

// DppResourceGuardProxyClientListOptions contains the optional parameters for the DppResourceGuardProxyClient.NewListPager
// method.
type DppResourceGuardProxyClientListOptions struct {
	// placeholder for future optional parameters
}

// DppResourceGuardProxyClientUnlockDeleteOptions contains the optional parameters for the DppResourceGuardProxyClient.UnlockDelete
// method.
type DppResourceGuardProxyClientUnlockDeleteOptions struct {
	XMSAuthorizationAuxiliary *string
}

// ExportJobsClientBeginTriggerOptions contains the optional parameters for the ExportJobsClient.BeginTrigger method.
type ExportJobsClientBeginTriggerOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ExportJobsOperationResultClientGetOptions contains the optional parameters for the ExportJobsOperationResultClient.Get
// method.
type ExportJobsOperationResultClientGetOptions struct {
	// placeholder for future optional parameters
}

// FetchCrossRegionRestoreJobClientGetOptions contains the optional parameters for the FetchCrossRegionRestoreJobClient.Get
// method.
type FetchCrossRegionRestoreJobClientGetOptions struct {
	// placeholder for future optional parameters
}

// FetchCrossRegionRestoreJobsClientListOptions contains the optional parameters for the FetchCrossRegionRestoreJobsClient.NewListPager
// method.
type FetchCrossRegionRestoreJobsClientListOptions struct {
	// OData filter options.
	Filter *string
}

// FetchSecondaryRecoveryPointsClientListOptions contains the optional parameters for the FetchSecondaryRecoveryPointsClient.NewListPager
// method.
type FetchSecondaryRecoveryPointsClientListOptions struct {
	// OData filter options.
	Filter *string

	// skipToken Filter.
	SkipToken *string
}

// JobsClientGetOptions contains the optional parameters for the JobsClient.Get method.
type JobsClientGetOptions struct {
	// placeholder for future optional parameters
}

// JobsClientListOptions contains the optional parameters for the JobsClient.NewListPager method.
type JobsClientListOptions struct {
	// placeholder for future optional parameters
}

// OperationResultClientGetOptions contains the optional parameters for the OperationResultClient.Get method.
type OperationResultClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationStatusBackupVaultContextClientGetOptions contains the optional parameters for the OperationStatusBackupVaultContextClient.Get
// method.
type OperationStatusBackupVaultContextClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationStatusClientGetOptions contains the optional parameters for the OperationStatusClient.Get method.
type OperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationStatusResourceGroupContextClientGetOptions contains the optional parameters for the OperationStatusResourceGroupContextClient.Get
// method.
type OperationStatusResourceGroupContextClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// RecoveryPointsClientGetOptions contains the optional parameters for the RecoveryPointsClient.Get method.
type RecoveryPointsClientGetOptions struct {
	// placeholder for future optional parameters
}

// RecoveryPointsClientListOptions contains the optional parameters for the RecoveryPointsClient.NewListPager method.
type RecoveryPointsClientListOptions struct {
	// OData filter options.
	Filter *string

	// skipToken Filter.
	SkipToken *string
}

// ResourceGuardsClientDeleteOptions contains the optional parameters for the ResourceGuardsClient.Delete method.
type ResourceGuardsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetBackupSecurityPINRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetBackupSecurityPINRequestsObjectsPager
// method.
type ResourceGuardsClientGetBackupSecurityPINRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultBackupSecurityPINRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultBackupSecurityPINRequestsObject
// method.
type ResourceGuardsClientGetDefaultBackupSecurityPINRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultDeleteProtectedItemRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultDeleteProtectedItemRequestsObject
// method.
type ResourceGuardsClientGetDefaultDeleteProtectedItemRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultDeleteResourceGuardProxyRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultDeleteResourceGuardProxyRequestsObject
// method.
type ResourceGuardsClientGetDefaultDeleteResourceGuardProxyRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultDisableSoftDeleteRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultDisableSoftDeleteRequestsObject
// method.
type ResourceGuardsClientGetDefaultDisableSoftDeleteRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultUpdateProtectedItemRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultUpdateProtectedItemRequestsObject
// method.
type ResourceGuardsClientGetDefaultUpdateProtectedItemRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDefaultUpdateProtectionPolicyRequestsObjectOptions contains the optional parameters for the ResourceGuardsClient.GetDefaultUpdateProtectionPolicyRequestsObject
// method.
type ResourceGuardsClientGetDefaultUpdateProtectionPolicyRequestsObjectOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDeleteProtectedItemRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetDeleteProtectedItemRequestsObjectsPager
// method.
type ResourceGuardsClientGetDeleteProtectedItemRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDeleteResourceGuardProxyRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetDeleteResourceGuardProxyRequestsObjectsPager
// method.
type ResourceGuardsClientGetDeleteResourceGuardProxyRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetDisableSoftDeleteRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetDisableSoftDeleteRequestsObjectsPager
// method.
type ResourceGuardsClientGetDisableSoftDeleteRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetOptions contains the optional parameters for the ResourceGuardsClient.Get method.
type ResourceGuardsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetResourcesInResourceGroupOptions contains the optional parameters for the ResourceGuardsClient.NewGetResourcesInResourceGroupPager
// method.
type ResourceGuardsClientGetResourcesInResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetResourcesInSubscriptionOptions contains the optional parameters for the ResourceGuardsClient.NewGetResourcesInSubscriptionPager
// method.
type ResourceGuardsClientGetResourcesInSubscriptionOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetUpdateProtectedItemRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetUpdateProtectedItemRequestsObjectsPager
// method.
type ResourceGuardsClientGetUpdateProtectedItemRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientGetUpdateProtectionPolicyRequestsObjectsOptions contains the optional parameters for the ResourceGuardsClient.NewGetUpdateProtectionPolicyRequestsObjectsPager
// method.
type ResourceGuardsClientGetUpdateProtectionPolicyRequestsObjectsOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientPatchOptions contains the optional parameters for the ResourceGuardsClient.Patch method.
type ResourceGuardsClientPatchOptions struct {
	// placeholder for future optional parameters
}

// ResourceGuardsClientPutOptions contains the optional parameters for the ResourceGuardsClient.Put method.
type ResourceGuardsClientPutOptions struct {
	// placeholder for future optional parameters
}

// RestorableTimeRangesClientFindOptions contains the optional parameters for the RestorableTimeRangesClient.Find method.
type RestorableTimeRangesClientFindOptions struct {
	// placeholder for future optional parameters
}
