//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armdevhub_test

import (
	"context"
	"log"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/devhub/armdevhub"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_List.json
func ExampleIacProfilesClient_NewListPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewIacProfilesClient().NewListPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.IacProfileListResult = armdevhub.IacProfileListResult{
		// 	Value: []*armdevhub.IacProfile{
		// 		{
		// 			Name: to.Ptr("profilename"),
		// 			Type: to.Ptr("Microsoft.DevHub/iacProfiles"),
		// 			ID: to.Ptr("/subscriptions/a0a37f63-7183-4e86-9ac7-ce8036a3ed31/resourceGroups/resourceGroup1/providers/Microsoft.DevHub/iacProfiles/profilename"),
		// 			SystemData: &armdevhub.SystemData{
		// 				CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:23.933Z"); return t}()),
		// 				CreatedBy: to.Ptr(""),
		// 				CreatedByType: to.Ptr(armdevhub.CreatedByTypeUser),
		// 				LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T14:32:00.783Z"); return t}()),
		// 				LastModifiedBy: to.Ptr("aks-dev-hub-devhub"),
		// 				LastModifiedByType: to.Ptr(armdevhub.CreatedByTypeApplication),
		// 			},
		// 			Location: to.Ptr(""),
		// 			Tags: map[string]*string{
		// 			},
		// 			Properties: &armdevhub.IacProfileProperties{
		// 				GithubProfile: &armdevhub.IacGitHubProfile{
		// 					AuthStatus: to.Ptr(armdevhub.AuthorizationStatusAuthorized),
		// 					BranchName: to.Ptr("aks-devhub-ybvmw"),
		// 					PrStatus: to.Ptr(armdevhub.PullRequestStatusSubmitted),
		// 					PullNumber: to.Ptr[int32](8),
		// 					RepositoryMainBranch: to.Ptr("main"),
		// 					RepositoryName: to.Ptr("localtest"),
		// 					RepositoryOwner: to.Ptr("owner"),
		// 				},
		// 				Stages: []*armdevhub.StageProperties{
		// 					{
		// 						Dependencies: []*string{
		// 						},
		// 						GitEnvironment: to.Ptr("Terraform"),
		// 						StageName: to.Ptr("dev"),
		// 					},
		// 					{
		// 						Dependencies: []*string{
		// 							to.Ptr("dev")},
		// 							GitEnvironment: to.Ptr("Terraform"),
		// 							StageName: to.Ptr("qa"),
		// 						},
		// 						{
		// 							Dependencies: []*string{
		// 								to.Ptr("qa")},
		// 								GitEnvironment: to.Ptr("Terraform"),
		// 								StageName: to.Ptr("prod"),
		// 						}},
		// 						Templates: []*armdevhub.IacTemplateProperties{
		// 							{
		// 								InstanceName: to.Ptr("contoso"),
		// 								InstanceStage: to.Ptr("dev"),
		// 								SourceResourceID: to.Ptr("/subscriptions/xxxx/resourceGroups/xxxx"),
		// 								TemplateDetails: []*armdevhub.IacTemplateDetails{
		// 									{
		// 										Count: to.Ptr[int32](1),
		// 										NamingConvention: to.Ptr("$sitid-hci"),
		// 										ProductName: to.Ptr("HCI"),
		// 									},
		// 									{
		// 										Count: to.Ptr[int32](1),
		// 										NamingConvention: to.Ptr("$sitid-aks"),
		// 										ProductName: to.Ptr("AKSarc"),
		// 								}},
		// 								TemplateName: to.Ptr("base"),
		// 						}},
		// 						TerraformProfile: &armdevhub.TerraformProfile{
		// 							StorageAccountName: to.Ptr("hybridiac"),
		// 							StorageAccountResourceGroup: to.Ptr("hybrid-iac"),
		// 							StorageAccountSubscription: to.Ptr("subscription"),
		// 							StorageContainerName: to.Ptr("hybridiac"),
		// 						},
		// 					},
		// 			}},
		// 		}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_ListByResourceGroup.json
func ExampleIacProfilesClient_NewListByResourceGroupPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewIacProfilesClient().NewListByResourceGroupPager("resourceGroup1", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.IacProfileListResult = armdevhub.IacProfileListResult{
		// 	Value: []*armdevhub.IacProfile{
		// 		{
		// 			Name: to.Ptr("profilename"),
		// 			Type: to.Ptr("Microsoft.DevHub/iacProfiles"),
		// 			ID: to.Ptr("/subscriptions/a0a37f63-7183-4e86-9ac7-ce8036a3ed31/resourceGroups/resourceGroup1/providers/Microsoft.DevHub/iacProfiles/profilename"),
		// 			SystemData: &armdevhub.SystemData{
		// 				CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:23.933Z"); return t}()),
		// 				CreatedBy: to.Ptr(""),
		// 				CreatedByType: to.Ptr(armdevhub.CreatedByTypeUser),
		// 				LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T14:32:00.783Z"); return t}()),
		// 				LastModifiedBy: to.Ptr("aks-dev-hub-devhub"),
		// 				LastModifiedByType: to.Ptr(armdevhub.CreatedByTypeApplication),
		// 			},
		// 			Location: to.Ptr(""),
		// 			Tags: map[string]*string{
		// 			},
		// 			Properties: &armdevhub.IacProfileProperties{
		// 				GithubProfile: &armdevhub.IacGitHubProfile{
		// 					AuthStatus: to.Ptr(armdevhub.AuthorizationStatusAuthorized),
		// 					BranchName: to.Ptr("aks-devhub-ybvmw"),
		// 					PrStatus: to.Ptr(armdevhub.PullRequestStatusSubmitted),
		// 					PullNumber: to.Ptr[int32](8),
		// 					RepositoryMainBranch: to.Ptr("main"),
		// 					RepositoryName: to.Ptr("localtest"),
		// 					RepositoryOwner: to.Ptr("owner"),
		// 				},
		// 				Stages: []*armdevhub.StageProperties{
		// 					{
		// 						Dependencies: []*string{
		// 						},
		// 						GitEnvironment: to.Ptr("Terraform"),
		// 						StageName: to.Ptr("dev"),
		// 					},
		// 					{
		// 						Dependencies: []*string{
		// 							to.Ptr("dev")},
		// 							GitEnvironment: to.Ptr("Terraform"),
		// 							StageName: to.Ptr("qa"),
		// 						},
		// 						{
		// 							Dependencies: []*string{
		// 								to.Ptr("qa")},
		// 								GitEnvironment: to.Ptr("Terraform"),
		// 								StageName: to.Ptr("prod"),
		// 						}},
		// 						Templates: []*armdevhub.IacTemplateProperties{
		// 							{
		// 								InstanceName: to.Ptr("contoso"),
		// 								InstanceStage: to.Ptr("dev"),
		// 								SourceResourceID: to.Ptr("/subscriptions/xxxx/resourceGroups/xxxx"),
		// 								TemplateDetails: []*armdevhub.IacTemplateDetails{
		// 									{
		// 										Count: to.Ptr[int32](1),
		// 										NamingConvention: to.Ptr("$sitid-hci"),
		// 										ProductName: to.Ptr("HCI"),
		// 									},
		// 									{
		// 										Count: to.Ptr[int32](1),
		// 										NamingConvention: to.Ptr("$sitid-aks"),
		// 										ProductName: to.Ptr("AKSarc"),
		// 								}},
		// 								TemplateName: to.Ptr("base"),
		// 						}},
		// 						TerraformProfile: &armdevhub.TerraformProfile{
		// 							StorageAccountName: to.Ptr("hybridiac"),
		// 							StorageAccountResourceGroup: to.Ptr("hybrid-iac"),
		// 							StorageAccountSubscription: to.Ptr("subscription"),
		// 							StorageContainerName: to.Ptr("hybridiac"),
		// 						},
		// 					},
		// 			}},
		// 		}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_Get.json
func ExampleIacProfilesClient_Get() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewIacProfilesClient().Get(ctx, "resourceGroup1", "iacprofile", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.IacProfile = armdevhub.IacProfile{
	// 	Name: to.Ptr("iacprofile"),
	// 	Type: to.Ptr("Micfosoft.DevHub/iacProfiles"),
	// 	ID: to.Ptr("/subscriptions/a0a37f63-7183-4e86-9ac7-ce8036a3ed31/resourceGroups/resourceGroup1/providers/Microsoft.DevHub/iacProfiles/iacprofile"),
	// 	SystemData: &armdevhub.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:23.933Z"); return t}()),
	// 		CreatedBy: to.Ptr(""),
	// 		CreatedByType: to.Ptr(armdevhub.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T14:35:15.206Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("aks-dev-hub-devhub"),
	// 		LastModifiedByType: to.Ptr(armdevhub.CreatedByTypeApplication),
	// 	},
	// 	Location: to.Ptr("location1"),
	// 	Tags: map[string]*string{
	// 		"appname": to.Ptr("testapp"),
	// 	},
	// 	Properties: &armdevhub.IacProfileProperties{
	// 		GithubProfile: &armdevhub.IacGitHubProfile{
	// 			AuthStatus: to.Ptr(armdevhub.AuthorizationStatusAuthorized),
	// 			BranchName: to.Ptr("aks-devhub-ybvmw"),
	// 			PrStatus: to.Ptr(armdevhub.PullRequestStatusSubmitted),
	// 			PullNumber: to.Ptr[int32](8),
	// 			RepositoryMainBranch: to.Ptr("main"),
	// 			RepositoryName: to.Ptr("localtest"),
	// 			RepositoryOwner: to.Ptr("owner"),
	// 		},
	// 		Stages: []*armdevhub.StageProperties{
	// 			{
	// 				Dependencies: []*string{
	// 				},
	// 				GitEnvironment: to.Ptr("Terraform"),
	// 				StageName: to.Ptr("dev"),
	// 			},
	// 			{
	// 				Dependencies: []*string{
	// 					to.Ptr("dev")},
	// 					GitEnvironment: to.Ptr("Terraform"),
	// 					StageName: to.Ptr("qa"),
	// 				},
	// 				{
	// 					Dependencies: []*string{
	// 						to.Ptr("qa")},
	// 						GitEnvironment: to.Ptr("Terraform"),
	// 						StageName: to.Ptr("prod"),
	// 				}},
	// 				Templates: []*armdevhub.IacTemplateProperties{
	// 					{
	// 						InstanceName: to.Ptr("contoso"),
	// 						InstanceStage: to.Ptr("dev"),
	// 						SourceResourceID: to.Ptr("/subscriptions/xxxx/resourceGroups/xxxx"),
	// 						TemplateDetails: []*armdevhub.IacTemplateDetails{
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-hci"),
	// 								ProductName: to.Ptr("HCI"),
	// 							},
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-aks"),
	// 								ProductName: to.Ptr("AKSarc"),
	// 						}},
	// 						TemplateName: to.Ptr("base"),
	// 				}},
	// 				TerraformProfile: &armdevhub.TerraformProfile{
	// 					StorageAccountName: to.Ptr("hybridiac"),
	// 					StorageAccountResourceGroup: to.Ptr("hybrid-iac"),
	// 					StorageAccountSubscription: to.Ptr("subscriptions"),
	// 					StorageContainerName: to.Ptr("hybridiac"),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_CreateOrUpdate.json
func ExampleIacProfilesClient_CreateOrUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewIacProfilesClient().CreateOrUpdate(ctx, "resourceGroup1", "profile1", armdevhub.IacProfile{
		Location: to.Ptr("eastus"),
		Properties: &armdevhub.IacProfileProperties{
			GithubProfile: &armdevhub.IacGitHubProfile{
				RepositoryName:  to.Ptr("localtest"),
				RepositoryOwner: to.Ptr("qfai"),
			},
			Stages: []*armdevhub.StageProperties{
				{
					Dependencies:   []*string{},
					GitEnvironment: to.Ptr("Terraform"),
					StageName:      to.Ptr("dev"),
				},
				{
					Dependencies: []*string{
						to.Ptr("dev")},
					GitEnvironment: to.Ptr("Terraform"),
					StageName:      to.Ptr("qa"),
				}},
			Templates: []*armdevhub.IacTemplateProperties{
				{
					InstanceName:           to.Ptr("quickinstance"),
					InstanceStage:          to.Ptr("dev"),
					QuickStartTemplateType: to.Ptr(armdevhub.QuickStartTemplateTypeHCIAKS),
					TemplateName:           to.Ptr("hciaksss"),
				}},
			TerraformProfile: &armdevhub.TerraformProfile{
				StorageAccountName:          to.Ptr("iacbackend"),
				StorageAccountResourceGroup: to.Ptr("test"),
				StorageAccountSubscription:  to.Ptr("586c20df-c465-4f10-8673-65aa4859e7ca"),
				StorageContainerName:        to.Ptr("tfbackend"),
			},
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.IacProfile = armdevhub.IacProfile{
	// 	Name: to.Ptr("profile1"),
	// 	Type: to.Ptr("Micfosoft.DevHub/iacProfiles"),
	// 	ID: to.Ptr("/subscriptions/a0a37f63-7183-4e86-9ac7-ce8036a3ed31/resourceGroups/resourceGroup1/providers/Microsoft.DevHub/iacProfiles/profile1"),
	// 	SystemData: &armdevhub.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:23.933Z"); return t}()),
	// 		CreatedBy: to.Ptr("foo@contoso.com"),
	// 		CreatedByType: to.Ptr(armdevhub.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:30.783Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("foo@contoso.com"),
	// 		LastModifiedByType: to.Ptr(armdevhub.CreatedByTypeUser),
	// 	},
	// 	Location: to.Ptr("location1"),
	// 	Tags: map[string]*string{
	// 		"appname": to.Ptr("testapp"),
	// 	},
	// 	Properties: &armdevhub.IacProfileProperties{
	// 		GithubProfile: &armdevhub.IacGitHubProfile{
	// 			AuthStatus: to.Ptr(armdevhub.AuthorizationStatus("Unspecified")),
	// 			BranchName: to.Ptr("aks-devhub-ybvmw"),
	// 			PrStatus: to.Ptr(armdevhub.PullRequestStatusSubmitted),
	// 			PullNumber: to.Ptr[int32](8),
	// 			RepositoryMainBranch: to.Ptr("main"),
	// 			RepositoryName: to.Ptr("localtest"),
	// 			RepositoryOwner: to.Ptr("owner"),
	// 		},
	// 		Stages: []*armdevhub.StageProperties{
	// 			{
	// 				Dependencies: []*string{
	// 				},
	// 				GitEnvironment: to.Ptr("Terraform"),
	// 				StageName: to.Ptr("dev"),
	// 			},
	// 			{
	// 				Dependencies: []*string{
	// 					to.Ptr("dev")},
	// 					GitEnvironment: to.Ptr("Terraform"),
	// 					StageName: to.Ptr("qa"),
	// 				},
	// 				{
	// 					Dependencies: []*string{
	// 						to.Ptr("qa")},
	// 						GitEnvironment: to.Ptr("Terraform"),
	// 						StageName: to.Ptr("prod"),
	// 				}},
	// 				Templates: []*armdevhub.IacTemplateProperties{
	// 					{
	// 						InstanceName: to.Ptr("contoso"),
	// 						InstanceStage: to.Ptr("dev"),
	// 						SourceResourceID: to.Ptr("/subscriptions/xxxx/resourceGroups/xxxx"),
	// 						TemplateDetails: []*armdevhub.IacTemplateDetails{
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-hci"),
	// 								ProductName: to.Ptr("HCI"),
	// 							},
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-aks"),
	// 								ProductName: to.Ptr("AKSarc"),
	// 						}},
	// 						TemplateName: to.Ptr("base"),
	// 				}},
	// 				TerraformProfile: &armdevhub.TerraformProfile{
	// 					StorageAccountName: to.Ptr("hybridiac"),
	// 					StorageAccountResourceGroup: to.Ptr("hybrid-iac"),
	// 					StorageAccountSubscription: to.Ptr("subscription"),
	// 					StorageContainerName: to.Ptr("hybridiac"),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_Delete.json
func ExampleIacProfilesClient_Delete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	_, err = clientFactory.NewIacProfilesClient().Delete(ctx, "resourceGroup1", "iacprofile", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_UpdateTags.json
func ExampleIacProfilesClient_UpdateTags() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewIacProfilesClient().UpdateTags(ctx, "resourceGroup1", "iacprofile", armdevhub.TagsObject{
		Tags: map[string]*string{
			"promote":     to.Ptr("false"),
			"resourceEnv": to.Ptr("testing"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.IacProfile = armdevhub.IacProfile{
	// 	Name: to.Ptr("iacprofile"),
	// 	Type: to.Ptr("Micfosoft.DevHub/iacProfiles"),
	// 	ID: to.Ptr("/subscriptions/a0a37f63-7183-4e86-9ac7-ce8036a3ed31/resourceGroups/resourceGroup1/providers/Microsoft.DevHub/iacProfiles/iacprofile"),
	// 	SystemData: &armdevhub.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T09:56:23.933Z"); return t}()),
	// 		CreatedBy: to.Ptr(""),
	// 		CreatedByType: to.Ptr(armdevhub.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-16T14:35:15.206Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("aks-dev-hub-devhub"),
	// 		LastModifiedByType: to.Ptr(armdevhub.CreatedByTypeApplication),
	// 	},
	// 	Location: to.Ptr("location1"),
	// 	Tags: map[string]*string{
	// 		"appname": to.Ptr("testapp"),
	// 		"promote": to.Ptr("false"),
	// 		"resourceEnv": to.Ptr("testing"),
	// 	},
	// 	Properties: &armdevhub.IacProfileProperties{
	// 		GithubProfile: &armdevhub.IacGitHubProfile{
	// 			AuthStatus: to.Ptr(armdevhub.AuthorizationStatusAuthorized),
	// 			BranchName: to.Ptr("aks-devhub-ybvmw"),
	// 			PrStatus: to.Ptr(armdevhub.PullRequestStatusSubmitted),
	// 			PullNumber: to.Ptr[int32](8),
	// 			RepositoryMainBranch: to.Ptr("main"),
	// 			RepositoryName: to.Ptr("localtest"),
	// 			RepositoryOwner: to.Ptr("owner"),
	// 		},
	// 		Stages: []*armdevhub.StageProperties{
	// 			{
	// 				Dependencies: []*string{
	// 				},
	// 				GitEnvironment: to.Ptr("Terraform"),
	// 				StageName: to.Ptr("dev"),
	// 			},
	// 			{
	// 				Dependencies: []*string{
	// 					to.Ptr("dev")},
	// 					GitEnvironment: to.Ptr("Terraform"),
	// 					StageName: to.Ptr("qa"),
	// 				},
	// 				{
	// 					Dependencies: []*string{
	// 						to.Ptr("qa")},
	// 						GitEnvironment: to.Ptr("Terraform"),
	// 						StageName: to.Ptr("prod"),
	// 				}},
	// 				Templates: []*armdevhub.IacTemplateProperties{
	// 					{
	// 						TemplateDetails: []*armdevhub.IacTemplateDetails{
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-hci"),
	// 								ProductName: to.Ptr("HCI"),
	// 							},
	// 							{
	// 								Count: to.Ptr[int32](1),
	// 								NamingConvention: to.Ptr("$sitid-aks"),
	// 								ProductName: to.Ptr("AKSarc"),
	// 						}},
	// 						TemplateName: to.Ptr("base"),
	// 				}},
	// 				TerraformProfile: &armdevhub.TerraformProfile{
	// 					StorageAccountName: to.Ptr("hybridiac"),
	// 					StorageAccountResourceGroup: to.Ptr("hybrid-iac"),
	// 					StorageAccountSubscription: to.Ptr("subscriptions"),
	// 					StorageContainerName: to.Ptr("hybridiac"),
	// 				},
	// 			},
	// 		}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_ExportTemplate.json
func ExampleIacProfilesClient_Export() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewIacProfilesClient().Export(ctx, "resourceGroup1", "iacprofile", armdevhub.ExportTemplateRequest{
		InstanceName:  to.Ptr("iac208"),
		InstanceStage: to.Ptr("dev"),
		ResourceGroupIDs: []*string{
			to.Ptr("/subscriptions/de3c4d5e-af08-451a-a873-438d86ab6f4b/resourceGroups/iac208-rg")},
		TemplateName: to.Ptr("test"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.PrLinkResponse = armdevhub.PrLinkResponse{
	// 	PrLink: to.Ptr("xxxx"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_ScaleTemplate.json
func ExampleIacProfilesClient_Scale() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewIacProfilesClient().Scale(ctx, "resourceGroup1", "iacprofile", armdevhub.ScaleTemplateRequest{
		ScaleProperties: []*armdevhub.ScaleProperty{
			{
				NumberOfStores: to.Ptr[int32](1),
				Region:         to.Ptr("useast"),
				Stage:          to.Ptr("dev"),
			}},
		TemplateName: to.Ptr("hciaksss"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.PrLinkResponse = armdevhub.PrLinkResponse{
	// 	PrLink: to.Ptr("xxxx"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/34f5146bc945549d087d38a8a593c0a5f475ad7f/specification/developerhub/resource-manager/Microsoft.DevHub/preview/2024-05-01-preview/examples/IacProfile_SyncTemplate.json
func ExampleIacProfilesClient_Sync() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armdevhub.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	_, err = clientFactory.NewIacProfilesClient().Sync(ctx, "resourceGroup1", "iacprofile", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
}
