//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdeviceupdate

// AccountsClientCreateResponse contains the response from method AccountsClient.BeginCreate.
type AccountsClientCreateResponse struct {
	// Device Update account details.
	Account
}

// AccountsClientDeleteResponse contains the response from method AccountsClient.BeginDelete.
type AccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// AccountsClientGetResponse contains the response from method AccountsClient.Get.
type AccountsClientGetResponse struct {
	// Device Update account details.
	Account
}

// AccountsClientHeadResponse contains the response from method AccountsClient.Head.
type AccountsClientHeadResponse struct {
	// Success indicates if the operation succeeded or failed.
	Success bool
}

// AccountsClientListByResourceGroupResponse contains the response from method AccountsClient.NewListByResourceGroupPager.
type AccountsClientListByResourceGroupResponse struct {
	// List of Accounts.
	AccountList
}

// AccountsClientListBySubscriptionResponse contains the response from method AccountsClient.NewListBySubscriptionPager.
type AccountsClientListBySubscriptionResponse struct {
	// List of Accounts.
	AccountList
}

// AccountsClientUpdateResponse contains the response from method AccountsClient.BeginUpdate.
type AccountsClientUpdateResponse struct {
	// Device Update account details.
	Account
}

// ClientCheckNameAvailabilityResponse contains the response from method Client.CheckNameAvailability.
type ClientCheckNameAvailabilityResponse struct {
	// The check availability result.
	CheckNameAvailabilityResponse
}

// InstancesClientCreateResponse contains the response from method InstancesClient.BeginCreate.
type InstancesClientCreateResponse struct {
	// Device Update instance details.
	Instance
}

// InstancesClientDeleteResponse contains the response from method InstancesClient.BeginDelete.
type InstancesClientDeleteResponse struct {
	// placeholder for future response values
}

// InstancesClientGetResponse contains the response from method InstancesClient.Get.
type InstancesClientGetResponse struct {
	// Device Update instance details.
	Instance
}

// InstancesClientHeadResponse contains the response from method InstancesClient.Head.
type InstancesClientHeadResponse struct {
	// Success indicates if the operation succeeded or failed.
	Success bool
}

// InstancesClientListByAccountResponse contains the response from method InstancesClient.NewListByAccountPager.
type InstancesClientListByAccountResponse struct {
	// List of Instances.
	InstanceList
}

// InstancesClientUpdateResponse contains the response from method InstancesClient.Update.
type InstancesClientUpdateResponse struct {
	// Device Update instance details.
	Instance
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionProxiesClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionProxiesClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionProxiesClientCreateOrUpdateResponse struct {
	// Private endpoint connection proxy details.
	PrivateEndpointConnectionProxy
}

// PrivateEndpointConnectionProxiesClientDeleteResponse contains the response from method PrivateEndpointConnectionProxiesClient.BeginDelete.
type PrivateEndpointConnectionProxiesClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionProxiesClientGetResponse contains the response from method PrivateEndpointConnectionProxiesClient.Get.
type PrivateEndpointConnectionProxiesClientGetResponse struct {
	// Private endpoint connection proxy details.
	PrivateEndpointConnectionProxy
}

// PrivateEndpointConnectionProxiesClientListByAccountResponse contains the response from method PrivateEndpointConnectionProxiesClient.NewListByAccountPager.
type PrivateEndpointConnectionProxiesClientListByAccountResponse struct {
	// The available private endpoint connection proxies for an Account (not to be used by anyone, here because of ARM requirements)
	PrivateEndpointConnectionProxyListResult
}

// PrivateEndpointConnectionProxiesClientUpdatePrivateEndpointPropertiesResponse contains the response from method PrivateEndpointConnectionProxiesClient.UpdatePrivateEndpointProperties.
type PrivateEndpointConnectionProxiesClientUpdatePrivateEndpointPropertiesResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionProxiesClientValidateResponse contains the response from method PrivateEndpointConnectionProxiesClient.Validate.
type PrivateEndpointConnectionProxiesClientValidateResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListByAccountResponse contains the response from method PrivateEndpointConnectionsClient.NewListByAccountPager.
type PrivateEndpointConnectionsClientListByAccountResponse struct {
	// List of private endpoint connection associated with the specified storage account
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// The group information for creating a private endpoint on an Account
	GroupInformation
}

// PrivateLinkResourcesClientListByAccountResponse contains the response from method PrivateLinkResourcesClient.NewListByAccountPager.
type PrivateLinkResourcesClientListByAccountResponse struct {
	// The available private link resources for an Account
	PrivateLinkResourceListResult
}
