//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdigitaltwins

// ClientCheckNameAvailabilityResponse contains the response from method Client.CheckNameAvailability.
type ClientCheckNameAvailabilityResponse struct {
	// The result returned from a check name availability request.
	CheckNameResult
}

// ClientCreateOrUpdateResponse contains the response from method Client.BeginCreateOrUpdate.
type ClientCreateOrUpdateResponse struct {
	// The description of the DigitalTwins service.
	Description
}

// ClientDeleteResponse contains the response from method Client.BeginDelete.
type ClientDeleteResponse struct {
	// The description of the DigitalTwins service.
	Description
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	// The description of the DigitalTwins service.
	Description
}

// ClientListByResourceGroupResponse contains the response from method Client.NewListByResourceGroupPager.
type ClientListByResourceGroupResponse struct {
	// A list of DigitalTwins description objects with a next link.
	DescriptionListResult
}

// ClientListResponse contains the response from method Client.NewListPager.
type ClientListResponse struct {
	// A list of DigitalTwins description objects with a next link.
	DescriptionListResult
}

// ClientUpdateResponse contains the response from method Client.BeginUpdate.
type ClientUpdateResponse struct {
	// The description of the DigitalTwins service.
	Description
}

// EndpointClientCreateOrUpdateResponse contains the response from method EndpointClient.BeginCreateOrUpdate.
type EndpointClientCreateOrUpdateResponse struct {
	// DigitalTwinsInstance endpoint resource.
	EndpointResource
}

// EndpointClientDeleteResponse contains the response from method EndpointClient.BeginDelete.
type EndpointClientDeleteResponse struct {
	// DigitalTwinsInstance endpoint resource.
	EndpointResource
}

// EndpointClientGetResponse contains the response from method EndpointClient.Get.
type EndpointClientGetResponse struct {
	// DigitalTwinsInstance endpoint resource.
	EndpointResource
}

// EndpointClientListResponse contains the response from method EndpointClient.NewListPager.
type EndpointClientListResponse struct {
	// A list of DigitalTwinsInstance Endpoints with a next link.
	EndpointResourceListResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of DigitalTwins service operations. It contains a list of operations and a URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginCreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The private endpoint connection of a Digital Twin.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The private endpoint connection of a Digital Twin.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.List.
type PrivateEndpointConnectionsClientListResponse struct {
	// The available private link connections for a Digital Twin.
	PrivateEndpointConnectionsResponse
}

// PrivateLinkResourcesClientGetResponse contains the response from method PrivateLinkResourcesClient.Get.
type PrivateLinkResourcesClientGetResponse struct {
	// The group information for creating a private endpoint on Digital Twin.
	GroupIDInformation
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	// The available private link resources for a Digital Twin.
	GroupIDInformationResponse
}

// TimeSeriesDatabaseConnectionsClientCreateOrUpdateResponse contains the response from method TimeSeriesDatabaseConnectionsClient.BeginCreateOrUpdate.
type TimeSeriesDatabaseConnectionsClientCreateOrUpdateResponse struct {
	// Describes a time series database connection resource.
	TimeSeriesDatabaseConnection
}

// TimeSeriesDatabaseConnectionsClientDeleteResponse contains the response from method TimeSeriesDatabaseConnectionsClient.BeginDelete.
type TimeSeriesDatabaseConnectionsClientDeleteResponse struct {
	// Describes a time series database connection resource.
	TimeSeriesDatabaseConnection
}

// TimeSeriesDatabaseConnectionsClientGetResponse contains the response from method TimeSeriesDatabaseConnectionsClient.Get.
type TimeSeriesDatabaseConnectionsClientGetResponse struct {
	// Describes a time series database connection resource.
	TimeSeriesDatabaseConnection
}

// TimeSeriesDatabaseConnectionsClientListResponse contains the response from method TimeSeriesDatabaseConnectionsClient.NewListPager.
type TimeSeriesDatabaseConnectionsClientListResponse struct {
	// A pageable list of time series database connection resources.
	TimeSeriesDatabaseConnectionListResult
}
