//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armdomainservices

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	credential     azcore.TokenCredential
	options        *arm.ClientOptions
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - Gets subscription credentials which uniquely identify the Microsoft Azure subscription. The subscription
//     ID forms part of the URI for every service call.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	_, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID, credential: credential,
		options: options.Clone(),
	}, nil
}

// NewClient creates a new instance of Client.
func (c *ClientFactory) NewClient() *Client {
	subClient, _ := NewClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

// NewDomainServiceOperationsClient creates a new instance of DomainServiceOperationsClient.
func (c *ClientFactory) NewDomainServiceOperationsClient() *DomainServiceOperationsClient {
	subClient, _ := NewDomainServiceOperationsClient(c.credential, c.options)
	return subClient
}

// NewOuContainerClient creates a new instance of OuContainerClient.
func (c *ClientFactory) NewOuContainerClient() *OuContainerClient {
	subClient, _ := NewOuContainerClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

// NewOuContainerOperationsClient creates a new instance of OuContainerOperationsClient.
func (c *ClientFactory) NewOuContainerOperationsClient() *OuContainerOperationsClient {
	subClient, _ := NewOuContainerOperationsClient(c.credential, c.options)
	return subClient
}
