//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Code generated by Microsoft (R) AutoRest Code Generator.Changes may cause incorrect behavior and will be lost if the code
// is regenerated.
// Code generated by @autorest/go. DO NOT EDIT.

package armelastic

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	internal       *arm.Client
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The ID of the target subscription. The value must be an UUID.
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	internal, err := arm.NewClient(moduleName, moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID,
		internal:       internal,
	}, nil
}

// NewAllTrafficFiltersClient creates a new instance of AllTrafficFiltersClient.
func (c *ClientFactory) NewAllTrafficFiltersClient() *AllTrafficFiltersClient {
	return &AllTrafficFiltersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewAssociateTrafficFilterClient creates a new instance of AssociateTrafficFilterClient.
func (c *ClientFactory) NewAssociateTrafficFilterClient() *AssociateTrafficFilterClient {
	return &AssociateTrafficFilterClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewBillingInfoClient creates a new instance of BillingInfoClient.
func (c *ClientFactory) NewBillingInfoClient() *BillingInfoClient {
	return &BillingInfoClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewConnectedPartnerResourcesClient creates a new instance of ConnectedPartnerResourcesClient.
func (c *ClientFactory) NewConnectedPartnerResourcesClient() *ConnectedPartnerResourcesClient {
	return &ConnectedPartnerResourcesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCreateAndAssociateIPFilterClient creates a new instance of CreateAndAssociateIPFilterClient.
func (c *ClientFactory) NewCreateAndAssociateIPFilterClient() *CreateAndAssociateIPFilterClient {
	return &CreateAndAssociateIPFilterClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewCreateAndAssociatePLFilterClient creates a new instance of CreateAndAssociatePLFilterClient.
func (c *ClientFactory) NewCreateAndAssociatePLFilterClient() *CreateAndAssociatePLFilterClient {
	return &CreateAndAssociatePLFilterClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDeploymentInfoClient creates a new instance of DeploymentInfoClient.
func (c *ClientFactory) NewDeploymentInfoClient() *DeploymentInfoClient {
	return &DeploymentInfoClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDetachAndDeleteTrafficFilterClient creates a new instance of DetachAndDeleteTrafficFilterClient.
func (c *ClientFactory) NewDetachAndDeleteTrafficFilterClient() *DetachAndDeleteTrafficFilterClient {
	return &DetachAndDeleteTrafficFilterClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewDetachTrafficFilterClient creates a new instance of DetachTrafficFilterClient.
func (c *ClientFactory) NewDetachTrafficFilterClient() *DetachTrafficFilterClient {
	return &DetachTrafficFilterClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewExternalUserClient creates a new instance of ExternalUserClient.
func (c *ClientFactory) NewExternalUserClient() *ExternalUserClient {
	return &ExternalUserClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewListAssociatedTrafficFiltersClient creates a new instance of ListAssociatedTrafficFiltersClient.
func (c *ClientFactory) NewListAssociatedTrafficFiltersClient() *ListAssociatedTrafficFiltersClient {
	return &ListAssociatedTrafficFiltersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewMonitorClient creates a new instance of MonitorClient.
func (c *ClientFactory) NewMonitorClient() *MonitorClient {
	return &MonitorClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewMonitoredResourcesClient creates a new instance of MonitoredResourcesClient.
func (c *ClientFactory) NewMonitoredResourcesClient() *MonitoredResourcesClient {
	return &MonitoredResourcesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewMonitorsClient creates a new instance of MonitorsClient.
func (c *ClientFactory) NewMonitorsClient() *MonitorsClient {
	return &MonitorsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOpenAIClient creates a new instance of OpenAIClient.
func (c *ClientFactory) NewOpenAIClient() *OpenAIClient {
	return &OpenAIClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewOperationsClient creates a new instance of OperationsClient.
func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	return &OperationsClient{
		internal: c.internal,
	}
}

// NewOrganizationsClient creates a new instance of OrganizationsClient.
func (c *ClientFactory) NewOrganizationsClient() *OrganizationsClient {
	return &OrganizationsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewTagRulesClient creates a new instance of TagRulesClient.
func (c *ClientFactory) NewTagRulesClient() *TagRulesClient {
	return &TagRulesClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewTrafficFiltersClient creates a new instance of TrafficFiltersClient.
func (c *ClientFactory) NewTrafficFiltersClient() *TrafficFiltersClient {
	return &TrafficFiltersClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewUpgradableVersionsClient creates a new instance of UpgradableVersionsClient.
func (c *ClientFactory) NewUpgradableVersionsClient() *UpgradableVersionsClient {
	return &UpgradableVersionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVMCollectionClient creates a new instance of VMCollectionClient.
func (c *ClientFactory) NewVMCollectionClient() *VMCollectionClient {
	return &VMCollectionClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVMHostClient creates a new instance of VMHostClient.
func (c *ClientFactory) NewVMHostClient() *VMHostClient {
	return &VMHostClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVMIngestionClient creates a new instance of VMIngestionClient.
func (c *ClientFactory) NewVMIngestionClient() *VMIngestionClient {
	return &VMIngestionClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}

// NewVersionsClient creates a new instance of VersionsClient.
func (c *ClientFactory) NewVersionsClient() *VersionsClient {
	return &VersionsClient{
		subscriptionID: c.subscriptionID,
		internal:       c.internal,
	}
}
