//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Code generated by Microsoft (R) AutoRest Code Generator.Changes may cause incorrect behavior and will be lost if the code
// is regenerated.
// Code generated by @autorest/go. DO NOT EDIT.

package armelastic

// AllTrafficFiltersClientListResponse contains the response from method AllTrafficFiltersClient.List.
type AllTrafficFiltersClientListResponse struct {
	// List of elastic traffic filters in the account
	TrafficFilterResponse
}

// AssociateTrafficFilterClientAssociateResponse contains the response from method AssociateTrafficFilterClient.BeginAssociate.
type AssociateTrafficFilterClientAssociateResponse struct {
	// placeholder for future response values
}

// BillingInfoClientGetResponse contains the response from method BillingInfoClient.Get.
type BillingInfoClientGetResponse struct {
	// Marketplace Subscription and Organization details to which resource gets billed into.
	BillingInfoResponse
}

// ConnectedPartnerResourcesClientListResponse contains the response from method ConnectedPartnerResourcesClient.NewListPager.
type ConnectedPartnerResourcesClientListResponse struct {
	// List of all active elastic deployments.
	ConnectedPartnerResourcesListResponse
}

// CreateAndAssociateIPFilterClientCreateResponse contains the response from method CreateAndAssociateIPFilterClient.BeginCreate.
type CreateAndAssociateIPFilterClientCreateResponse struct {
	// placeholder for future response values
}

// CreateAndAssociatePLFilterClientCreateResponse contains the response from method CreateAndAssociatePLFilterClient.BeginCreate.
type CreateAndAssociatePLFilterClientCreateResponse struct {
	// placeholder for future response values
}

// DeploymentInfoClientListResponse contains the response from method DeploymentInfoClient.List.
type DeploymentInfoClientListResponse struct {
	// The properties of deployment in Elastic cloud corresponding to the Elastic monitor resource.
	DeploymentInfoResponse
}

// DetachAndDeleteTrafficFilterClientDeleteResponse contains the response from method DetachAndDeleteTrafficFilterClient.Delete.
type DetachAndDeleteTrafficFilterClientDeleteResponse struct {
	// placeholder for future response values
}

// DetachTrafficFilterClientUpdateResponse contains the response from method DetachTrafficFilterClient.BeginUpdate.
type DetachTrafficFilterClientUpdateResponse struct {
	// placeholder for future response values
}

// ExternalUserClientCreateOrUpdateResponse contains the response from method ExternalUserClient.CreateOrUpdate.
type ExternalUserClientCreateOrUpdateResponse struct {
	// The properties of the response we got from elastic while creating external user
	ExternalUserCreationResponse
}

// ListAssociatedTrafficFiltersClientListResponse contains the response from method ListAssociatedTrafficFiltersClient.List.
type ListAssociatedTrafficFiltersClientListResponse struct {
	// List of elastic traffic filters in the account
	TrafficFilterResponse
}

// MonitorClientUpgradeResponse contains the response from method MonitorClient.BeginUpgrade.
type MonitorClientUpgradeResponse struct {
	// placeholder for future response values
}

// MonitoredResourcesClientListResponse contains the response from method MonitoredResourcesClient.NewListPager.
type MonitoredResourcesClientListResponse struct {
	// Response of a list operation.
	MonitoredResourceListResponse
}

// MonitorsClientCreateResponse contains the response from method MonitorsClient.BeginCreate.
type MonitorsClientCreateResponse struct {
	// Monitor resource.
	MonitorResource
}

// MonitorsClientDeleteResponse contains the response from method MonitorsClient.BeginDelete.
type MonitorsClientDeleteResponse struct {
	// placeholder for future response values
}

// MonitorsClientGetResponse contains the response from method MonitorsClient.Get.
type MonitorsClientGetResponse struct {
	// Monitor resource.
	MonitorResource
}

// MonitorsClientListByResourceGroupResponse contains the response from method MonitorsClient.NewListByResourceGroupPager.
type MonitorsClientListByResourceGroupResponse struct {
	// Response of a list operation.
	MonitorResourceListResponse
}

// MonitorsClientListResponse contains the response from method MonitorsClient.NewListPager.
type MonitorsClientListResponse struct {
	// Response of a list operation.
	MonitorResourceListResponse
}

// MonitorsClientUpdateResponse contains the response from method MonitorsClient.Update.
type MonitorsClientUpdateResponse struct {
	// Monitor resource.
	MonitorResource
}

// OpenAIClientCreateOrUpdateResponse contains the response from method OpenAIClient.CreateOrUpdate.
type OpenAIClientCreateOrUpdateResponse struct {
	// Capture properties of Open AI resource Integration.
	OpenAIIntegrationRPModel
}

// OpenAIClientDeleteResponse contains the response from method OpenAIClient.Delete.
type OpenAIClientDeleteResponse struct {
	// placeholder for future response values
}

// OpenAIClientGetResponse contains the response from method OpenAIClient.Get.
type OpenAIClientGetResponse struct {
	// Capture properties of Open AI resource Integration.
	OpenAIIntegrationRPModel
}

// OpenAIClientGetStatusResponse contains the response from method OpenAIClient.GetStatus.
type OpenAIClientGetStatusResponse struct {
	// Status of the OpenAI Integration
	OpenAIIntegrationStatusResponse
}

// OpenAIClientListResponse contains the response from method OpenAIClient.NewListPager.
type OpenAIClientListResponse struct {
	// Response of a list operation.
	OpenAIIntegrationRPModelListResponse
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of GET request to list the Microsoft.Elastic operations.
	OperationListResult
}

// OrganizationsClientGetAPIKeyResponse contains the response from method OrganizationsClient.GetAPIKey.
type OrganizationsClientGetAPIKeyResponse struct {
	// The User Api Key created for the Organization associated with the User Email Id that was passed in the request
	UserAPIKeyResponse
}

// OrganizationsClientGetElasticToAzureSubscriptionMappingResponse contains the response from method OrganizationsClient.GetElasticToAzureSubscriptionMapping.
type OrganizationsClientGetElasticToAzureSubscriptionMappingResponse struct {
	// The Azure Subscription ID to which the Organization of the logged in user belongs and gets billed into.
	OrganizationToAzureSubscriptionMappingResponse
}

// TagRulesClientCreateOrUpdateResponse contains the response from method TagRulesClient.CreateOrUpdate.
type TagRulesClientCreateOrUpdateResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// TagRulesClientDeleteResponse contains the response from method TagRulesClient.BeginDelete.
type TagRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// TagRulesClientGetResponse contains the response from method TagRulesClient.Get.
type TagRulesClientGetResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// TagRulesClientListResponse contains the response from method TagRulesClient.NewListPager.
type TagRulesClientListResponse struct {
	// Response of a list operation.
	MonitoringTagRulesListResponse
}

// TrafficFiltersClientDeleteResponse contains the response from method TrafficFiltersClient.Delete.
type TrafficFiltersClientDeleteResponse struct {
	// placeholder for future response values
}

// UpgradableVersionsClientDetailsResponse contains the response from method UpgradableVersionsClient.Details.
type UpgradableVersionsClientDetailsResponse struct {
	// Stack Versions that this version can upgrade to
	UpgradableVersionsList
}

// VMCollectionClientUpdateResponse contains the response from method VMCollectionClient.Update.
type VMCollectionClientUpdateResponse struct {
	// placeholder for future response values
}

// VMHostClientListResponse contains the response from method VMHostClient.NewListPager.
type VMHostClientListResponse struct {
	// Response of a list operation.
	VMHostListResponse
}

// VMIngestionClientDetailsResponse contains the response from method VMIngestionClient.Details.
type VMIngestionClientDetailsResponse struct {
	// The vm ingestion details to install an agent.
	VMIngestionDetailsResponse
}

// VersionsClientListResponse contains the response from method VersionsClient.NewListPager.
type VersionsClientListResponse struct {
	// List of elastic versions available in a region.
	VersionsListResponse
}
