// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) Go Code Generator. DO NOT EDIT.

package armfabric_test

import (
	"context"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/fabric/armfabric"
	"log"
)

// Generated from example definition: 2023-11-01/Operations_List.json
func ExampleOperationsClient_NewListPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armfabric.NewClientFactory("<subscriptionID>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewOperationsClient().NewListPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page = armfabric.OperationsClientListResponse{
		// 	OperationListResult: armfabric.OperationListResult{
		// 		Value: []*armfabric.Operation{
		// 			{
		// 				Name: to.Ptr("Microsoft.Fabric/capacities/read"),
		// 				Display: &armfabric.OperationDisplay{
		// 					Provider: to.Ptr("Microsoft Fabric"),
		// 					Resource: to.Ptr("capacities"),
		// 					Operation: to.Ptr("Read Fabric Capacity"),
		// 					Description: to.Ptr("Retrieves the information of the specified Fabric Capacity."),
		// 				},
		// 				Origin: to.Ptr(armfabric.OriginUserSystem),
		// 			},
		// 			{
		// 				Name: to.Ptr("Microsoft.Fabric/capacities/write"),
		// 				Display: &armfabric.OperationDisplay{
		// 					Provider: to.Ptr("Microsoft Fabric"),
		// 					Resource: to.Ptr("capacities"),
		// 					Operation: to.Ptr("Create/Update Fabric Capacity"),
		// 					Description: to.Ptr("Creates or updates the specified Fabric Capacity."),
		// 				},
		// 				Origin: to.Ptr(armfabric.OriginUserSystem),
		// 			},
		// 			{
		// 				Name: to.Ptr("Microsoft.Fabric/capacities/delete"),
		// 				Display: &armfabric.OperationDisplay{
		// 					Provider: to.Ptr("Microsoft Fabric"),
		// 					Resource: to.Ptr("capacities"),
		// 					Operation: to.Ptr("Delete the Fabric Capacity"),
		// 					Description: to.Ptr("Deletes the Fabric Capacity."),
		// 				},
		// 				Origin: to.Ptr(armfabric.OriginUserSystem),
		// 			},
		// 			{
		// 				Name: to.Ptr("Microsoft.Fabric/capacities/suspend/action"),
		// 				Display: &armfabric.OperationDisplay{
		// 					Provider: to.Ptr("Microsoft Fabric"),
		// 					Resource: to.Ptr("capacities"),
		// 					Operation: to.Ptr("Suspend the specified Fabric capacity"),
		// 					Description: to.Ptr("Suspend the specified Fabric capacity"),
		// 				},
		// 				Origin: to.Ptr(armfabric.OriginUserSystem),
		// 			},
		// 			{
		// 				Name: to.Ptr("Microsoft.Fabric/capacities/resume/action"),
		// 				Display: &armfabric.OperationDisplay{
		// 					Provider: to.Ptr("Microsoft Fabric"),
		// 					Resource: to.Ptr("capacities"),
		// 					Operation: to.Ptr("Resume the specified Fabric capacity"),
		// 					Description: to.Ptr("Resume the specified Fabric capacity"),
		// 				},
		// 				Origin: to.Ptr(armfabric.OriginUserSystem),
		// 			},
		// 		},
		// 	},
		// }
	}
}
