//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armfrontdoor

// EndpointsClientPurgeContentResponse contains the response from method EndpointsClient.BeginPurgeContent.
type EndpointsClientPurgeContentResponse struct {
	// placeholder for future response values
}

// ExperimentsClientCreateOrUpdateResponse contains the response from method ExperimentsClient.BeginCreateOrUpdate.
type ExperimentsClientCreateOrUpdateResponse struct {
	// Defines the properties of an Experiment
	Experiment
}

// ExperimentsClientDeleteResponse contains the response from method ExperimentsClient.BeginDelete.
type ExperimentsClientDeleteResponse struct {
	// placeholder for future response values
}

// ExperimentsClientGetResponse contains the response from method ExperimentsClient.Get.
type ExperimentsClientGetResponse struct {
	// Defines the properties of an Experiment
	Experiment
}

// ExperimentsClientListByProfileResponse contains the response from method ExperimentsClient.NewListByProfilePager.
type ExperimentsClientListByProfileResponse struct {
	// Defines a list of Experiments. It contains a list of Experiment objects and a URL link to get the next set of results.
	ExperimentList
}

// ExperimentsClientUpdateResponse contains the response from method ExperimentsClient.BeginUpdate.
type ExperimentsClientUpdateResponse struct {
	// Defines the properties of an Experiment
	Experiment
}

// FrontDoorsClientCreateOrUpdateResponse contains the response from method FrontDoorsClient.BeginCreateOrUpdate.
type FrontDoorsClientCreateOrUpdateResponse struct {
	// Front Door represents a collection of backend endpoints to route traffic to along with rules that specify how traffic is
	// sent there.
	FrontDoor
}

// FrontDoorsClientDeleteResponse contains the response from method FrontDoorsClient.BeginDelete.
type FrontDoorsClientDeleteResponse struct {
	// placeholder for future response values
}

// FrontDoorsClientGetResponse contains the response from method FrontDoorsClient.Get.
type FrontDoorsClientGetResponse struct {
	// Front Door represents a collection of backend endpoints to route traffic to along with rules that specify how traffic is
	// sent there.
	FrontDoor
}

// FrontDoorsClientListByResourceGroupResponse contains the response from method FrontDoorsClient.NewListByResourceGroupPager.
type FrontDoorsClientListByResourceGroupResponse struct {
	// Result of the request to list Front Doors. It contains a list of Front Door objects and a URL link to get the next set
	// of results.
	ListResult
}

// FrontDoorsClientListResponse contains the response from method FrontDoorsClient.NewListPager.
type FrontDoorsClientListResponse struct {
	// Result of the request to list Front Doors. It contains a list of Front Door objects and a URL link to get the next set
	// of results.
	ListResult
}

// FrontDoorsClientValidateCustomDomainResponse contains the response from method FrontDoorsClient.ValidateCustomDomain.
type FrontDoorsClientValidateCustomDomainResponse struct {
	// Output of custom domain validation.
	ValidateCustomDomainOutput
}

// FrontendEndpointsClientDisableHTTPSResponse contains the response from method FrontendEndpointsClient.BeginDisableHTTPS.
type FrontendEndpointsClientDisableHTTPSResponse struct {
	// placeholder for future response values
}

// FrontendEndpointsClientEnableHTTPSResponse contains the response from method FrontendEndpointsClient.BeginEnableHTTPS.
type FrontendEndpointsClientEnableHTTPSResponse struct {
	// placeholder for future response values
}

// FrontendEndpointsClientGetResponse contains the response from method FrontendEndpointsClient.Get.
type FrontendEndpointsClientGetResponse struct {
	// A frontend endpoint used for routing.
	FrontendEndpoint
}

// FrontendEndpointsClientListByFrontDoorResponse contains the response from method FrontendEndpointsClient.NewListByFrontDoorPager.
type FrontendEndpointsClientListByFrontDoorResponse struct {
	// Result of the request to list frontend endpoints. It contains a list of Frontend endpoint objects and a URL link to get
	// the next set of results.
	FrontendEndpointsListResult
}

// ManagedRuleSetsClientListResponse contains the response from method ManagedRuleSetsClient.NewListPager.
type ManagedRuleSetsClientListResponse struct {
	// List of managed rule set definitions available for use in a policy.
	ManagedRuleSetDefinitionList
}

// NameAvailabilityClientCheckResponse contains the response from method NameAvailabilityClient.Check.
type NameAvailabilityClientCheckResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// NameAvailabilityWithSubscriptionClientCheckResponse contains the response from method NameAvailabilityWithSubscriptionClient.Check.
type NameAvailabilityWithSubscriptionClientCheckResponse struct {
	// Output of check name availability API.
	CheckNameAvailabilityOutput
}

// NetworkExperimentProfilesClientCreateOrUpdateResponse contains the response from method NetworkExperimentProfilesClient.BeginCreateOrUpdate.
type NetworkExperimentProfilesClientCreateOrUpdateResponse struct {
	// Defines an Network Experiment Profile and lists of Experiments
	Profile
}

// NetworkExperimentProfilesClientDeleteResponse contains the response from method NetworkExperimentProfilesClient.BeginDelete.
type NetworkExperimentProfilesClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkExperimentProfilesClientGetResponse contains the response from method NetworkExperimentProfilesClient.Get.
type NetworkExperimentProfilesClientGetResponse struct {
	// Defines an Network Experiment Profile and lists of Experiments
	Profile
}

// NetworkExperimentProfilesClientListByResourceGroupResponse contains the response from method NetworkExperimentProfilesClient.NewListByResourceGroupPager.
type NetworkExperimentProfilesClientListByResourceGroupResponse struct {
	// Defines a list of Profiles. It contains a list of Profile objects and a URL link to get the next set of results.
	ProfileList
}

// NetworkExperimentProfilesClientListResponse contains the response from method NetworkExperimentProfilesClient.NewListPager.
type NetworkExperimentProfilesClientListResponse struct {
	// Defines a list of Profiles. It contains a list of Profile objects and a URL link to get the next set of results.
	ProfileList
}

// NetworkExperimentProfilesClientUpdateResponse contains the response from method NetworkExperimentProfilesClient.BeginUpdate.
type NetworkExperimentProfilesClientUpdateResponse struct {
	// Defines an Network Experiment Profile and lists of Experiments
	Profile
}

// PoliciesClientCreateOrUpdateResponse contains the response from method PoliciesClient.BeginCreateOrUpdate.
type PoliciesClientCreateOrUpdateResponse struct {
	// Defines web application firewall policy.
	WebApplicationFirewallPolicy
}

// PoliciesClientDeleteResponse contains the response from method PoliciesClient.BeginDelete.
type PoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// PoliciesClientGetResponse contains the response from method PoliciesClient.Get.
type PoliciesClientGetResponse struct {
	// Defines web application firewall policy.
	WebApplicationFirewallPolicy
}

// PoliciesClientListBySubscriptionResponse contains the response from method PoliciesClient.NewListBySubscriptionPager.
type PoliciesClientListBySubscriptionResponse struct {
	// Defines a list of WebApplicationFirewallPolicies. It contains a list of WebApplicationFirewallPolicy objects and a URL
	// link to get the next set of results.
	WebApplicationFirewallPolicyList
}

// PoliciesClientListResponse contains the response from method PoliciesClient.NewListPager.
type PoliciesClientListResponse struct {
	// Defines a list of WebApplicationFirewallPolicies. It contains a list of WebApplicationFirewallPolicy objects and a URL
	// link to get the next set of results.
	WebApplicationFirewallPolicyList
}

// PoliciesClientUpdateResponse contains the response from method PoliciesClient.BeginUpdate.
type PoliciesClientUpdateResponse struct {
	// Defines web application firewall policy.
	WebApplicationFirewallPolicy
}

// PreconfiguredEndpointsClientListResponse contains the response from method PreconfiguredEndpointsClient.NewListPager.
type PreconfiguredEndpointsClientListResponse struct {
	// Defines a list of preconfigured endpoints.
	PreconfiguredEndpointList
}

// ReportsClientGetLatencyScorecardsResponse contains the response from method ReportsClient.GetLatencyScorecards.
type ReportsClientGetLatencyScorecardsResponse struct {
	// Defines the LatencyScorecard
	LatencyScorecard
}

// ReportsClientGetTimeseriesResponse contains the response from method ReportsClient.GetTimeseries.
type ReportsClientGetTimeseriesResponse struct {
	// Defines the Timeseries
	Timeseries
}

// RulesEnginesClientCreateOrUpdateResponse contains the response from method RulesEnginesClient.BeginCreateOrUpdate.
type RulesEnginesClientCreateOrUpdateResponse struct {
	// A rules engine configuration containing a list of rules that will run to modify the runtime behavior of the request and
	// response.
	RulesEngine
}

// RulesEnginesClientDeleteResponse contains the response from method RulesEnginesClient.BeginDelete.
type RulesEnginesClientDeleteResponse struct {
	// placeholder for future response values
}

// RulesEnginesClientGetResponse contains the response from method RulesEnginesClient.Get.
type RulesEnginesClientGetResponse struct {
	// A rules engine configuration containing a list of rules that will run to modify the runtime behavior of the request and
	// response.
	RulesEngine
}

// RulesEnginesClientListByFrontDoorResponse contains the response from method RulesEnginesClient.NewListByFrontDoorPager.
type RulesEnginesClientListByFrontDoorResponse struct {
	// Result of the request to list Rules Engine Configurations. It contains a list of RulesEngine objects and a URL link to
	// get the next set of results.
	RulesEngineListResult
}
