//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armguestconfiguration

// AssignmentReportsClientGetResponse contains the response from method AssignmentReportsClient.Get.
type AssignmentReportsClientGetResponse struct {
	// Report for the guest configuration assignment. Report contains information such as compliance status, reason, and more.
	AssignmentReport
}

// AssignmentReportsClientListResponse contains the response from method AssignmentReportsClient.List.
type AssignmentReportsClientListResponse struct {
	// List of guest configuration assignment reports.
	AssignmentReportList
}

// AssignmentReportsVMSSClientGetResponse contains the response from method AssignmentReportsVMSSClient.Get.
type AssignmentReportsVMSSClientGetResponse struct {
	// Report for the guest configuration assignment. Report contains information such as compliance status, reason, and more.
	AssignmentReport
}

// AssignmentReportsVMSSClientListResponse contains the response from method AssignmentReportsVMSSClient.NewListPager.
type AssignmentReportsVMSSClientListResponse struct {
	// List of guest configuration assignment reports.
	AssignmentReportList
}

// AssignmentsClientCreateOrUpdateResponse contains the response from method AssignmentsClient.CreateOrUpdate.
type AssignmentsClientCreateOrUpdateResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// AssignmentsClientDeleteResponse contains the response from method AssignmentsClient.Delete.
type AssignmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// AssignmentsClientGetResponse contains the response from method AssignmentsClient.Get.
type AssignmentsClientGetResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// AssignmentsClientListResponse contains the response from method AssignmentsClient.NewListPager.
type AssignmentsClientListResponse struct {
	// The response of the list guest configuration assignment operation.
	AssignmentList
}

// AssignmentsClientRGListResponse contains the response from method AssignmentsClient.NewRGListPager.
type AssignmentsClientRGListResponse struct {
	// The response of the list guest configuration assignment operation.
	AssignmentList
}

// AssignmentsClientSubscriptionListResponse contains the response from method AssignmentsClient.NewSubscriptionListPager.
type AssignmentsClientSubscriptionListResponse struct {
	// The response of the list guest configuration assignment operation.
	AssignmentList
}

// AssignmentsVMSSClientDeleteResponse contains the response from method AssignmentsVMSSClient.Delete.
type AssignmentsVMSSClientDeleteResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// AssignmentsVMSSClientGetResponse contains the response from method AssignmentsVMSSClient.Get.
type AssignmentsVMSSClientGetResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// AssignmentsVMSSClientListResponse contains the response from method AssignmentsVMSSClient.NewListPager.
type AssignmentsVMSSClientListResponse struct {
	// The response of the list guest configuration assignment operation.
	AssignmentList
}

// HCRPAssignmentReportsClientGetResponse contains the response from method HCRPAssignmentReportsClient.Get.
type HCRPAssignmentReportsClientGetResponse struct {
	// Report for the guest configuration assignment. Report contains information such as compliance status, reason, and more.
	AssignmentReport
}

// HCRPAssignmentReportsClientListResponse contains the response from method HCRPAssignmentReportsClient.List.
type HCRPAssignmentReportsClientListResponse struct {
	// List of guest configuration assignment reports.
	AssignmentReportList
}

// HCRPAssignmentsClientCreateOrUpdateResponse contains the response from method HCRPAssignmentsClient.CreateOrUpdate.
type HCRPAssignmentsClientCreateOrUpdateResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// HCRPAssignmentsClientDeleteResponse contains the response from method HCRPAssignmentsClient.Delete.
type HCRPAssignmentsClientDeleteResponse struct {
	// placeholder for future response values
}

// HCRPAssignmentsClientGetResponse contains the response from method HCRPAssignmentsClient.Get.
type HCRPAssignmentsClientGetResponse struct {
	// Guest configuration assignment is an association between a machine and guest configuration.
	Assignment
}

// HCRPAssignmentsClientListResponse contains the response from method HCRPAssignmentsClient.NewListPager.
type HCRPAssignmentsClientListResponse struct {
	// The response of the list guest configuration assignment operation.
	AssignmentList
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// The response model for the list of Automation operations
	OperationList
}
