//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armhybriddatamanager

// DataManagersClientBeginCreateOptions contains the optional parameters for the DataManagersClient.BeginCreate method.
type DataManagersClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataManagersClientBeginDeleteOptions contains the optional parameters for the DataManagersClient.BeginDelete method.
type DataManagersClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataManagersClientBeginUpdateOptions contains the optional parameters for the DataManagersClient.BeginUpdate method.
type DataManagersClientBeginUpdateOptions struct {
	// Defines the If-Match condition. The patch will be performed only if the ETag of the data manager resource on the server
	// matches this value.
	IfMatch *string

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataManagersClientGetOptions contains the optional parameters for the DataManagersClient.Get method.
type DataManagersClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataManagersClientListByResourceGroupOptions contains the optional parameters for the DataManagersClient.NewListByResourceGroupPager
// method.
type DataManagersClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// DataManagersClientListOptions contains the optional parameters for the DataManagersClient.NewListPager method.
type DataManagersClientListOptions struct {
	// placeholder for future optional parameters
}

// DataServicesClientGetOptions contains the optional parameters for the DataServicesClient.Get method.
type DataServicesClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataServicesClientListByDataManagerOptions contains the optional parameters for the DataServicesClient.NewListByDataManagerPager
// method.
type DataServicesClientListByDataManagerOptions struct {
	// placeholder for future optional parameters
}

// DataStoreTypesClientGetOptions contains the optional parameters for the DataStoreTypesClient.Get method.
type DataStoreTypesClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataStoreTypesClientListByDataManagerOptions contains the optional parameters for the DataStoreTypesClient.NewListByDataManagerPager
// method.
type DataStoreTypesClientListByDataManagerOptions struct {
	// placeholder for future optional parameters
}

// DataStoresClientBeginCreateOrUpdateOptions contains the optional parameters for the DataStoresClient.BeginCreateOrUpdate
// method.
type DataStoresClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataStoresClientBeginDeleteOptions contains the optional parameters for the DataStoresClient.BeginDelete method.
type DataStoresClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DataStoresClientGetOptions contains the optional parameters for the DataStoresClient.Get method.
type DataStoresClientGetOptions struct {
	// placeholder for future optional parameters
}

// DataStoresClientListByDataManagerOptions contains the optional parameters for the DataStoresClient.NewListByDataManagerPager
// method.
type DataStoresClientListByDataManagerOptions struct {
	// OData Filter options
	Filter *string
}

// JobDefinitionsClientBeginCreateOrUpdateOptions contains the optional parameters for the JobDefinitionsClient.BeginCreateOrUpdate
// method.
type JobDefinitionsClientBeginCreateOrUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobDefinitionsClientBeginDeleteOptions contains the optional parameters for the JobDefinitionsClient.BeginDelete method.
type JobDefinitionsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobDefinitionsClientBeginRunOptions contains the optional parameters for the JobDefinitionsClient.BeginRun method.
type JobDefinitionsClientBeginRunOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobDefinitionsClientGetOptions contains the optional parameters for the JobDefinitionsClient.Get method.
type JobDefinitionsClientGetOptions struct {
	// placeholder for future optional parameters
}

// JobDefinitionsClientListByDataManagerOptions contains the optional parameters for the JobDefinitionsClient.NewListByDataManagerPager
// method.
type JobDefinitionsClientListByDataManagerOptions struct {
	// OData Filter options
	Filter *string
}

// JobDefinitionsClientListByDataServiceOptions contains the optional parameters for the JobDefinitionsClient.NewListByDataServicePager
// method.
type JobDefinitionsClientListByDataServiceOptions struct {
	// OData Filter options
	Filter *string
}

// JobsClientBeginCancelOptions contains the optional parameters for the JobsClient.BeginCancel method.
type JobsClientBeginCancelOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobsClientBeginResumeOptions contains the optional parameters for the JobsClient.BeginResume method.
type JobsClientBeginResumeOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// JobsClientGetOptions contains the optional parameters for the JobsClient.Get method.
type JobsClientGetOptions struct {
	// $expand is supported on details parameter for job, which provides details on the job stages.
	Expand *string
}

// JobsClientListByDataManagerOptions contains the optional parameters for the JobsClient.NewListByDataManagerPager method.
type JobsClientListByDataManagerOptions struct {
	// OData Filter options
	Filter *string
}

// JobsClientListByDataServiceOptions contains the optional parameters for the JobsClient.NewListByDataServicePager method.
type JobsClientListByDataServiceOptions struct {
	// OData Filter options
	Filter *string
}

// JobsClientListByJobDefinitionOptions contains the optional parameters for the JobsClient.NewListByJobDefinitionPager method.
type JobsClientListByJobDefinitionOptions struct {
	// OData Filter options
	Filter *string
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// PublicKeysClientGetOptions contains the optional parameters for the PublicKeysClient.Get method.
type PublicKeysClientGetOptions struct {
	// placeholder for future optional parameters
}

// PublicKeysClientListByDataManagerOptions contains the optional parameters for the PublicKeysClient.NewListByDataManagerPager
// method.
type PublicKeysClientListByDataManagerOptions struct {
	// placeholder for future optional parameters
}
