//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package arminformaticadatamgmt_test

import (
	"context"
	"log"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/informaticadatamgmt/arminformaticadatamgmt"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_ListBySubscription_MaximumSet_Gen.json
func ExampleOrganizationsClient_NewListBySubscriptionPager_organizationsListBySubscription() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewOrganizationsClient().NewListBySubscriptionPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.InformaticaOrganizationResourceListResult = arminformaticadatamgmt.InformaticaOrganizationResourceListResult{
		// 	Value: []*arminformaticadatamgmt.InformaticaOrganizationResource{
		// 		{
		// 			Name: to.Ptr("qmlpllxohjomejbeylyhlqwt"),
		// 			Type: to.Ptr("korjyotq"),
		// 			ID: to.Ptr("cadokiejnrth"),
		// 			SystemData: &arminformaticadatamgmt.SystemData{
		// 				CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
		// 				CreatedBy: to.Ptr("kocqbxulqrggzbfrifpvy"),
		// 				CreatedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
		// 				LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
		// 				LastModifiedBy: to.Ptr("lzpllqnildoamkmgf"),
		// 				LastModifiedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
		// 			},
		// 			Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
		// 			Tags: map[string]*string{
		// 				"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
		// 			},
		// 			Properties: &arminformaticadatamgmt.OrganizationProperties{
		// 				CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
		// 					Business: to.Ptr("pucosrtjv"),
		// 					CompanyName: to.Ptr("xszcggknokhw"),
		// 					Country: to.Ptr("gwkcpnwyaqc"),
		// 					Domain: to.Ptr("utcxetzzpmbvwmjrvphqngvp"),
		// 					NumberOfEmployees: to.Ptr[int32](25),
		// 					OfficeAddress: to.Ptr("sbttzwyajgdbsvipuiclbzvkcvwyil"),
		// 				},
		// 				InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
		// 					InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
		// 					OrganizationID: to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
		// 					OrganizationName: to.Ptr("nomzbvwe"),
		// 					SingleSignOnURL: to.Ptr("https://contoso.com/singlesignon"),
		// 				},
		// 				LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
		// 					Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
		// 				},
		// 				MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
		// 					MarketplaceSubscriptionID: to.Ptr("ovenlecocg"),
		// 					OfferDetails: &arminformaticadatamgmt.OfferDetails{
		// 						OfferID: to.Ptr("cwswcfwmzhjcoksmueukegwaptvpcmbfyvixfhvgwnjyblqivqdkkwkunkgimiopwwkvgnwclmajhuty"),
		// 						PlanID: to.Ptr("jfnemevyivtlxhectiutdavdgfyidolivuojumdzckp"),
		// 						PlanName: to.Ptr("iaoxgaitteuoqgujkgxbdgryaobtkjjecuvchwutntrvmuorikrbqqegmelenbewhakiysprrnovjixyxrikscaptrbapbdspu"),
		// 						PublisherID: to.Ptr("zajxpfacudwongxjvnnuhhpygmnydchgowjccyuzsjonegmqxcqqpnzafanggowfqdixnnutyfvmvwrkx"),
		// 						TermID: to.Ptr("tcvvsxdjnjlfmjhmvwklptdmxetnzydxyuhfqchoubmtoeqbchnfxoxqzezlgpxdnzyvzgkynjxzzgetkqccxvpzahxattluqdipvbdktqmndfefitzuifqjpschzlbvixnvznkmmgjwvkplfhemnapsewgqxggdzdokryhv"),
		// 						TermUnit: to.Ptr("gjwmgevrblbosuogsvfspsgspetbnxaygkbelvadpgwiywl"),
		// 					},
		// 				},
		// 				ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateSucceeded),
		// 				UserDetails: &arminformaticadatamgmt.UserDetails{
		// 					EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
		// 					FirstName: to.Ptr("appvdclawzfjntdfdftjevlhvzropnxqtnypid"),
		// 					LastName: to.Ptr("nzirbvzmkxtbrlamyatlcszebxgcyncxoascojsmacwvjsjvn"),
		// 					PhoneNumber: to.Ptr("fvcjylxlmhdnshsgywnzlyvshu"),
		// 					Upn: to.Ptr("undljch"),
		// 				},
		// 			},
		// 	}},
		// }
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_ListBySubscription_MinimumSet_Gen.json
func ExampleOrganizationsClient_NewListBySubscriptionPager_organizationsListBySubscriptionMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewOrganizationsClient().NewListBySubscriptionPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.InformaticaOrganizationResourceListResult = arminformaticadatamgmt.InformaticaOrganizationResourceListResult{
		// 	Value: []*arminformaticadatamgmt.InformaticaOrganizationResource{
		// 		{
		// 			ID: to.Ptr("cadokiejnrth"),
		// 			Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
		// 	}},
		// }
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_ListByResourceGroup_MaximumSet_Gen.json
func ExampleOrganizationsClient_NewListByResourceGroupPager_organizationsListByResourceGroup() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewOrganizationsClient().NewListByResourceGroupPager("rgopenapi", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.InformaticaOrganizationResourceListResult = arminformaticadatamgmt.InformaticaOrganizationResourceListResult{
		// 	Value: []*arminformaticadatamgmt.InformaticaOrganizationResource{
		// 		{
		// 			Name: to.Ptr("qmlpllxohjomejbeylyhlqwt"),
		// 			Type: to.Ptr("korjyotq"),
		// 			ID: to.Ptr("cadokiejnrth"),
		// 			SystemData: &arminformaticadatamgmt.SystemData{
		// 				CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
		// 				CreatedBy: to.Ptr("kocqbxulqrggzbfrifpvy"),
		// 				CreatedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
		// 				LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
		// 				LastModifiedBy: to.Ptr("lzpllqnildoamkmgf"),
		// 				LastModifiedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
		// 			},
		// 			Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
		// 			Tags: map[string]*string{
		// 				"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
		// 			},
		// 			Properties: &arminformaticadatamgmt.OrganizationProperties{
		// 				CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
		// 					Business: to.Ptr("pucosrtjv"),
		// 					CompanyName: to.Ptr("xszcggknokhw"),
		// 					Country: to.Ptr("gwkcpnwyaqc"),
		// 					Domain: to.Ptr("utcxetzzpmbvwmjrvphqngvp"),
		// 					NumberOfEmployees: to.Ptr[int32](25),
		// 					OfficeAddress: to.Ptr("sbttzwyajgdbsvipuiclbzvkcvwyil"),
		// 				},
		// 				InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
		// 					InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
		// 					OrganizationID: to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
		// 					OrganizationName: to.Ptr("nomzbvwe"),
		// 					SingleSignOnURL: to.Ptr("https://contoso.com/singlesignon"),
		// 				},
		// 				LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
		// 					Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
		// 				},
		// 				MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
		// 					MarketplaceSubscriptionID: to.Ptr("ovenlecocg"),
		// 					OfferDetails: &arminformaticadatamgmt.OfferDetails{
		// 						OfferID: to.Ptr("cwswcfwmzhjcoksmueukegwaptvpcmbfyvixfhvgwnjyblqivqdkkwkunkgimiopwwkvgnwclmajhuty"),
		// 						PlanID: to.Ptr("jfnemevyivtlxhectiutdavdgfyidolivuojumdzckp"),
		// 						PlanName: to.Ptr("iaoxgaitteuoqgujkgxbdgryaobtkjjecuvchwutntrvmuorikrbqqegmelenbewhakiysprrnovjixyxrikscaptrbapbdspu"),
		// 						PublisherID: to.Ptr("zajxpfacudwongxjvnnuhhpygmnydchgowjccyuzsjonegmqxcqqpnzafanggowfqdixnnutyfvmvwrkx"),
		// 						TermID: to.Ptr("tcvvsxdjnjlfmjhmvwklptdmxetnzydxyuhfqchoubmtoeqbchnfxoxqzezlgpxdnzyvzgkynjxzzgetkqccxvpzahxattluqdipvbdktqmndfefitzuifqjpschzlbvixnvznkmmgjwvkplfhemnapsewgqxggdzdokryhv"),
		// 						TermUnit: to.Ptr("gjwmgevrblbosuogsvfspsgspetbnxaygkbelvadpgwiywl"),
		// 					},
		// 				},
		// 				ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateSucceeded),
		// 				UserDetails: &arminformaticadatamgmt.UserDetails{
		// 					EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
		// 					FirstName: to.Ptr("appvdclawzfjntdfdftjevlhvzropnxqtnypid"),
		// 					LastName: to.Ptr("nzirbvzmkxtbrlamyatlcszebxgcyncxoascojsmacwvjsjvn"),
		// 					PhoneNumber: to.Ptr("fvcjylxlmhdnshsgywnzlyvshu"),
		// 					Upn: to.Ptr("undljch"),
		// 				},
		// 			},
		// 	}},
		// }
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_ListByResourceGroup_MinimumSet_Gen.json
func ExampleOrganizationsClient_NewListByResourceGroupPager_organizationsListByResourceGroupMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewOrganizationsClient().NewListByResourceGroupPager("rgopenapi", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.InformaticaOrganizationResourceListResult = arminformaticadatamgmt.InformaticaOrganizationResourceListResult{
		// 	Value: []*arminformaticadatamgmt.InformaticaOrganizationResource{
		// 		{
		// 			ID: to.Ptr("cadokiejnrth"),
		// 			Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
		// 	}},
		// }
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Get_MaximumSet_Gen.json
func ExampleOrganizationsClient_Get_organizationsGet() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().Get(ctx, "rgopenapi", "Sg", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	Name: to.Ptr("qmlpllxohjomejbeylyhlqwt"),
	// 	Type: to.Ptr("korjyotq"),
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	SystemData: &arminformaticadatamgmt.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		CreatedBy: to.Ptr("kocqbxulqrggzbfrifpvy"),
	// 		CreatedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("lzpllqnildoamkmgf"),
	// 		LastModifiedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 	},
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// 	Tags: map[string]*string{
	// 		"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
	// 	},
	// 	Properties: &arminformaticadatamgmt.OrganizationProperties{
	// 		CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
	// 			Business: to.Ptr("pucosrtjv"),
	// 			CompanyName: to.Ptr("xszcggknokhw"),
	// 			Country: to.Ptr("gwkcpnwyaqc"),
	// 			Domain: to.Ptr("utcxetzzpmbvwmjrvphqngvp"),
	// 			NumberOfEmployees: to.Ptr[int32](25),
	// 			OfficeAddress: to.Ptr("sbttzwyajgdbsvipuiclbzvkcvwyil"),
	// 		},
	// 		InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
	// 			InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
	// 			OrganizationID: to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
	// 			OrganizationName: to.Ptr("nomzbvwe"),
	// 			SingleSignOnURL: to.Ptr("https://contoso.com/singlesignon"),
	// 		},
	// 		LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
	// 			Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
	// 		},
	// 		MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
	// 			MarketplaceSubscriptionID: to.Ptr("ovenlecocg"),
	// 			OfferDetails: &arminformaticadatamgmt.OfferDetails{
	// 				OfferID: to.Ptr("cwswcfwmzhjcoksmueukegwaptvpcmbfyvixfhvgwnjyblqivqdkkwkunkgimiopwwkvgnwclmajhuty"),
	// 				PlanID: to.Ptr("jfnemevyivtlxhectiutdavdgfyidolivuojumdzckp"),
	// 				PlanName: to.Ptr("iaoxgaitteuoqgujkgxbdgryaobtkjjecuvchwutntrvmuorikrbqqegmelenbewhakiysprrnovjixyxrikscaptrbapbdspu"),
	// 				PublisherID: to.Ptr("zajxpfacudwongxjvnnuhhpygmnydchgowjccyuzsjonegmqxcqqpnzafanggowfqdixnnutyfvmvwrkx"),
	// 				TermID: to.Ptr("tcvvsxdjnjlfmjhmvwklptdmxetnzydxyuhfqchoubmtoeqbchnfxoxqzezlgpxdnzyvzgkynjxzzgetkqccxvpzahxattluqdipvbdktqmndfefitzuifqjpschzlbvixnvznkmmgjwvkplfhemnapsewgqxggdzdokryhv"),
	// 				TermUnit: to.Ptr("gjwmgevrblbosuogsvfspsgspetbnxaygkbelvadpgwiywl"),
	// 			},
	// 		},
	// 		ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateSucceeded),
	// 		UserDetails: &arminformaticadatamgmt.UserDetails{
	// 			EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
	// 			FirstName: to.Ptr("appvdclawzfjntdfdftjevlhvzropnxqtnypid"),
	// 			LastName: to.Ptr("nzirbvzmkxtbrlamyatlcszebxgcyncxoascojsmacwvjsjvn"),
	// 			PhoneNumber: to.Ptr("fvcjylxlmhdnshsgywnzlyvshu"),
	// 			Upn: to.Ptr("undljch"),
	// 		},
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Get_MinimumSet_Gen.json
func ExampleOrganizationsClient_Get_organizationsGetMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().Get(ctx, "rgopenapi", "q", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_CreateOrUpdate_MaximumSet_Gen.json
func ExampleOrganizationsClient_BeginCreateOrUpdate_organizationsCreateOrUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewOrganizationsClient().BeginCreateOrUpdate(ctx, "rgopenapi", "C", arminformaticadatamgmt.InformaticaOrganizationResource{
		Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
		Tags: map[string]*string{
			"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
		},
		Properties: &arminformaticadatamgmt.OrganizationProperties{
			CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
				Business:          to.Ptr("pucosrtjv"),
				CompanyName:       to.Ptr("xszcggknokhw"),
				Country:           to.Ptr("gwkcpnwyaqc"),
				Domain:            to.Ptr("utcxetzzpmbvwmjrvphqngvp"),
				NumberOfEmployees: to.Ptr[int32](25),
				OfficeAddress:     to.Ptr("sbttzwyajgdbsvipuiclbzvkcvwyil"),
			},
			InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
				InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
				OrganizationID:    to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
				OrganizationName:  to.Ptr("nomzbvwe"),
				SingleSignOnURL:   to.Ptr("https://contoso.com/singlesignon"),
			},
			LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
				Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
			},
			MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
				MarketplaceSubscriptionID: to.Ptr("ovenlecocg"),
				OfferDetails: &arminformaticadatamgmt.OfferDetails{
					OfferID:     to.Ptr("cwswcfwmzhjcoksmueukegwaptvpcmbfyvixfhvgwnjyblqivqdkkwkunkgimiopwwkvgnwclmajhuty"),
					PlanID:      to.Ptr("jfnemevyivtlxhectiutdavdgfyidolivuojumdzckp"),
					PlanName:    to.Ptr("iaoxgaitteuoqgujkgxbdgryaobtkjjecuvchwutntrvmuorikrbqqegmelenbewhakiysprrnovjixyxrikscaptrbapbdspu"),
					PublisherID: to.Ptr("zajxpfacudwongxjvnnuhhpygmnydchgowjccyuzsjonegmqxcqqpnzafanggowfqdixnnutyfvmvwrkx"),
					TermID:      to.Ptr("tcvvsxdjnjlfmjhmvwklptdmxetnzydxyuhfqchoubmtoeqbchnfxoxqzezlgpxdnzyvzgkynjxzzgetkqccxvpzahxattluqdipvbdktqmndfefitzuifqjpschzlbvixnvznkmmgjwvkplfhemnapsewgqxggdzdokryhv"),
					TermUnit:    to.Ptr("gjwmgevrblbosuogsvfspsgspetbnxaygkbelvadpgwiywl"),
				},
			},
			ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateAccepted),
			UserDetails: &arminformaticadatamgmt.UserDetails{
				EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
				FirstName:    to.Ptr("appvdclawzfjntdfdftjevlhvzropnxqtnypid"),
				LastName:     to.Ptr("nzirbvzmkxtbrlamyatlcszebxgcyncxoascojsmacwvjsjvn"),
				PhoneNumber:  to.Ptr("fvcjylxlmhdnshsgywnzlyvshu"),
				Upn:          to.Ptr("undljch"),
			},
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	Name: to.Ptr("qmlpllxohjomejbeylyhlqwt"),
	// 	Type: to.Ptr("korjyotq"),
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	SystemData: &arminformaticadatamgmt.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		CreatedBy: to.Ptr("kocqbxulqrggzbfrifpvy"),
	// 		CreatedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("lzpllqnildoamkmgf"),
	// 		LastModifiedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 	},
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// 	Tags: map[string]*string{
	// 		"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
	// 	},
	// 	Properties: &arminformaticadatamgmt.OrganizationProperties{
	// 		CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
	// 			Business: to.Ptr("pucosrtjv"),
	// 			CompanyName: to.Ptr("xszcggknokhw"),
	// 			Country: to.Ptr("gwkcpnwyaqc"),
	// 			Domain: to.Ptr("utcxetzzpmbvwmjrvphqngvp"),
	// 			NumberOfEmployees: to.Ptr[int32](25),
	// 			OfficeAddress: to.Ptr("sbttzwyajgdbsvipuiclbzvkcvwyil"),
	// 		},
	// 		InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
	// 			InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
	// 			OrganizationID: to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
	// 			OrganizationName: to.Ptr("nomzbvwe"),
	// 			SingleSignOnURL: to.Ptr("https://contoso.com/singlesignon"),
	// 		},
	// 		LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
	// 			Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
	// 		},
	// 		MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
	// 			MarketplaceSubscriptionID: to.Ptr("ovenlecocg"),
	// 			OfferDetails: &arminformaticadatamgmt.OfferDetails{
	// 				OfferID: to.Ptr("cwswcfwmzhjcoksmueukegwaptvpcmbfyvixfhvgwnjyblqivqdkkwkunkgimiopwwkvgnwclmajhuty"),
	// 				PlanID: to.Ptr("jfnemevyivtlxhectiutdavdgfyidolivuojumdzckp"),
	// 				PlanName: to.Ptr("iaoxgaitteuoqgujkgxbdgryaobtkjjecuvchwutntrvmuorikrbqqegmelenbewhakiysprrnovjixyxrikscaptrbapbdspu"),
	// 				PublisherID: to.Ptr("zajxpfacudwongxjvnnuhhpygmnydchgowjccyuzsjonegmqxcqqpnzafanggowfqdixnnutyfvmvwrkx"),
	// 				TermID: to.Ptr("tcvvsxdjnjlfmjhmvwklptdmxetnzydxyuhfqchoubmtoeqbchnfxoxqzezlgpxdnzyvzgkynjxzzgetkqccxvpzahxattluqdipvbdktqmndfefitzuifqjpschzlbvixnvznkmmgjwvkplfhemnapsewgqxggdzdokryhv"),
	// 				TermUnit: to.Ptr("gjwmgevrblbosuogsvfspsgspetbnxaygkbelvadpgwiywl"),
	// 			},
	// 		},
	// 		ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateSucceeded),
	// 		UserDetails: &arminformaticadatamgmt.UserDetails{
	// 			EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
	// 			FirstName: to.Ptr("appvdclawzfjntdfdftjevlhvzropnxqtnypid"),
	// 			LastName: to.Ptr("nzirbvzmkxtbrlamyatlcszebxgcyncxoascojsmacwvjsjvn"),
	// 			PhoneNumber: to.Ptr("fvcjylxlmhdnshsgywnzlyvshu"),
	// 			Upn: to.Ptr("undljch"),
	// 		},
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_CreateOrUpdate_MinimumSet_Gen.json
func ExampleOrganizationsClient_BeginCreateOrUpdate_organizationsCreateOrUpdateMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewOrganizationsClient().BeginCreateOrUpdate(ctx, "rgopenapi", "n6v", arminformaticadatamgmt.InformaticaOrganizationResource{
		Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Update_MaximumSet_Gen.json
func ExampleOrganizationsClient_Update_organizationsUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().Update(ctx, "rgopenapi", "_-", arminformaticadatamgmt.InformaticaOrganizationResourceUpdate{
		Properties: &arminformaticadatamgmt.OrganizationPropertiesCustomUpdate{
			CompanyDetails: &arminformaticadatamgmt.CompanyDetailsUpdate{
				Business:          to.Ptr("mwqblnruflwpolgbxpqbqneve"),
				CompanyName:       to.Ptr("xkrvbozrjcvappqeeyt"),
				Country:           to.Ptr("rvlzppgvopcw"),
				Domain:            to.Ptr("dponvwnrdrnzahcurqssesukbsokdd"),
				NumberOfEmployees: to.Ptr[int32](22),
				OfficeAddress:     to.Ptr("sfcx"),
			},
			ExistingResourceID: to.Ptr("/subscriptions/subid/resourceGroups/rg1/providers/Informatica.DataManagement/organizations/org1/serverlessRuntimes/serverlessRuntimeName"),
			MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetailsUpdate{
				MarketplaceSubscriptionID: to.Ptr("szhyxzgjtssjmlguivepc"),
				OfferDetails: &arminformaticadatamgmt.OfferDetailsUpdate{
					OfferID:     to.Ptr("idaxbflabvjsippplyenvrpgeydsjxcmyubgukffkcdvlvrtwpdhnvdblxjsldiuswrchsibk"),
					PlanID:      to.Ptr("giihvvnwdwzkfqrhkpqzbgfotzyixnsvmxzauseebillhslauglzfxzvzvts"),
					PlanName:    to.Ptr("tfqjenotaewzdeerliteqxdawuqxhwdzbtiiimsaedrlsnbdoonnloakjtvnwhhrcyxxsgoachguthqvlahpjyofpoqpfacfmiaauawazkmxkjgvktbptojknzojtjrfzvbbjjkvstabqyaczxinijhoxrjukftsagpwgsvpmczopztmplipyufhuaumfx"),
					PublisherID: to.Ptr("ktzfghsyjqbsswhltoaemgotmnorhdogvkaxplutbjjqzuepxizliynyakersobagvpwvpzwjtjjxigsqgcyqaahaxdijghnexliofhfjlqzjmmbvrhcvjxdodnexxizbgfhjopbwzjojxsluasnwwsgcajefglbcvzpaeblanhmurcculndtfwnfjyxol"),
					TermID:      to.Ptr("eolmwogtgpdncqoigqcdomupwummaicwvdxgbskpdsmjizdfbdgbxbuekcpwmenqzbhqxpdnjtup"),
					TermUnit:    to.Ptr("nykqoplazujcwmfldntifjqrnx"),
				},
			},
			UserDetails: &arminformaticadatamgmt.UserDetailsUpdate{
				EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
				FirstName:    to.Ptr("qguqrmanyupoi"),
				LastName:     to.Ptr("ugzg"),
				PhoneNumber:  to.Ptr("uxa"),
				Upn:          to.Ptr("viwjrkn"),
			},
		},
		Tags: map[string]*string{
			"key1918": to.Ptr("fbjvtuvzsghpl"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	Name: to.Ptr("qmlpllxohjomejbeylyhlqwt"),
	// 	Type: to.Ptr("korjyotq"),
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	SystemData: &arminformaticadatamgmt.SystemData{
	// 		CreatedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		CreatedBy: to.Ptr("kocqbxulqrggzbfrifpvy"),
	// 		CreatedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 		LastModifiedAt: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2023-12-05T15:45:15.582Z"); return t}()),
	// 		LastModifiedBy: to.Ptr("lzpllqnildoamkmgf"),
	// 		LastModifiedByType: to.Ptr(arminformaticadatamgmt.CreatedByTypeUser),
	// 	},
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// 	Tags: map[string]*string{
	// 		"key8430": to.Ptr("cagshqtjlxtqqhdwtchokvxszybp"),
	// 	},
	// 	Properties: &arminformaticadatamgmt.OrganizationProperties{
	// 		CompanyDetails: &arminformaticadatamgmt.CompanyDetails{
	// 			Business: to.Ptr("mwqblnruflwpolgbxpqbqneve"),
	// 			CompanyName: to.Ptr("xkrvbozrjcvappqeeyt"),
	// 			Country: to.Ptr("rvlzppgvopcw"),
	// 			Domain: to.Ptr("dponvwnrdrnzahcurqssesukbsokdd"),
	// 			NumberOfEmployees: to.Ptr[int32](22),
	// 			OfficeAddress: to.Ptr("sfcx"),
	// 		},
	// 		InformaticaProperties: &arminformaticadatamgmt.InformaticaProperties{
	// 			InformaticaRegion: to.Ptr("zfqodqpbeflhedypiijdkc"),
	// 			OrganizationID: to.Ptr("wtdmhlwhkvgqdumaehgfgiqcxgnqpx"),
	// 			OrganizationName: to.Ptr("nomzbvwe"),
	// 			SingleSignOnURL: to.Ptr("https://contoso.com/singlesignon"),
	// 		},
	// 		LinkOrganization: &arminformaticadatamgmt.LinkOrganization{
	// 			Token: to.Ptr("jjfouhoqpumjvrdsfbimgcy"),
	// 		},
	// 		MarketplaceDetails: &arminformaticadatamgmt.MarketplaceDetails{
	// 			MarketplaceSubscriptionID: to.Ptr("szhyxzgjtssjmlguivepc"),
	// 			OfferDetails: &arminformaticadatamgmt.OfferDetails{
	// 				OfferID: to.Ptr("idaxbflabvjsippplyenvrpgeydsjxcmyubgukffkcdvlvrtwpdhnvdblxjsldiuswrchsibk"),
	// 				PlanID: to.Ptr("giihvvnwdwzkfqrhkpqzbgfotzyixnsvmxzauseebillhslauglzfxzvzvts"),
	// 				PlanName: to.Ptr("tfqjenotaewzdeerliteqxdawuqxhwdzbtiiimsaedrlsnbdoonnloakjtvnwhhrcyxxsgoachguthqvlahpjyofpoqpfacfmiaauawazkmxkjgvktbptojknzojtjrfzvbbjjkvstabqyaczxinijhoxrjukftsagpwgsvpmczopztmplipyufhuaumfx"),
	// 				PublisherID: to.Ptr("ktzfghsyjqbsswhltoaemgotmnorhdogvkaxplutbjjqzuepxizliynyakersobagvpwvpzwjtjjxigsqgcyqaahaxdijghnexliofhfjlqzjmmbvrhcvjxdodnexxizbgfhjopbwzjojxsluasnwwsgcajefglbcvzpaeblanhmurcculndtfwnfjyxol"),
	// 				TermID: to.Ptr("eolmwogtgpdncqoigqcdomupwummaicwvdxgbskpdsmjizdfbdgbxbuekcpwmenqzbhqxpdnjtup"),
	// 				TermUnit: to.Ptr("nykqoplazujcwmfldntifjqrnx"),
	// 			},
	// 		},
	// 		ProvisioningState: to.Ptr(arminformaticadatamgmt.ProvisioningStateSucceeded),
	// 		UserDetails: &arminformaticadatamgmt.UserDetails{
	// 			EmailAddress: to.Ptr("7_-46@13D--3.m-4x-.11.c-9-.DHLYFc"),
	// 			FirstName: to.Ptr("qguqrmanyupoi"),
	// 			LastName: to.Ptr("ugzg"),
	// 			PhoneNumber: to.Ptr("uxa"),
	// 			Upn: to.Ptr("viwjrkn"),
	// 		},
	// 	},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Update_MinimumSet_Gen.json
func ExampleOrganizationsClient_Update_organizationsUpdateMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().Update(ctx, "rgopenapi", "-", arminformaticadatamgmt.InformaticaOrganizationResourceUpdate{}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaOrganizationResource = arminformaticadatamgmt.InformaticaOrganizationResource{
	// 	ID: to.Ptr("cadokiejnrth"),
	// 	Location: to.Ptr("pamjoudtssthlbhrnfjidr"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Delete_MaximumSet_Gen.json
func ExampleOrganizationsClient_BeginDelete_organizationsDelete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewOrganizationsClient().BeginDelete(ctx, "rgopenapi", "_", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_Delete_MinimumSet_Gen.json
func ExampleOrganizationsClient_BeginDelete_organizationsDeleteMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewOrganizationsClient().BeginDelete(ctx, "rgopenapi", "_-", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_GetAllServerlessRuntimes_MaximumSet_Gen.json
func ExampleOrganizationsClient_GetAllServerlessRuntimes_organizationsGetAllServerlessRuntimes() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().GetAllServerlessRuntimes(ctx, "rgopenapi", "t", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaServerlessRuntimeResourceList = arminformaticadatamgmt.InformaticaServerlessRuntimeResourceList{
	// 	InformaticaRuntimeResources: []*arminformaticadatamgmt.InfaRuntimeResourceFetchMetaData{
	// 		{
	// 			Name: to.Ptr("wwhnptecwbip"),
	// 			Type: to.Ptr(arminformaticadatamgmt.RuntimeTypeSERVERLESS),
	// 			Description: to.Ptr("kozzyfee"),
	// 			CreatedBy: to.Ptr("sxizcppjasypefvhacvzfhzn"),
	// 			CreatedTime: to.Ptr("wfbezwbdyszdvwlzvthrxi"),
	// 			ID: to.Ptr("hgnqusidmutarhmwnswhalpjzievdm"),
	// 			ServerlessConfigProperties: &arminformaticadatamgmt.InfaServerlessFetchConfigProperties{
	// 				AdvancedCustomProperties: to.Ptr("pvusvtqtkhozfuqtokw"),
	// 				ApplicationType: to.Ptr("qnrsngoycualsvmmsu"),
	// 				ComputeUnits: to.Ptr("ao"),
	// 				ExecutionTimeout: to.Ptr("pbnxiricrjifreoiazmzeqiwu"),
	// 				Platform: to.Ptr("p"),
	// 				Region: to.Ptr("lrudpuvzcuh"),
	// 				ResourceGroupName: to.Ptr("ly"),
	// 				ServerlessArmResourceID: to.Ptr("/subscriptions/subid/resourceGroups/rg1/providers/Informatica.DataManagement/organizations/org1/serverlessRuntimes/serverlessRuntimeName"),
	// 				Subnet: to.Ptr("mmhpqazmxniguwzmqiu"),
	// 				SubscriptionID: to.Ptr("zl"),
	// 				SupplementaryFileLocation: to.Ptr("wylmhc"),
	// 				Tags: to.Ptr("tevuusglxuivd"),
	// 				TenantID: to.Ptr("00000000-0000-0000-0000-000000000000"),
	// 				Vnet: to.Ptr("vvs"),
	// 			},
	// 			Status: to.Ptr("exvtblad"),
	// 			StatusLocalized: to.Ptr("otg"),
	// 			StatusMessage: to.Ptr("bnosdq"),
	// 			UpdatedBy: to.Ptr("uhsmrmagqrtfd"),
	// 			UpdatedTime: to.Ptr("mjiscnhzzutsrsffhdqsl"),
	// 	}},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_GetAllServerlessRuntimes_MinimumSet_Gen.json
func ExampleOrganizationsClient_GetAllServerlessRuntimes_organizationsGetAllServerlessRuntimesMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().GetAllServerlessRuntimes(ctx, "rgopenapi", "0", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.InformaticaServerlessRuntimeResourceList = arminformaticadatamgmt.InformaticaServerlessRuntimeResourceList{
	// 	InformaticaRuntimeResources: []*arminformaticadatamgmt.InfaRuntimeResourceFetchMetaData{
	// 		{
	// 			Name: to.Ptr("wwhnptecwbip"),
	// 			Type: to.Ptr(arminformaticadatamgmt.RuntimeTypeSERVERLESS),
	// 			CreatedBy: to.Ptr("sxizcppjasypefvhacvzfhzn"),
	// 			CreatedTime: to.Ptr("wfbezwbdyszdvwlzvthrxi"),
	// 			ID: to.Ptr("hgnqusidmutarhmwnswhalpjzievdm"),
	// 			ServerlessConfigProperties: &arminformaticadatamgmt.InfaServerlessFetchConfigProperties{
	// 			},
	// 			Status: to.Ptr("exvtblad"),
	// 			StatusLocalized: to.Ptr("otg"),
	// 			StatusMessage: to.Ptr("bnosdq"),
	// 			UpdatedBy: to.Ptr("uhsmrmagqrtfd"),
	// 			UpdatedTime: to.Ptr("mjiscnhzzutsrsffhdqsl"),
	// 	}},
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_GetServerlessMetadata_MaximumSet_Gen.json
func ExampleOrganizationsClient_GetServerlessMetadata_organizationsGetServerlessMetadata() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().GetServerlessMetadata(ctx, "rgopenapi", "3_UC", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.ServerlessMetadataResponse = arminformaticadatamgmt.ServerlessMetadataResponse{
	// 	Type: to.Ptr(arminformaticadatamgmt.RuntimeTypeSERVERLESS),
	// 	ServerlessConfigProperties: &arminformaticadatamgmt.ServerlessConfigProperties{
	// 		ApplicationTypes: []*arminformaticadatamgmt.ApplicationTypeMetadata{
	// 			{
	// 				Name: to.Ptr("kdbgedaiazvoakoheguldnmhadcs"),
	// 				Value: to.Ptr("ipbrpyvxilvqfnwktnq"),
	// 		}},
	// 		ComputeUnits: []*arminformaticadatamgmt.ComputeUnitsMetadata{
	// 			{
	// 				Name: to.Ptr("dvvnxwibhl"),
	// 				Value: []*string{
	// 					to.Ptr("msdbcuekw")},
	// 			}},
	// 			ExecutionTimeout: to.Ptr("zmypifivoqmdpzfjhtpqzvlxol"),
	// 			Platform: to.Ptr(arminformaticadatamgmt.PlatformTypeAZURE),
	// 			Regions: []*arminformaticadatamgmt.RegionsMetadata{
	// 				{
	// 					Name: to.Ptr("wwnertzjidsshgoesojbnaopb"),
	// 					ID: to.Ptr("mqkbutwvzbnnisnen"),
	// 			}},
	// 		},
	// 		ServerlessRuntimeConfigProperties: &arminformaticadatamgmt.ServerlessRuntimeConfigProperties{
	// 			CdiConfigProps: []*arminformaticadatamgmt.CdiConfigProps{
	// 				{
	// 					ApplicationConfigs: []*arminformaticadatamgmt.ApplicationConfigs{
	// 						{
	// 							Name: to.Ptr("upfvjrqcrwwedfujkmsodeinw"),
	// 							Type: to.Ptr("lw"),
	// 							Customized: to.Ptr("j"),
	// 							DefaultValue: to.Ptr("zvgkqwmi"),
	// 							Platform: to.Ptr("dixfyeobngivyvf"),
	// 							Value: to.Ptr("mozgsetpwjmtyl"),
	// 					}},
	// 					EngineName: to.Ptr("hngsdqvtjdhwqlbqfotipaiwjuys"),
	// 					EngineVersion: to.Ptr("zlrlbg"),
	// 			}},
	// 			CdieConfigProps: []*arminformaticadatamgmt.CdiConfigProps{
	// 				{
	// 					ApplicationConfigs: []*arminformaticadatamgmt.ApplicationConfigs{
	// 						{
	// 							Name: to.Ptr("upfvjrqcrwwedfujkmsodeinw"),
	// 							Type: to.Ptr("lw"),
	// 							Customized: to.Ptr("j"),
	// 							DefaultValue: to.Ptr("zvgkqwmi"),
	// 							Platform: to.Ptr("dixfyeobngivyvf"),
	// 							Value: to.Ptr("mozgsetpwjmtyl"),
	// 					}},
	// 					EngineName: to.Ptr("hngsdqvtjdhwqlbqfotipaiwjuys"),
	// 					EngineVersion: to.Ptr("zlrlbg"),
	// 			}},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/56537883b7cdb95618c3d1ec1c0ee37b59d88d72/specification/informatica/resource-manager/Informatica.DataManagement/stable/2024-05-08/examples/Organizations_GetServerlessMetadata_MinimumSet_Gen.json
func ExampleOrganizationsClient_GetServerlessMetadata_organizationsGetServerlessMetadataMin() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := arminformaticadatamgmt.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewOrganizationsClient().GetServerlessMetadata(ctx, "rgopenapi", "A", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.ServerlessMetadataResponse = arminformaticadatamgmt.ServerlessMetadataResponse{
	// }
}
