//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armintegrationspaces

// ApplicationResourcesClientCreateOrUpdateResponse contains the response from method ApplicationResourcesClient.CreateOrUpdate.
type ApplicationResourcesClientCreateOrUpdateResponse struct {
	// A resource under application.
	ApplicationResource
}

// ApplicationResourcesClientDeleteResponse contains the response from method ApplicationResourcesClient.Delete.
type ApplicationResourcesClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationResourcesClientGetResponse contains the response from method ApplicationResourcesClient.Get.
type ApplicationResourcesClientGetResponse struct {
	// A resource under application.
	ApplicationResource
}

// ApplicationResourcesClientListByApplicationResponse contains the response from method ApplicationResourcesClient.NewListByApplicationPager.
type ApplicationResourcesClientListByApplicationResponse struct {
	// The response of a ApplicationResource list operation.
	ApplicationResourceListResult
}

// ApplicationResourcesClientPatchResponse contains the response from method ApplicationResourcesClient.Patch.
type ApplicationResourcesClientPatchResponse struct {
	// A resource under application.
	ApplicationResource
}

// ApplicationsClientCreateOrUpdateResponse contains the response from method ApplicationsClient.CreateOrUpdate.
type ApplicationsClientCreateOrUpdateResponse struct {
	// An integration application under space.
	Application
}

// ApplicationsClientDeleteBusinessProcessDevelopmentArtifactResponse contains the response from method ApplicationsClient.DeleteBusinessProcessDevelopmentArtifact.
type ApplicationsClientDeleteBusinessProcessDevelopmentArtifactResponse struct {
	// placeholder for future response values
}

// ApplicationsClientDeleteResponse contains the response from method ApplicationsClient.Delete.
type ApplicationsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationsClientGetBusinessProcessDevelopmentArtifactResponse contains the response from method ApplicationsClient.GetBusinessProcessDevelopmentArtifact.
type ApplicationsClientGetBusinessProcessDevelopmentArtifactResponse struct {
	// The business process development artifact save or get response.
	SaveOrGetBusinessProcessDevelopmentArtifactResponse
}

// ApplicationsClientGetResponse contains the response from method ApplicationsClient.Get.
type ApplicationsClientGetResponse struct {
	// An integration application under space.
	Application
}

// ApplicationsClientListBusinessProcessDevelopmentArtifactsResponse contains the response from method ApplicationsClient.ListBusinessProcessDevelopmentArtifacts.
type ApplicationsClientListBusinessProcessDevelopmentArtifactsResponse struct {
	// The business process development artifact get collection response.
	ListBusinessProcessDevelopmentArtifactsResponse
}

// ApplicationsClientListBySpaceResponse contains the response from method ApplicationsClient.NewListBySpacePager.
type ApplicationsClientListBySpaceResponse struct {
	// The response of a Application list operation.
	ApplicationListResult
}

// ApplicationsClientPatchResponse contains the response from method ApplicationsClient.Patch.
type ApplicationsClientPatchResponse struct {
	// An integration application under space.
	Application
}

// ApplicationsClientSaveBusinessProcessDevelopmentArtifactResponse contains the response from method ApplicationsClient.SaveBusinessProcessDevelopmentArtifact.
type ApplicationsClientSaveBusinessProcessDevelopmentArtifactResponse struct {
	// The business process development artifact save or get response.
	SaveOrGetBusinessProcessDevelopmentArtifactResponse
}

// ApplicationsClientValidateBusinessProcessDevelopmentArtifactResponse contains the response from method ApplicationsClient.ValidateBusinessProcessDevelopmentArtifact.
type ApplicationsClientValidateBusinessProcessDevelopmentArtifactResponse struct {
	// placeholder for future response values
}

// BusinessProcessVersionsClientGetResponse contains the response from method BusinessProcessVersionsClient.Get.
type BusinessProcessVersionsClientGetResponse struct {
	// A business process version.
	BusinessProcessVersion
}

// BusinessProcessVersionsClientListByBusinessProcessResponse contains the response from method BusinessProcessVersionsClient.NewListByBusinessProcessPager.
type BusinessProcessVersionsClientListByBusinessProcessResponse struct {
	// The response of a BusinessProcessVersion list operation.
	BusinessProcessVersionListResult
}

// BusinessProcessesClientCreateOrUpdateResponse contains the response from method BusinessProcessesClient.CreateOrUpdate.
type BusinessProcessesClientCreateOrUpdateResponse struct {
	// A business process under application.
	BusinessProcess
}

// BusinessProcessesClientDeleteResponse contains the response from method BusinessProcessesClient.Delete.
type BusinessProcessesClientDeleteResponse struct {
	// placeholder for future response values
}

// BusinessProcessesClientGetResponse contains the response from method BusinessProcessesClient.Get.
type BusinessProcessesClientGetResponse struct {
	// A business process under application.
	BusinessProcess
}

// BusinessProcessesClientListByApplicationResponse contains the response from method BusinessProcessesClient.NewListByApplicationPager.
type BusinessProcessesClientListByApplicationResponse struct {
	// The response of a BusinessProcess list operation.
	BusinessProcessListResult
}

// BusinessProcessesClientPatchResponse contains the response from method BusinessProcessesClient.Patch.
type BusinessProcessesClientPatchResponse struct {
	// A business process under application.
	BusinessProcess
}

// InfrastructureResourcesClientCreateOrUpdateResponse contains the response from method InfrastructureResourcesClient.CreateOrUpdate.
type InfrastructureResourcesClientCreateOrUpdateResponse struct {
	// An infrastructure resource under Space.
	InfrastructureResource
}

// InfrastructureResourcesClientDeleteResponse contains the response from method InfrastructureResourcesClient.Delete.
type InfrastructureResourcesClientDeleteResponse struct {
	// placeholder for future response values
}

// InfrastructureResourcesClientGetResponse contains the response from method InfrastructureResourcesClient.Get.
type InfrastructureResourcesClientGetResponse struct {
	// An infrastructure resource under Space.
	InfrastructureResource
}

// InfrastructureResourcesClientListBySpaceResponse contains the response from method InfrastructureResourcesClient.NewListBySpacePager.
type InfrastructureResourcesClientListBySpaceResponse struct {
	// The response of a InfrastructureResource list operation.
	InfrastructureResourceListResult
}

// InfrastructureResourcesClientPatchResponse contains the response from method InfrastructureResourcesClient.Patch.
type InfrastructureResourcesClientPatchResponse struct {
	// An infrastructure resource under Space.
	InfrastructureResource
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// SpacesClientCreateOrUpdateResponse contains the response from method SpacesClient.CreateOrUpdate.
type SpacesClientCreateOrUpdateResponse struct {
	// An integration space.
	Space
}

// SpacesClientDeleteResponse contains the response from method SpacesClient.Delete.
type SpacesClientDeleteResponse struct {
	// placeholder for future response values
}

// SpacesClientGetResponse contains the response from method SpacesClient.Get.
type SpacesClientGetResponse struct {
	// An integration space.
	Space
}

// SpacesClientListByResourceGroupResponse contains the response from method SpacesClient.NewListByResourceGroupPager.
type SpacesClientListByResourceGroupResponse struct {
	// The response of a Space list operation.
	SpaceListResult
}

// SpacesClientListBySubscriptionResponse contains the response from method SpacesClient.NewListBySubscriptionPager.
type SpacesClientListBySubscriptionResponse struct {
	// The response of a Space list operation.
	SpaceListResult
}

// SpacesClientPatchResponse contains the response from method SpacesClient.Patch.
type SpacesClientPatchResponse struct {
	// An integration space.
	Space
}
