//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armiotfirmwaredefense

// BinaryHardeningClientListByFirmwareResponse contains the response from method BinaryHardeningClient.NewListByFirmwarePager.
type BinaryHardeningClientListByFirmwareResponse struct {
	// List of binary hardening results.
	BinaryHardeningListResult
}

// CryptoCertificatesClientListByFirmwareResponse contains the response from method CryptoCertificatesClient.NewListByFirmwarePager.
type CryptoCertificatesClientListByFirmwareResponse struct {
	// List of crypto certificates.
	CryptoCertificateListResult
}

// CryptoKeysClientListByFirmwareResponse contains the response from method CryptoKeysClient.NewListByFirmwarePager.
type CryptoKeysClientListByFirmwareResponse struct {
	// List of crypto keys.
	CryptoKeyListResult
}

// CvesClientListByFirmwareResponse contains the response from method CvesClient.NewListByFirmwarePager.
type CvesClientListByFirmwareResponse struct {
	// List of CVE results.
	CveListResult
}

// FirmwaresClientCreateResponse contains the response from method FirmwaresClient.Create.
type FirmwaresClientCreateResponse struct {
	// Firmware definition
	Firmware
}

// FirmwaresClientDeleteResponse contains the response from method FirmwaresClient.Delete.
type FirmwaresClientDeleteResponse struct {
	// placeholder for future response values
}

// FirmwaresClientGenerateDownloadURLResponse contains the response from method FirmwaresClient.GenerateDownloadURL.
type FirmwaresClientGenerateDownloadURLResponse struct {
	// Url data for creating or accessing a blob file.
	URLToken
}

// FirmwaresClientGenerateFilesystemDownloadURLResponse contains the response from method FirmwaresClient.GenerateFilesystemDownloadURL.
type FirmwaresClientGenerateFilesystemDownloadURLResponse struct {
	// Url data for creating or accessing a blob file.
	URLToken
}

// FirmwaresClientGetResponse contains the response from method FirmwaresClient.Get.
type FirmwaresClientGetResponse struct {
	// Firmware definition
	Firmware
}

// FirmwaresClientListByWorkspaceResponse contains the response from method FirmwaresClient.NewListByWorkspacePager.
type FirmwaresClientListByWorkspaceResponse struct {
	// List of firmwares
	FirmwareList
}

// FirmwaresClientUpdateResponse contains the response from method FirmwaresClient.Update.
type FirmwaresClientUpdateResponse struct {
	// Firmware definition
	Firmware
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PasswordHashesClientListByFirmwareResponse contains the response from method PasswordHashesClient.NewListByFirmwarePager.
type PasswordHashesClientListByFirmwareResponse struct {
	// List of password hash results
	PasswordHashListResult
}

// SbomComponentsClientListByFirmwareResponse contains the response from method SbomComponentsClient.NewListByFirmwarePager.
type SbomComponentsClientListByFirmwareResponse struct {
	// List of SBOM results.
	SbomComponentListResult
}

// SummariesClientGetResponse contains the response from method SummariesClient.Get.
type SummariesClientGetResponse struct {
	// The object representing a firmware analysis summary resource.
	SummaryResource
}

// SummariesClientListByFirmwareResponse contains the response from method SummariesClient.NewListByFirmwarePager.
type SummariesClientListByFirmwareResponse struct {
	// List of analysis summaries.
	SummaryListResult
}

// WorkspacesClientCreateResponse contains the response from method WorkspacesClient.Create.
type WorkspacesClientCreateResponse struct {
	// Firmware analysis workspace.
	Workspace
}

// WorkspacesClientDeleteResponse contains the response from method WorkspacesClient.Delete.
type WorkspacesClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspacesClientGenerateUploadURLResponse contains the response from method WorkspacesClient.GenerateUploadURL.
type WorkspacesClientGenerateUploadURLResponse struct {
	// Url data for creating or accessing a blob file.
	URLToken
}

// WorkspacesClientGetResponse contains the response from method WorkspacesClient.Get.
type WorkspacesClientGetResponse struct {
	// Firmware analysis workspace.
	Workspace
}

// WorkspacesClientListByResourceGroupResponse contains the response from method WorkspacesClient.NewListByResourceGroupPager.
type WorkspacesClientListByResourceGroupResponse struct {
	// Return a list of firmware analysis workspaces.
	WorkspaceList
}

// WorkspacesClientListBySubscriptionResponse contains the response from method WorkspacesClient.NewListBySubscriptionPager.
type WorkspacesClientListBySubscriptionResponse struct {
	// Return a list of firmware analysis workspaces.
	WorkspaceList
}

// WorkspacesClientUpdateResponse contains the response from method WorkspacesClient.Update.
type WorkspacesClientUpdateResponse struct {
	// Firmware analysis workspace.
	Workspace
}
