//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armiothub

// CertificatesClientCreateOrUpdateOptions contains the optional parameters for the CertificatesClient.CreateOrUpdate method.
type CertificatesClientCreateOrUpdateOptions struct {
	// ETag of the Certificate. Do not specify for creating a brand new certificate. Required to update an existing certificate.
	IfMatch *string
}

// CertificatesClientDeleteOptions contains the optional parameters for the CertificatesClient.Delete method.
type CertificatesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// CertificatesClientGenerateVerificationCodeOptions contains the optional parameters for the CertificatesClient.GenerateVerificationCode
// method.
type CertificatesClientGenerateVerificationCodeOptions struct {
	// placeholder for future optional parameters
}

// CertificatesClientGetOptions contains the optional parameters for the CertificatesClient.Get method.
type CertificatesClientGetOptions struct {
	// placeholder for future optional parameters
}

// CertificatesClientListByIotHubOptions contains the optional parameters for the CertificatesClient.ListByIotHub method.
type CertificatesClientListByIotHubOptions struct {
	// placeholder for future optional parameters
}

// CertificatesClientVerifyOptions contains the optional parameters for the CertificatesClient.Verify method.
type CertificatesClientVerifyOptions struct {
	// placeholder for future optional parameters
}

// ClientBeginManualFailoverOptions contains the optional parameters for the Client.BeginManualFailover method.
type ClientBeginManualFailoverOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// PrivateEndpointConnectionsClientBeginDeleteOptions contains the optional parameters for the PrivateEndpointConnectionsClient.BeginDelete
// method.
type PrivateEndpointConnectionsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PrivateEndpointConnectionsClientBeginUpdateOptions contains the optional parameters for the PrivateEndpointConnectionsClient.BeginUpdate
// method.
type PrivateEndpointConnectionsClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PrivateEndpointConnectionsClientGetOptions contains the optional parameters for the PrivateEndpointConnectionsClient.Get
// method.
type PrivateEndpointConnectionsClientGetOptions struct {
	// placeholder for future optional parameters
}

// PrivateEndpointConnectionsClientListOptions contains the optional parameters for the PrivateEndpointConnectionsClient.List
// method.
type PrivateEndpointConnectionsClientListOptions struct {
	// placeholder for future optional parameters
}

// PrivateLinkResourcesClientGetOptions contains the optional parameters for the PrivateLinkResourcesClient.Get method.
type PrivateLinkResourcesClientGetOptions struct {
	// placeholder for future optional parameters
}

// PrivateLinkResourcesClientListOptions contains the optional parameters for the PrivateLinkResourcesClient.List method.
type PrivateLinkResourcesClientListOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientBeginCreateOrUpdateOptions contains the optional parameters for the ResourceClient.BeginCreateOrUpdate method.
type ResourceClientBeginCreateOrUpdateOptions struct {
	// ETag of the IoT Hub. Do not specify for creating a brand new IoT Hub. Required to update an existing IoT Hub.
	IfMatch *string

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ResourceClientBeginDeleteOptions contains the optional parameters for the ResourceClient.BeginDelete method.
type ResourceClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ResourceClientBeginUpdateOptions contains the optional parameters for the ResourceClient.BeginUpdate method.
type ResourceClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ResourceClientCheckNameAvailabilityOptions contains the optional parameters for the ResourceClient.CheckNameAvailability
// method.
type ResourceClientCheckNameAvailabilityOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientCreateEventHubConsumerGroupOptions contains the optional parameters for the ResourceClient.CreateEventHubConsumerGroup
// method.
type ResourceClientCreateEventHubConsumerGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientDeleteEventHubConsumerGroupOptions contains the optional parameters for the ResourceClient.DeleteEventHubConsumerGroup
// method.
type ResourceClientDeleteEventHubConsumerGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientExportDevicesOptions contains the optional parameters for the ResourceClient.ExportDevices method.
type ResourceClientExportDevicesOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetEndpointHealthOptions contains the optional parameters for the ResourceClient.NewGetEndpointHealthPager
// method.
type ResourceClientGetEndpointHealthOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetEventHubConsumerGroupOptions contains the optional parameters for the ResourceClient.GetEventHubConsumerGroup
// method.
type ResourceClientGetEventHubConsumerGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetJobOptions contains the optional parameters for the ResourceClient.GetJob method.
type ResourceClientGetJobOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetKeysForKeyNameOptions contains the optional parameters for the ResourceClient.GetKeysForKeyName method.
type ResourceClientGetKeysForKeyNameOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetOptions contains the optional parameters for the ResourceClient.Get method.
type ResourceClientGetOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetQuotaMetricsOptions contains the optional parameters for the ResourceClient.NewGetQuotaMetricsPager method.
type ResourceClientGetQuotaMetricsOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetStatsOptions contains the optional parameters for the ResourceClient.GetStats method.
type ResourceClientGetStatsOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientGetValidSKUsOptions contains the optional parameters for the ResourceClient.NewGetValidSKUsPager method.
type ResourceClientGetValidSKUsOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientImportDevicesOptions contains the optional parameters for the ResourceClient.ImportDevices method.
type ResourceClientImportDevicesOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientListByResourceGroupOptions contains the optional parameters for the ResourceClient.NewListByResourceGroupPager
// method.
type ResourceClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientListBySubscriptionOptions contains the optional parameters for the ResourceClient.NewListBySubscriptionPager
// method.
type ResourceClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientListEventHubConsumerGroupsOptions contains the optional parameters for the ResourceClient.NewListEventHubConsumerGroupsPager
// method.
type ResourceClientListEventHubConsumerGroupsOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientListJobsOptions contains the optional parameters for the ResourceClient.NewListJobsPager method.
type ResourceClientListJobsOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientListKeysOptions contains the optional parameters for the ResourceClient.NewListKeysPager method.
type ResourceClientListKeysOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientTestAllRoutesOptions contains the optional parameters for the ResourceClient.TestAllRoutes method.
type ResourceClientTestAllRoutesOptions struct {
	// placeholder for future optional parameters
}

// ResourceClientTestRouteOptions contains the optional parameters for the ResourceClient.TestRoute method.
type ResourceClientTestRouteOptions struct {
	// placeholder for future optional parameters
}

// ResourceProviderCommonClientGetSubscriptionQuotaOptions contains the optional parameters for the ResourceProviderCommonClient.GetSubscriptionQuota
// method.
type ResourceProviderCommonClientGetSubscriptionQuotaOptions struct {
	// placeholder for future optional parameters
}
