//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armlabservices

// ImagesClientCreateOrUpdateResponse contains the response from method ImagesClient.CreateOrUpdate.
type ImagesClientCreateOrUpdateResponse struct {
	// Lab services virtual machine image
	Image
}

// ImagesClientGetResponse contains the response from method ImagesClient.Get.
type ImagesClientGetResponse struct {
	// Lab services virtual machine image
	Image
}

// ImagesClientListByLabPlanResponse contains the response from method ImagesClient.NewListByLabPlanPager.
type ImagesClientListByLabPlanResponse struct {
	// Paged list of Lab services virtual machine images.
	PagedImages
}

// ImagesClientUpdateResponse contains the response from method ImagesClient.Update.
type ImagesClientUpdateResponse struct {
	// Lab services virtual machine image
	Image
}

// LabPlansClientCreateOrUpdateResponse contains the response from method LabPlansClient.BeginCreateOrUpdate.
type LabPlansClientCreateOrUpdateResponse struct {
	// Lab Plans act as a permission container for creating labs via labs.azure.com. Additionally, they can provide a set of default
	// configurations that will apply at the time of creating a lab, but these defaults can still be overwritten.
	LabPlan
}

// LabPlansClientDeleteResponse contains the response from method LabPlansClient.BeginDelete.
type LabPlansClientDeleteResponse struct {
	// placeholder for future response values
}

// LabPlansClientGetResponse contains the response from method LabPlansClient.Get.
type LabPlansClientGetResponse struct {
	// Lab Plans act as a permission container for creating labs via labs.azure.com. Additionally, they can provide a set of default
	// configurations that will apply at the time of creating a lab, but these defaults can still be overwritten.
	LabPlan
}

// LabPlansClientListByResourceGroupResponse contains the response from method LabPlansClient.NewListByResourceGroupPager.
type LabPlansClientListByResourceGroupResponse struct {
	// Paged list of lab plans.
	PagedLabPlans
}

// LabPlansClientListBySubscriptionResponse contains the response from method LabPlansClient.NewListBySubscriptionPager.
type LabPlansClientListBySubscriptionResponse struct {
	// Paged list of lab plans.
	PagedLabPlans
}

// LabPlansClientSaveImageResponse contains the response from method LabPlansClient.BeginSaveImage.
type LabPlansClientSaveImageResponse struct {
	// placeholder for future response values
}

// LabPlansClientUpdateResponse contains the response from method LabPlansClient.BeginUpdate.
type LabPlansClientUpdateResponse struct {
	// Lab Plans act as a permission container for creating labs via labs.azure.com. Additionally, they can provide a set of default
	// configurations that will apply at the time of creating a lab, but these defaults can still be overwritten.
	LabPlan
}

// LabsClientCreateOrUpdateResponse contains the response from method LabsClient.BeginCreateOrUpdate.
type LabsClientCreateOrUpdateResponse struct {
	// The lab resource.
	Lab
}

// LabsClientDeleteResponse contains the response from method LabsClient.BeginDelete.
type LabsClientDeleteResponse struct {
	// placeholder for future response values
}

// LabsClientGetResponse contains the response from method LabsClient.Get.
type LabsClientGetResponse struct {
	// The lab resource.
	Lab
}

// LabsClientListByResourceGroupResponse contains the response from method LabsClient.NewListByResourceGroupPager.
type LabsClientListByResourceGroupResponse struct {
	// Paged list of labs.
	PagedLabs
}

// LabsClientListBySubscriptionResponse contains the response from method LabsClient.NewListBySubscriptionPager.
type LabsClientListBySubscriptionResponse struct {
	// Paged list of labs.
	PagedLabs
}

// LabsClientPublishResponse contains the response from method LabsClient.BeginPublish.
type LabsClientPublishResponse struct {
	// placeholder for future response values
}

// LabsClientSyncGroupResponse contains the response from method LabsClient.BeginSyncGroup.
type LabsClientSyncGroupResponse struct {
	// placeholder for future response values
}

// LabsClientUpdateResponse contains the response from method LabsClient.BeginUpdate.
type LabsClientUpdateResponse struct {
	// The lab resource.
	Lab
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.Get.
type OperationResultsClientGetResponse struct {
	// A long running operation result
	OperationResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// SKUsClientListResponse contains the response from method SKUsClient.NewListPager.
type SKUsClientListResponse struct {
	// Paged list of lab services skus.
	PagedSKUInfos
}

// SchedulesClientCreateOrUpdateResponse contains the response from method SchedulesClient.CreateOrUpdate.
type SchedulesClientCreateOrUpdateResponse struct {
	// Schedule for automatically turning virtual machines in a lab on and off at specified times.
	Schedule
}

// SchedulesClientDeleteResponse contains the response from method SchedulesClient.BeginDelete.
type SchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// SchedulesClientGetResponse contains the response from method SchedulesClient.Get.
type SchedulesClientGetResponse struct {
	// Schedule for automatically turning virtual machines in a lab on and off at specified times.
	Schedule
}

// SchedulesClientListByLabResponse contains the response from method SchedulesClient.NewListByLabPager.
type SchedulesClientListByLabResponse struct {
	// Paged list of schedules.
	PagedSchedules
}

// SchedulesClientUpdateResponse contains the response from method SchedulesClient.Update.
type SchedulesClientUpdateResponse struct {
	// Schedule for automatically turning virtual machines in a lab on and off at specified times.
	Schedule
}

// UsagesClientListByLocationResponse contains the response from method UsagesClient.NewListByLocationPager.
type UsagesClientListByLocationResponse struct {
	// List of Core Usages.
	ListUsagesResult
}

// UsersClientCreateOrUpdateResponse contains the response from method UsersClient.BeginCreateOrUpdate.
type UsersClientCreateOrUpdateResponse struct {
	// User of a lab that can register for and use virtual machines within the lab.
	User
}

// UsersClientDeleteResponse contains the response from method UsersClient.BeginDelete.
type UsersClientDeleteResponse struct {
	// placeholder for future response values
}

// UsersClientGetResponse contains the response from method UsersClient.Get.
type UsersClientGetResponse struct {
	// User of a lab that can register for and use virtual machines within the lab.
	User
}

// UsersClientInviteResponse contains the response from method UsersClient.BeginInvite.
type UsersClientInviteResponse struct {
	// placeholder for future response values
}

// UsersClientListByLabResponse contains the response from method UsersClient.NewListByLabPager.
type UsersClientListByLabResponse struct {
	// Paged list of users.
	PagedUsers
}

// UsersClientUpdateResponse contains the response from method UsersClient.BeginUpdate.
type UsersClientUpdateResponse struct {
	// User of a lab that can register for and use virtual machines within the lab.
	User
}

// VirtualMachinesClientGetResponse contains the response from method VirtualMachinesClient.Get.
type VirtualMachinesClientGetResponse struct {
	// A lab virtual machine resource.
	VirtualMachine
}

// VirtualMachinesClientListByLabResponse contains the response from method VirtualMachinesClient.NewListByLabPager.
type VirtualMachinesClientListByLabResponse struct {
	// Paged list of lab services virtual machines.
	PagedVirtualMachines
}

// VirtualMachinesClientRedeployResponse contains the response from method VirtualMachinesClient.BeginRedeploy.
type VirtualMachinesClientRedeployResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientReimageResponse contains the response from method VirtualMachinesClient.BeginReimage.
type VirtualMachinesClientReimageResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientResetPasswordResponse contains the response from method VirtualMachinesClient.BeginResetPassword.
type VirtualMachinesClientResetPasswordResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientStartResponse contains the response from method VirtualMachinesClient.BeginStart.
type VirtualMachinesClientStartResponse struct {
	// placeholder for future response values
}

// VirtualMachinesClientStopResponse contains the response from method VirtualMachinesClient.BeginStop.
type VirtualMachinesClientStopResponse struct {
	// placeholder for future response values
}
