//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armlogz

// MonitorClientListVMHostUpdateOptions contains the optional parameters for the MonitorClient.NewListVMHostUpdatePager method.
type MonitorClientListVMHostUpdateOptions struct {
	// Request body to update the collection for agent installed in the given monitor.
	Body *VMHostUpdateRequest
}

// MonitorClientListVMHostsOptions contains the optional parameters for the MonitorClient.NewListVMHostsPager method.
type MonitorClientListVMHostsOptions struct {
	// placeholder for future optional parameters
}

// MonitorClientVMHostPayloadOptions contains the optional parameters for the MonitorClient.VMHostPayload method.
type MonitorClientVMHostPayloadOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientBeginCreateOptions contains the optional parameters for the MonitorsClient.BeginCreate method.
type MonitorsClientBeginCreateOptions struct {
	Body *MonitorResource

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// MonitorsClientBeginDeleteOptions contains the optional parameters for the MonitorsClient.BeginDelete method.
type MonitorsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// MonitorsClientGetOptions contains the optional parameters for the MonitorsClient.Get method.
type MonitorsClientGetOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListByResourceGroupOptions contains the optional parameters for the MonitorsClient.NewListByResourceGroupPager
// method.
type MonitorsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListBySubscriptionOptions contains the optional parameters for the MonitorsClient.NewListBySubscriptionPager
// method.
type MonitorsClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListMonitoredResourcesOptions contains the optional parameters for the MonitorsClient.NewListMonitoredResourcesPager
// method.
type MonitorsClientListMonitoredResourcesOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListUserRolesOptions contains the optional parameters for the MonitorsClient.NewListUserRolesPager method.
type MonitorsClientListUserRolesOptions struct {
	Body *UserRoleRequest
}

// MonitorsClientUpdateOptions contains the optional parameters for the MonitorsClient.Update method.
type MonitorsClientUpdateOptions struct {
	Body *MonitorResourceUpdateParameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// SingleSignOnClientBeginCreateOrUpdateOptions contains the optional parameters for the SingleSignOnClient.BeginCreateOrUpdate
// method.
type SingleSignOnClientBeginCreateOrUpdateOptions struct {
	Body *SingleSignOnResource

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SingleSignOnClientGetOptions contains the optional parameters for the SingleSignOnClient.Get method.
type SingleSignOnClientGetOptions struct {
	// placeholder for future optional parameters
}

// SingleSignOnClientListOptions contains the optional parameters for the SingleSignOnClient.NewListPager method.
type SingleSignOnClientListOptions struct {
	// placeholder for future optional parameters
}

// SubAccountClientBeginCreateOptions contains the optional parameters for the SubAccountClient.BeginCreate method.
type SubAccountClientBeginCreateOptions struct {
	Body *MonitorResource

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SubAccountClientBeginDeleteOptions contains the optional parameters for the SubAccountClient.BeginDelete method.
type SubAccountClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SubAccountClientGetOptions contains the optional parameters for the SubAccountClient.Get method.
type SubAccountClientGetOptions struct {
	// placeholder for future optional parameters
}

// SubAccountClientListMonitoredResourcesOptions contains the optional parameters for the SubAccountClient.NewListMonitoredResourcesPager
// method.
type SubAccountClientListMonitoredResourcesOptions struct {
	// placeholder for future optional parameters
}

// SubAccountClientListOptions contains the optional parameters for the SubAccountClient.NewListPager method.
type SubAccountClientListOptions struct {
	// placeholder for future optional parameters
}

// SubAccountClientListVMHostUpdateOptions contains the optional parameters for the SubAccountClient.NewListVMHostUpdatePager
// method.
type SubAccountClientListVMHostUpdateOptions struct {
	// Request body to update the collection for agent installed in the given monitor.
	Body *VMHostUpdateRequest
}

// SubAccountClientListVMHostsOptions contains the optional parameters for the SubAccountClient.NewListVMHostsPager method.
type SubAccountClientListVMHostsOptions struct {
	// placeholder for future optional parameters
}

// SubAccountClientUpdateOptions contains the optional parameters for the SubAccountClient.Update method.
type SubAccountClientUpdateOptions struct {
	Body *MonitorResourceUpdateParameters
}

// SubAccountClientVMHostPayloadOptions contains the optional parameters for the SubAccountClient.VMHostPayload method.
type SubAccountClientVMHostPayloadOptions struct {
	// placeholder for future optional parameters
}

// SubAccountTagRulesClientCreateOrUpdateOptions contains the optional parameters for the SubAccountTagRulesClient.CreateOrUpdate
// method.
type SubAccountTagRulesClientCreateOrUpdateOptions struct {
	Body *MonitoringTagRules
}

// SubAccountTagRulesClientDeleteOptions contains the optional parameters for the SubAccountTagRulesClient.Delete method.
type SubAccountTagRulesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// SubAccountTagRulesClientGetOptions contains the optional parameters for the SubAccountTagRulesClient.Get method.
type SubAccountTagRulesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SubAccountTagRulesClientListOptions contains the optional parameters for the SubAccountTagRulesClient.NewListPager method.
type SubAccountTagRulesClientListOptions struct {
	// placeholder for future optional parameters
}

// TagRulesClientCreateOrUpdateOptions contains the optional parameters for the TagRulesClient.CreateOrUpdate method.
type TagRulesClientCreateOrUpdateOptions struct {
	Body *MonitoringTagRules
}

// TagRulesClientDeleteOptions contains the optional parameters for the TagRulesClient.Delete method.
type TagRulesClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// TagRulesClientGetOptions contains the optional parameters for the TagRulesClient.Get method.
type TagRulesClientGetOptions struct {
	// placeholder for future optional parameters
}

// TagRulesClientListOptions contains the optional parameters for the TagRulesClient.NewListPager method.
type TagRulesClientListOptions struct {
	// placeholder for future optional parameters
}
