//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armlogz

// MonitorClientListVMHostUpdateResponse contains the response from method MonitorClient.NewListVMHostUpdatePager.
type MonitorClientListVMHostUpdateResponse struct {
	// Response of a list VM Host Update Operation.
	VMResourcesListResponse
}

// MonitorClientListVMHostsResponse contains the response from method MonitorClient.NewListVMHostsPager.
type MonitorClientListVMHostsResponse struct {
	// Response of a list VM Host Update Operation.
	VMResourcesListResponse
}

// MonitorClientVMHostPayloadResponse contains the response from method MonitorClient.VMHostPayload.
type MonitorClientVMHostPayloadResponse struct {
	// Response of payload to be passed while installing VM agent.
	VMExtensionPayload
}

// MonitorsClientCreateResponse contains the response from method MonitorsClient.BeginCreate.
type MonitorsClientCreateResponse struct {
	MonitorResource
}

// MonitorsClientDeleteResponse contains the response from method MonitorsClient.BeginDelete.
type MonitorsClientDeleteResponse struct {
	// placeholder for future response values
}

// MonitorsClientGetResponse contains the response from method MonitorsClient.Get.
type MonitorsClientGetResponse struct {
	MonitorResource
}

// MonitorsClientListByResourceGroupResponse contains the response from method MonitorsClient.NewListByResourceGroupPager.
type MonitorsClientListByResourceGroupResponse struct {
	// Response of a list operation.
	MonitorResourceListResponse
}

// MonitorsClientListBySubscriptionResponse contains the response from method MonitorsClient.NewListBySubscriptionPager.
type MonitorsClientListBySubscriptionResponse struct {
	// Response of a list operation.
	MonitorResourceListResponse
}

// MonitorsClientListMonitoredResourcesResponse contains the response from method MonitorsClient.NewListMonitoredResourcesPager.
type MonitorsClientListMonitoredResourcesResponse struct {
	// Response of a list operation.
	MonitoredResourceListResponse
}

// MonitorsClientListUserRolesResponse contains the response from method MonitorsClient.NewListUserRolesPager.
type MonitorsClientListUserRolesResponse struct {
	// Response for list of user's role for Logz.io account.
	UserRoleListResponse
}

// MonitorsClientUpdateResponse contains the response from method MonitorsClient.Update.
type MonitorsClientUpdateResponse struct {
	MonitorResource
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of GET request to list the Microsoft.Logz operations.
	OperationListResult
}

// SingleSignOnClientCreateOrUpdateResponse contains the response from method SingleSignOnClient.BeginCreateOrUpdate.
type SingleSignOnClientCreateOrUpdateResponse struct {
	SingleSignOnResource
}

// SingleSignOnClientGetResponse contains the response from method SingleSignOnClient.Get.
type SingleSignOnClientGetResponse struct {
	SingleSignOnResource
}

// SingleSignOnClientListResponse contains the response from method SingleSignOnClient.NewListPager.
type SingleSignOnClientListResponse struct {
	// Response of a list operation.
	SingleSignOnResourceListResponse
}

// SubAccountClientCreateResponse contains the response from method SubAccountClient.BeginCreate.
type SubAccountClientCreateResponse struct {
	MonitorResource
}

// SubAccountClientDeleteResponse contains the response from method SubAccountClient.BeginDelete.
type SubAccountClientDeleteResponse struct {
	// placeholder for future response values
}

// SubAccountClientGetResponse contains the response from method SubAccountClient.Get.
type SubAccountClientGetResponse struct {
	MonitorResource
}

// SubAccountClientListMonitoredResourcesResponse contains the response from method SubAccountClient.NewListMonitoredResourcesPager.
type SubAccountClientListMonitoredResourcesResponse struct {
	// Response of a list operation.
	MonitoredResourceListResponse
}

// SubAccountClientListResponse contains the response from method SubAccountClient.NewListPager.
type SubAccountClientListResponse struct {
	// Response of a list operation.
	MonitorResourceListResponse
}

// SubAccountClientListVMHostUpdateResponse contains the response from method SubAccountClient.NewListVMHostUpdatePager.
type SubAccountClientListVMHostUpdateResponse struct {
	// Response of a list VM Host Update Operation.
	VMResourcesListResponse
}

// SubAccountClientListVMHostsResponse contains the response from method SubAccountClient.NewListVMHostsPager.
type SubAccountClientListVMHostsResponse struct {
	// Response of a list VM Host Update Operation.
	VMResourcesListResponse
}

// SubAccountClientUpdateResponse contains the response from method SubAccountClient.Update.
type SubAccountClientUpdateResponse struct {
	MonitorResource
}

// SubAccountClientVMHostPayloadResponse contains the response from method SubAccountClient.VMHostPayload.
type SubAccountClientVMHostPayloadResponse struct {
	// Response of payload to be passed while installing VM agent.
	VMExtensionPayload
}

// SubAccountTagRulesClientCreateOrUpdateResponse contains the response from method SubAccountTagRulesClient.CreateOrUpdate.
type SubAccountTagRulesClientCreateOrUpdateResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// SubAccountTagRulesClientDeleteResponse contains the response from method SubAccountTagRulesClient.Delete.
type SubAccountTagRulesClientDeleteResponse struct {
	// Location contains the information returned from the location header response.
	Location *string
}

// SubAccountTagRulesClientGetResponse contains the response from method SubAccountTagRulesClient.Get.
type SubAccountTagRulesClientGetResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// SubAccountTagRulesClientListResponse contains the response from method SubAccountTagRulesClient.NewListPager.
type SubAccountTagRulesClientListResponse struct {
	// Response of a list operation.
	MonitoringTagRulesListResponse
}

// TagRulesClientCreateOrUpdateResponse contains the response from method TagRulesClient.CreateOrUpdate.
type TagRulesClientCreateOrUpdateResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// TagRulesClientDeleteResponse contains the response from method TagRulesClient.Delete.
type TagRulesClientDeleteResponse struct {
	// Location contains the information returned from the location header response.
	Location *string
}

// TagRulesClientGetResponse contains the response from method TagRulesClient.Get.
type TagRulesClientGetResponse struct {
	// Capture logs and metrics of Azure resources based on ARM tags.
	MonitoringTagRules
}

// TagRulesClientListResponse contains the response from method TagRulesClient.NewListPager.
type TagRulesClientListResponse struct {
	// Response of a list operation.
	MonitoringTagRulesListResponse
}
