//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armmachinelearning

// BatchDeploymentsClientCreateOrUpdateResponse contains the response from method BatchDeploymentsClient.BeginCreateOrUpdate.
type BatchDeploymentsClientCreateOrUpdateResponse struct {
	BatchDeployment
}

// BatchDeploymentsClientDeleteResponse contains the response from method BatchDeploymentsClient.BeginDelete.
type BatchDeploymentsClientDeleteResponse struct {
	// placeholder for future response values
}

// BatchDeploymentsClientGetResponse contains the response from method BatchDeploymentsClient.Get.
type BatchDeploymentsClientGetResponse struct {
	BatchDeployment
}

// BatchDeploymentsClientListResponse contains the response from method BatchDeploymentsClient.NewListPager.
type BatchDeploymentsClientListResponse struct {
	// A paginated list of BatchDeployment entities.
	BatchDeploymentTrackedResourceArmPaginatedResult
}

// BatchDeploymentsClientUpdateResponse contains the response from method BatchDeploymentsClient.BeginUpdate.
type BatchDeploymentsClientUpdateResponse struct {
	BatchDeployment
}

// BatchEndpointsClientCreateOrUpdateResponse contains the response from method BatchEndpointsClient.BeginCreateOrUpdate.
type BatchEndpointsClientCreateOrUpdateResponse struct {
	BatchEndpoint
}

// BatchEndpointsClientDeleteResponse contains the response from method BatchEndpointsClient.BeginDelete.
type BatchEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// BatchEndpointsClientGetResponse contains the response from method BatchEndpointsClient.Get.
type BatchEndpointsClientGetResponse struct {
	BatchEndpoint
}

// BatchEndpointsClientListKeysResponse contains the response from method BatchEndpointsClient.ListKeys.
type BatchEndpointsClientListKeysResponse struct {
	// Keys for endpoint authentication.
	EndpointAuthKeys
}

// BatchEndpointsClientListResponse contains the response from method BatchEndpointsClient.NewListPager.
type BatchEndpointsClientListResponse struct {
	// A paginated list of BatchEndpoint entities.
	BatchEndpointTrackedResourceArmPaginatedResult
}

// BatchEndpointsClientUpdateResponse contains the response from method BatchEndpointsClient.BeginUpdate.
type BatchEndpointsClientUpdateResponse struct {
	BatchEndpoint
}

// CodeContainersClientCreateOrUpdateResponse contains the response from method CodeContainersClient.CreateOrUpdate.
type CodeContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	CodeContainer
}

// CodeContainersClientDeleteResponse contains the response from method CodeContainersClient.Delete.
type CodeContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// CodeContainersClientGetResponse contains the response from method CodeContainersClient.Get.
type CodeContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	CodeContainer
}

// CodeContainersClientListResponse contains the response from method CodeContainersClient.NewListPager.
type CodeContainersClientListResponse struct {
	// A paginated list of CodeContainer entities.
	CodeContainerResourceArmPaginatedResult
}

// CodeVersionsClientCreateOrGetStartPendingUploadResponse contains the response from method CodeVersionsClient.CreateOrGetStartPendingUpload.
type CodeVersionsClientCreateOrGetStartPendingUploadResponse struct {
	PendingUploadResponseDto
}

// CodeVersionsClientCreateOrUpdateResponse contains the response from method CodeVersionsClient.CreateOrUpdate.
type CodeVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	CodeVersion
}

// CodeVersionsClientDeleteResponse contains the response from method CodeVersionsClient.Delete.
type CodeVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// CodeVersionsClientGetResponse contains the response from method CodeVersionsClient.Get.
type CodeVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	CodeVersion
}

// CodeVersionsClientListResponse contains the response from method CodeVersionsClient.NewListPager.
type CodeVersionsClientListResponse struct {
	// A paginated list of CodeVersion entities.
	CodeVersionResourceArmPaginatedResult
}

// CodeVersionsClientPublishResponse contains the response from method CodeVersionsClient.BeginPublish.
type CodeVersionsClientPublishResponse struct {
	// placeholder for future response values
}

// ComponentContainersClientCreateOrUpdateResponse contains the response from method ComponentContainersClient.CreateOrUpdate.
type ComponentContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentContainer
}

// ComponentContainersClientDeleteResponse contains the response from method ComponentContainersClient.Delete.
type ComponentContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// ComponentContainersClientGetResponse contains the response from method ComponentContainersClient.Get.
type ComponentContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentContainer
}

// ComponentContainersClientListResponse contains the response from method ComponentContainersClient.NewListPager.
type ComponentContainersClientListResponse struct {
	// A paginated list of ComponentContainer entities.
	ComponentContainerResourceArmPaginatedResult
}

// ComponentVersionsClientCreateOrUpdateResponse contains the response from method ComponentVersionsClient.CreateOrUpdate.
type ComponentVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentVersion
}

// ComponentVersionsClientDeleteResponse contains the response from method ComponentVersionsClient.Delete.
type ComponentVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ComponentVersionsClientGetResponse contains the response from method ComponentVersionsClient.Get.
type ComponentVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentVersion
}

// ComponentVersionsClientListResponse contains the response from method ComponentVersionsClient.NewListPager.
type ComponentVersionsClientListResponse struct {
	// A paginated list of ComponentVersion entities.
	ComponentVersionResourceArmPaginatedResult
}

// ComponentVersionsClientPublishResponse contains the response from method ComponentVersionsClient.BeginPublish.
type ComponentVersionsClientPublishResponse struct {
	// placeholder for future response values
}

// ComputeClientCreateOrUpdateResponse contains the response from method ComputeClient.BeginCreateOrUpdate.
type ComputeClientCreateOrUpdateResponse struct {
	// Machine Learning compute object wrapped into ARM resource envelope.
	ComputeResource
}

// ComputeClientDeleteResponse contains the response from method ComputeClient.BeginDelete.
type ComputeClientDeleteResponse struct {
	// placeholder for future response values
}

// ComputeClientGetResponse contains the response from method ComputeClient.Get.
type ComputeClientGetResponse struct {
	// Machine Learning compute object wrapped into ARM resource envelope.
	ComputeResource
}

// ComputeClientListKeysResponse contains the response from method ComputeClient.ListKeys.
type ComputeClientListKeysResponse struct {
	// Secrets related to a Machine Learning compute. Might differ for every type of compute.
	ComputeSecretsClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type ComputeClientListKeysResponse.
func (c *ComputeClientListKeysResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalComputeSecretsClassification(data)
	if err != nil {
		return err
	}
	c.ComputeSecretsClassification = res
	return nil
}

// ComputeClientListNodesResponse contains the response from method ComputeClient.NewListNodesPager.
type ComputeClientListNodesResponse struct {
	// Result of AmlCompute Nodes
	AmlComputeNodesInformation
}

// ComputeClientListResponse contains the response from method ComputeClient.NewListPager.
type ComputeClientListResponse struct {
	// Paginated list of Machine Learning compute objects wrapped in ARM resource envelope.
	PaginatedComputeResourcesList
}

// ComputeClientRestartResponse contains the response from method ComputeClient.BeginRestart.
type ComputeClientRestartResponse struct {
	// placeholder for future response values
}

// ComputeClientStartResponse contains the response from method ComputeClient.BeginStart.
type ComputeClientStartResponse struct {
	// placeholder for future response values
}

// ComputeClientStopResponse contains the response from method ComputeClient.BeginStop.
type ComputeClientStopResponse struct {
	// placeholder for future response values
}

// ComputeClientUpdateResponse contains the response from method ComputeClient.BeginUpdate.
type ComputeClientUpdateResponse struct {
	// Machine Learning compute object wrapped into ARM resource envelope.
	ComputeResource
}

// DataContainersClientCreateOrUpdateResponse contains the response from method DataContainersClient.CreateOrUpdate.
type DataContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	DataContainer
}

// DataContainersClientDeleteResponse contains the response from method DataContainersClient.Delete.
type DataContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// DataContainersClientGetResponse contains the response from method DataContainersClient.Get.
type DataContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	DataContainer
}

// DataContainersClientListResponse contains the response from method DataContainersClient.NewListPager.
type DataContainersClientListResponse struct {
	// A paginated list of DataContainer entities.
	DataContainerResourceArmPaginatedResult
}

// DataVersionsClientCreateOrUpdateResponse contains the response from method DataVersionsClient.CreateOrUpdate.
type DataVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	DataVersionBase
}

// DataVersionsClientDeleteResponse contains the response from method DataVersionsClient.Delete.
type DataVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// DataVersionsClientGetResponse contains the response from method DataVersionsClient.Get.
type DataVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	DataVersionBase
}

// DataVersionsClientListResponse contains the response from method DataVersionsClient.NewListPager.
type DataVersionsClientListResponse struct {
	// A paginated list of DataVersionBase entities.
	DataVersionBaseResourceArmPaginatedResult
}

// DataVersionsClientPublishResponse contains the response from method DataVersionsClient.BeginPublish.
type DataVersionsClientPublishResponse struct {
	// placeholder for future response values
}

// DatastoresClientCreateOrUpdateResponse contains the response from method DatastoresClient.CreateOrUpdate.
type DatastoresClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	Datastore
}

// DatastoresClientDeleteResponse contains the response from method DatastoresClient.Delete.
type DatastoresClientDeleteResponse struct {
	// placeholder for future response values
}

// DatastoresClientGetResponse contains the response from method DatastoresClient.Get.
type DatastoresClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	Datastore
}

// DatastoresClientListResponse contains the response from method DatastoresClient.NewListPager.
type DatastoresClientListResponse struct {
	// A paginated list of Datastore entities.
	DatastoreResourceArmPaginatedResult
}

// DatastoresClientListSecretsResponse contains the response from method DatastoresClient.ListSecrets.
type DatastoresClientListSecretsResponse struct {
	// Base definition for datastore secrets.
	DatastoreSecretsClassification
}

// UnmarshalJSON implements the json.Unmarshaller interface for type DatastoresClientListSecretsResponse.
func (d *DatastoresClientListSecretsResponse) UnmarshalJSON(data []byte) error {
	res, err := unmarshalDatastoreSecretsClassification(data)
	if err != nil {
		return err
	}
	d.DatastoreSecretsClassification = res
	return nil
}

// EnvironmentContainersClientCreateOrUpdateResponse contains the response from method EnvironmentContainersClient.CreateOrUpdate.
type EnvironmentContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentContainer
}

// EnvironmentContainersClientDeleteResponse contains the response from method EnvironmentContainersClient.Delete.
type EnvironmentContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// EnvironmentContainersClientGetResponse contains the response from method EnvironmentContainersClient.Get.
type EnvironmentContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentContainer
}

// EnvironmentContainersClientListResponse contains the response from method EnvironmentContainersClient.NewListPager.
type EnvironmentContainersClientListResponse struct {
	// A paginated list of EnvironmentContainer entities.
	EnvironmentContainerResourceArmPaginatedResult
}

// EnvironmentVersionsClientCreateOrUpdateResponse contains the response from method EnvironmentVersionsClient.CreateOrUpdate.
type EnvironmentVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentVersion
}

// EnvironmentVersionsClientDeleteResponse contains the response from method EnvironmentVersionsClient.Delete.
type EnvironmentVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// EnvironmentVersionsClientGetResponse contains the response from method EnvironmentVersionsClient.Get.
type EnvironmentVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentVersion
}

// EnvironmentVersionsClientListResponse contains the response from method EnvironmentVersionsClient.NewListPager.
type EnvironmentVersionsClientListResponse struct {
	// A paginated list of EnvironmentVersion entities.
	EnvironmentVersionResourceArmPaginatedResult
}

// EnvironmentVersionsClientPublishResponse contains the response from method EnvironmentVersionsClient.BeginPublish.
type EnvironmentVersionsClientPublishResponse struct {
	// placeholder for future response values
}

// FeaturesClientGetResponse contains the response from method FeaturesClient.Get.
type FeaturesClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	Feature
}

// FeaturesClientListResponse contains the response from method FeaturesClient.NewListPager.
type FeaturesClientListResponse struct {
	// A paginated list of Feature entities.
	FeatureResourceArmPaginatedResult
}

// FeaturesetContainersClientCreateOrUpdateResponse contains the response from method FeaturesetContainersClient.BeginCreateOrUpdate.
type FeaturesetContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturesetContainer
}

// FeaturesetContainersClientDeleteResponse contains the response from method FeaturesetContainersClient.BeginDelete.
type FeaturesetContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// FeaturesetContainersClientGetEntityResponse contains the response from method FeaturesetContainersClient.GetEntity.
type FeaturesetContainersClientGetEntityResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturesetContainer
}

// FeaturesetContainersClientListResponse contains the response from method FeaturesetContainersClient.NewListPager.
type FeaturesetContainersClientListResponse struct {
	// A paginated list of FeaturesetContainer entities.
	FeaturesetContainerResourceArmPaginatedResult
}

// FeaturesetVersionsClientBackfillResponse contains the response from method FeaturesetVersionsClient.BeginBackfill.
type FeaturesetVersionsClientBackfillResponse struct {
	// Response payload for creating a backfill request for a given feature set version
	FeaturesetVersionBackfillResponse
}

// FeaturesetVersionsClientCreateOrUpdateResponse contains the response from method FeaturesetVersionsClient.BeginCreateOrUpdate.
type FeaturesetVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturesetVersion
}

// FeaturesetVersionsClientDeleteResponse contains the response from method FeaturesetVersionsClient.BeginDelete.
type FeaturesetVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// FeaturesetVersionsClientGetResponse contains the response from method FeaturesetVersionsClient.Get.
type FeaturesetVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturesetVersion
}

// FeaturesetVersionsClientListResponse contains the response from method FeaturesetVersionsClient.NewListPager.
type FeaturesetVersionsClientListResponse struct {
	// A paginated list of FeaturesetVersion entities.
	FeaturesetVersionResourceArmPaginatedResult
}

// FeaturestoreEntityContainersClientCreateOrUpdateResponse contains the response from method FeaturestoreEntityContainersClient.BeginCreateOrUpdate.
type FeaturestoreEntityContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturestoreEntityContainer
}

// FeaturestoreEntityContainersClientDeleteResponse contains the response from method FeaturestoreEntityContainersClient.BeginDelete.
type FeaturestoreEntityContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// FeaturestoreEntityContainersClientGetEntityResponse contains the response from method FeaturestoreEntityContainersClient.GetEntity.
type FeaturestoreEntityContainersClientGetEntityResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturestoreEntityContainer
}

// FeaturestoreEntityContainersClientListResponse contains the response from method FeaturestoreEntityContainersClient.NewListPager.
type FeaturestoreEntityContainersClientListResponse struct {
	// A paginated list of FeaturestoreEntityContainer entities.
	FeaturestoreEntityContainerResourceArmPaginatedResult
}

// FeaturestoreEntityVersionsClientCreateOrUpdateResponse contains the response from method FeaturestoreEntityVersionsClient.BeginCreateOrUpdate.
type FeaturestoreEntityVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturestoreEntityVersion
}

// FeaturestoreEntityVersionsClientDeleteResponse contains the response from method FeaturestoreEntityVersionsClient.BeginDelete.
type FeaturestoreEntityVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// FeaturestoreEntityVersionsClientGetResponse contains the response from method FeaturestoreEntityVersionsClient.Get.
type FeaturestoreEntityVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	FeaturestoreEntityVersion
}

// FeaturestoreEntityVersionsClientListResponse contains the response from method FeaturestoreEntityVersionsClient.NewListPager.
type FeaturestoreEntityVersionsClientListResponse struct {
	// A paginated list of FeaturestoreEntityVersion entities.
	FeaturestoreEntityVersionResourceArmPaginatedResult
}

// JobsClientCancelResponse contains the response from method JobsClient.BeginCancel.
type JobsClientCancelResponse struct {
	// placeholder for future response values
}

// JobsClientCreateOrUpdateResponse contains the response from method JobsClient.CreateOrUpdate.
type JobsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	JobBase
}

// JobsClientDeleteResponse contains the response from method JobsClient.BeginDelete.
type JobsClientDeleteResponse struct {
	// placeholder for future response values
}

// JobsClientGetResponse contains the response from method JobsClient.Get.
type JobsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	JobBase
}

// JobsClientListResponse contains the response from method JobsClient.NewListPager.
type JobsClientListResponse struct {
	// A paginated list of JobBase entities.
	JobBaseResourceArmPaginatedResult
}

// ManagedNetworkProvisionsClientProvisionManagedNetworkResponse contains the response from method ManagedNetworkProvisionsClient.BeginProvisionManagedNetwork.
type ManagedNetworkProvisionsClientProvisionManagedNetworkResponse struct {
	// Status of the Provisioning for the managed network of a machine learning workspace.
	ManagedNetworkProvisionStatus
}

// ManagedNetworkSettingsRuleClientCreateOrUpdateResponse contains the response from method ManagedNetworkSettingsRuleClient.BeginCreateOrUpdate.
type ManagedNetworkSettingsRuleClientCreateOrUpdateResponse struct {
	// Outbound Rule Basic Resource for the managed network of a machine learning workspace.
	OutboundRuleBasicResource
}

// ManagedNetworkSettingsRuleClientDeleteResponse contains the response from method ManagedNetworkSettingsRuleClient.BeginDelete.
type ManagedNetworkSettingsRuleClientDeleteResponse struct {
	// placeholder for future response values
}

// ManagedNetworkSettingsRuleClientGetResponse contains the response from method ManagedNetworkSettingsRuleClient.Get.
type ManagedNetworkSettingsRuleClientGetResponse struct {
	// Outbound Rule Basic Resource for the managed network of a machine learning workspace.
	OutboundRuleBasicResource
}

// ManagedNetworkSettingsRuleClientListResponse contains the response from method ManagedNetworkSettingsRuleClient.NewListPager.
type ManagedNetworkSettingsRuleClientListResponse struct {
	// List of outbound rules for the managed network of a machine learning workspace.
	OutboundRuleListResult
}

// MarketplaceSubscriptionsClientCreateOrUpdateResponse contains the response from method MarketplaceSubscriptionsClient.BeginCreateOrUpdate.
type MarketplaceSubscriptionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	MarketplaceSubscription
}

// MarketplaceSubscriptionsClientDeleteResponse contains the response from method MarketplaceSubscriptionsClient.BeginDelete.
type MarketplaceSubscriptionsClientDeleteResponse struct {
	// placeholder for future response values
}

// MarketplaceSubscriptionsClientGetResponse contains the response from method MarketplaceSubscriptionsClient.Get.
type MarketplaceSubscriptionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	MarketplaceSubscription
}

// MarketplaceSubscriptionsClientListResponse contains the response from method MarketplaceSubscriptionsClient.NewListPager.
type MarketplaceSubscriptionsClientListResponse struct {
	// A paginated list of MarketplaceSubscription entities.
	MarketplaceSubscriptionResourceArmPaginatedResult
}

// ModelContainersClientCreateOrUpdateResponse contains the response from method ModelContainersClient.CreateOrUpdate.
type ModelContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ModelContainer
}

// ModelContainersClientDeleteResponse contains the response from method ModelContainersClient.Delete.
type ModelContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// ModelContainersClientGetResponse contains the response from method ModelContainersClient.Get.
type ModelContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ModelContainer
}

// ModelContainersClientListResponse contains the response from method ModelContainersClient.NewListPager.
type ModelContainersClientListResponse struct {
	// A paginated list of ModelContainer entities.
	ModelContainerResourceArmPaginatedResult
}

// ModelVersionsClientCreateOrUpdateResponse contains the response from method ModelVersionsClient.CreateOrUpdate.
type ModelVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ModelVersion
}

// ModelVersionsClientDeleteResponse contains the response from method ModelVersionsClient.Delete.
type ModelVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ModelVersionsClientGetResponse contains the response from method ModelVersionsClient.Get.
type ModelVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ModelVersion
}

// ModelVersionsClientListResponse contains the response from method ModelVersionsClient.NewListPager.
type ModelVersionsClientListResponse struct {
	// A paginated list of ModelVersion entities.
	ModelVersionResourceArmPaginatedResult
}

// ModelVersionsClientPublishResponse contains the response from method ModelVersionsClient.BeginPublish.
type ModelVersionsClientPublishResponse struct {
	// placeholder for future response values
}

// OnlineDeploymentsClientCreateOrUpdateResponse contains the response from method OnlineDeploymentsClient.BeginCreateOrUpdate.
type OnlineDeploymentsClientCreateOrUpdateResponse struct {
	OnlineDeployment
}

// OnlineDeploymentsClientDeleteResponse contains the response from method OnlineDeploymentsClient.BeginDelete.
type OnlineDeploymentsClientDeleteResponse struct {
	// placeholder for future response values
}

// OnlineDeploymentsClientGetLogsResponse contains the response from method OnlineDeploymentsClient.GetLogs.
type OnlineDeploymentsClientGetLogsResponse struct {
	DeploymentLogs
}

// OnlineDeploymentsClientGetResponse contains the response from method OnlineDeploymentsClient.Get.
type OnlineDeploymentsClientGetResponse struct {
	OnlineDeployment
}

// OnlineDeploymentsClientListResponse contains the response from method OnlineDeploymentsClient.NewListPager.
type OnlineDeploymentsClientListResponse struct {
	// A paginated list of OnlineDeployment entities.
	OnlineDeploymentTrackedResourceArmPaginatedResult
}

// OnlineDeploymentsClientListSKUsResponse contains the response from method OnlineDeploymentsClient.NewListSKUsPager.
type OnlineDeploymentsClientListSKUsResponse struct {
	// A paginated list of SkuResource entities.
	SKUResourceArmPaginatedResult
}

// OnlineDeploymentsClientUpdateResponse contains the response from method OnlineDeploymentsClient.BeginUpdate.
type OnlineDeploymentsClientUpdateResponse struct {
	OnlineDeployment
}

// OnlineEndpointsClientCreateOrUpdateResponse contains the response from method OnlineEndpointsClient.BeginCreateOrUpdate.
type OnlineEndpointsClientCreateOrUpdateResponse struct {
	OnlineEndpoint
}

// OnlineEndpointsClientDeleteResponse contains the response from method OnlineEndpointsClient.BeginDelete.
type OnlineEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// OnlineEndpointsClientGetResponse contains the response from method OnlineEndpointsClient.Get.
type OnlineEndpointsClientGetResponse struct {
	OnlineEndpoint
}

// OnlineEndpointsClientGetTokenResponse contains the response from method OnlineEndpointsClient.GetToken.
type OnlineEndpointsClientGetTokenResponse struct {
	// Service Token
	EndpointAuthToken
}

// OnlineEndpointsClientListKeysResponse contains the response from method OnlineEndpointsClient.ListKeys.
type OnlineEndpointsClientListKeysResponse struct {
	// Keys for endpoint authentication.
	EndpointAuthKeys
}

// OnlineEndpointsClientListResponse contains the response from method OnlineEndpointsClient.NewListPager.
type OnlineEndpointsClientListResponse struct {
	// A paginated list of OnlineEndpoint entities.
	OnlineEndpointTrackedResourceArmPaginatedResult
}

// OnlineEndpointsClientRegenerateKeysResponse contains the response from method OnlineEndpointsClient.BeginRegenerateKeys.
type OnlineEndpointsClientRegenerateKeysResponse struct {
	// placeholder for future response values
}

// OnlineEndpointsClientUpdateResponse contains the response from method OnlineEndpointsClient.BeginUpdate.
type OnlineEndpointsClientUpdateResponse struct {
	OnlineEndpoint
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientCreateOrUpdateResponse contains the response from method PrivateEndpointConnectionsClient.CreateOrUpdate.
type PrivateEndpointConnectionsClientCreateOrUpdateResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.Delete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// The Private Endpoint Connection resource.
	PrivateEndpointConnection
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// List of private endpoint connection associated with the specified workspace
	PrivateEndpointConnectionListResult
}

// PrivateLinkResourcesClientListResponse contains the response from method PrivateLinkResourcesClient.List.
type PrivateLinkResourcesClientListResponse struct {
	// A list of private link resources
	PrivateLinkResourceListResult
}

// QuotasClientListResponse contains the response from method QuotasClient.NewListPager.
type QuotasClientListResponse struct {
	// The List WorkspaceQuotasByVMFamily operation response.
	ListWorkspaceQuotas
}

// QuotasClientUpdateResponse contains the response from method QuotasClient.Update.
type QuotasClientUpdateResponse struct {
	// The result of update workspace quota.
	UpdateWorkspaceQuotasResult
}

// RegistriesClientCreateOrUpdateResponse contains the response from method RegistriesClient.BeginCreateOrUpdate.
type RegistriesClientCreateOrUpdateResponse struct {
	Registry
}

// RegistriesClientDeleteResponse contains the response from method RegistriesClient.BeginDelete.
type RegistriesClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistriesClientGetResponse contains the response from method RegistriesClient.Get.
type RegistriesClientGetResponse struct {
	Registry
}

// RegistriesClientListBySubscriptionResponse contains the response from method RegistriesClient.NewListBySubscriptionPager.
type RegistriesClientListBySubscriptionResponse struct {
	// A paginated list of Registry entities.
	RegistryTrackedResourceArmPaginatedResult
}

// RegistriesClientListResponse contains the response from method RegistriesClient.NewListPager.
type RegistriesClientListResponse struct {
	// A paginated list of Registry entities.
	RegistryTrackedResourceArmPaginatedResult
}

// RegistriesClientRemoveRegionsResponse contains the response from method RegistriesClient.BeginRemoveRegions.
type RegistriesClientRemoveRegionsResponse struct {
	Registry
}

// RegistriesClientUpdateResponse contains the response from method RegistriesClient.Update.
type RegistriesClientUpdateResponse struct {
	Registry
}

// RegistryCodeContainersClientCreateOrUpdateResponse contains the response from method RegistryCodeContainersClient.BeginCreateOrUpdate.
type RegistryCodeContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	CodeContainer
}

// RegistryCodeContainersClientDeleteResponse contains the response from method RegistryCodeContainersClient.BeginDelete.
type RegistryCodeContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryCodeContainersClientGetResponse contains the response from method RegistryCodeContainersClient.Get.
type RegistryCodeContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	CodeContainer
}

// RegistryCodeContainersClientListResponse contains the response from method RegistryCodeContainersClient.NewListPager.
type RegistryCodeContainersClientListResponse struct {
	// A paginated list of CodeContainer entities.
	CodeContainerResourceArmPaginatedResult
}

// RegistryCodeVersionsClientCreateOrGetStartPendingUploadResponse contains the response from method RegistryCodeVersionsClient.CreateOrGetStartPendingUpload.
type RegistryCodeVersionsClientCreateOrGetStartPendingUploadResponse struct {
	PendingUploadResponseDto
}

// RegistryCodeVersionsClientCreateOrUpdateResponse contains the response from method RegistryCodeVersionsClient.BeginCreateOrUpdate.
type RegistryCodeVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	CodeVersion
}

// RegistryCodeVersionsClientDeleteResponse contains the response from method RegistryCodeVersionsClient.BeginDelete.
type RegistryCodeVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryCodeVersionsClientGetResponse contains the response from method RegistryCodeVersionsClient.Get.
type RegistryCodeVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	CodeVersion
}

// RegistryCodeVersionsClientListResponse contains the response from method RegistryCodeVersionsClient.NewListPager.
type RegistryCodeVersionsClientListResponse struct {
	// A paginated list of CodeVersion entities.
	CodeVersionResourceArmPaginatedResult
}

// RegistryComponentContainersClientCreateOrUpdateResponse contains the response from method RegistryComponentContainersClient.BeginCreateOrUpdate.
type RegistryComponentContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentContainer
}

// RegistryComponentContainersClientDeleteResponse contains the response from method RegistryComponentContainersClient.BeginDelete.
type RegistryComponentContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryComponentContainersClientGetResponse contains the response from method RegistryComponentContainersClient.Get.
type RegistryComponentContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentContainer
}

// RegistryComponentContainersClientListResponse contains the response from method RegistryComponentContainersClient.NewListPager.
type RegistryComponentContainersClientListResponse struct {
	// A paginated list of ComponentContainer entities.
	ComponentContainerResourceArmPaginatedResult
}

// RegistryComponentVersionsClientCreateOrUpdateResponse contains the response from method RegistryComponentVersionsClient.BeginCreateOrUpdate.
type RegistryComponentVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentVersion
}

// RegistryComponentVersionsClientDeleteResponse contains the response from method RegistryComponentVersionsClient.BeginDelete.
type RegistryComponentVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryComponentVersionsClientGetResponse contains the response from method RegistryComponentVersionsClient.Get.
type RegistryComponentVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ComponentVersion
}

// RegistryComponentVersionsClientListResponse contains the response from method RegistryComponentVersionsClient.NewListPager.
type RegistryComponentVersionsClientListResponse struct {
	// A paginated list of ComponentVersion entities.
	ComponentVersionResourceArmPaginatedResult
}

// RegistryDataContainersClientCreateOrUpdateResponse contains the response from method RegistryDataContainersClient.BeginCreateOrUpdate.
type RegistryDataContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	DataContainer
}

// RegistryDataContainersClientDeleteResponse contains the response from method RegistryDataContainersClient.BeginDelete.
type RegistryDataContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryDataContainersClientGetResponse contains the response from method RegistryDataContainersClient.Get.
type RegistryDataContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	DataContainer
}

// RegistryDataContainersClientListResponse contains the response from method RegistryDataContainersClient.NewListPager.
type RegistryDataContainersClientListResponse struct {
	// A paginated list of DataContainer entities.
	DataContainerResourceArmPaginatedResult
}

// RegistryDataReferencesClientGetBlobReferenceSASResponse contains the response from method RegistryDataReferencesClient.GetBlobReferenceSAS.
type RegistryDataReferencesClientGetBlobReferenceSASResponse struct {
	// BlobReferenceSASResponse for getBlobReferenceSAS API
	GetBlobReferenceSASResponseDto
}

// RegistryDataVersionsClientCreateOrGetStartPendingUploadResponse contains the response from method RegistryDataVersionsClient.CreateOrGetStartPendingUpload.
type RegistryDataVersionsClientCreateOrGetStartPendingUploadResponse struct {
	PendingUploadResponseDto
}

// RegistryDataVersionsClientCreateOrUpdateResponse contains the response from method RegistryDataVersionsClient.BeginCreateOrUpdate.
type RegistryDataVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	DataVersionBase
}

// RegistryDataVersionsClientDeleteResponse contains the response from method RegistryDataVersionsClient.BeginDelete.
type RegistryDataVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryDataVersionsClientGetResponse contains the response from method RegistryDataVersionsClient.Get.
type RegistryDataVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	DataVersionBase
}

// RegistryDataVersionsClientListResponse contains the response from method RegistryDataVersionsClient.NewListPager.
type RegistryDataVersionsClientListResponse struct {
	// A paginated list of DataVersionBase entities.
	DataVersionBaseResourceArmPaginatedResult
}

// RegistryEnvironmentContainersClientCreateOrUpdateResponse contains the response from method RegistryEnvironmentContainersClient.BeginCreateOrUpdate.
type RegistryEnvironmentContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentContainer
}

// RegistryEnvironmentContainersClientDeleteResponse contains the response from method RegistryEnvironmentContainersClient.BeginDelete.
type RegistryEnvironmentContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryEnvironmentContainersClientGetResponse contains the response from method RegistryEnvironmentContainersClient.Get.
type RegistryEnvironmentContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentContainer
}

// RegistryEnvironmentContainersClientListResponse contains the response from method RegistryEnvironmentContainersClient.NewListPager.
type RegistryEnvironmentContainersClientListResponse struct {
	// A paginated list of EnvironmentContainer entities.
	EnvironmentContainerResourceArmPaginatedResult
}

// RegistryEnvironmentVersionsClientCreateOrUpdateResponse contains the response from method RegistryEnvironmentVersionsClient.BeginCreateOrUpdate.
type RegistryEnvironmentVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentVersion
}

// RegistryEnvironmentVersionsClientDeleteResponse contains the response from method RegistryEnvironmentVersionsClient.BeginDelete.
type RegistryEnvironmentVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryEnvironmentVersionsClientGetResponse contains the response from method RegistryEnvironmentVersionsClient.Get.
type RegistryEnvironmentVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	EnvironmentVersion
}

// RegistryEnvironmentVersionsClientListResponse contains the response from method RegistryEnvironmentVersionsClient.NewListPager.
type RegistryEnvironmentVersionsClientListResponse struct {
	// A paginated list of EnvironmentVersion entities.
	EnvironmentVersionResourceArmPaginatedResult
}

// RegistryModelContainersClientCreateOrUpdateResponse contains the response from method RegistryModelContainersClient.BeginCreateOrUpdate.
type RegistryModelContainersClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ModelContainer
}

// RegistryModelContainersClientDeleteResponse contains the response from method RegistryModelContainersClient.BeginDelete.
type RegistryModelContainersClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryModelContainersClientGetResponse contains the response from method RegistryModelContainersClient.Get.
type RegistryModelContainersClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ModelContainer
}

// RegistryModelContainersClientListResponse contains the response from method RegistryModelContainersClient.NewListPager.
type RegistryModelContainersClientListResponse struct {
	// A paginated list of ModelContainer entities.
	ModelContainerResourceArmPaginatedResult
}

// RegistryModelVersionsClientCreateOrGetStartPendingUploadResponse contains the response from method RegistryModelVersionsClient.CreateOrGetStartPendingUpload.
type RegistryModelVersionsClientCreateOrGetStartPendingUploadResponse struct {
	PendingUploadResponseDto
}

// RegistryModelVersionsClientCreateOrUpdateResponse contains the response from method RegistryModelVersionsClient.BeginCreateOrUpdate.
type RegistryModelVersionsClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	ModelVersion
}

// RegistryModelVersionsClientDeleteResponse contains the response from method RegistryModelVersionsClient.BeginDelete.
type RegistryModelVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// RegistryModelVersionsClientGetResponse contains the response from method RegistryModelVersionsClient.Get.
type RegistryModelVersionsClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	ModelVersion
}

// RegistryModelVersionsClientListResponse contains the response from method RegistryModelVersionsClient.NewListPager.
type RegistryModelVersionsClientListResponse struct {
	// A paginated list of ModelVersion entities.
	ModelVersionResourceArmPaginatedResult
}

// SchedulesClientCreateOrUpdateResponse contains the response from method SchedulesClient.BeginCreateOrUpdate.
type SchedulesClientCreateOrUpdateResponse struct {
	// Azure Resource Manager resource envelope.
	Schedule
}

// SchedulesClientDeleteResponse contains the response from method SchedulesClient.BeginDelete.
type SchedulesClientDeleteResponse struct {
	// placeholder for future response values
}

// SchedulesClientGetResponse contains the response from method SchedulesClient.Get.
type SchedulesClientGetResponse struct {
	// Azure Resource Manager resource envelope.
	Schedule
}

// SchedulesClientListResponse contains the response from method SchedulesClient.NewListPager.
type SchedulesClientListResponse struct {
	// A paginated list of Schedule entities.
	ScheduleResourceArmPaginatedResult
}

// ServerlessEndpointsClientCreateOrUpdateResponse contains the response from method ServerlessEndpointsClient.BeginCreateOrUpdate.
type ServerlessEndpointsClientCreateOrUpdateResponse struct {
	ServerlessEndpoint
}

// ServerlessEndpointsClientDeleteResponse contains the response from method ServerlessEndpointsClient.BeginDelete.
type ServerlessEndpointsClientDeleteResponse struct {
	// placeholder for future response values
}

// ServerlessEndpointsClientGetResponse contains the response from method ServerlessEndpointsClient.Get.
type ServerlessEndpointsClientGetResponse struct {
	ServerlessEndpoint
}

// ServerlessEndpointsClientListKeysResponse contains the response from method ServerlessEndpointsClient.ListKeys.
type ServerlessEndpointsClientListKeysResponse struct {
	// Keys for endpoint authentication.
	EndpointAuthKeys
}

// ServerlessEndpointsClientListResponse contains the response from method ServerlessEndpointsClient.NewListPager.
type ServerlessEndpointsClientListResponse struct {
	// A paginated list of ServerlessEndpoint entities.
	ServerlessEndpointTrackedResourceArmPaginatedResult
}

// ServerlessEndpointsClientRegenerateKeysResponse contains the response from method ServerlessEndpointsClient.BeginRegenerateKeys.
type ServerlessEndpointsClientRegenerateKeysResponse struct {
	// Keys for endpoint authentication.
	EndpointAuthKeys
}

// ServerlessEndpointsClientUpdateResponse contains the response from method ServerlessEndpointsClient.BeginUpdate.
type ServerlessEndpointsClientUpdateResponse struct {
	ServerlessEndpoint
}

// UsagesClientListResponse contains the response from method UsagesClient.NewListPager.
type UsagesClientListResponse struct {
	// The List Usages operation response.
	ListUsagesResult
}

// VirtualMachineSizesClientListResponse contains the response from method VirtualMachineSizesClient.List.
type VirtualMachineSizesClientListResponse struct {
	// The List Virtual Machine size operation response.
	VirtualMachineSizeListResult
}

// WorkspaceConnectionsClientCreateResponse contains the response from method WorkspaceConnectionsClient.Create.
type WorkspaceConnectionsClientCreateResponse struct {
	WorkspaceConnectionPropertiesV2BasicResource
}

// WorkspaceConnectionsClientDeleteResponse contains the response from method WorkspaceConnectionsClient.Delete.
type WorkspaceConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspaceConnectionsClientGetResponse contains the response from method WorkspaceConnectionsClient.Get.
type WorkspaceConnectionsClientGetResponse struct {
	WorkspaceConnectionPropertiesV2BasicResource
}

// WorkspaceConnectionsClientListResponse contains the response from method WorkspaceConnectionsClient.NewListPager.
type WorkspaceConnectionsClientListResponse struct {
	WorkspaceConnectionPropertiesV2BasicResourceArmPaginatedResult
}

// WorkspaceConnectionsClientListSecretsResponse contains the response from method WorkspaceConnectionsClient.ListSecrets.
type WorkspaceConnectionsClientListSecretsResponse struct {
	WorkspaceConnectionPropertiesV2BasicResource
}

// WorkspaceFeaturesClientListResponse contains the response from method WorkspaceFeaturesClient.NewListPager.
type WorkspaceFeaturesClientListResponse struct {
	// The List Aml user feature operation response.
	ListAmlUserFeatureResult
}

// WorkspacesClientCreateOrUpdateResponse contains the response from method WorkspacesClient.BeginCreateOrUpdate.
type WorkspacesClientCreateOrUpdateResponse struct {
	// An object that represents a machine learning workspace.
	Workspace
}

// WorkspacesClientDeleteResponse contains the response from method WorkspacesClient.BeginDelete.
type WorkspacesClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspacesClientDiagnoseResponse contains the response from method WorkspacesClient.BeginDiagnose.
type WorkspacesClientDiagnoseResponse struct {
	DiagnoseResponseResult
}

// WorkspacesClientGetResponse contains the response from method WorkspacesClient.Get.
type WorkspacesClientGetResponse struct {
	// An object that represents a machine learning workspace.
	Workspace
}

// WorkspacesClientListByResourceGroupResponse contains the response from method WorkspacesClient.NewListByResourceGroupPager.
type WorkspacesClientListByResourceGroupResponse struct {
	// The result of a request to list machine learning workspaces.
	WorkspaceListResult
}

// WorkspacesClientListBySubscriptionResponse contains the response from method WorkspacesClient.NewListBySubscriptionPager.
type WorkspacesClientListBySubscriptionResponse struct {
	// The result of a request to list machine learning workspaces.
	WorkspaceListResult
}

// WorkspacesClientListKeysResponse contains the response from method WorkspacesClient.ListKeys.
type WorkspacesClientListKeysResponse struct {
	ListWorkspaceKeysResult
}

// WorkspacesClientListNotebookAccessTokenResponse contains the response from method WorkspacesClient.ListNotebookAccessToken.
type WorkspacesClientListNotebookAccessTokenResponse struct {
	NotebookAccessTokenResult
}

// WorkspacesClientListNotebookKeysResponse contains the response from method WorkspacesClient.ListNotebookKeys.
type WorkspacesClientListNotebookKeysResponse struct {
	ListNotebookKeysResult
}

// WorkspacesClientListOutboundNetworkDependenciesEndpointsResponse contains the response from method WorkspacesClient.ListOutboundNetworkDependenciesEndpoints.
type WorkspacesClientListOutboundNetworkDependenciesEndpointsResponse struct {
	ExternalFQDNResponse
}

// WorkspacesClientListStorageAccountKeysResponse contains the response from method WorkspacesClient.ListStorageAccountKeys.
type WorkspacesClientListStorageAccountKeysResponse struct {
	ListStorageAccountKeysResult
}

// WorkspacesClientPrepareNotebookResponse contains the response from method WorkspacesClient.BeginPrepareNotebook.
type WorkspacesClientPrepareNotebookResponse struct {
	NotebookResourceInfo
}

// WorkspacesClientResyncKeysResponse contains the response from method WorkspacesClient.BeginResyncKeys.
type WorkspacesClientResyncKeysResponse struct {
	// placeholder for future response values
}

// WorkspacesClientUpdateResponse contains the response from method WorkspacesClient.BeginUpdate.
type WorkspacesClientUpdateResponse struct {
	// An object that represents a machine learning workspace.
	Workspace
}
