//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armmanagednetworkfabric

// AccessControlListsClientCreateResponse contains the response from method AccessControlListsClient.BeginCreate.
type AccessControlListsClientCreateResponse struct {
	// The Access Control List resource definition.
	AccessControlList
}

// AccessControlListsClientDeleteResponse contains the response from method AccessControlListsClient.BeginDelete.
type AccessControlListsClientDeleteResponse struct {
	// placeholder for future response values
}

// AccessControlListsClientGetResponse contains the response from method AccessControlListsClient.Get.
type AccessControlListsClientGetResponse struct {
	// The Access Control List resource definition.
	AccessControlList
}

// AccessControlListsClientListByResourceGroupResponse contains the response from method AccessControlListsClient.NewListByResourceGroupPager.
type AccessControlListsClientListByResourceGroupResponse struct {
	// List of Access Control Lists.
	AccessControlListsListResult
}

// AccessControlListsClientListBySubscriptionResponse contains the response from method AccessControlListsClient.NewListBySubscriptionPager.
type AccessControlListsClientListBySubscriptionResponse struct {
	// List of Access Control Lists.
	AccessControlListsListResult
}

// AccessControlListsClientResyncResponse contains the response from method AccessControlListsClient.BeginResync.
type AccessControlListsClientResyncResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// AccessControlListsClientUpdateAdministrativeStateResponse contains the response from method AccessControlListsClient.BeginUpdateAdministrativeState.
type AccessControlListsClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// AccessControlListsClientUpdateResponse contains the response from method AccessControlListsClient.BeginUpdate.
type AccessControlListsClientUpdateResponse struct {
	// The Access Control List resource definition.
	AccessControlList
}

// AccessControlListsClientValidateConfigurationResponse contains the response from method AccessControlListsClient.BeginValidateConfiguration.
type AccessControlListsClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// ExternalNetworksClientCreateResponse contains the response from method ExternalNetworksClient.BeginCreate.
type ExternalNetworksClientCreateResponse struct {
	// Defines the External Network resource.
	ExternalNetwork
}

// ExternalNetworksClientDeleteResponse contains the response from method ExternalNetworksClient.BeginDelete.
type ExternalNetworksClientDeleteResponse struct {
	// placeholder for future response values
}

// ExternalNetworksClientGetResponse contains the response from method ExternalNetworksClient.Get.
type ExternalNetworksClientGetResponse struct {
	// Defines the External Network resource.
	ExternalNetwork
}

// ExternalNetworksClientListByL3IsolationDomainResponse contains the response from method ExternalNetworksClient.NewListByL3IsolationDomainPager.
type ExternalNetworksClientListByL3IsolationDomainResponse struct {
	// List of External Networks.
	ExternalNetworksList
}

// ExternalNetworksClientUpdateAdministrativeStateResponse contains the response from method ExternalNetworksClient.BeginUpdateAdministrativeState.
type ExternalNetworksClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// ExternalNetworksClientUpdateResponse contains the response from method ExternalNetworksClient.BeginUpdate.
type ExternalNetworksClientUpdateResponse struct {
	// Defines the External Network resource.
	ExternalNetwork
}

// ExternalNetworksClientUpdateStaticRouteBfdAdministrativeStateResponse contains the response from method ExternalNetworksClient.BeginUpdateStaticRouteBfdAdministrativeState.
type ExternalNetworksClientUpdateStaticRouteBfdAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// IPCommunitiesClientCreateResponse contains the response from method IPCommunitiesClient.BeginCreate.
type IPCommunitiesClientCreateResponse struct {
	// The IP Community resource definition.
	IPCommunity
}

// IPCommunitiesClientDeleteResponse contains the response from method IPCommunitiesClient.BeginDelete.
type IPCommunitiesClientDeleteResponse struct {
	// placeholder for future response values
}

// IPCommunitiesClientGetResponse contains the response from method IPCommunitiesClient.Get.
type IPCommunitiesClientGetResponse struct {
	// The IP Community resource definition.
	IPCommunity
}

// IPCommunitiesClientListByResourceGroupResponse contains the response from method IPCommunitiesClient.NewListByResourceGroupPager.
type IPCommunitiesClientListByResourceGroupResponse struct {
	// List of IP Communities.
	IPCommunitiesListResult
}

// IPCommunitiesClientListBySubscriptionResponse contains the response from method IPCommunitiesClient.NewListBySubscriptionPager.
type IPCommunitiesClientListBySubscriptionResponse struct {
	// List of IP Communities.
	IPCommunitiesListResult
}

// IPCommunitiesClientUpdateResponse contains the response from method IPCommunitiesClient.BeginUpdate.
type IPCommunitiesClientUpdateResponse struct {
	// The IP Community resource definition.
	IPCommunity
}

// IPExtendedCommunitiesClientCreateResponse contains the response from method IPExtendedCommunitiesClient.BeginCreate.
type IPExtendedCommunitiesClientCreateResponse struct {
	// The IP Extended Community resource definition.
	IPExtendedCommunity
}

// IPExtendedCommunitiesClientDeleteResponse contains the response from method IPExtendedCommunitiesClient.BeginDelete.
type IPExtendedCommunitiesClientDeleteResponse struct {
	// placeholder for future response values
}

// IPExtendedCommunitiesClientGetResponse contains the response from method IPExtendedCommunitiesClient.Get.
type IPExtendedCommunitiesClientGetResponse struct {
	// The IP Extended Community resource definition.
	IPExtendedCommunity
}

// IPExtendedCommunitiesClientListByResourceGroupResponse contains the response from method IPExtendedCommunitiesClient.NewListByResourceGroupPager.
type IPExtendedCommunitiesClientListByResourceGroupResponse struct {
	// List of IP Extended Communities.
	IPExtendedCommunityListResult
}

// IPExtendedCommunitiesClientListBySubscriptionResponse contains the response from method IPExtendedCommunitiesClient.NewListBySubscriptionPager.
type IPExtendedCommunitiesClientListBySubscriptionResponse struct {
	// List of IP Extended Communities.
	IPExtendedCommunityListResult
}

// IPExtendedCommunitiesClientUpdateResponse contains the response from method IPExtendedCommunitiesClient.BeginUpdate.
type IPExtendedCommunitiesClientUpdateResponse struct {
	// The IP Extended Community resource definition.
	IPExtendedCommunity
}

// IPPrefixesClientCreateResponse contains the response from method IPPrefixesClient.BeginCreate.
type IPPrefixesClientCreateResponse struct {
	// The IP Prefix resource definition.
	IPPrefix
}

// IPPrefixesClientDeleteResponse contains the response from method IPPrefixesClient.BeginDelete.
type IPPrefixesClientDeleteResponse struct {
	// placeholder for future response values
}

// IPPrefixesClientGetResponse contains the response from method IPPrefixesClient.Get.
type IPPrefixesClientGetResponse struct {
	// The IP Prefix resource definition.
	IPPrefix
}

// IPPrefixesClientListByResourceGroupResponse contains the response from method IPPrefixesClient.NewListByResourceGroupPager.
type IPPrefixesClientListByResourceGroupResponse struct {
	// List of IP Prefixes.
	IPPrefixesListResult
}

// IPPrefixesClientListBySubscriptionResponse contains the response from method IPPrefixesClient.NewListBySubscriptionPager.
type IPPrefixesClientListBySubscriptionResponse struct {
	// List of IP Prefixes.
	IPPrefixesListResult
}

// IPPrefixesClientUpdateResponse contains the response from method IPPrefixesClient.BeginUpdate.
type IPPrefixesClientUpdateResponse struct {
	// The IP Prefix resource definition.
	IPPrefix
}

// InternalNetworksClientCreateResponse contains the response from method InternalNetworksClient.BeginCreate.
type InternalNetworksClientCreateResponse struct {
	// Defines the Internal Network resource.
	InternalNetwork
}

// InternalNetworksClientDeleteResponse contains the response from method InternalNetworksClient.BeginDelete.
type InternalNetworksClientDeleteResponse struct {
	// placeholder for future response values
}

// InternalNetworksClientGetResponse contains the response from method InternalNetworksClient.Get.
type InternalNetworksClientGetResponse struct {
	// Defines the Internal Network resource.
	InternalNetwork
}

// InternalNetworksClientListByL3IsolationDomainResponse contains the response from method InternalNetworksClient.NewListByL3IsolationDomainPager.
type InternalNetworksClientListByL3IsolationDomainResponse struct {
	// List of Internal Networks.
	InternalNetworksList
}

// InternalNetworksClientUpdateAdministrativeStateResponse contains the response from method InternalNetworksClient.BeginUpdateAdministrativeState.
type InternalNetworksClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// InternalNetworksClientUpdateBgpAdministrativeStateResponse contains the response from method InternalNetworksClient.BeginUpdateBgpAdministrativeState.
type InternalNetworksClientUpdateBgpAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// InternalNetworksClientUpdateResponse contains the response from method InternalNetworksClient.BeginUpdate.
type InternalNetworksClientUpdateResponse struct {
	// Defines the Internal Network resource.
	InternalNetwork
}

// InternalNetworksClientUpdateStaticRouteBfdAdministrativeStateResponse contains the response from method InternalNetworksClient.BeginUpdateStaticRouteBfdAdministrativeState.
type InternalNetworksClientUpdateStaticRouteBfdAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// InternetGatewayRulesClientCreateResponse contains the response from method InternetGatewayRulesClient.BeginCreate.
type InternetGatewayRulesClientCreateResponse struct {
	// The Internet Gateway Rule resource definition.
	InternetGatewayRule
}

// InternetGatewayRulesClientDeleteResponse contains the response from method InternetGatewayRulesClient.BeginDelete.
type InternetGatewayRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// InternetGatewayRulesClientGetResponse contains the response from method InternetGatewayRulesClient.Get.
type InternetGatewayRulesClientGetResponse struct {
	// The Internet Gateway Rule resource definition.
	InternetGatewayRule
}

// InternetGatewayRulesClientListByResourceGroupResponse contains the response from method InternetGatewayRulesClient.NewListByResourceGroupPager.
type InternetGatewayRulesClientListByResourceGroupResponse struct {
	// List of Internet Gateway Rules.
	InternetGatewayRulesListResult
}

// InternetGatewayRulesClientListBySubscriptionResponse contains the response from method InternetGatewayRulesClient.NewListBySubscriptionPager.
type InternetGatewayRulesClientListBySubscriptionResponse struct {
	// List of Internet Gateway Rules.
	InternetGatewayRulesListResult
}

// InternetGatewayRulesClientUpdateResponse contains the response from method InternetGatewayRulesClient.BeginUpdate.
type InternetGatewayRulesClientUpdateResponse struct {
	// The Internet Gateway Rule resource definition.
	InternetGatewayRule
}

// InternetGatewaysClientCreateResponse contains the response from method InternetGatewaysClient.BeginCreate.
type InternetGatewaysClientCreateResponse struct {
	// The Internet Gateway resource definition.
	InternetGateway
}

// InternetGatewaysClientDeleteResponse contains the response from method InternetGatewaysClient.BeginDelete.
type InternetGatewaysClientDeleteResponse struct {
	// placeholder for future response values
}

// InternetGatewaysClientGetResponse contains the response from method InternetGatewaysClient.Get.
type InternetGatewaysClientGetResponse struct {
	// The Internet Gateway resource definition.
	InternetGateway
}

// InternetGatewaysClientListByResourceGroupResponse contains the response from method InternetGatewaysClient.NewListByResourceGroupPager.
type InternetGatewaysClientListByResourceGroupResponse struct {
	// List of InternetGateways.
	InternetGatewaysListResult
}

// InternetGatewaysClientListBySubscriptionResponse contains the response from method InternetGatewaysClient.NewListBySubscriptionPager.
type InternetGatewaysClientListBySubscriptionResponse struct {
	// List of InternetGateways.
	InternetGatewaysListResult
}

// InternetGatewaysClientUpdateResponse contains the response from method InternetGatewaysClient.BeginUpdate.
type InternetGatewaysClientUpdateResponse struct {
	// The Internet Gateway resource definition.
	InternetGateway
}

// L2IsolationDomainsClientCommitConfigurationResponse contains the response from method L2IsolationDomainsClient.BeginCommitConfiguration.
type L2IsolationDomainsClientCommitConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// L2IsolationDomainsClientCreateResponse contains the response from method L2IsolationDomainsClient.BeginCreate.
type L2IsolationDomainsClientCreateResponse struct {
	// The L2 Isolation Domain resource definition.
	L2IsolationDomain
}

// L2IsolationDomainsClientDeleteResponse contains the response from method L2IsolationDomainsClient.BeginDelete.
type L2IsolationDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// L2IsolationDomainsClientGetResponse contains the response from method L2IsolationDomainsClient.Get.
type L2IsolationDomainsClientGetResponse struct {
	// The L2 Isolation Domain resource definition.
	L2IsolationDomain
}

// L2IsolationDomainsClientListByResourceGroupResponse contains the response from method L2IsolationDomainsClient.NewListByResourceGroupPager.
type L2IsolationDomainsClientListByResourceGroupResponse struct {
	// List of L2 Isolation Domains.
	L2IsolationDomainsListResult
}

// L2IsolationDomainsClientListBySubscriptionResponse contains the response from method L2IsolationDomainsClient.NewListBySubscriptionPager.
type L2IsolationDomainsClientListBySubscriptionResponse struct {
	// List of L2 Isolation Domains.
	L2IsolationDomainsListResult
}

// L2IsolationDomainsClientUpdateAdministrativeStateResponse contains the response from method L2IsolationDomainsClient.BeginUpdateAdministrativeState.
type L2IsolationDomainsClientUpdateAdministrativeStateResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// L2IsolationDomainsClientUpdateResponse contains the response from method L2IsolationDomainsClient.BeginUpdate.
type L2IsolationDomainsClientUpdateResponse struct {
	// The L2 Isolation Domain resource definition.
	L2IsolationDomain
}

// L2IsolationDomainsClientValidateConfigurationResponse contains the response from method L2IsolationDomainsClient.BeginValidateConfiguration.
type L2IsolationDomainsClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// L3IsolationDomainsClientCommitConfigurationResponse contains the response from method L3IsolationDomainsClient.BeginCommitConfiguration.
type L3IsolationDomainsClientCommitConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// L3IsolationDomainsClientCreateResponse contains the response from method L3IsolationDomainsClient.BeginCreate.
type L3IsolationDomainsClientCreateResponse struct {
	// The L3 Isolation Domain resource definition.
	L3IsolationDomain
}

// L3IsolationDomainsClientDeleteResponse contains the response from method L3IsolationDomainsClient.BeginDelete.
type L3IsolationDomainsClientDeleteResponse struct {
	// placeholder for future response values
}

// L3IsolationDomainsClientGetResponse contains the response from method L3IsolationDomainsClient.Get.
type L3IsolationDomainsClientGetResponse struct {
	// The L3 Isolation Domain resource definition.
	L3IsolationDomain
}

// L3IsolationDomainsClientListByResourceGroupResponse contains the response from method L3IsolationDomainsClient.NewListByResourceGroupPager.
type L3IsolationDomainsClientListByResourceGroupResponse struct {
	// List of L3 Isolation Domains.
	L3IsolationDomainsListResult
}

// L3IsolationDomainsClientListBySubscriptionResponse contains the response from method L3IsolationDomainsClient.NewListBySubscriptionPager.
type L3IsolationDomainsClientListBySubscriptionResponse struct {
	// List of L3 Isolation Domains.
	L3IsolationDomainsListResult
}

// L3IsolationDomainsClientUpdateAdministrativeStateResponse contains the response from method L3IsolationDomainsClient.BeginUpdateAdministrativeState.
type L3IsolationDomainsClientUpdateAdministrativeStateResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// L3IsolationDomainsClientUpdateResponse contains the response from method L3IsolationDomainsClient.BeginUpdate.
type L3IsolationDomainsClientUpdateResponse struct {
	// The L3 Isolation Domain resource definition.
	L3IsolationDomain
}

// L3IsolationDomainsClientValidateConfigurationResponse contains the response from method L3IsolationDomainsClient.BeginValidateConfiguration.
type L3IsolationDomainsClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// NeighborGroupsClientCreateResponse contains the response from method NeighborGroupsClient.BeginCreate.
type NeighborGroupsClientCreateResponse struct {
	// Defines the Neighbor Group.
	NeighborGroup
}

// NeighborGroupsClientDeleteResponse contains the response from method NeighborGroupsClient.BeginDelete.
type NeighborGroupsClientDeleteResponse struct {
	// placeholder for future response values
}

// NeighborGroupsClientGetResponse contains the response from method NeighborGroupsClient.Get.
type NeighborGroupsClientGetResponse struct {
	// Defines the Neighbor Group.
	NeighborGroup
}

// NeighborGroupsClientListByResourceGroupResponse contains the response from method NeighborGroupsClient.NewListByResourceGroupPager.
type NeighborGroupsClientListByResourceGroupResponse struct {
	// List of Neighbor Group.
	NeighborGroupsListResult
}

// NeighborGroupsClientListBySubscriptionResponse contains the response from method NeighborGroupsClient.NewListBySubscriptionPager.
type NeighborGroupsClientListBySubscriptionResponse struct {
	// List of Neighbor Group.
	NeighborGroupsListResult
}

// NeighborGroupsClientUpdateResponse contains the response from method NeighborGroupsClient.BeginUpdate.
type NeighborGroupsClientUpdateResponse struct {
	// Defines the Neighbor Group.
	NeighborGroup
}

// NetworkDeviceSKUsClientGetResponse contains the response from method NetworkDeviceSKUsClient.Get.
type NetworkDeviceSKUsClientGetResponse struct {
	// The NetworkDeviceSku resource definition.
	NetworkDeviceSKU
}

// NetworkDeviceSKUsClientListBySubscriptionResponse contains the response from method NetworkDeviceSKUsClient.NewListBySubscriptionPager.
type NetworkDeviceSKUsClientListBySubscriptionResponse struct {
	// List of Network Device SKUs.
	NetworkDeviceSKUsListResult
}

// NetworkDevicesClientCreateResponse contains the response from method NetworkDevicesClient.BeginCreate.
type NetworkDevicesClientCreateResponse struct {
	// The Network Device resource definition.
	NetworkDevice
}

// NetworkDevicesClientDeleteResponse contains the response from method NetworkDevicesClient.BeginDelete.
type NetworkDevicesClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkDevicesClientGetResponse contains the response from method NetworkDevicesClient.Get.
type NetworkDevicesClientGetResponse struct {
	// The Network Device resource definition.
	NetworkDevice
}

// NetworkDevicesClientListByResourceGroupResponse contains the response from method NetworkDevicesClient.NewListByResourceGroupPager.
type NetworkDevicesClientListByResourceGroupResponse struct {
	// List of NetworkDevices.
	NetworkDevicesListResult
}

// NetworkDevicesClientListBySubscriptionResponse contains the response from method NetworkDevicesClient.NewListBySubscriptionPager.
type NetworkDevicesClientListBySubscriptionResponse struct {
	// List of NetworkDevices.
	NetworkDevicesListResult
}

// NetworkDevicesClientRebootResponse contains the response from method NetworkDevicesClient.BeginReboot.
type NetworkDevicesClientRebootResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkDevicesClientRefreshConfigurationResponse contains the response from method NetworkDevicesClient.BeginRefreshConfiguration.
type NetworkDevicesClientRefreshConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkDevicesClientUpdateAdministrativeStateResponse contains the response from method NetworkDevicesClient.BeginUpdateAdministrativeState.
type NetworkDevicesClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkDevicesClientUpdateResponse contains the response from method NetworkDevicesClient.BeginUpdate.
type NetworkDevicesClientUpdateResponse struct {
	// The Network Device resource definition.
	NetworkDevice
}

// NetworkDevicesClientUpgradeResponse contains the response from method NetworkDevicesClient.BeginUpgrade.
type NetworkDevicesClientUpgradeResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricControllersClientCreateResponse contains the response from method NetworkFabricControllersClient.BeginCreate.
type NetworkFabricControllersClientCreateResponse struct {
	// The Network Fabric Controller resource definition.
	NetworkFabricController
}

// NetworkFabricControllersClientDeleteResponse contains the response from method NetworkFabricControllersClient.BeginDelete.
type NetworkFabricControllersClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFabricControllersClientGetResponse contains the response from method NetworkFabricControllersClient.Get.
type NetworkFabricControllersClientGetResponse struct {
	// The Network Fabric Controller resource definition.
	NetworkFabricController
}

// NetworkFabricControllersClientListByResourceGroupResponse contains the response from method NetworkFabricControllersClient.NewListByResourceGroupPager.
type NetworkFabricControllersClientListByResourceGroupResponse struct {
	// List of Network Fabric Controllers.
	NetworkFabricControllersListResult
}

// NetworkFabricControllersClientListBySubscriptionResponse contains the response from method NetworkFabricControllersClient.NewListBySubscriptionPager.
type NetworkFabricControllersClientListBySubscriptionResponse struct {
	// List of Network Fabric Controllers.
	NetworkFabricControllersListResult
}

// NetworkFabricControllersClientUpdateResponse contains the response from method NetworkFabricControllersClient.BeginUpdate.
type NetworkFabricControllersClientUpdateResponse struct {
	// The Network Fabric Controller resource definition.
	NetworkFabricController
}

// NetworkFabricSKUsClientGetResponse contains the response from method NetworkFabricSKUsClient.Get.
type NetworkFabricSKUsClientGetResponse struct {
	// The Network Fabric SKU resource definition.
	NetworkFabricSKU
}

// NetworkFabricSKUsClientListBySubscriptionResponse contains the response from method NetworkFabricSKUsClient.NewListBySubscriptionPager.
type NetworkFabricSKUsClientListBySubscriptionResponse struct {
	// List of Network Fabric SKUs.
	NetworkFabricSKUsListResult
}

// NetworkFabricsClientCommitConfigurationResponse contains the response from method NetworkFabricsClient.BeginCommitConfiguration.
type NetworkFabricsClientCommitConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricsClientCreateResponse contains the response from method NetworkFabricsClient.BeginCreate.
type NetworkFabricsClientCreateResponse struct {
	// The Network Fabric resource definition.
	NetworkFabric
}

// NetworkFabricsClientDeleteResponse contains the response from method NetworkFabricsClient.BeginDelete.
type NetworkFabricsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkFabricsClientDeprovisionResponse contains the response from method NetworkFabricsClient.BeginDeprovision.
type NetworkFabricsClientDeprovisionResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// NetworkFabricsClientGetResponse contains the response from method NetworkFabricsClient.Get.
type NetworkFabricsClientGetResponse struct {
	// The Network Fabric resource definition.
	NetworkFabric
}

// NetworkFabricsClientGetTopologyResponse contains the response from method NetworkFabricsClient.BeginGetTopology.
type NetworkFabricsClientGetTopologyResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// NetworkFabricsClientListByResourceGroupResponse contains the response from method NetworkFabricsClient.NewListByResourceGroupPager.
type NetworkFabricsClientListByResourceGroupResponse struct {
	// List of Network Fabrics.
	NetworkFabricsListResult
}

// NetworkFabricsClientListBySubscriptionResponse contains the response from method NetworkFabricsClient.NewListBySubscriptionPager.
type NetworkFabricsClientListBySubscriptionResponse struct {
	// List of Network Fabrics.
	NetworkFabricsListResult
}

// NetworkFabricsClientProvisionResponse contains the response from method NetworkFabricsClient.BeginProvision.
type NetworkFabricsClientProvisionResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// NetworkFabricsClientRefreshConfigurationResponse contains the response from method NetworkFabricsClient.BeginRefreshConfiguration.
type NetworkFabricsClientRefreshConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricsClientUpdateInfraManagementBfdConfigurationResponse contains the response from method NetworkFabricsClient.BeginUpdateInfraManagementBfdConfiguration.
type NetworkFabricsClientUpdateInfraManagementBfdConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricsClientUpdateResponse contains the response from method NetworkFabricsClient.BeginUpdate.
type NetworkFabricsClientUpdateResponse struct {
	// The Network Fabric resource definition.
	NetworkFabric
}

// NetworkFabricsClientUpdateWorkloadManagementBfdConfigurationResponse contains the response from method NetworkFabricsClient.BeginUpdateWorkloadManagementBfdConfiguration.
type NetworkFabricsClientUpdateWorkloadManagementBfdConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricsClientUpgradeResponse contains the response from method NetworkFabricsClient.BeginUpgrade.
type NetworkFabricsClientUpgradeResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkFabricsClientValidateConfigurationResponse contains the response from method NetworkFabricsClient.BeginValidateConfiguration.
type NetworkFabricsClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// NetworkInterfacesClientCreateResponse contains the response from method NetworkInterfacesClient.BeginCreate.
type NetworkInterfacesClientCreateResponse struct {
	// Defines the NetworkInterface resource.
	NetworkInterface
}

// NetworkInterfacesClientDeleteResponse contains the response from method NetworkInterfacesClient.BeginDelete.
type NetworkInterfacesClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkInterfacesClientGetResponse contains the response from method NetworkInterfacesClient.Get.
type NetworkInterfacesClientGetResponse struct {
	// Defines the NetworkInterface resource.
	NetworkInterface
}

// NetworkInterfacesClientListByNetworkDeviceResponse contains the response from method NetworkInterfacesClient.NewListByNetworkDevicePager.
type NetworkInterfacesClientListByNetworkDeviceResponse struct {
	// List of NetworkInterfaces.
	NetworkInterfacesList
}

// NetworkInterfacesClientUpdateAdministrativeStateResponse contains the response from method NetworkInterfacesClient.BeginUpdateAdministrativeState.
type NetworkInterfacesClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkInterfacesClientUpdateResponse contains the response from method NetworkInterfacesClient.BeginUpdate.
type NetworkInterfacesClientUpdateResponse struct {
	// Defines the NetworkInterface resource.
	NetworkInterface
}

// NetworkPacketBrokersClientCreateResponse contains the response from method NetworkPacketBrokersClient.BeginCreate.
type NetworkPacketBrokersClientCreateResponse struct {
	// The NetworkPacketBroker resource definition.
	NetworkPacketBroker
}

// NetworkPacketBrokersClientDeleteResponse contains the response from method NetworkPacketBrokersClient.BeginDelete.
type NetworkPacketBrokersClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkPacketBrokersClientGetResponse contains the response from method NetworkPacketBrokersClient.Get.
type NetworkPacketBrokersClientGetResponse struct {
	// The NetworkPacketBroker resource definition.
	NetworkPacketBroker
}

// NetworkPacketBrokersClientListByResourceGroupResponse contains the response from method NetworkPacketBrokersClient.NewListByResourceGroupPager.
type NetworkPacketBrokersClientListByResourceGroupResponse struct {
	// List of NetworkPacketBrokers.
	NetworkPacketBrokersListResult
}

// NetworkPacketBrokersClientListBySubscriptionResponse contains the response from method NetworkPacketBrokersClient.NewListBySubscriptionPager.
type NetworkPacketBrokersClientListBySubscriptionResponse struct {
	// List of NetworkPacketBrokers.
	NetworkPacketBrokersListResult
}

// NetworkPacketBrokersClientUpdateResponse contains the response from method NetworkPacketBrokersClient.BeginUpdate.
type NetworkPacketBrokersClientUpdateResponse struct {
	// The NetworkPacketBroker resource definition.
	NetworkPacketBroker
}

// NetworkRacksClientCreateResponse contains the response from method NetworkRacksClient.BeginCreate.
type NetworkRacksClientCreateResponse struct {
	// The Network Rack resource definition.
	NetworkRack
}

// NetworkRacksClientDeleteResponse contains the response from method NetworkRacksClient.BeginDelete.
type NetworkRacksClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkRacksClientGetResponse contains the response from method NetworkRacksClient.Get.
type NetworkRacksClientGetResponse struct {
	// The Network Rack resource definition.
	NetworkRack
}

// NetworkRacksClientListByResourceGroupResponse contains the response from method NetworkRacksClient.NewListByResourceGroupPager.
type NetworkRacksClientListByResourceGroupResponse struct {
	// List of Network Racks.
	NetworkRacksListResult
}

// NetworkRacksClientListBySubscriptionResponse contains the response from method NetworkRacksClient.NewListBySubscriptionPager.
type NetworkRacksClientListBySubscriptionResponse struct {
	// List of Network Racks.
	NetworkRacksListResult
}

// NetworkRacksClientUpdateResponse contains the response from method NetworkRacksClient.BeginUpdate.
type NetworkRacksClientUpdateResponse struct {
	// The Network Rack resource definition.
	NetworkRack
}

// NetworkTapRulesClientCreateResponse contains the response from method NetworkTapRulesClient.BeginCreate.
type NetworkTapRulesClientCreateResponse struct {
	// The NetworkTapRule resource definition.
	NetworkTapRule
}

// NetworkTapRulesClientDeleteResponse contains the response from method NetworkTapRulesClient.BeginDelete.
type NetworkTapRulesClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkTapRulesClientGetResponse contains the response from method NetworkTapRulesClient.Get.
type NetworkTapRulesClientGetResponse struct {
	// The NetworkTapRule resource definition.
	NetworkTapRule
}

// NetworkTapRulesClientListByResourceGroupResponse contains the response from method NetworkTapRulesClient.NewListByResourceGroupPager.
type NetworkTapRulesClientListByResourceGroupResponse struct {
	// List of NetworkTapRules.
	NetworkTapRulesListResult
}

// NetworkTapRulesClientListBySubscriptionResponse contains the response from method NetworkTapRulesClient.NewListBySubscriptionPager.
type NetworkTapRulesClientListBySubscriptionResponse struct {
	// List of NetworkTapRules.
	NetworkTapRulesListResult
}

// NetworkTapRulesClientResyncResponse contains the response from method NetworkTapRulesClient.BeginResync.
type NetworkTapRulesClientResyncResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkTapRulesClientUpdateAdministrativeStateResponse contains the response from method NetworkTapRulesClient.BeginUpdateAdministrativeState.
type NetworkTapRulesClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkTapRulesClientUpdateResponse contains the response from method NetworkTapRulesClient.BeginUpdate.
type NetworkTapRulesClientUpdateResponse struct {
	// The NetworkTapRule resource definition.
	NetworkTapRule
}

// NetworkTapRulesClientValidateConfigurationResponse contains the response from method NetworkTapRulesClient.BeginValidateConfiguration.
type NetworkTapRulesClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}

// NetworkTapsClientCreateResponse contains the response from method NetworkTapsClient.BeginCreate.
type NetworkTapsClientCreateResponse struct {
	// The Network Tap resource definition.
	NetworkTap
}

// NetworkTapsClientDeleteResponse contains the response from method NetworkTapsClient.BeginDelete.
type NetworkTapsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkTapsClientGetResponse contains the response from method NetworkTapsClient.Get.
type NetworkTapsClientGetResponse struct {
	// The Network Tap resource definition.
	NetworkTap
}

// NetworkTapsClientListByResourceGroupResponse contains the response from method NetworkTapsClient.NewListByResourceGroupPager.
type NetworkTapsClientListByResourceGroupResponse struct {
	// List of NetworkTaps.
	NetworkTapsListResult
}

// NetworkTapsClientListBySubscriptionResponse contains the response from method NetworkTapsClient.NewListBySubscriptionPager.
type NetworkTapsClientListBySubscriptionResponse struct {
	// List of NetworkTaps.
	NetworkTapsListResult
}

// NetworkTapsClientResyncResponse contains the response from method NetworkTapsClient.BeginResync.
type NetworkTapsClientResyncResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkTapsClientUpdateAdministrativeStateResponse contains the response from method NetworkTapsClient.BeginUpdateAdministrativeState.
type NetworkTapsClientUpdateAdministrativeStateResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// NetworkTapsClientUpdateResponse contains the response from method NetworkTapsClient.BeginUpdate.
type NetworkTapsClientUpdateResponse struct {
	// The Network Tap resource definition.
	NetworkTap
}

// NetworkToNetworkInterconnectsClientCreateResponse contains the response from method NetworkToNetworkInterconnectsClient.BeginCreate.
type NetworkToNetworkInterconnectsClientCreateResponse struct {
	// The Network To Network Interconnect resource definition.
	NetworkToNetworkInterconnect
}

// NetworkToNetworkInterconnectsClientDeleteResponse contains the response from method NetworkToNetworkInterconnectsClient.BeginDelete.
type NetworkToNetworkInterconnectsClientDeleteResponse struct {
	// placeholder for future response values
}

// NetworkToNetworkInterconnectsClientGetResponse contains the response from method NetworkToNetworkInterconnectsClient.Get.
type NetworkToNetworkInterconnectsClientGetResponse struct {
	// The Network To Network Interconnect resource definition.
	NetworkToNetworkInterconnect
}

// NetworkToNetworkInterconnectsClientListByNetworkFabricResponse contains the response from method NetworkToNetworkInterconnectsClient.NewListByNetworkFabricPager.
type NetworkToNetworkInterconnectsClientListByNetworkFabricResponse struct {
	// List of Network To Network Interconnects.
	NetworkToNetworkInterconnectsList
}

// NetworkToNetworkInterconnectsClientUpdateAdministrativeStateResponse contains the response from method NetworkToNetworkInterconnectsClient.BeginUpdateAdministrativeState.
type NetworkToNetworkInterconnectsClientUpdateAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkToNetworkInterconnectsClientUpdateNpbStaticRouteBfdAdministrativeStateResponse contains the response from method
// NetworkToNetworkInterconnectsClient.BeginUpdateNpbStaticRouteBfdAdministrativeState.
type NetworkToNetworkInterconnectsClientUpdateNpbStaticRouteBfdAdministrativeStateResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// NetworkToNetworkInterconnectsClientUpdateResponse contains the response from method NetworkToNetworkInterconnectsClient.BeginUpdate.
type NetworkToNetworkInterconnectsClientUpdateResponse struct {
	// The Network To Network Interconnect resource definition.
	NetworkToNetworkInterconnect
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// RoutePoliciesClientCommitConfigurationResponse contains the response from method RoutePoliciesClient.BeginCommitConfiguration.
type RoutePoliciesClientCommitConfigurationResponse struct {
	// Common response for the state updates.
	CommonPostActionResponseForStateUpdate
}

// RoutePoliciesClientCreateResponse contains the response from method RoutePoliciesClient.BeginCreate.
type RoutePoliciesClientCreateResponse struct {
	// The RoutePolicy resource definition.
	RoutePolicy
}

// RoutePoliciesClientDeleteResponse contains the response from method RoutePoliciesClient.BeginDelete.
type RoutePoliciesClientDeleteResponse struct {
	// placeholder for future response values
}

// RoutePoliciesClientGetResponse contains the response from method RoutePoliciesClient.Get.
type RoutePoliciesClientGetResponse struct {
	// The RoutePolicy resource definition.
	RoutePolicy
}

// RoutePoliciesClientListByResourceGroupResponse contains the response from method RoutePoliciesClient.NewListByResourceGroupPager.
type RoutePoliciesClientListByResourceGroupResponse struct {
	// List of RoutePolicies.
	RoutePoliciesListResult
}

// RoutePoliciesClientListBySubscriptionResponse contains the response from method RoutePoliciesClient.NewListBySubscriptionPager.
type RoutePoliciesClientListBySubscriptionResponse struct {
	// List of RoutePolicies.
	RoutePoliciesListResult
}

// RoutePoliciesClientUpdateAdministrativeStateResponse contains the response from method RoutePoliciesClient.BeginUpdateAdministrativeState.
type RoutePoliciesClientUpdateAdministrativeStateResponse struct {
	// Common response for device updates.
	CommonPostActionResponseForDeviceUpdate
}

// RoutePoliciesClientUpdateResponse contains the response from method RoutePoliciesClient.BeginUpdate.
type RoutePoliciesClientUpdateResponse struct {
	// The RoutePolicy resource definition.
	RoutePolicy
}

// RoutePoliciesClientValidateConfigurationResponse contains the response from method RoutePoliciesClient.BeginValidateConfiguration.
type RoutePoliciesClientValidateConfigurationResponse struct {
	// The response of the action validate configuration.
	ValidateConfigurationResponse
}
