//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armnetworkcloud

// AgentPoolsClientCreateOrUpdateResponse contains the response from method AgentPoolsClient.BeginCreateOrUpdate.
type AgentPoolsClientCreateOrUpdateResponse struct {
	// AgentPool represents the agent pool of Kubernetes cluster.
	AgentPool
}

// AgentPoolsClientDeleteResponse contains the response from method AgentPoolsClient.BeginDelete.
type AgentPoolsClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// AgentPoolsClientGetResponse contains the response from method AgentPoolsClient.Get.
type AgentPoolsClientGetResponse struct {
	// AgentPool represents the agent pool of Kubernetes cluster.
	AgentPool
}

// AgentPoolsClientListByKubernetesClusterResponse contains the response from method AgentPoolsClient.NewListByKubernetesClusterPager.
type AgentPoolsClientListByKubernetesClusterResponse struct {
	// AgentPoolList represents a list of Kubernetes cluster agent pools.
	AgentPoolList
}

// AgentPoolsClientUpdateResponse contains the response from method AgentPoolsClient.BeginUpdate.
type AgentPoolsClientUpdateResponse struct {
	// AgentPool represents the agent pool of Kubernetes cluster.
	AgentPool
}

// BareMetalMachineKeySetsClientCreateOrUpdateResponse contains the response from method BareMetalMachineKeySetsClient.BeginCreateOrUpdate.
type BareMetalMachineKeySetsClientCreateOrUpdateResponse struct {
	// BareMetalMachineKeySet represents the bare metal machine key set.
	BareMetalMachineKeySet
}

// BareMetalMachineKeySetsClientDeleteResponse contains the response from method BareMetalMachineKeySetsClient.BeginDelete.
type BareMetalMachineKeySetsClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachineKeySetsClientGetResponse contains the response from method BareMetalMachineKeySetsClient.Get.
type BareMetalMachineKeySetsClientGetResponse struct {
	// BareMetalMachineKeySet represents the bare metal machine key set.
	BareMetalMachineKeySet
}

// BareMetalMachineKeySetsClientListByClusterResponse contains the response from method BareMetalMachineKeySetsClient.NewListByClusterPager.
type BareMetalMachineKeySetsClientListByClusterResponse struct {
	// BareMetalMachineKeySetList represents a list of bare metal machine key sets.
	BareMetalMachineKeySetList
}

// BareMetalMachineKeySetsClientUpdateResponse contains the response from method BareMetalMachineKeySetsClient.BeginUpdate.
type BareMetalMachineKeySetsClientUpdateResponse struct {
	// BareMetalMachineKeySet represents the bare metal machine key set.
	BareMetalMachineKeySet
}

// BareMetalMachinesClientCordonResponse contains the response from method BareMetalMachinesClient.BeginCordon.
type BareMetalMachinesClientCordonResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientCreateOrUpdateResponse contains the response from method BareMetalMachinesClient.BeginCreateOrUpdate.
type BareMetalMachinesClientCreateOrUpdateResponse struct {
	// BareMetalMachine represents the physical machine in the rack.
	BareMetalMachine
}

// BareMetalMachinesClientDeleteResponse contains the response from method BareMetalMachinesClient.BeginDelete.
type BareMetalMachinesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientGetResponse contains the response from method BareMetalMachinesClient.Get.
type BareMetalMachinesClientGetResponse struct {
	// BareMetalMachine represents the physical machine in the rack.
	BareMetalMachine
}

// BareMetalMachinesClientListByResourceGroupResponse contains the response from method BareMetalMachinesClient.NewListByResourceGroupPager.
type BareMetalMachinesClientListByResourceGroupResponse struct {
	// BareMetalMachineList represents a list of bare metal machines.
	BareMetalMachineList
}

// BareMetalMachinesClientListBySubscriptionResponse contains the response from method BareMetalMachinesClient.NewListBySubscriptionPager.
type BareMetalMachinesClientListBySubscriptionResponse struct {
	// BareMetalMachineList represents a list of bare metal machines.
	BareMetalMachineList
}

// BareMetalMachinesClientPowerOffResponse contains the response from method BareMetalMachinesClient.BeginPowerOff.
type BareMetalMachinesClientPowerOffResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientReimageResponse contains the response from method BareMetalMachinesClient.BeginReimage.
type BareMetalMachinesClientReimageResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientReplaceResponse contains the response from method BareMetalMachinesClient.BeginReplace.
type BareMetalMachinesClientReplaceResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientRestartResponse contains the response from method BareMetalMachinesClient.BeginRestart.
type BareMetalMachinesClientRestartResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientRunCommandResponse contains the response from method BareMetalMachinesClient.BeginRunCommand.
type BareMetalMachinesClientRunCommandResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientRunDataExtractsResponse contains the response from method BareMetalMachinesClient.BeginRunDataExtracts.
type BareMetalMachinesClientRunDataExtractsResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientRunReadCommandsResponse contains the response from method BareMetalMachinesClient.BeginRunReadCommands.
type BareMetalMachinesClientRunReadCommandsResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientStartResponse contains the response from method BareMetalMachinesClient.BeginStart.
type BareMetalMachinesClientStartResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientUncordonResponse contains the response from method BareMetalMachinesClient.BeginUncordon.
type BareMetalMachinesClientUncordonResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BareMetalMachinesClientUpdateResponse contains the response from method BareMetalMachinesClient.BeginUpdate.
type BareMetalMachinesClientUpdateResponse struct {
	// BareMetalMachine represents the physical machine in the rack.
	BareMetalMachine
}

// BmcKeySetsClientCreateOrUpdateResponse contains the response from method BmcKeySetsClient.BeginCreateOrUpdate.
type BmcKeySetsClientCreateOrUpdateResponse struct {
	// BmcKeySet represents the baseboard management controller key set.
	BmcKeySet
}

// BmcKeySetsClientDeleteResponse contains the response from method BmcKeySetsClient.BeginDelete.
type BmcKeySetsClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// BmcKeySetsClientGetResponse contains the response from method BmcKeySetsClient.Get.
type BmcKeySetsClientGetResponse struct {
	// BmcKeySet represents the baseboard management controller key set.
	BmcKeySet
}

// BmcKeySetsClientListByClusterResponse contains the response from method BmcKeySetsClient.NewListByClusterPager.
type BmcKeySetsClientListByClusterResponse struct {
	// BmcKeySetList represents a list of baseboard management controller key sets.
	BmcKeySetList
}

// BmcKeySetsClientUpdateResponse contains the response from method BmcKeySetsClient.BeginUpdate.
type BmcKeySetsClientUpdateResponse struct {
	// BmcKeySet represents the baseboard management controller key set.
	BmcKeySet
}

// CloudServicesNetworksClientCreateOrUpdateResponse contains the response from method CloudServicesNetworksClient.BeginCreateOrUpdate.
type CloudServicesNetworksClientCreateOrUpdateResponse struct {
	// Upon creation, the additional services that are provided by the platform will be allocated and
	// represented in the status of this resource. All resources associated with this cloud services network will be part
	// of the same layer 2 (L2) isolation domain. At least one service network must be created but may be reused across many
	// virtual machines and/or Hybrid AKS clusters.
	CloudServicesNetwork
}

// CloudServicesNetworksClientDeleteResponse contains the response from method CloudServicesNetworksClient.BeginDelete.
type CloudServicesNetworksClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// CloudServicesNetworksClientGetResponse contains the response from method CloudServicesNetworksClient.Get.
type CloudServicesNetworksClientGetResponse struct {
	// Upon creation, the additional services that are provided by the platform will be allocated and
	// represented in the status of this resource. All resources associated with this cloud services network will be part
	// of the same layer 2 (L2) isolation domain. At least one service network must be created but may be reused across many
	// virtual machines and/or Hybrid AKS clusters.
	CloudServicesNetwork
}

// CloudServicesNetworksClientListByResourceGroupResponse contains the response from method CloudServicesNetworksClient.NewListByResourceGroupPager.
type CloudServicesNetworksClientListByResourceGroupResponse struct {
	// CloudServicesNetworkList represents a list of cloud services networks.
	CloudServicesNetworkList
}

// CloudServicesNetworksClientListBySubscriptionResponse contains the response from method CloudServicesNetworksClient.NewListBySubscriptionPager.
type CloudServicesNetworksClientListBySubscriptionResponse struct {
	// CloudServicesNetworkList represents a list of cloud services networks.
	CloudServicesNetworkList
}

// CloudServicesNetworksClientUpdateResponse contains the response from method CloudServicesNetworksClient.BeginUpdate.
type CloudServicesNetworksClientUpdateResponse struct {
	// Upon creation, the additional services that are provided by the platform will be allocated and
	// represented in the status of this resource. All resources associated with this cloud services network will be part
	// of the same layer 2 (L2) isolation domain. At least one service network must be created but may be reused across many
	// virtual machines and/or Hybrid AKS clusters.
	CloudServicesNetwork
}

// ClusterManagersClientCreateOrUpdateResponse contains the response from method ClusterManagersClient.BeginCreateOrUpdate.
type ClusterManagersClientCreateOrUpdateResponse struct {
	// ClusterManager represents a control-plane to manage one or more on-premises clusters.
	ClusterManager
}

// ClusterManagersClientDeleteResponse contains the response from method ClusterManagersClient.BeginDelete.
type ClusterManagersClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClusterManagersClientGetResponse contains the response from method ClusterManagersClient.Get.
type ClusterManagersClientGetResponse struct {
	// ClusterManager represents a control-plane to manage one or more on-premises clusters.
	ClusterManager
}

// ClusterManagersClientListByResourceGroupResponse contains the response from method ClusterManagersClient.NewListByResourceGroupPager.
type ClusterManagersClientListByResourceGroupResponse struct {
	// ClusterManagerList represents a list of cluster manager objects.
	ClusterManagerList
}

// ClusterManagersClientListBySubscriptionResponse contains the response from method ClusterManagersClient.NewListBySubscriptionPager.
type ClusterManagersClientListBySubscriptionResponse struct {
	// ClusterManagerList represents a list of cluster manager objects.
	ClusterManagerList
}

// ClusterManagersClientUpdateResponse contains the response from method ClusterManagersClient.Update.
type ClusterManagersClientUpdateResponse struct {
	// ClusterManager represents a control-plane to manage one or more on-premises clusters.
	ClusterManager
}

// ClustersClientContinueUpdateVersionResponse contains the response from method ClustersClient.BeginContinueUpdateVersion.
type ClustersClientContinueUpdateVersionResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClustersClientCreateOrUpdateResponse contains the response from method ClustersClient.BeginCreateOrUpdate.
type ClustersClientCreateOrUpdateResponse struct {
	// Cluster represents the on-premises Network Cloud cluster.
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClustersClientDeployResponse contains the response from method ClustersClient.BeginDeploy.
type ClustersClientDeployResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// Cluster represents the on-premises Network Cloud cluster.
	Cluster
}

// ClustersClientListByResourceGroupResponse contains the response from method ClustersClient.NewListByResourceGroupPager.
type ClustersClientListByResourceGroupResponse struct {
	// ClusterList represents a list of clusters.
	ClusterList
}

// ClustersClientListBySubscriptionResponse contains the response from method ClustersClient.NewListBySubscriptionPager.
type ClustersClientListBySubscriptionResponse struct {
	// ClusterList represents a list of clusters.
	ClusterList
}

// ClustersClientScanRuntimeResponse contains the response from method ClustersClient.BeginScanRuntime.
type ClustersClientScanRuntimeResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.BeginUpdate.
type ClustersClientUpdateResponse struct {
	// Cluster represents the on-premises Network Cloud cluster.
	Cluster
}

// ClustersClientUpdateVersionResponse contains the response from method ClustersClient.BeginUpdateVersion.
type ClustersClientUpdateVersionResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ConsolesClientCreateOrUpdateResponse contains the response from method ConsolesClient.BeginCreateOrUpdate.
type ConsolesClientCreateOrUpdateResponse struct {
	// Console represents the console of an on-premises Network Cloud virtual machine.
	Console
}

// ConsolesClientDeleteResponse contains the response from method ConsolesClient.BeginDelete.
type ConsolesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// ConsolesClientGetResponse contains the response from method ConsolesClient.Get.
type ConsolesClientGetResponse struct {
	// Console represents the console of an on-premises Network Cloud virtual machine.
	Console
}

// ConsolesClientListByVirtualMachineResponse contains the response from method ConsolesClient.NewListByVirtualMachinePager.
type ConsolesClientListByVirtualMachineResponse struct {
	// ConsoleList represents a list of virtual machine consoles.
	ConsoleList
}

// ConsolesClientUpdateResponse contains the response from method ConsolesClient.BeginUpdate.
type ConsolesClientUpdateResponse struct {
	// Console represents the console of an on-premises Network Cloud virtual machine.
	Console
}

// KubernetesClusterFeaturesClientCreateOrUpdateResponse contains the response from method KubernetesClusterFeaturesClient.BeginCreateOrUpdate.
type KubernetesClusterFeaturesClientCreateOrUpdateResponse struct {
	// KubernetesClusterFeature represents the feature of a Kubernetes cluster.
	KubernetesClusterFeature
}

// KubernetesClusterFeaturesClientDeleteResponse contains the response from method KubernetesClusterFeaturesClient.BeginDelete.
type KubernetesClusterFeaturesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// KubernetesClusterFeaturesClientGetResponse contains the response from method KubernetesClusterFeaturesClient.Get.
type KubernetesClusterFeaturesClientGetResponse struct {
	// KubernetesClusterFeature represents the feature of a Kubernetes cluster.
	KubernetesClusterFeature
}

// KubernetesClusterFeaturesClientListByKubernetesClusterResponse contains the response from method KubernetesClusterFeaturesClient.NewListByKubernetesClusterPager.
type KubernetesClusterFeaturesClientListByKubernetesClusterResponse struct {
	// KubernetesClusterFeatureList represents the list of Kubernetes cluster feature resources.
	KubernetesClusterFeatureList
}

// KubernetesClusterFeaturesClientUpdateResponse contains the response from method KubernetesClusterFeaturesClient.BeginUpdate.
type KubernetesClusterFeaturesClientUpdateResponse struct {
	// KubernetesClusterFeature represents the feature of a Kubernetes cluster.
	KubernetesClusterFeature
}

// KubernetesClustersClientCreateOrUpdateResponse contains the response from method KubernetesClustersClient.BeginCreateOrUpdate.
type KubernetesClustersClientCreateOrUpdateResponse struct {
	// KubernetesCluster represents the Kubernetes cluster hosted on Network Cloud.
	KubernetesCluster
}

// KubernetesClustersClientDeleteResponse contains the response from method KubernetesClustersClient.BeginDelete.
type KubernetesClustersClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// KubernetesClustersClientGetResponse contains the response from method KubernetesClustersClient.Get.
type KubernetesClustersClientGetResponse struct {
	// KubernetesCluster represents the Kubernetes cluster hosted on Network Cloud.
	KubernetesCluster
}

// KubernetesClustersClientListByResourceGroupResponse contains the response from method KubernetesClustersClient.NewListByResourceGroupPager.
type KubernetesClustersClientListByResourceGroupResponse struct {
	// KubernetesClusterList represents a list of Kubernetes clusters.
	KubernetesClusterList
}

// KubernetesClustersClientListBySubscriptionResponse contains the response from method KubernetesClustersClient.NewListBySubscriptionPager.
type KubernetesClustersClientListBySubscriptionResponse struct {
	// KubernetesClusterList represents a list of Kubernetes clusters.
	KubernetesClusterList
}

// KubernetesClustersClientRestartNodeResponse contains the response from method KubernetesClustersClient.BeginRestartNode.
type KubernetesClustersClientRestartNodeResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// KubernetesClustersClientUpdateResponse contains the response from method KubernetesClustersClient.BeginUpdate.
type KubernetesClustersClientUpdateResponse struct {
	// KubernetesCluster represents the Kubernetes cluster hosted on Network Cloud.
	KubernetesCluster
}

// L2NetworksClientCreateOrUpdateResponse contains the response from method L2NetworksClient.BeginCreateOrUpdate.
type L2NetworksClientCreateOrUpdateResponse struct {
	// L2Network represents a network that utilizes a single isolation domain set up for layer-2 resources.
	L2Network
}

// L2NetworksClientDeleteResponse contains the response from method L2NetworksClient.BeginDelete.
type L2NetworksClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// L2NetworksClientGetResponse contains the response from method L2NetworksClient.Get.
type L2NetworksClientGetResponse struct {
	// L2Network represents a network that utilizes a single isolation domain set up for layer-2 resources.
	L2Network
}

// L2NetworksClientListByResourceGroupResponse contains the response from method L2NetworksClient.NewListByResourceGroupPager.
type L2NetworksClientListByResourceGroupResponse struct {
	// L2NetworkList represents a list of L2 networks.
	L2NetworkList
}

// L2NetworksClientListBySubscriptionResponse contains the response from method L2NetworksClient.NewListBySubscriptionPager.
type L2NetworksClientListBySubscriptionResponse struct {
	// L2NetworkList represents a list of L2 networks.
	L2NetworkList
}

// L2NetworksClientUpdateResponse contains the response from method L2NetworksClient.Update.
type L2NetworksClientUpdateResponse struct {
	// L2Network represents a network that utilizes a single isolation domain set up for layer-2 resources.
	L2Network
}

// L3NetworksClientCreateOrUpdateResponse contains the response from method L3NetworksClient.BeginCreateOrUpdate.
type L3NetworksClientCreateOrUpdateResponse struct {
	// L3Network represents a network that utilizes a single isolation domain set up for layer-3 resources.
	L3Network
}

// L3NetworksClientDeleteResponse contains the response from method L3NetworksClient.BeginDelete.
type L3NetworksClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// L3NetworksClientGetResponse contains the response from method L3NetworksClient.Get.
type L3NetworksClientGetResponse struct {
	// L3Network represents a network that utilizes a single isolation domain set up for layer-3 resources.
	L3Network
}

// L3NetworksClientListByResourceGroupResponse contains the response from method L3NetworksClient.NewListByResourceGroupPager.
type L3NetworksClientListByResourceGroupResponse struct {
	// L3NetworkList represents a list of L3 networks.
	L3NetworkList
}

// L3NetworksClientListBySubscriptionResponse contains the response from method L3NetworksClient.NewListBySubscriptionPager.
type L3NetworksClientListBySubscriptionResponse struct {
	// L3NetworkList represents a list of L3 networks.
	L3NetworkList
}

// L3NetworksClientUpdateResponse contains the response from method L3NetworksClient.Update.
type L3NetworksClientUpdateResponse struct {
	// L3Network represents a network that utilizes a single isolation domain set up for layer-3 resources.
	L3Network
}

// MetricsConfigurationsClientCreateOrUpdateResponse contains the response from method MetricsConfigurationsClient.BeginCreateOrUpdate.
type MetricsConfigurationsClientCreateOrUpdateResponse struct {
	// ClusterMetricsConfiguration represents the metrics configuration of an on-premises Network Cloud cluster.
	ClusterMetricsConfiguration
}

// MetricsConfigurationsClientDeleteResponse contains the response from method MetricsConfigurationsClient.BeginDelete.
type MetricsConfigurationsClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// MetricsConfigurationsClientGetResponse contains the response from method MetricsConfigurationsClient.Get.
type MetricsConfigurationsClientGetResponse struct {
	// ClusterMetricsConfiguration represents the metrics configuration of an on-premises Network Cloud cluster.
	ClusterMetricsConfiguration
}

// MetricsConfigurationsClientListByClusterResponse contains the response from method MetricsConfigurationsClient.NewListByClusterPager.
type MetricsConfigurationsClientListByClusterResponse struct {
	// ClusterMetricsConfigurationList represents a list of metrics configuration of the cluster.
	ClusterMetricsConfigurationList
}

// MetricsConfigurationsClientUpdateResponse contains the response from method MetricsConfigurationsClient.BeginUpdate.
type MetricsConfigurationsClientUpdateResponse struct {
	// ClusterMetricsConfiguration represents the metrics configuration of an on-premises Network Cloud cluster.
	ClusterMetricsConfiguration
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}

// RackSKUsClientGetResponse contains the response from method RackSKUsClient.Get.
type RackSKUsClientGetResponse struct {
	// RackSku represents the SKU information of the rack.
	RackSKU
}

// RackSKUsClientListBySubscriptionResponse contains the response from method RackSKUsClient.NewListBySubscriptionPager.
type RackSKUsClientListBySubscriptionResponse struct {
	// RackSkuList represents a list of rack SKUs.
	RackSKUList
}

// RacksClientCreateOrUpdateResponse contains the response from method RacksClient.BeginCreateOrUpdate.
type RacksClientCreateOrUpdateResponse struct {
	// Rack represents the hardware of the rack and is dependent upon the cluster for lifecycle.
	Rack
}

// RacksClientDeleteResponse contains the response from method RacksClient.BeginDelete.
type RacksClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// RacksClientGetResponse contains the response from method RacksClient.Get.
type RacksClientGetResponse struct {
	// Rack represents the hardware of the rack and is dependent upon the cluster for lifecycle.
	Rack
}

// RacksClientListByResourceGroupResponse contains the response from method RacksClient.NewListByResourceGroupPager.
type RacksClientListByResourceGroupResponse struct {
	// RackList represents a list of racks.
	RackList
}

// RacksClientListBySubscriptionResponse contains the response from method RacksClient.NewListBySubscriptionPager.
type RacksClientListBySubscriptionResponse struct {
	// RackList represents a list of racks.
	RackList
}

// RacksClientUpdateResponse contains the response from method RacksClient.BeginUpdate.
type RacksClientUpdateResponse struct {
	// Rack represents the hardware of the rack and is dependent upon the cluster for lifecycle.
	Rack
}

// StorageAppliancesClientCreateOrUpdateResponse contains the response from method StorageAppliancesClient.BeginCreateOrUpdate.
type StorageAppliancesClientCreateOrUpdateResponse struct {
	// StorageAppliance represents on-premises Network Cloud storage appliance.
	StorageAppliance
}

// StorageAppliancesClientDeleteResponse contains the response from method StorageAppliancesClient.BeginDelete.
type StorageAppliancesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// StorageAppliancesClientDisableRemoteVendorManagementResponse contains the response from method StorageAppliancesClient.BeginDisableRemoteVendorManagement.
type StorageAppliancesClientDisableRemoteVendorManagementResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// StorageAppliancesClientEnableRemoteVendorManagementResponse contains the response from method StorageAppliancesClient.BeginEnableRemoteVendorManagement.
type StorageAppliancesClientEnableRemoteVendorManagementResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// StorageAppliancesClientGetResponse contains the response from method StorageAppliancesClient.Get.
type StorageAppliancesClientGetResponse struct {
	// StorageAppliance represents on-premises Network Cloud storage appliance.
	StorageAppliance
}

// StorageAppliancesClientListByResourceGroupResponse contains the response from method StorageAppliancesClient.NewListByResourceGroupPager.
type StorageAppliancesClientListByResourceGroupResponse struct {
	// StorageApplianceList represents a list of storage appliances.
	StorageApplianceList
}

// StorageAppliancesClientListBySubscriptionResponse contains the response from method StorageAppliancesClient.NewListBySubscriptionPager.
type StorageAppliancesClientListBySubscriptionResponse struct {
	// StorageApplianceList represents a list of storage appliances.
	StorageApplianceList
}

// StorageAppliancesClientUpdateResponse contains the response from method StorageAppliancesClient.BeginUpdate.
type StorageAppliancesClientUpdateResponse struct {
	// StorageAppliance represents on-premises Network Cloud storage appliance.
	StorageAppliance
}

// TrunkedNetworksClientCreateOrUpdateResponse contains the response from method TrunkedNetworksClient.BeginCreateOrUpdate.
type TrunkedNetworksClientCreateOrUpdateResponse struct {
	// TrunkedNetwork represents a network that utilizes multiple isolation domains and specified VLANs to create a trunked network.
	TrunkedNetwork
}

// TrunkedNetworksClientDeleteResponse contains the response from method TrunkedNetworksClient.BeginDelete.
type TrunkedNetworksClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// TrunkedNetworksClientGetResponse contains the response from method TrunkedNetworksClient.Get.
type TrunkedNetworksClientGetResponse struct {
	// TrunkedNetwork represents a network that utilizes multiple isolation domains and specified VLANs to create a trunked network.
	TrunkedNetwork
}

// TrunkedNetworksClientListByResourceGroupResponse contains the response from method TrunkedNetworksClient.NewListByResourceGroupPager.
type TrunkedNetworksClientListByResourceGroupResponse struct {
	// TrunkedNetworkList represents a list of trunked networks.
	TrunkedNetworkList
}

// TrunkedNetworksClientListBySubscriptionResponse contains the response from method TrunkedNetworksClient.NewListBySubscriptionPager.
type TrunkedNetworksClientListBySubscriptionResponse struct {
	// TrunkedNetworkList represents a list of trunked networks.
	TrunkedNetworkList
}

// TrunkedNetworksClientUpdateResponse contains the response from method TrunkedNetworksClient.Update.
type TrunkedNetworksClientUpdateResponse struct {
	// TrunkedNetwork represents a network that utilizes multiple isolation domains and specified VLANs to create a trunked network.
	TrunkedNetwork
}

// VirtualMachinesClientCreateOrUpdateResponse contains the response from method VirtualMachinesClient.BeginCreateOrUpdate.
type VirtualMachinesClientCreateOrUpdateResponse struct {
	// VirtualMachine represents the on-premises Network Cloud virtual machine.
	VirtualMachine
}

// VirtualMachinesClientDeleteResponse contains the response from method VirtualMachinesClient.BeginDelete.
type VirtualMachinesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VirtualMachinesClientGetResponse contains the response from method VirtualMachinesClient.Get.
type VirtualMachinesClientGetResponse struct {
	// VirtualMachine represents the on-premises Network Cloud virtual machine.
	VirtualMachine
}

// VirtualMachinesClientListByResourceGroupResponse contains the response from method VirtualMachinesClient.NewListByResourceGroupPager.
type VirtualMachinesClientListByResourceGroupResponse struct {
	// VirtualMachineList represents a list of virtual machines.
	VirtualMachineList
}

// VirtualMachinesClientListBySubscriptionResponse contains the response from method VirtualMachinesClient.NewListBySubscriptionPager.
type VirtualMachinesClientListBySubscriptionResponse struct {
	// VirtualMachineList represents a list of virtual machines.
	VirtualMachineList
}

// VirtualMachinesClientPowerOffResponse contains the response from method VirtualMachinesClient.BeginPowerOff.
type VirtualMachinesClientPowerOffResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VirtualMachinesClientReimageResponse contains the response from method VirtualMachinesClient.BeginReimage.
type VirtualMachinesClientReimageResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VirtualMachinesClientRestartResponse contains the response from method VirtualMachinesClient.BeginRestart.
type VirtualMachinesClientRestartResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VirtualMachinesClientStartResponse contains the response from method VirtualMachinesClient.BeginStart.
type VirtualMachinesClientStartResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VirtualMachinesClientUpdateResponse contains the response from method VirtualMachinesClient.BeginUpdate.
type VirtualMachinesClientUpdateResponse struct {
	// VirtualMachine represents the on-premises Network Cloud virtual machine.
	VirtualMachine
}

// VolumesClientCreateOrUpdateResponse contains the response from method VolumesClient.BeginCreateOrUpdate.
type VolumesClientCreateOrUpdateResponse struct {
	// Volume represents storage made available for use by resources running on the cluster.
	Volume
}

// VolumesClientDeleteResponse contains the response from method VolumesClient.BeginDelete.
type VolumesClientDeleteResponse struct {
	// The current status of an async operation.
	OperationStatusResult
}

// VolumesClientGetResponse contains the response from method VolumesClient.Get.
type VolumesClientGetResponse struct {
	// Volume represents storage made available for use by resources running on the cluster.
	Volume
}

// VolumesClientListByResourceGroupResponse contains the response from method VolumesClient.NewListByResourceGroupPager.
type VolumesClientListByResourceGroupResponse struct {
	// VolumeList represents a list of volumes.
	VolumeList
}

// VolumesClientListBySubscriptionResponse contains the response from method VolumesClient.NewListBySubscriptionPager.
type VolumesClientListBySubscriptionResponse struct {
	// VolumeList represents a list of volumes.
	VolumeList
}

// VolumesClientUpdateResponse contains the response from method VolumesClient.Update.
type VolumesClientUpdateResponse struct {
	// Volume represents storage made available for use by resources running on the cluster.
	Volume
}
