//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armnotificationhubs

// ClientCheckNotificationHubAvailabilityResponse contains the response from method Client.CheckNotificationHubAvailability.
type ClientCheckNotificationHubAvailabilityResponse struct {
	// Description of a CheckAvailability resource.
	CheckAvailabilityResult
}

// ClientCreateOrUpdateAuthorizationRuleResponse contains the response from method Client.CreateOrUpdateAuthorizationRule.
type ClientCreateOrUpdateAuthorizationRuleResponse struct {
	// Response for POST requests that return single SharedAccessAuthorizationRule.
	SharedAccessAuthorizationRuleResource
}

// ClientCreateOrUpdateResponse contains the response from method Client.CreateOrUpdate.
type ClientCreateOrUpdateResponse struct {
	// Notification Hub Resource.
	NotificationHubResource
}

// ClientDebugSendResponse contains the response from method Client.DebugSend.
type ClientDebugSendResponse struct {
	// Description of a NotificationHub Resource.
	DebugSendResponse
}

// ClientDeleteAuthorizationRuleResponse contains the response from method Client.DeleteAuthorizationRule.
type ClientDeleteAuthorizationRuleResponse struct {
	// placeholder for future response values
}

// ClientDeleteResponse contains the response from method Client.Delete.
type ClientDeleteResponse struct {
	// placeholder for future response values
}

// ClientGetAuthorizationRuleResponse contains the response from method Client.GetAuthorizationRule.
type ClientGetAuthorizationRuleResponse struct {
	// Response for POST requests that return single SharedAccessAuthorizationRule.
	SharedAccessAuthorizationRuleResource
}

// ClientGetPnsCredentialsResponse contains the response from method Client.GetPnsCredentials.
type ClientGetPnsCredentialsResponse struct {
	// Description of a NotificationHub PNS Credentials. This is a response of the POST requests that return namespace or hubs
	// PNS credentials.
	PnsCredentialsResource
}

// ClientGetResponse contains the response from method Client.Get.
type ClientGetResponse struct {
	// Notification Hub Resource.
	NotificationHubResource
}

// ClientListAuthorizationRulesResponse contains the response from method Client.NewListAuthorizationRulesPager.
type ClientListAuthorizationRulesResponse struct {
	// The response of the List Namespace operation.
	SharedAccessAuthorizationRuleListResult
}

// ClientListKeysResponse contains the response from method Client.ListKeys.
type ClientListKeysResponse struct {
	// Response for the POST request that returns Namespace or NotificationHub access keys (connection strings).
	ResourceListKeys
}

// ClientListResponse contains the response from method Client.NewListPager.
type ClientListResponse struct {
	// The response of the List NotificationHub operation.
	NotificationHubListResult
}

// ClientRegenerateKeysResponse contains the response from method Client.RegenerateKeys.
type ClientRegenerateKeysResponse struct {
	// Response for the POST request that returns Namespace or NotificationHub access keys (connection strings).
	ResourceListKeys
}

// ClientUpdateResponse contains the response from method Client.Update.
type ClientUpdateResponse struct {
	// Notification Hub Resource.
	NotificationHubResource
}

// NamespacesClientCheckAvailabilityResponse contains the response from method NamespacesClient.CheckAvailability.
type NamespacesClientCheckAvailabilityResponse struct {
	// Description of a CheckAvailability resource.
	CheckAvailabilityResult
}

// NamespacesClientCreateOrUpdateAuthorizationRuleResponse contains the response from method NamespacesClient.CreateOrUpdateAuthorizationRule.
type NamespacesClientCreateOrUpdateAuthorizationRuleResponse struct {
	// Response for POST requests that return single SharedAccessAuthorizationRule.
	SharedAccessAuthorizationRuleResource
}

// NamespacesClientCreateOrUpdateResponse contains the response from method NamespacesClient.BeginCreateOrUpdate.
type NamespacesClientCreateOrUpdateResponse struct {
	// Notification Hubs Namespace Resource.
	NamespaceResource
}

// NamespacesClientDeleteAuthorizationRuleResponse contains the response from method NamespacesClient.DeleteAuthorizationRule.
type NamespacesClientDeleteAuthorizationRuleResponse struct {
	// placeholder for future response values
}

// NamespacesClientDeleteResponse contains the response from method NamespacesClient.Delete.
type NamespacesClientDeleteResponse struct {
	// placeholder for future response values
}

// NamespacesClientGetAuthorizationRuleResponse contains the response from method NamespacesClient.GetAuthorizationRule.
type NamespacesClientGetAuthorizationRuleResponse struct {
	// Response for POST requests that return single SharedAccessAuthorizationRule.
	SharedAccessAuthorizationRuleResource
}

// NamespacesClientGetPnsCredentialsResponse contains the response from method NamespacesClient.GetPnsCredentials.
type NamespacesClientGetPnsCredentialsResponse struct {
	// Description of a NotificationHub PNS Credentials. This is a response of the POST requests that return namespace or hubs
	// PNS credentials.
	PnsCredentialsResource
}

// NamespacesClientGetResponse contains the response from method NamespacesClient.Get.
type NamespacesClientGetResponse struct {
	// Notification Hubs Namespace Resource.
	NamespaceResource
}

// NamespacesClientListAllResponse contains the response from method NamespacesClient.NewListAllPager.
type NamespacesClientListAllResponse struct {
	// The response of the List Namespace operation.
	NamespaceListResult
}

// NamespacesClientListAuthorizationRulesResponse contains the response from method NamespacesClient.NewListAuthorizationRulesPager.
type NamespacesClientListAuthorizationRulesResponse struct {
	// The response of the List Namespace operation.
	SharedAccessAuthorizationRuleListResult
}

// NamespacesClientListKeysResponse contains the response from method NamespacesClient.ListKeys.
type NamespacesClientListKeysResponse struct {
	// Response for the POST request that returns Namespace or NotificationHub access keys (connection strings).
	ResourceListKeys
}

// NamespacesClientListResponse contains the response from method NamespacesClient.NewListPager.
type NamespacesClientListResponse struct {
	// The response of the List Namespace operation.
	NamespaceListResult
}

// NamespacesClientRegenerateKeysResponse contains the response from method NamespacesClient.RegenerateKeys.
type NamespacesClientRegenerateKeysResponse struct {
	// Response for the POST request that returns Namespace or NotificationHub access keys (connection strings).
	ResourceListKeys
}

// NamespacesClientUpdateResponse contains the response from method NamespacesClient.Update.
type NamespacesClientUpdateResponse struct {
	// Notification Hubs Namespace Resource.
	NamespaceResource
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list NotificationHubs operations. It contains
	// a list of operations and a URL link to get the next set of results.
	OperationListResult
}

// PrivateEndpointConnectionsClientDeleteResponse contains the response from method PrivateEndpointConnectionsClient.BeginDelete.
type PrivateEndpointConnectionsClientDeleteResponse struct {
	// placeholder for future response values
}

// PrivateEndpointConnectionsClientGetGroupIDResponse contains the response from method PrivateEndpointConnectionsClient.GetGroupID.
type PrivateEndpointConnectionsClientGetGroupIDResponse struct {
	// A Private Link Arm Resource.
	PrivateLinkResource
}

// PrivateEndpointConnectionsClientGetResponse contains the response from method PrivateEndpointConnectionsClient.Get.
type PrivateEndpointConnectionsClientGetResponse struct {
	// Represents a Private Endpoint Connection ARM resource - a sub-resource of Notification Hubs namespace.
	PrivateEndpointConnectionResource
}

// PrivateEndpointConnectionsClientListGroupIDsResponse contains the response from method PrivateEndpointConnectionsClient.NewListGroupIDsPager.
type PrivateEndpointConnectionsClientListGroupIDsResponse struct {
	// The response of the List Private Link Resources operation.
	PrivateLinkResourceListResult
}

// PrivateEndpointConnectionsClientListResponse contains the response from method PrivateEndpointConnectionsClient.NewListPager.
type PrivateEndpointConnectionsClientListResponse struct {
	// The response of the List Private Endpoint Connections operation.
	PrivateEndpointConnectionResourceListResult
}

// PrivateEndpointConnectionsClientUpdateResponse contains the response from method PrivateEndpointConnectionsClient.BeginUpdate.
type PrivateEndpointConnectionsClientUpdateResponse struct {
	// Represents a Private Endpoint Connection ARM resource - a sub-resource of Notification Hubs namespace.
	PrivateEndpointConnectionResource
}
