//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armoperationalinsights

// AvailableServiceTiersClientListByWorkspaceResponse contains the response from method AvailableServiceTiersClient.ListByWorkspace.
type AvailableServiceTiersClientListByWorkspaceResponse struct {
	// Array of AvailableServiceTier
	AvailableServiceTierArray []*AvailableServiceTier
}

// ClustersClientCreateOrUpdateResponse contains the response from method ClustersClient.BeginCreateOrUpdate.
type ClustersClientCreateOrUpdateResponse struct {
	// The top level Log Analytics cluster resource container.
	Cluster
}

// ClustersClientDeleteResponse contains the response from method ClustersClient.BeginDelete.
type ClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ClustersClientGetResponse contains the response from method ClustersClient.Get.
type ClustersClientGetResponse struct {
	// The top level Log Analytics cluster resource container.
	Cluster
}

// ClustersClientListByResourceGroupResponse contains the response from method ClustersClient.NewListByResourceGroupPager.
type ClustersClientListByResourceGroupResponse struct {
	// The list clusters operation response.
	ClusterListResult
}

// ClustersClientListResponse contains the response from method ClustersClient.NewListPager.
type ClustersClientListResponse struct {
	// The list clusters operation response.
	ClusterListResult
}

// ClustersClientUpdateResponse contains the response from method ClustersClient.BeginUpdate.
type ClustersClientUpdateResponse struct {
	// The top level Log Analytics cluster resource container.
	Cluster
}

// DataExportsClientCreateOrUpdateResponse contains the response from method DataExportsClient.CreateOrUpdate.
type DataExportsClientCreateOrUpdateResponse struct {
	// The top level data export resource container.
	DataExport
}

// DataExportsClientDeleteResponse contains the response from method DataExportsClient.Delete.
type DataExportsClientDeleteResponse struct {
	// placeholder for future response values
}

// DataExportsClientGetResponse contains the response from method DataExportsClient.Get.
type DataExportsClientGetResponse struct {
	// The top level data export resource container.
	DataExport
}

// DataExportsClientListByWorkspaceResponse contains the response from method DataExportsClient.NewListByWorkspacePager.
type DataExportsClientListByWorkspaceResponse struct {
	// Result of the request to list data exports.
	DataExportListResult
}

// DataSourcesClientCreateOrUpdateResponse contains the response from method DataSourcesClient.CreateOrUpdate.
type DataSourcesClientCreateOrUpdateResponse struct {
	// Datasources under OMS Workspace.
	DataSource
}

// DataSourcesClientDeleteResponse contains the response from method DataSourcesClient.Delete.
type DataSourcesClientDeleteResponse struct {
	// placeholder for future response values
}

// DataSourcesClientGetResponse contains the response from method DataSourcesClient.Get.
type DataSourcesClientGetResponse struct {
	// Datasources under OMS Workspace.
	DataSource
}

// DataSourcesClientListByWorkspaceResponse contains the response from method DataSourcesClient.NewListByWorkspacePager.
type DataSourcesClientListByWorkspaceResponse struct {
	// The list data source by workspace operation response.
	DataSourceListResult
}

// DeletedWorkspacesClientListByResourceGroupResponse contains the response from method DeletedWorkspacesClient.NewListByResourceGroupPager.
type DeletedWorkspacesClientListByResourceGroupResponse struct {
	// The list workspaces operation response.
	WorkspaceListResult
}

// DeletedWorkspacesClientListResponse contains the response from method DeletedWorkspacesClient.NewListPager.
type DeletedWorkspacesClientListResponse struct {
	// The list workspaces operation response.
	WorkspaceListResult
}

// GatewaysClientDeleteResponse contains the response from method GatewaysClient.Delete.
type GatewaysClientDeleteResponse struct {
	// placeholder for future response values
}

// IntelligencePacksClientDisableResponse contains the response from method IntelligencePacksClient.Disable.
type IntelligencePacksClientDisableResponse struct {
	// placeholder for future response values
}

// IntelligencePacksClientEnableResponse contains the response from method IntelligencePacksClient.Enable.
type IntelligencePacksClientEnableResponse struct {
	// placeholder for future response values
}

// IntelligencePacksClientListResponse contains the response from method IntelligencePacksClient.List.
type IntelligencePacksClientListResponse struct {
	// Array of IntelligencePack
	IntelligencePackArray []*IntelligencePack
}

// LinkedServicesClientCreateOrUpdateResponse contains the response from method LinkedServicesClient.BeginCreateOrUpdate.
type LinkedServicesClientCreateOrUpdateResponse struct {
	// The top level Linked service resource container.
	LinkedService
}

// LinkedServicesClientDeleteResponse contains the response from method LinkedServicesClient.BeginDelete.
type LinkedServicesClientDeleteResponse struct {
	// The top level Linked service resource container.
	LinkedService
}

// LinkedServicesClientGetResponse contains the response from method LinkedServicesClient.Get.
type LinkedServicesClientGetResponse struct {
	// The top level Linked service resource container.
	LinkedService
}

// LinkedServicesClientListByWorkspaceResponse contains the response from method LinkedServicesClient.NewListByWorkspacePager.
type LinkedServicesClientListByWorkspaceResponse struct {
	// The list linked service operation response.
	LinkedServiceListResult
}

// LinkedStorageAccountsClientCreateOrUpdateResponse contains the response from method LinkedStorageAccountsClient.CreateOrUpdate.
type LinkedStorageAccountsClientCreateOrUpdateResponse struct {
	// Linked storage accounts top level resource container.
	LinkedStorageAccountsResource
}

// LinkedStorageAccountsClientDeleteResponse contains the response from method LinkedStorageAccountsClient.Delete.
type LinkedStorageAccountsClientDeleteResponse struct {
	// placeholder for future response values
}

// LinkedStorageAccountsClientGetResponse contains the response from method LinkedStorageAccountsClient.Get.
type LinkedStorageAccountsClientGetResponse struct {
	// Linked storage accounts top level resource container.
	LinkedStorageAccountsResource
}

// LinkedStorageAccountsClientListByWorkspaceResponse contains the response from method LinkedStorageAccountsClient.NewListByWorkspacePager.
type LinkedStorageAccountsClientListByWorkspaceResponse struct {
	// The list linked storage accounts service operation response.
	LinkedStorageAccountsListResult
}

// ManagementGroupsClientListResponse contains the response from method ManagementGroupsClient.NewListPager.
type ManagementGroupsClientListResponse struct {
	// The list workspace management groups operation response.
	WorkspaceListManagementGroupsResult
}

// OperationStatusesClientGetResponse contains the response from method OperationStatusesClient.Get.
type OperationStatusesClientGetResponse struct {
	// The status of operation.
	OperationStatus
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list solution operations.
	OperationListResult
}

// QueriesClientDeleteResponse contains the response from method QueriesClient.Delete.
type QueriesClientDeleteResponse struct {
	// placeholder for future response values
}

// QueriesClientGetResponse contains the response from method QueriesClient.Get.
type QueriesClientGetResponse struct {
	// A Log Analytics QueryPack-Query definition.
	LogAnalyticsQueryPackQuery
}

// QueriesClientListResponse contains the response from method QueriesClient.NewListPager.
type QueriesClientListResponse struct {
	// Describes the list of Log Analytics QueryPack-Query resources.
	LogAnalyticsQueryPackQueryListResult
}

// QueriesClientPutResponse contains the response from method QueriesClient.Put.
type QueriesClientPutResponse struct {
	// A Log Analytics QueryPack-Query definition.
	LogAnalyticsQueryPackQuery
}

// QueriesClientSearchResponse contains the response from method QueriesClient.NewSearchPager.
type QueriesClientSearchResponse struct {
	// Describes the list of Log Analytics QueryPack-Query resources.
	LogAnalyticsQueryPackQueryListResult
}

// QueriesClientUpdateResponse contains the response from method QueriesClient.Update.
type QueriesClientUpdateResponse struct {
	// A Log Analytics QueryPack-Query definition.
	LogAnalyticsQueryPackQuery
}

// QueryPacksClientCreateOrUpdateResponse contains the response from method QueryPacksClient.CreateOrUpdate.
type QueryPacksClientCreateOrUpdateResponse struct {
	// An Log Analytics QueryPack definition.
	LogAnalyticsQueryPack
}

// QueryPacksClientCreateOrUpdateWithoutNameResponse contains the response from method QueryPacksClient.CreateOrUpdateWithoutName.
type QueryPacksClientCreateOrUpdateWithoutNameResponse struct {
	// An Log Analytics QueryPack definition.
	LogAnalyticsQueryPack
}

// QueryPacksClientDeleteResponse contains the response from method QueryPacksClient.Delete.
type QueryPacksClientDeleteResponse struct {
	// placeholder for future response values
}

// QueryPacksClientGetResponse contains the response from method QueryPacksClient.Get.
type QueryPacksClientGetResponse struct {
	// An Log Analytics QueryPack definition.
	LogAnalyticsQueryPack
}

// QueryPacksClientListByResourceGroupResponse contains the response from method QueryPacksClient.NewListByResourceGroupPager.
type QueryPacksClientListByResourceGroupResponse struct {
	// Describes the list of Log Analytics QueryPack resources.
	LogAnalyticsQueryPackListResult
}

// QueryPacksClientListResponse contains the response from method QueryPacksClient.NewListPager.
type QueryPacksClientListResponse struct {
	// Describes the list of Log Analytics QueryPack resources.
	LogAnalyticsQueryPackListResult
}

// QueryPacksClientUpdateTagsResponse contains the response from method QueryPacksClient.UpdateTags.
type QueryPacksClientUpdateTagsResponse struct {
	// An Log Analytics QueryPack definition.
	LogAnalyticsQueryPack
}

// SavedSearchesClientCreateOrUpdateResponse contains the response from method SavedSearchesClient.CreateOrUpdate.
type SavedSearchesClientCreateOrUpdateResponse struct {
	// Value object for saved search results.
	SavedSearch
}

// SavedSearchesClientDeleteResponse contains the response from method SavedSearchesClient.Delete.
type SavedSearchesClientDeleteResponse struct {
	// placeholder for future response values
}

// SavedSearchesClientGetResponse contains the response from method SavedSearchesClient.Get.
type SavedSearchesClientGetResponse struct {
	// Value object for saved search results.
	SavedSearch
}

// SavedSearchesClientListByWorkspaceResponse contains the response from method SavedSearchesClient.ListByWorkspace.
type SavedSearchesClientListByWorkspaceResponse struct {
	// The saved search list operation response.
	SavedSearchesListResult
}

// SchemaClientGetResponse contains the response from method SchemaClient.Get.
type SchemaClientGetResponse struct {
	// The get schema operation response.
	SearchGetSchemaResponse
}

// SharedKeysClientGetSharedKeysResponse contains the response from method SharedKeysClient.GetSharedKeys.
type SharedKeysClientGetSharedKeysResponse struct {
	// The shared keys for a workspace.
	SharedKeys
}

// SharedKeysClientRegenerateResponse contains the response from method SharedKeysClient.Regenerate.
type SharedKeysClientRegenerateResponse struct {
	// The shared keys for a workspace.
	SharedKeys
}

// StorageInsightConfigsClientCreateOrUpdateResponse contains the response from method StorageInsightConfigsClient.CreateOrUpdate.
type StorageInsightConfigsClientCreateOrUpdateResponse struct {
	// The top level storage insight resource container.
	StorageInsight
}

// StorageInsightConfigsClientDeleteResponse contains the response from method StorageInsightConfigsClient.Delete.
type StorageInsightConfigsClientDeleteResponse struct {
	// placeholder for future response values
}

// StorageInsightConfigsClientGetResponse contains the response from method StorageInsightConfigsClient.Get.
type StorageInsightConfigsClientGetResponse struct {
	// The top level storage insight resource container.
	StorageInsight
}

// StorageInsightConfigsClientListByWorkspaceResponse contains the response from method StorageInsightConfigsClient.NewListByWorkspacePager.
type StorageInsightConfigsClientListByWorkspaceResponse struct {
	// The list storage insights operation response.
	StorageInsightListResult
}

// TablesClientCreateOrUpdateResponse contains the response from method TablesClient.BeginCreateOrUpdate.
type TablesClientCreateOrUpdateResponse struct {
	// Workspace data table definition.
	Table
}

// TablesClientDeleteResponse contains the response from method TablesClient.BeginDelete.
type TablesClientDeleteResponse struct {
	// placeholder for future response values
}

// TablesClientGetResponse contains the response from method TablesClient.Get.
type TablesClientGetResponse struct {
	// Workspace data table definition.
	Table
}

// TablesClientListByWorkspaceResponse contains the response from method TablesClient.NewListByWorkspacePager.
type TablesClientListByWorkspaceResponse struct {
	// The list tables operation response.
	TablesListResult
}

// TablesClientMigrateResponse contains the response from method TablesClient.Migrate.
type TablesClientMigrateResponse struct {
	// placeholder for future response values
}

// TablesClientUpdateResponse contains the response from method TablesClient.BeginUpdate.
type TablesClientUpdateResponse struct {
	// Workspace data table definition.
	Table
}

// UsagesClientListResponse contains the response from method UsagesClient.NewListPager.
type UsagesClientListResponse struct {
	// The list workspace usages operation response.
	WorkspaceListUsagesResult
}

// WorkspacePurgeClientGetPurgeStatusResponse contains the response from method WorkspacePurgeClient.GetPurgeStatus.
type WorkspacePurgeClientGetPurgeStatusResponse struct {
	// Response containing status for a specific purge operation.
	WorkspacePurgeStatusResponse
}

// WorkspacePurgeClientPurgeResponse contains the response from method WorkspacePurgeClient.Purge.
type WorkspacePurgeClientPurgeResponse struct {
	// Response containing operationId for a specific purge action.
	WorkspacePurgeResponse

	// XMSStatusLocation contains the information returned from the x-ms-status-location header response.
	XMSStatusLocation *string
}

// WorkspacesClientCreateOrUpdateResponse contains the response from method WorkspacesClient.BeginCreateOrUpdate.
type WorkspacesClientCreateOrUpdateResponse struct {
	// The top level Workspace resource container.
	Workspace
}

// WorkspacesClientDeleteResponse contains the response from method WorkspacesClient.BeginDelete.
type WorkspacesClientDeleteResponse struct {
	// placeholder for future response values
}

// WorkspacesClientGetResponse contains the response from method WorkspacesClient.Get.
type WorkspacesClientGetResponse struct {
	// The top level Workspace resource container.
	Workspace
}

// WorkspacesClientListByResourceGroupResponse contains the response from method WorkspacesClient.NewListByResourceGroupPager.
type WorkspacesClientListByResourceGroupResponse struct {
	// The list workspaces operation response.
	WorkspaceListResult
}

// WorkspacesClientListResponse contains the response from method WorkspacesClient.NewListPager.
type WorkspacesClientListResponse struct {
	// The list workspaces operation response.
	WorkspaceListResult
}

// WorkspacesClientUpdateResponse contains the response from method WorkspacesClient.Update.
type WorkspacesClientUpdateResponse struct {
	// The top level Workspace resource container.
	Workspace
}
