//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armoracledatabase_test

import (
	"context"
	"log"

	"time"

	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/oracledatabase/armoracledatabase"
)

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_listBySubscription.json
func ExampleAutonomousDatabasesClient_NewListBySubscriptionPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewAutonomousDatabasesClient().NewListBySubscriptionPager(nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.AutonomousDatabaseListResult = armoracledatabase.AutonomousDatabaseListResult{
		// 	Value: []*armoracledatabase.AutonomousDatabase{
		// 		{
		// 			Type: to.Ptr("Oracle.Database/autonomousDatabases"),
		// 			ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
		// 			Location: to.Ptr("eastus"),
		// 			Tags: map[string]*string{
		// 				"tagK1": to.Ptr("tagV1"),
		// 			},
		// 			Properties: &armoracledatabase.AutonomousDatabaseProperties{
		// 				AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
		// 				AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
		// 				CharacterSet: to.Ptr("AL32UTF8"),
		// 				ComputeCount: to.Ptr[float32](2),
		// 				ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
		// 				CPUCoreCount: to.Ptr[int32](1),
		// 				DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
		// 				DataStorageSizeInGbs: to.Ptr[int32](1024),
		// 				DataStorageSizeInTbs: to.Ptr[int32](1),
		// 				DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
		// 				DbVersion: to.Ptr("18.4.0.0"),
		// 				DisplayName: to.Ptr("example_autonomous_databasedb1"),
		// 				IsAutoScalingEnabled: to.Ptr(false),
		// 				IsAutoScalingForStorageEnabled: to.Ptr(false),
		// 				IsLocalDataGuardEnabled: to.Ptr(false),
		// 				IsMtlsConnectionRequired: to.Ptr(true),
		// 				LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
		// 				LifecycleDetails: to.Ptr("success"),
		// 				LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
		// 				NcharacterSet: to.Ptr("AL16UTF16"),
		// 				OciURL: to.Ptr("https://fake"),
		// 				Ocid: to.Ptr("ocid1..aaaaa"),
		// 				ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
		// 				SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
		// 				TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
		// 				VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
		// 				WhitelistedIPs: []*string{
		// 					to.Ptr("1.1.1.1"),
		// 					to.Ptr("1.1.1.0/24"),
		// 					to.Ptr("1.1.2.25")},
		// 				},
		// 		}},
		// 	}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_listByResourceGroup.json
func ExampleAutonomousDatabasesClient_NewListByResourceGroupPager() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	pager := clientFactory.NewAutonomousDatabasesClient().NewListByResourceGroupPager("rg000", nil)
	for pager.More() {
		page, err := pager.NextPage(ctx)
		if err != nil {
			log.Fatalf("failed to advance page: %v", err)
		}
		for _, v := range page.Value {
			// You could use page here. We use blank identifier for just demo purposes.
			_ = v
		}
		// If the HTTP response code is 200 as defined in example definition, your page structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
		// page.AutonomousDatabaseListResult = armoracledatabase.AutonomousDatabaseListResult{
		// 	Value: []*armoracledatabase.AutonomousDatabase{
		// 		{
		// 			Type: to.Ptr("Oracle.Database/autonomousDatabases"),
		// 			ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
		// 			Location: to.Ptr("eastus"),
		// 			Tags: map[string]*string{
		// 				"tagK1": to.Ptr("tagV1"),
		// 			},
		// 			Properties: &armoracledatabase.AutonomousDatabaseProperties{
		// 				AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
		// 				AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
		// 				CharacterSet: to.Ptr("AL32UTF8"),
		// 				ComputeCount: to.Ptr[float32](2),
		// 				ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
		// 				CPUCoreCount: to.Ptr[int32](1),
		// 				DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
		// 				DataStorageSizeInGbs: to.Ptr[int32](1024),
		// 				DataStorageSizeInTbs: to.Ptr[int32](1),
		// 				DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
		// 				DbVersion: to.Ptr("18.4.0.0"),
		// 				DisplayName: to.Ptr("example_autonomous_databasedb1"),
		// 				IsAutoScalingEnabled: to.Ptr(false),
		// 				IsAutoScalingForStorageEnabled: to.Ptr(false),
		// 				IsLocalDataGuardEnabled: to.Ptr(false),
		// 				IsMtlsConnectionRequired: to.Ptr(true),
		// 				LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
		// 				LifecycleDetails: to.Ptr("success"),
		// 				LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
		// 				NcharacterSet: to.Ptr("AL16UTF16"),
		// 				OciURL: to.Ptr("https://fake"),
		// 				Ocid: to.Ptr("ocid1..aaaaa"),
		// 				ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
		// 				SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
		// 				TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
		// 				VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
		// 				WhitelistedIPs: []*string{
		// 					to.Ptr("1.1.1.1"),
		// 					to.Ptr("1.1.1.0/24"),
		// 					to.Ptr("1.1.2.25")},
		// 				},
		// 		}},
		// 	}
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_get.json
func ExampleAutonomousDatabasesClient_Get_autonomousDatabasesGet() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewAutonomousDatabasesClient().Get(ctx, "rg000", "databasedb1", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr("success"),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_create.json
func ExampleAutonomousDatabasesClient_BeginCreateOrUpdate_autonomousDatabasesCreateOrUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginCreateOrUpdate(ctx, "rg000", "databasedb1", armoracledatabase.AutonomousDatabase{
		Location: to.Ptr("eastus"),
		Tags: map[string]*string{
			"tagK1": to.Ptr("tagV1"),
		},
		Properties: &armoracledatabase.AutonomousDatabaseProperties{
			AdminPassword:        to.Ptr("********"),
			CharacterSet:         to.Ptr("AL32UTF8"),
			ComputeCount:         to.Ptr[float32](2),
			ComputeModel:         to.Ptr(armoracledatabase.ComputeModelECPU),
			DataBaseType:         to.Ptr(armoracledatabase.DataBaseTypeRegular),
			DataStorageSizeInTbs: to.Ptr[int32](1),
			DbVersion:            to.Ptr("18.4.0.0"),
			DisplayName:          to.Ptr("example_autonomous_databasedb1"),
			NcharacterSet:        to.Ptr("AL16UTF16"),
			SubnetID:             to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
			VnetID:               to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr("success"),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabaseClone_create.json
func ExampleAutonomousDatabasesClient_BeginCreateOrUpdate_autonomousDatabasesCreateOrUpdateClone() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginCreateOrUpdate(ctx, "rg000", "databasedb1", armoracledatabase.AutonomousDatabase{
		Location: to.Ptr("eastus"),
		Tags: map[string]*string{
			"tagK1": to.Ptr("tagV1"),
		},
		Properties: &armoracledatabase.AutonomousDatabaseCloneProperties{
			AdminPassword:        to.Ptr("********"),
			CharacterSet:         to.Ptr("AL32UTF8"),
			ComputeCount:         to.Ptr[float32](2),
			ComputeModel:         to.Ptr(armoracledatabase.ComputeModelECPU),
			DataBaseType:         to.Ptr(armoracledatabase.DataBaseTypeClone),
			DataStorageSizeInTbs: to.Ptr[int32](1),
			DisplayName:          to.Ptr("example_autonomous_databasedb1_clone"),
			NcharacterSet:        to.Ptr("AL16UTF16"),
			SubnetID:             to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
			VnetID:               to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
			CloneType:            to.Ptr(armoracledatabase.CloneTypeFull),
			SourceID:             to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
		},
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseCloneProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1Clone"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeClone),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr("success"),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 			CloneType: to.Ptr(armoracledatabase.CloneTypeFull),
	// 			SourceID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_patch.json
func ExampleAutonomousDatabasesClient_BeginUpdate() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginUpdate(ctx, "rg000", "databasedb1", armoracledatabase.AutonomousDatabaseUpdate{}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr("success"),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleState("Succeeded")),
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_delete.json
func ExampleAutonomousDatabasesClient_BeginDelete() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginDelete(ctx, "rg000", "databasedb1", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	_, err = poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_failover.json
func ExampleAutonomousDatabasesClient_BeginFailover_autonomousDatabasesFailover() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginFailover(ctx, "rg000", "databasedb1", armoracledatabase.PeerDbDetails{
		PeerDbID: to.Ptr("peerDbId"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(true),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateUpdating),
	// 		LocalAdgAutoFailoverMaxDataLossLimit: to.Ptr[int32](300),
	// 		LocalDisasterRecoveryType: to.Ptr(armoracledatabase.DisasterRecoveryTypeAdg),
	// 		LocalStandbyDb: &armoracledatabase.AutonomousDatabaseStandbySummary{
	// 			LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateRoleChangeInProgress),
	// 		},
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		Role: to.Ptr(armoracledatabase.RoleTypePrimary),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		TimeLocalDataGuardEnabled: to.Ptr("2024-02-28T19:03:43.714Z"),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_generateWallet.json
func ExampleAutonomousDatabasesClient_GenerateWallet() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	res, err := clientFactory.NewAutonomousDatabasesClient().GenerateWallet(ctx, "rg000", "databasedb1", armoracledatabase.GenerateAutonomousDatabaseWalletDetails{
		GenerateType: to.Ptr(armoracledatabase.GenerateTypeSingle),
		IsRegional:   to.Ptr(false),
		Password:     to.Ptr("********"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabaseWalletFile = armoracledatabase.AutonomousDatabaseWalletFile{
	// 	WalletFiles: to.Ptr("testEncodedFiles"),
	// }
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_restore.json
func ExampleAutonomousDatabasesClient_BeginRestore_autonomousDatabasesRestore() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginRestore(ctx, "rg000", "databasedb1", armoracledatabase.RestoreAutonomousDatabaseDetails{
		Timestamp: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-04-23T00:00:00.000Z"); return t }()),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		BackupRetentionPeriodInDays: to.Ptr[int32](60),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr(""),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateRestoreInProgress),
	// 		LongTermBackupSchedule: &armoracledatabase.LongTermBackUpScheduleDetails{
	// 			RepeatCadence: to.Ptr(armoracledatabase.RepeatCadenceTypeWeekly),
	// 			RetentionPeriodInDays: to.Ptr[int32](365),
	// 			TimeOfBackup: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-04-21T21:03:41.309Z"); return t}()),
	// 		},
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		NextLongTermBackupTimeStamp: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-04-24T21:03:41.000Z"); return t}()),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_shrink.json
func ExampleAutonomousDatabasesClient_BeginShrink() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginShrink(ctx, "rg000", "databasedb1", nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		BackupRetentionPeriodInDays: to.Ptr[int32](90),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleDetails: to.Ptr(""),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateScaleInProgress),
	// 		LongTermBackupSchedule: &armoracledatabase.LongTermBackUpScheduleDetails{
	// 			RepeatCadence: to.Ptr(armoracledatabase.RepeatCadenceTypeWeekly),
	// 			RetentionPeriodInDays: to.Ptr[int32](365),
	// 			TimeOfBackup: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-04-21T21:03:41.309Z"); return t}()),
	// 		},
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		NextLongTermBackupTimeStamp: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-04-24T21:03:41.000Z"); return t}()),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}

// Generated from example definition: https://github.com/Azure/azure-rest-api-specs/blob/1c63635d66ae38cff18045ab416a6572d3e15f6e/specification/oracle/resource-manager/Oracle.Database/stable/2023-09-01/examples/autonomousDatabase_switchover.json
func ExampleAutonomousDatabasesClient_BeginSwitchover_autonomousDatabasesSwitchover() {
	cred, err := azidentity.NewDefaultAzureCredential(nil)
	if err != nil {
		log.Fatalf("failed to obtain a credential: %v", err)
	}
	ctx := context.Background()
	clientFactory, err := armoracledatabase.NewClientFactory("<subscription-id>", cred, nil)
	if err != nil {
		log.Fatalf("failed to create client: %v", err)
	}
	poller, err := clientFactory.NewAutonomousDatabasesClient().BeginSwitchover(ctx, "rg000", "databasedb1", armoracledatabase.PeerDbDetails{
		PeerDbID: to.Ptr("peerDbId"),
	}, nil)
	if err != nil {
		log.Fatalf("failed to finish the request: %v", err)
	}
	res, err := poller.PollUntilDone(ctx, nil)
	if err != nil {
		log.Fatalf("failed to pull the result: %v", err)
	}
	// You could use response here. We use blank identifier for just demo purposes.
	_ = res
	// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
	// res.AutonomousDatabase = armoracledatabase.AutonomousDatabase{
	// 	Type: to.Ptr("Oracle.Database/autonomousDatabases"),
	// 	ID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 	Location: to.Ptr("eastus"),
	// 	Tags: map[string]*string{
	// 		"tagK1": to.Ptr("tagV1"),
	// 	},
	// 	Properties: &armoracledatabase.AutonomousDatabaseProperties{
	// 		AutonomousDatabaseID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Oracle.Database/autonomousDatabases/databasedb1"),
	// 		AutonomousMaintenanceScheduleType: to.Ptr(armoracledatabase.AutonomousMaintenanceScheduleTypeRegular),
	// 		CharacterSet: to.Ptr("AL32UTF8"),
	// 		ComputeCount: to.Ptr[float32](2),
	// 		ComputeModel: to.Ptr(armoracledatabase.ComputeModelECPU),
	// 		CPUCoreCount: to.Ptr[int32](1),
	// 		DataBaseType: to.Ptr(armoracledatabase.DataBaseTypeRegular),
	// 		DataStorageSizeInGbs: to.Ptr[int32](1024),
	// 		DataStorageSizeInTbs: to.Ptr[int32](1),
	// 		DatabaseEdition: to.Ptr(armoracledatabase.DatabaseEditionTypeEnterpriseEdition),
	// 		DbVersion: to.Ptr("18.4.0.0"),
	// 		DisplayName: to.Ptr("example_autonomous_databasedb1"),
	// 		IsAutoScalingEnabled: to.Ptr(false),
	// 		IsAutoScalingForStorageEnabled: to.Ptr(false),
	// 		IsLocalDataGuardEnabled: to.Ptr(false),
	// 		IsMtlsConnectionRequired: to.Ptr(true),
	// 		LicenseModel: to.Ptr(armoracledatabase.LicenseModelBringYourOwnLicense),
	// 		LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateUpdating),
	// 		LocalDisasterRecoveryType: to.Ptr(armoracledatabase.DisasterRecoveryTypeBackupBased),
	// 		LocalStandbyDb: &armoracledatabase.AutonomousDatabaseStandbySummary{
	// 			LifecycleState: to.Ptr(armoracledatabase.AutonomousDatabaseLifecycleStateRoleChangeInProgress),
	// 		},
	// 		NcharacterSet: to.Ptr("AL16UTF16"),
	// 		OciURL: to.Ptr("https://fake"),
	// 		Ocid: to.Ptr("ocid1..aaaaa"),
	// 		ProvisioningState: to.Ptr(armoracledatabase.AzureResourceProvisioningStateSucceeded),
	// 		Role: to.Ptr(armoracledatabase.RoleTypePrimary),
	// 		SubnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1/subnets/subnet1"),
	// 		TimeCreated: to.Ptr(func() time.Time { t, _ := time.Parse(time.RFC3339Nano, "2024-01-09T20:44:09.466Z"); return t}()),
	// 		TimeOfLastSwitchover: to.Ptr("2024-02-27T18:37:08.069Z"),
	// 		VnetID: to.Ptr("/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg000/providers/Microsoft.Network/virtualNetworks/vnet1"),
	// 		WhitelistedIPs: []*string{
	// 			to.Ptr("1.1.1.1"),
	// 			to.Ptr("1.1.1.0/24"),
	// 			to.Ptr("1.1.2.25")},
	// 		},
	// 	}
}
