//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/portal/armportal"
	"net/http"
)

// ListTenantConfigurationViolationsServer is a fake server for instances of the armportal.ListTenantConfigurationViolationsClient type.
type ListTenantConfigurationViolationsServer struct {
	// NewListPager is the fake for method ListTenantConfigurationViolationsClient.NewListPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListPager func(options *armportal.ListTenantConfigurationViolationsClientListOptions) (resp azfake.PagerResponder[armportal.ListTenantConfigurationViolationsClientListResponse])
}

// NewListTenantConfigurationViolationsServerTransport creates a new instance of ListTenantConfigurationViolationsServerTransport with the provided implementation.
// The returned ListTenantConfigurationViolationsServerTransport instance is connected to an instance of armportal.ListTenantConfigurationViolationsClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewListTenantConfigurationViolationsServerTransport(srv *ListTenantConfigurationViolationsServer) *ListTenantConfigurationViolationsServerTransport {
	return &ListTenantConfigurationViolationsServerTransport{
		srv:          srv,
		newListPager: newTracker[azfake.PagerResponder[armportal.ListTenantConfigurationViolationsClientListResponse]](),
	}
}

// ListTenantConfigurationViolationsServerTransport connects instances of armportal.ListTenantConfigurationViolationsClient to instances of ListTenantConfigurationViolationsServer.
// Don't use this type directly, use NewListTenantConfigurationViolationsServerTransport instead.
type ListTenantConfigurationViolationsServerTransport struct {
	srv          *ListTenantConfigurationViolationsServer
	newListPager *tracker[azfake.PagerResponder[armportal.ListTenantConfigurationViolationsClientListResponse]]
}

// Do implements the policy.Transporter interface for ListTenantConfigurationViolationsServerTransport.
func (l *ListTenantConfigurationViolationsServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "ListTenantConfigurationViolationsClient.NewListPager":
		resp, err = l.dispatchNewListPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (l *ListTenantConfigurationViolationsServerTransport) dispatchNewListPager(req *http.Request) (*http.Response, error) {
	if l.srv.NewListPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListPager not implemented")}
	}
	newListPager := l.newListPager.get(req)
	if newListPager == nil {
		resp := l.srv.NewListPager(nil)
		newListPager = &resp
		l.newListPager.add(req, newListPager)
		server.PagerResponderInjectNextLinks(newListPager, req, func(page *armportal.ListTenantConfigurationViolationsClientListResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		l.newListPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListPager) {
		l.newListPager.remove(req)
	}
	return resp, nil
}
