//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armrecoveryservicesdatareplication

// AzureSiteRecoveryManagementServiceAPIClientCheckNameAvailabilityOptions contains the optional parameters for the AzureSiteRecoveryManagementServiceAPIClient.CheckNameAvailability
// method.
type AzureSiteRecoveryManagementServiceAPIClientCheckNameAvailabilityOptions struct {
	// Resource details.
	Body *CheckNameAvailabilityModel
}

// AzureSiteRecoveryManagementServiceAPIClientDeploymentPreflightOptions contains the optional parameters for the AzureSiteRecoveryManagementServiceAPIClient.DeploymentPreflight
// method.
type AzureSiteRecoveryManagementServiceAPIClientDeploymentPreflightOptions struct {
	// Deployment preflight model.
	Body *DeploymentPreflightModel
}

// DraClientBeginCreateOptions contains the optional parameters for the DraClient.BeginCreate method.
type DraClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DraClientBeginDeleteOptions contains the optional parameters for the DraClient.BeginDelete method.
type DraClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// DraClientGetOptions contains the optional parameters for the DraClient.Get method.
type DraClientGetOptions struct {
	// placeholder for future optional parameters
}

// DraClientListOptions contains the optional parameters for the DraClient.NewListPager method.
type DraClientListOptions struct {
	// placeholder for future optional parameters
}

// DraOperationStatusClientGetOptions contains the optional parameters for the DraOperationStatusClient.Get method.
type DraOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// EmailConfigurationClientCreateOptions contains the optional parameters for the EmailConfigurationClient.Create method.
type EmailConfigurationClientCreateOptions struct {
	// placeholder for future optional parameters
}

// EmailConfigurationClientGetOptions contains the optional parameters for the EmailConfigurationClient.Get method.
type EmailConfigurationClientGetOptions struct {
	// placeholder for future optional parameters
}

// EmailConfigurationClientListOptions contains the optional parameters for the EmailConfigurationClient.NewListPager method.
type EmailConfigurationClientListOptions struct {
	// placeholder for future optional parameters
}

// EventClientGetOptions contains the optional parameters for the EventClient.Get method.
type EventClientGetOptions struct {
	// placeholder for future optional parameters
}

// EventClientListOptions contains the optional parameters for the EventClient.NewListPager method.
type EventClientListOptions struct {
	// Continuation token.
	ContinuationToken *string

	// Filter string.
	Filter *string
}

// FabricClientBeginCreateOptions contains the optional parameters for the FabricClient.BeginCreate method.
type FabricClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// FabricClientBeginDeleteOptions contains the optional parameters for the FabricClient.BeginDelete method.
type FabricClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// FabricClientBeginUpdateOptions contains the optional parameters for the FabricClient.BeginUpdate method.
type FabricClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// FabricClientGetOptions contains the optional parameters for the FabricClient.Get method.
type FabricClientGetOptions struct {
	// placeholder for future optional parameters
}

// FabricClientListBySubscriptionOptions contains the optional parameters for the FabricClient.NewListBySubscriptionPager
// method.
type FabricClientListBySubscriptionOptions struct {
	// Continuation token from the previous call.
	ContinuationToken *string
}

// FabricClientListOptions contains the optional parameters for the FabricClient.NewListPager method.
type FabricClientListOptions struct {
	// Continuation token from the previous call.
	ContinuationToken *string
}

// FabricOperationsStatusClientGetOptions contains the optional parameters for the FabricOperationsStatusClient.Get method.
type FabricOperationsStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// PolicyClientBeginCreateOptions contains the optional parameters for the PolicyClient.BeginCreate method.
type PolicyClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PolicyClientBeginDeleteOptions contains the optional parameters for the PolicyClient.BeginDelete method.
type PolicyClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PolicyClientGetOptions contains the optional parameters for the PolicyClient.Get method.
type PolicyClientGetOptions struct {
	// placeholder for future optional parameters
}

// PolicyClientListOptions contains the optional parameters for the PolicyClient.NewListPager method.
type PolicyClientListOptions struct {
	// placeholder for future optional parameters
}

// PolicyOperationStatusClientGetOptions contains the optional parameters for the PolicyOperationStatusClient.Get method.
type PolicyOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// ProtectedItemClientBeginCreateOptions contains the optional parameters for the ProtectedItemClient.BeginCreate method.
type ProtectedItemClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProtectedItemClientBeginDeleteOptions contains the optional parameters for the ProtectedItemClient.BeginDelete method.
type ProtectedItemClientBeginDeleteOptions struct {
	// A flag indicating whether to do force delete or not.
	ForceDelete *bool

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProtectedItemClientBeginPlannedFailoverOptions contains the optional parameters for the ProtectedItemClient.BeginPlannedFailover
// method.
type ProtectedItemClientBeginPlannedFailoverOptions struct {
	// Planned failover model.
	Body *PlannedFailoverModel

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProtectedItemClientGetOptions contains the optional parameters for the ProtectedItemClient.Get method.
type ProtectedItemClientGetOptions struct {
	// placeholder for future optional parameters
}

// ProtectedItemClientListOptions contains the optional parameters for the ProtectedItemClient.NewListPager method.
type ProtectedItemClientListOptions struct {
	// placeholder for future optional parameters
}

// ProtectedItemOperationStatusClientGetOptions contains the optional parameters for the ProtectedItemOperationStatusClient.Get
// method.
type ProtectedItemOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// RecoveryPointsClientGetOptions contains the optional parameters for the RecoveryPointsClient.Get method.
type RecoveryPointsClientGetOptions struct {
	// placeholder for future optional parameters
}

// RecoveryPointsClientListOptions contains the optional parameters for the RecoveryPointsClient.NewListPager method.
type RecoveryPointsClientListOptions struct {
	// placeholder for future optional parameters
}

// ReplicationExtensionClientBeginCreateOptions contains the optional parameters for the ReplicationExtensionClient.BeginCreate
// method.
type ReplicationExtensionClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ReplicationExtensionClientBeginDeleteOptions contains the optional parameters for the ReplicationExtensionClient.BeginDelete
// method.
type ReplicationExtensionClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ReplicationExtensionClientGetOptions contains the optional parameters for the ReplicationExtensionClient.Get method.
type ReplicationExtensionClientGetOptions struct {
	// placeholder for future optional parameters
}

// ReplicationExtensionClientListOptions contains the optional parameters for the ReplicationExtensionClient.NewListPager
// method.
type ReplicationExtensionClientListOptions struct {
	// placeholder for future optional parameters
}

// ReplicationExtensionOperationStatusClientGetOptions contains the optional parameters for the ReplicationExtensionOperationStatusClient.Get
// method.
type ReplicationExtensionOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// VaultClientBeginCreateOptions contains the optional parameters for the VaultClient.BeginCreate method.
type VaultClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VaultClientBeginDeleteOptions contains the optional parameters for the VaultClient.BeginDelete method.
type VaultClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VaultClientBeginUpdateOptions contains the optional parameters for the VaultClient.BeginUpdate method.
type VaultClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// VaultClientGetOptions contains the optional parameters for the VaultClient.Get method.
type VaultClientGetOptions struct {
	// placeholder for future optional parameters
}

// VaultClientListBySubscriptionOptions contains the optional parameters for the VaultClient.NewListBySubscriptionPager method.
type VaultClientListBySubscriptionOptions struct {
	// Continuation token from the previous call.
	ContinuationToken *string
}

// VaultClientListOptions contains the optional parameters for the VaultClient.NewListPager method.
type VaultClientListOptions struct {
	// Continuation token from the previous call.
	ContinuationToken *string
}

// VaultOperationStatusClientGetOptions contains the optional parameters for the VaultOperationStatusClient.Get method.
type VaultOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// WorkflowClientGetOptions contains the optional parameters for the WorkflowClient.Get method.
type WorkflowClientGetOptions struct {
	// placeholder for future optional parameters
}

// WorkflowClientListOptions contains the optional parameters for the WorkflowClient.NewListPager method.
type WorkflowClientListOptions struct {
	// Continuation token.
	ContinuationToken *string

	// Filter string.
	Filter *string
}

// WorkflowOperationStatusClientGetOptions contains the optional parameters for the WorkflowOperationStatusClient.Get method.
type WorkflowOperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}
