# Release History

## 0.14.0 (2024-04-04)
### Breaking Changes

- Function `*ContactsClient.Create` parameter(s) have been changed from `(context.Context, string, Contact, *ContactsClientCreateOptions)` to `(context.Context, SecurityContactName, Contact, *ContactsClientCreateOptions)`
- Function `*ContactsClient.Delete` parameter(s) have been changed from `(context.Context, string, *ContactsClientDeleteOptions)` to `(context.Context, SecurityContactName, *ContactsClientDeleteOptions)`
- Function `*ContactsClient.Get` parameter(s) have been changed from `(context.Context, string, *ContactsClientGetOptions)` to `(context.Context, SecurityContactName, *ContactsClientGetOptions)`
- Type of `ContactPropertiesNotificationsByRole.Roles` has been changed from `[]*Roles` to `[]*SecurityContactRole`
- Type of `DefenderCspmAwsOfferingVMScanners.Configuration` has been changed from `*DefenderCspmAwsOfferingVMScannersConfiguration` to `*VMScannersBaseConfiguration`
- Type of `DefenderCspmGcpOfferingVMScanners.Configuration` has been changed from `*DefenderCspmGcpOfferingVMScannersConfiguration` to `*VMScannersBaseConfiguration`
- Type of `DefenderFoDatabasesAwsOfferingArcAutoProvisioning.Configuration` has been changed from `*DefenderFoDatabasesAwsOfferingArcAutoProvisioningConfiguration` to `*ArcAutoProvisioningConfiguration`
- Type of `DefenderForDatabasesGcpOfferingArcAutoProvisioning.Configuration` has been changed from `*DefenderForDatabasesGcpOfferingArcAutoProvisioningConfiguration` to `*ArcAutoProvisioningConfiguration`
- Type of `DefenderForServersAwsOfferingArcAutoProvisioning.Configuration` has been changed from `*DefenderForServersAwsOfferingArcAutoProvisioningConfiguration` to `*ArcAutoProvisioningConfiguration`
- Type of `DefenderForServersAwsOfferingVMScanners.Configuration` has been changed from `*DefenderForServersAwsOfferingVMScannersConfiguration` to `*VMScannersBaseConfiguration`
- Type of `DefenderForServersGcpOfferingArcAutoProvisioning.Configuration` has been changed from `*DefenderForServersGcpOfferingArcAutoProvisioningConfiguration` to `*ArcAutoProvisioningConfiguration`
- Type of `DefenderForServersGcpOfferingVMScanners.Configuration` has been changed from `*DefenderForServersGcpOfferingVMScannersConfiguration` to `*VMScannersBaseConfiguration`
- `OfferingTypeDefenderForDevOpsAzureDevOps`, `OfferingTypeDefenderForDevOpsGitLab`, `OfferingTypeDefenderForDevOpsGithub`, `OfferingTypeInformationProtectionAws` from enum `OfferingType` has been removed
- Enum `Roles` has been removed
- Function `NewCenterClient` has been removed
- Function `*CenterClient.GetSensitivitySettings` has been removed
- Function `*CenterClient.UpdateSensitivitySettings` has been removed
- Function `*ClientFactory.NewCenterClient` has been removed
- Function `*DefenderForDevOpsAzureDevOpsOffering.GetCloudOffering` has been removed
- Function `*DefenderForDevOpsGitLabOffering.GetCloudOffering` has been removed
- Function `*DefenderForDevOpsGithubOffering.GetCloudOffering` has been removed
- Function `*InformationProtectionAwsOffering.GetCloudOffering` has been removed
- Struct `ContactPropertiesAlertNotifications` has been removed
- Struct `DefenderCspmAwsOfferingVMScannersConfiguration` has been removed
- Struct `DefenderCspmGcpOfferingVMScannersConfiguration` has been removed
- Struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioningConfiguration` has been removed
- Struct `DefenderForContainersAwsOfferingContainerVulnerabilityAssessment` has been removed
- Struct `DefenderForContainersAwsOfferingContainerVulnerabilityAssessmentTask` has been removed
- Struct `DefenderForContainersAwsOfferingKubernetesScubaReader` has been removed
- Struct `DefenderForDatabasesGcpOfferingArcAutoProvisioningConfiguration` has been removed
- Struct `DefenderForDevOpsAzureDevOpsOffering` has been removed
- Struct `DefenderForDevOpsGitLabOffering` has been removed
- Struct `DefenderForDevOpsGithubOffering` has been removed
- Struct `DefenderForServersAwsOfferingArcAutoProvisioningConfiguration` has been removed
- Struct `DefenderForServersAwsOfferingVMScannersConfiguration` has been removed
- Struct `DefenderForServersGcpOfferingArcAutoProvisioningConfiguration` has been removed
- Struct `DefenderForServersGcpOfferingVMScannersConfiguration` has been removed
- Struct `InformationProtectionAwsOffering` has been removed
- Struct `InformationProtectionAwsOfferingInformationProtection` has been removed
- Field `AlertNotifications` of struct `ContactProperties` has been removed
- Field `AutoProvisioning`, `ContainerVulnerabilityAssessment`, `ContainerVulnerabilityAssessmentTask`, `EnableContainerVulnerabilityAssessment`, `KubernetesScubaReader`, `ScubaExternalID` of struct `DefenderForContainersAwsOffering` has been removed
- Field `AuditLogsAutoProvisioningFlag`, `DefenderAgentAutoProvisioningFlag`, `PolicyAgentAutoProvisioningFlag` of struct `DefenderForContainersGcpOffering` has been removed

### Features Added

- New value `EventSourceAttackPaths`, `EventSourceAttackPathsSnapshot` added to enum type `EventSource`
- New enum type `MinimalRiskLevel` with values `MinimalRiskLevelCritical`, `MinimalRiskLevelHigh`, `MinimalRiskLevelLow`, `MinimalRiskLevelMedium`
- New enum type `SecurityContactName` with values `SecurityContactNameDefault`
- New enum type `SecurityContactRole` with values `SecurityContactRoleAccountAdmin`, `SecurityContactRoleContributor`, `SecurityContactRoleOwner`, `SecurityContactRoleServiceAdmin`
- New enum type `SourceType` with values `SourceTypeAlert`, `SourceTypeAttackPath`
- New function `*AutomationsClient.Update(context.Context, string, string, AutomationUpdateModel, *AutomationsClientUpdateOptions) (AutomationsClientUpdateResponse, error)`
- New function `*SensitivitySettingsClient.CreateOrUpdate(context.Context, UpdateSensitivitySettingsRequest, *SensitivitySettingsClientCreateOrUpdateOptions) (SensitivitySettingsClientCreateOrUpdateResponse, error)`
- New function `*SensitivitySettingsClient.Get(context.Context, *SensitivitySettingsClientGetOptions) (SensitivitySettingsClientGetResponse, error)`
- New function `*NotificationsSource.GetNotificationsSource() *NotificationsSource`
- New function `*NotificationsSourceAlert.GetNotificationsSource() *NotificationsSource`
- New function `*NotificationsSourceAttackPath.GetNotificationsSource() *NotificationsSource`
- New struct `ArcAutoProvisioning`
- New struct `ArcAutoProvisioningAws`
- New struct `ArcAutoProvisioningConfiguration`
- New struct `ArcAutoProvisioningGcp`
- New struct `AutomationUpdateModel`
- New struct `DefenderForContainersAwsOfferingKubernetesDataCollection`
- New struct `DefenderForContainersAwsOfferingVMScanners`
- New struct `DefenderForContainersGcpOfferingVMScanners`
- New struct `NotificationsSourceAlert`
- New struct `NotificationsSourceAttackPath`
- New struct `VMScannersAws`
- New struct `VMScannersBase`
- New struct `VMScannersBaseConfiguration`
- New struct `VMScannersGcp`
- New field `IsTrustedServiceEnabled` in struct `AutomationActionEventHub`
- New field `IsEnabled`, `NotificationsSources` in struct `ContactProperties`
- New field `CloudRoleArn` in struct `DefenderCspmAwsOfferingVMScanners`
- New field `DataCollectionExternalID`, `EnableAuditLogsAutoProvisioning`, `EnableDefenderAgentAutoProvisioning`, `EnablePolicyAgentAutoProvisioning`, `KubernetesDataCollection`, `VMScanners` in struct `DefenderForContainersAwsOffering`
- New field `EnableAuditLogsAutoProvisioning`, `EnableDefenderAgentAutoProvisioning`, `EnablePolicyAgentAutoProvisioning`, `VMScanners` in struct `DefenderForContainersGcpOffering`
- New field `CloudRoleArn` in struct `DefenderForServersAwsOfferingVMScanners`


## 0.13.0 (2024-03-08)
### Breaking Changes

- Function `*PricingsClient.Get` parameter(s) have been changed from `(context.Context, string, *PricingsClientGetOptions)` to `(context.Context, string, string, *PricingsClientGetOptions)`
- Function `*PricingsClient.List` parameter(s) have been changed from `(context.Context, *PricingsClientListOptions)` to `(context.Context, string, *PricingsClientListOptions)`
- Function `*PricingsClient.Update` parameter(s) have been changed from `(context.Context, string, Pricing, *PricingsClientUpdateOptions)` to `(context.Context, string, string, Pricing, *PricingsClientUpdateOptions)`
- Function `*SettingsClient.Get` parameter(s) have been changed from `(context.Context, SettingName, *SettingsClientGetOptions)` to `(context.Context, SettingNameAutoGenerated, *SettingsClientGetOptions)`
- Function `*SettingsClient.Update` parameter(s) have been changed from `(context.Context, SettingName, SettingClassification, *SettingsClientUpdateOptions)` to `(context.Context, SettingNameAutoGenerated, SettingClassification, *SettingsClientUpdateOptions)`
- Type of `Extension.OperationStatus` has been changed from `*OperationStatus` to `*OperationStatusAutoGenerated`
- Type of `HealthDataClassification.Scope` has been changed from `*ScopeName` to `*string`
- Type of `OperationStatus.Code` has been changed from `*Code` to `*string`
- `SettingNameMCAS`, `SettingNameSentinel`, `SettingNameWDATP`, `SettingNameWDATPEXCLUDELINUXPUBLICPREVIEW`, `SettingNameWDATPUNIFIEDSOLUTION` from enum `SettingName` has been removed
- Enum `ScopeName` has been removed
- Function `NewAPICollectionClient` has been removed
- Function `*APICollectionClient.Get` has been removed
- Function `*APICollectionClient.NewListPager` has been removed
- Function `NewAPICollectionOffboardingClient` has been removed
- Function `*APICollectionOffboardingClient.Delete` has been removed
- Function `NewAPICollectionOnboardingClient` has been removed
- Function `*APICollectionOnboardingClient.Create` has been removed
- Function `*ClientFactory.NewAPICollectionClient` has been removed
- Function `*ClientFactory.NewAPICollectionOffboardingClient` has been removed
- Function `*ClientFactory.NewAPICollectionOnboardingClient` has been removed
- Function `*ClientFactory.NewHealthReportClient` has been removed
- Function `*ClientFactory.NewIngestionSettingsClient` has been removed
- Function `NewHealthReportClient` has been removed
- Function `*HealthReportClient.Get` has been removed
- Function `NewIngestionSettingsClient` has been removed
- Function `*IngestionSettingsClient.Create` has been removed
- Function `*IngestionSettingsClient.Delete` has been removed
- Function `*IngestionSettingsClient.Get` has been removed
- Function `*IngestionSettingsClient.ListConnectionStrings` has been removed
- Function `*IngestionSettingsClient.NewListPager` has been removed
- Function `*IngestionSettingsClient.ListTokens` has been removed
- Struct `APICollectionResponse` has been removed
- Struct `APICollectionResponseList` has been removed
- Struct `ConnectionStrings` has been removed
- Struct `IngestionConnectionString` has been removed
- Struct `IngestionSetting` has been removed
- Struct `IngestionSettingList` has been removed
- Struct `IngestionSettingToken` has been removed
- Field `AdditionalData` of struct `APICollectionProperties` has been removed

### Features Added

- New value `SettingNameCurrent` added to enum type `SettingName`
- New enum type `ActionableRemediationState` with values `ActionableRemediationStateDisabled`, `ActionableRemediationStateEnabled`, `ActionableRemediationStateNone`
- New enum type `AnnotateDefaultBranchState` with values `AnnotateDefaultBranchStateDisabled`, `AnnotateDefaultBranchStateEnabled`
- New enum type `AutoDiscovery` with values `AutoDiscoveryDisabled`, `AutoDiscoveryEnabled`, `AutoDiscoveryNotApplicable`
- New enum type `DesiredOnboardingState` with values `DesiredOnboardingStateDisabled`, `DesiredOnboardingStateEnabled`
- New enum type `DevOpsProvisioningState` with values `DevOpsProvisioningStateCanceled`, `DevOpsProvisioningStateDeletionFailure`, `DevOpsProvisioningStateDeletionSuccess`, `DevOpsProvisioningStateFailed`, `DevOpsProvisioningStatePending`, `DevOpsProvisioningStatePendingDeletion`, `DevOpsProvisioningStateSucceeded`
- New enum type `Enforce` with values `EnforceFalse`, `EnforceTrue`
- New enum type `InheritFromParentState` with values `InheritFromParentStateDisabled`, `InheritFromParentStateEnabled`
- New enum type `Inherited` with values `InheritedFalse`, `InheritedTrue`
- New enum type `OnboardingState` with values `OnboardingStateNotApplicable`, `OnboardingStateNotOnboarded`, `OnboardingStateOnboarded`, `OnboardingStateOnboardedByOtherConnector`
- New enum type `ResourcesCoverageStatus` with values `ResourcesCoverageStatusFullyCovered`, `ResourcesCoverageStatusNotCovered`, `ResourcesCoverageStatusPartiallyCovered`
- New enum type `RuleCategory` with values `RuleCategoryArtifacts`, `RuleCategoryCode`, `RuleCategoryContainers`, `RuleCategoryDependencies`, `RuleCategoryIaC`, `RuleCategorySecrets`
- New enum type `ServerVulnerabilityAssessmentsAzureSettingSelectedProvider` with values `ServerVulnerabilityAssessmentsAzureSettingSelectedProviderMdeTvm`
- New enum type `ServerVulnerabilityAssessmentsSettingKind` with values `ServerVulnerabilityAssessmentsSettingKindAzureServersSetting`
- New enum type `ServerVulnerabilityAssessmentsSettingKindName` with values `ServerVulnerabilityAssessmentsSettingKindNameAzureServersSetting`
- New enum type `SettingNameAutoGenerated` with values `SettingNameAutoGeneratedMCAS`, `SettingNameAutoGeneratedSentinel`, `SettingNameAutoGeneratedWDATP`, `SettingNameAutoGeneratedWDATPEXCLUDELINUXPUBLICPREVIEW`, `SettingNameAutoGeneratedWDATPUNIFIEDSOLUTION`
- New function `NewAPICollectionsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*APICollectionsClient, error)`
- New function `*APICollectionsClient.GetByAzureAPIManagementService(context.Context, string, string, string, *APICollectionsClientGetByAzureAPIManagementServiceOptions) (APICollectionsClientGetByAzureAPIManagementServiceResponse, error)`
- New function `*APICollectionsClient.NewListByAzureAPIManagementServicePager(string, string, *APICollectionsClientListByAzureAPIManagementServiceOptions) *runtime.Pager[APICollectionsClientListByAzureAPIManagementServiceResponse]`
- New function `*APICollectionsClient.NewListByResourceGroupPager(string, *APICollectionsClientListByResourceGroupOptions) *runtime.Pager[APICollectionsClientListByResourceGroupResponse]`
- New function `*APICollectionsClient.NewListBySubscriptionPager(*APICollectionsClientListBySubscriptionOptions) *runtime.Pager[APICollectionsClientListBySubscriptionResponse]`
- New function `*APICollectionsClient.OffboardAzureAPIManagementAPI(context.Context, string, string, string, *APICollectionsClientOffboardAzureAPIManagementAPIOptions) (APICollectionsClientOffboardAzureAPIManagementAPIResponse, error)`
- New function `*APICollectionsClient.BeginOnboardAzureAPIManagementAPI(context.Context, string, string, string, *APICollectionsClientBeginOnboardAzureAPIManagementAPIOptions) (*runtime.Poller[APICollectionsClientOnboardAzureAPIManagementAPIResponse], error)`
- New function `NewAzureDevOpsOrgsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*AzureDevOpsOrgsClient, error)`
- New function `*AzureDevOpsOrgsClient.BeginCreateOrUpdate(context.Context, string, string, string, AzureDevOpsOrg, *AzureDevOpsOrgsClientBeginCreateOrUpdateOptions) (*runtime.Poller[AzureDevOpsOrgsClientCreateOrUpdateResponse], error)`
- New function `*AzureDevOpsOrgsClient.Get(context.Context, string, string, string, *AzureDevOpsOrgsClientGetOptions) (AzureDevOpsOrgsClientGetResponse, error)`
- New function `*AzureDevOpsOrgsClient.ListAvailable(context.Context, string, string, *AzureDevOpsOrgsClientListAvailableOptions) (AzureDevOpsOrgsClientListAvailableResponse, error)`
- New function `*AzureDevOpsOrgsClient.NewListPager(string, string, *AzureDevOpsOrgsClientListOptions) *runtime.Pager[AzureDevOpsOrgsClientListResponse]`
- New function `*AzureDevOpsOrgsClient.BeginUpdate(context.Context, string, string, string, AzureDevOpsOrg, *AzureDevOpsOrgsClientBeginUpdateOptions) (*runtime.Poller[AzureDevOpsOrgsClientUpdateResponse], error)`
- New function `NewAzureDevOpsProjectsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*AzureDevOpsProjectsClient, error)`
- New function `*AzureDevOpsProjectsClient.BeginCreateOrUpdate(context.Context, string, string, string, string, AzureDevOpsProject, *AzureDevOpsProjectsClientBeginCreateOrUpdateOptions) (*runtime.Poller[AzureDevOpsProjectsClientCreateOrUpdateResponse], error)`
- New function `*AzureDevOpsProjectsClient.Get(context.Context, string, string, string, string, *AzureDevOpsProjectsClientGetOptions) (AzureDevOpsProjectsClientGetResponse, error)`
- New function `*AzureDevOpsProjectsClient.NewListPager(string, string, string, *AzureDevOpsProjectsClientListOptions) *runtime.Pager[AzureDevOpsProjectsClientListResponse]`
- New function `*AzureDevOpsProjectsClient.BeginUpdate(context.Context, string, string, string, string, AzureDevOpsProject, *AzureDevOpsProjectsClientBeginUpdateOptions) (*runtime.Poller[AzureDevOpsProjectsClientUpdateResponse], error)`
- New function `NewAzureDevOpsReposClient(string, azcore.TokenCredential, *arm.ClientOptions) (*AzureDevOpsReposClient, error)`
- New function `*AzureDevOpsReposClient.BeginCreateOrUpdate(context.Context, string, string, string, string, string, AzureDevOpsRepository, *AzureDevOpsReposClientBeginCreateOrUpdateOptions) (*runtime.Poller[AzureDevOpsReposClientCreateOrUpdateResponse], error)`
- New function `*AzureDevOpsReposClient.Get(context.Context, string, string, string, string, string, *AzureDevOpsReposClientGetOptions) (AzureDevOpsReposClientGetResponse, error)`
- New function `*AzureDevOpsReposClient.NewListPager(string, string, string, string, *AzureDevOpsReposClientListOptions) *runtime.Pager[AzureDevOpsReposClientListResponse]`
- New function `*AzureDevOpsReposClient.BeginUpdate(context.Context, string, string, string, string, string, AzureDevOpsRepository, *AzureDevOpsReposClientBeginUpdateOptions) (*runtime.Poller[AzureDevOpsReposClientUpdateResponse], error)`
- New function `*AzureServersSetting.GetServerVulnerabilityAssessmentsSetting() *ServerVulnerabilityAssessmentsSetting`
- New function `*ClientFactory.NewAPICollectionsClient() *APICollectionsClient`
- New function `*ClientFactory.NewAzureDevOpsOrgsClient() *AzureDevOpsOrgsClient`
- New function `*ClientFactory.NewAzureDevOpsProjectsClient() *AzureDevOpsProjectsClient`
- New function `*ClientFactory.NewAzureDevOpsReposClient() *AzureDevOpsReposClient`
- New function `*ClientFactory.NewDefenderForStorageClient() *DefenderForStorageClient`
- New function `*ClientFactory.NewDevOpsConfigurationsClient() *DevOpsConfigurationsClient`
- New function `*ClientFactory.NewDevOpsOperationResultsClient() *DevOpsOperationResultsClient`
- New function `*ClientFactory.NewGitHubOwnersClient() *GitHubOwnersClient`
- New function `*ClientFactory.NewGitHubReposClient() *GitHubReposClient`
- New function `*ClientFactory.NewGitLabGroupsClient() *GitLabGroupsClient`
- New function `*ClientFactory.NewGitLabProjectsClient() *GitLabProjectsClient`
- New function `*ClientFactory.NewGitLabSubgroupsClient() *GitLabSubgroupsClient`
- New function `*ClientFactory.NewServerVulnerabilityAssessmentsSettingsClient() *ServerVulnerabilityAssessmentsSettingsClient`
- New function `NewDefenderForStorageClient(azcore.TokenCredential, *arm.ClientOptions) (*DefenderForStorageClient, error)`
- New function `*DefenderForStorageClient.Create(context.Context, string, SettingName, DefenderForStorageSetting, *DefenderForStorageClientCreateOptions) (DefenderForStorageClientCreateResponse, error)`
- New function `*DefenderForStorageClient.Get(context.Context, string, SettingName, *DefenderForStorageClientGetOptions) (DefenderForStorageClientGetResponse, error)`
- New function `NewDevOpsConfigurationsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*DevOpsConfigurationsClient, error)`
- New function `*DevOpsConfigurationsClient.BeginCreateOrUpdate(context.Context, string, string, DevOpsConfiguration, *DevOpsConfigurationsClientBeginCreateOrUpdateOptions) (*runtime.Poller[DevOpsConfigurationsClientCreateOrUpdateResponse], error)`
- New function `*DevOpsConfigurationsClient.BeginDelete(context.Context, string, string, *DevOpsConfigurationsClientBeginDeleteOptions) (*runtime.Poller[DevOpsConfigurationsClientDeleteResponse], error)`
- New function `*DevOpsConfigurationsClient.Get(context.Context, string, string, *DevOpsConfigurationsClientGetOptions) (DevOpsConfigurationsClientGetResponse, error)`
- New function `*DevOpsConfigurationsClient.NewListPager(string, string, *DevOpsConfigurationsClientListOptions) *runtime.Pager[DevOpsConfigurationsClientListResponse]`
- New function `*DevOpsConfigurationsClient.BeginUpdate(context.Context, string, string, DevOpsConfiguration, *DevOpsConfigurationsClientBeginUpdateOptions) (*runtime.Poller[DevOpsConfigurationsClientUpdateResponse], error)`
- New function `NewDevOpsOperationResultsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*DevOpsOperationResultsClient, error)`
- New function `*DevOpsOperationResultsClient.Get(context.Context, string, string, string, *DevOpsOperationResultsClientGetOptions) (DevOpsOperationResultsClientGetResponse, error)`
- New function `NewGitHubOwnersClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GitHubOwnersClient, error)`
- New function `*GitHubOwnersClient.Get(context.Context, string, string, string, *GitHubOwnersClientGetOptions) (GitHubOwnersClientGetResponse, error)`
- New function `*GitHubOwnersClient.ListAvailable(context.Context, string, string, *GitHubOwnersClientListAvailableOptions) (GitHubOwnersClientListAvailableResponse, error)`
- New function `*GitHubOwnersClient.NewListPager(string, string, *GitHubOwnersClientListOptions) *runtime.Pager[GitHubOwnersClientListResponse]`
- New function `NewGitHubReposClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GitHubReposClient, error)`
- New function `*GitHubReposClient.Get(context.Context, string, string, string, string, *GitHubReposClientGetOptions) (GitHubReposClientGetResponse, error)`
- New function `*GitHubReposClient.NewListPager(string, string, string, *GitHubReposClientListOptions) *runtime.Pager[GitHubReposClientListResponse]`
- New function `NewGitLabGroupsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GitLabGroupsClient, error)`
- New function `*GitLabGroupsClient.Get(context.Context, string, string, string, *GitLabGroupsClientGetOptions) (GitLabGroupsClientGetResponse, error)`
- New function `*GitLabGroupsClient.ListAvailable(context.Context, string, string, *GitLabGroupsClientListAvailableOptions) (GitLabGroupsClientListAvailableResponse, error)`
- New function `*GitLabGroupsClient.NewListPager(string, string, *GitLabGroupsClientListOptions) *runtime.Pager[GitLabGroupsClientListResponse]`
- New function `NewGitLabProjectsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GitLabProjectsClient, error)`
- New function `*GitLabProjectsClient.Get(context.Context, string, string, string, string, *GitLabProjectsClientGetOptions) (GitLabProjectsClientGetResponse, error)`
- New function `*GitLabProjectsClient.NewListPager(string, string, string, *GitLabProjectsClientListOptions) *runtime.Pager[GitLabProjectsClientListResponse]`
- New function `NewGitLabSubgroupsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GitLabSubgroupsClient, error)`
- New function `*GitLabSubgroupsClient.List(context.Context, string, string, string, *GitLabSubgroupsClientListOptions) (GitLabSubgroupsClientListResponse, error)`
- New function `*HealthReportsClient.Get(context.Context, string, string, *HealthReportsClientGetOptions) (HealthReportsClientGetResponse, error)`
- New function `*PricingsClient.Delete(context.Context, string, string, *PricingsClientDeleteOptions) (PricingsClientDeleteResponse, error)`
- New function `*ServerVulnerabilityAssessmentsSetting.GetServerVulnerabilityAssessmentsSetting() *ServerVulnerabilityAssessmentsSetting`
- New function `NewServerVulnerabilityAssessmentsSettingsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ServerVulnerabilityAssessmentsSettingsClient, error)`
- New function `*ServerVulnerabilityAssessmentsSettingsClient.CreateOrUpdate(context.Context, ServerVulnerabilityAssessmentsSettingKindName, ServerVulnerabilityAssessmentsSettingClassification, *ServerVulnerabilityAssessmentsSettingsClientCreateOrUpdateOptions) (ServerVulnerabilityAssessmentsSettingsClientCreateOrUpdateResponse, error)`
- New function `*ServerVulnerabilityAssessmentsSettingsClient.Delete(context.Context, ServerVulnerabilityAssessmentsSettingKindName, *ServerVulnerabilityAssessmentsSettingsClientDeleteOptions) (ServerVulnerabilityAssessmentsSettingsClientDeleteResponse, error)`
- New function `*ServerVulnerabilityAssessmentsSettingsClient.Get(context.Context, ServerVulnerabilityAssessmentsSettingKindName, *ServerVulnerabilityAssessmentsSettingsClientGetOptions) (ServerVulnerabilityAssessmentsSettingsClientGetResponse, error)`
- New function `*ServerVulnerabilityAssessmentsSettingsClient.NewListBySubscriptionPager(*ServerVulnerabilityAssessmentsSettingsClientListBySubscriptionOptions) *runtime.Pager[ServerVulnerabilityAssessmentsSettingsClientListBySubscriptionResponse]`
- New struct `APICollection`
- New struct `APICollectionList`
- New struct `ActionableRemediation`
- New struct `Authorization`
- New struct `AzureDevOpsOrg`
- New struct `AzureDevOpsOrgListResponse`
- New struct `AzureDevOpsOrgProperties`
- New struct `AzureDevOpsOrganizationConfiguration`
- New struct `AzureDevOpsProject`
- New struct `AzureDevOpsProjectConfiguration`
- New struct `AzureDevOpsProjectListResponse`
- New struct `AzureDevOpsProjectProperties`
- New struct `AzureDevOpsRepository`
- New struct `AzureDevOpsRepositoryListResponse`
- New struct `AzureDevOpsRepositoryProperties`
- New struct `AzureServersSetting`
- New struct `BaseResourceConfiguration`
- New struct `CategoryConfiguration`
- New struct `DefenderCspmAwsOfferingCiem`
- New struct `DefenderCspmAwsOfferingCiemDiscovery`
- New struct `DefenderCspmAwsOfferingCiemOidc`
- New struct `DefenderCspmAwsOfferingMdcContainersAgentlessDiscoveryK8S`
- New struct `DefenderCspmAwsOfferingMdcContainersImageAssessment`
- New struct `DefenderCspmGcpOfferingCiemDiscovery`
- New struct `DefenderCspmGcpOfferingDataSensitivityDiscovery`
- New struct `DefenderCspmGcpOfferingMdcContainersAgentlessDiscoveryK8S`
- New struct `DefenderCspmGcpOfferingMdcContainersImageAssessment`
- New struct `DefenderCspmGcpOfferingVMScanners`
- New struct `DefenderCspmGcpOfferingVMScannersConfiguration`
- New struct `DefenderForContainersAwsOfferingMdcContainersAgentlessDiscoveryK8S`
- New struct `DefenderForContainersAwsOfferingMdcContainersImageAssessment`
- New struct `DefenderForContainersGcpOfferingMdcContainersAgentlessDiscoveryK8S`
- New struct `DefenderForContainersGcpOfferingMdcContainersImageAssessment`
- New struct `DefenderForStorageSetting`
- New struct `DefenderForStorageSettingProperties`
- New struct `DevOpsConfiguration`
- New struct `DevOpsConfigurationListResponse`
- New struct `DevOpsConfigurationProperties`
- New struct `GitHubOwner`
- New struct `GitHubOwnerConfiguration`
- New struct `GitHubOwnerListResponse`
- New struct `GitHubOwnerProperties`
- New struct `GitHubRepository`
- New struct `GitHubRepositoryListResponse`
- New struct `GitHubRepositoryProperties`
- New struct `GitLabGroup`
- New struct `GitLabGroupConfiguration`
- New struct `GitLabGroupListResponse`
- New struct `GitLabGroupProperties`
- New struct `GitLabProject`
- New struct `GitLabProjectListResponse`
- New struct `GitLabProjectProperties`
- New struct `MalwareScanningProperties`
- New struct `OnUploadProperties`
- New struct `OperationStatusAutoGenerated`
- New struct `OperationStatusResult`
- New struct `ProxyResource`
- New struct `ResourceAutoGenerated`
- New struct `ResourceAutoGenerated2`
- New struct `SensitiveDataDiscoveryProperties`
- New struct `ServerVulnerabilityAssessmentsAzureSettingProperties`
- New struct `ServerVulnerabilityAssessmentsSettingsList`
- New struct `TargetBranchConfiguration`
- New field `BaseURL`, `DiscoveredVia`, `NumberOfAPIEndpoints`, `NumberOfAPIEndpointsWithSensitiveDataExposed`, `NumberOfExternalAPIEndpoints`, `NumberOfInactiveAPIEndpoints`, `NumberOfUnauthenticatedAPIEndpoints`, `ProvisioningState`, `SensitivityLabel` in struct `APICollectionProperties`
- New field `ScanInterval` in struct `AwsEnvironmentData`
- New field `Ciem`, `MdcContainersAgentlessDiscoveryK8S`, `MdcContainersImageAssessment` in struct `DefenderCspmAwsOffering`
- New field `CiemDiscovery`, `DataSensitivityDiscovery`, `MdcContainersAgentlessDiscoveryK8S`, `MdcContainersImageAssessment`, `VMScanners` in struct `DefenderCspmGcpOffering`
- New field `MdcContainersAgentlessDiscoveryK8S`, `MdcContainersImageAssessment` in struct `DefenderForContainersAwsOffering`
- New field `MdcContainersAgentlessDiscoveryK8S`, `MdcContainersImageAssessment` in struct `DefenderForContainersGcpOffering`
- New field `ScanInterval` in struct `GcpProjectEnvironmentData`
- New field `AffectedDefendersSubPlans`, `ReportAdditionalData` in struct `HealthReportProperties`
- New field `Enforce`, `Inherited`, `InheritedFrom`, `ResourcesCoverageStatus` in struct `PricingProperties`
- New field `Filter` in struct `PricingsClientListOptions`
- New field `LastScannedDate`, `Reason` in struct `StatusAutoGenerated`


## 0.12.0 (2023-11-30)
### Breaking Changes

- Type of `ExternalSecuritySolutionList.Value` has been changed from `[]*ExternalSecuritySolution` to `[]ExternalSecuritySolutionClassification`
- Struct `ExternalSecuritySolutionKindAutoGenerated` has been removed
- Field `ExternalSecuritySolution` of struct `ExternalSecuritySolutionsClientGetResponse` has been removed

### Features Added

- Support for test fakes and OpenTelemetry trace spans.
- New function `*AADExternalSecuritySolution.GetExternalSecuritySolution() *ExternalSecuritySolution`
- New function `*AtaExternalSecuritySolution.GetExternalSecuritySolution() *ExternalSecuritySolution`
- New function `*CefExternalSecuritySolution.GetExternalSecuritySolution() *ExternalSecuritySolution`
- New function `*ExternalSecuritySolution.GetExternalSecuritySolution() *ExternalSecuritySolution`
- New anonymous field `ExternalSecuritySolutionClassification` in struct `ExternalSecuritySolutionsClientGetResponse`


## 0.11.0 (2023-04-28)
### Breaking Changes

- Function `NewGovernanceRulesClient` parameter(s) have been changed from `(string, azcore.TokenCredential, *arm.ClientOptions)` to `(azcore.TokenCredential, *arm.ClientOptions)`
- Function `*GovernanceRulesClient.CreateOrUpdate` parameter(s) have been changed from `(context.Context, string, GovernanceRule, *GovernanceRulesClientCreateOrUpdateOptions)` to `(context.Context, string, string, GovernanceRule, *GovernanceRulesClientCreateOrUpdateOptions)`
- Function `*GovernanceRulesClient.Get` parameter(s) have been changed from `(context.Context, string, *GovernanceRulesClientGetOptions)` to `(context.Context, string, string, *GovernanceRulesClientGetOptions)`
- Function `*ClientFactory.NewConnectorGovernanceRuleClient` has been removed
- Function `*ClientFactory.NewConnectorGovernanceRulesClient` has been removed
- Function `*ClientFactory.NewConnectorGovernanceRulesExecuteStatusClient` has been removed
- Function `*ClientFactory.NewGovernanceRuleClient` has been removed
- Function `*ClientFactory.NewSubscriptionGovernanceRulesExecuteStatusClient` has been removed
- Function `NewConnectorGovernanceRuleClient` has been removed
- Function `*ConnectorGovernanceRuleClient.NewListPager` has been removed
- Function `NewConnectorGovernanceRulesClient` has been removed
- Function `*ConnectorGovernanceRulesClient.CreateOrUpdate` has been removed
- Function `*ConnectorGovernanceRulesClient.Delete` has been removed
- Function `*ConnectorGovernanceRulesClient.Get` has been removed
- Function `NewConnectorGovernanceRulesExecuteStatusClient` has been removed
- Function `*ConnectorGovernanceRulesExecuteStatusClient.BeginGet` has been removed
- Function `NewGovernanceRuleClient` has been removed
- Function `*GovernanceRuleClient.NewListPager` has been removed
- Function `*GovernanceRulesClient.BeginRuleIDExecuteSingleSecurityConnector` has been removed
- Function `*GovernanceRulesClient.BeginRuleIDExecuteSingleSubscription` has been removed
- Function `NewSubscriptionGovernanceRulesExecuteStatusClient` has been removed
- Function `*SubscriptionGovernanceRulesExecuteStatusClient.BeginGet` has been removed
- Operation `*GovernanceRulesClient.Delete` has been changed to LRO, use `*GovernanceRulesClient.BeginDelete` instead.
- Struct `ExecuteRuleStatus` has been removed

### Features Added

- New value `CloudNameGitLab` added to enum type `CloudName`
- New value `EnvironmentTypeGitlabScope` added to enum type `EnvironmentType`
- New value `OfferingTypeCspmMonitorGitLab`, `OfferingTypeDefenderForDevOpsGitLab` added to enum type `OfferingType`
- New enum type `Code` with values `CodeFailed`, `CodeSucceeded`
- New enum type `IsEnabled` with values `IsEnabledFalse`, `IsEnabledTrue`
- New enum type `MipIntegrationStatus` with values `MipIntegrationStatusNoAutoLabelingRules`, `MipIntegrationStatusNoConsent`, `MipIntegrationStatusNoMipLabels`, `MipIntegrationStatusOk`
- New enum type `OperationResult` with values `OperationResultCanceled`, `OperationResultFailed`, `OperationResultSucceeded`
- New enum type `ScopeName` with values `ScopeNameClusters`, `ScopeNameConnectors`, `ScopeNameUnknown`, `ScopeNameVirtualMachines`
- New enum type `StatusName` with values `StatusNameHealthy`, `StatusNameNotApplicable`, `StatusNameNotHealthy`
- New function `NewAPICollectionClient(string, azcore.TokenCredential, *arm.ClientOptions) (*APICollectionClient, error)`
- New function `*APICollectionClient.Get(context.Context, string, string, string, *APICollectionClientGetOptions) (APICollectionClientGetResponse, error)`
- New function `*APICollectionClient.NewListPager(string, string, *APICollectionClientListOptions) *runtime.Pager[APICollectionClientListResponse]`
- New function `NewAPICollectionOffboardingClient(string, azcore.TokenCredential, *arm.ClientOptions) (*APICollectionOffboardingClient, error)`
- New function `*APICollectionOffboardingClient.Delete(context.Context, string, string, string, *APICollectionOffboardingClientDeleteOptions) (APICollectionOffboardingClientDeleteResponse, error)`
- New function `NewAPICollectionOnboardingClient(string, azcore.TokenCredential, *arm.ClientOptions) (*APICollectionOnboardingClient, error)`
- New function `*APICollectionOnboardingClient.Create(context.Context, string, string, string, *APICollectionOnboardingClientCreateOptions) (APICollectionOnboardingClientCreateResponse, error)`
- New function `NewCenterClient(azcore.TokenCredential, *arm.ClientOptions) (*CenterClient, error)`
- New function `*CenterClient.GetSensitivitySettings(context.Context, *CenterClientGetSensitivitySettingsOptions) (CenterClientGetSensitivitySettingsResponse, error)`
- New function `*CenterClient.UpdateSensitivitySettings(context.Context, UpdateSensitivitySettingsRequest, *CenterClientUpdateSensitivitySettingsOptions) (CenterClientUpdateSensitivitySettingsResponse, error)`
- New function `*ClientFactory.NewAPICollectionClient() *APICollectionClient`
- New function `*ClientFactory.NewAPICollectionOffboardingClient() *APICollectionOffboardingClient`
- New function `*ClientFactory.NewAPICollectionOnboardingClient() *APICollectionOnboardingClient`
- New function `*ClientFactory.NewCenterClient() *CenterClient`
- New function `*ClientFactory.NewHealthReportClient() *HealthReportClient`
- New function `*ClientFactory.NewHealthReportsClient() *HealthReportsClient`
- New function `*ClientFactory.NewOperatorsClient() *OperatorsClient`
- New function `*ClientFactory.NewSensitivitySettingsClient() *SensitivitySettingsClient`
- New function `*CspmMonitorGitLabOffering.GetCloudOffering() *CloudOffering`
- New function `*DefenderForDevOpsGitLabOffering.GetCloudOffering() *CloudOffering`
- New function `*GitlabScopeEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `*GovernanceRulesClient.BeginExecute(context.Context, string, string, *GovernanceRulesClientBeginExecuteOptions) (*runtime.Poller[GovernanceRulesClientExecuteResponse], error)`
- New function `*GovernanceRulesClient.NewListPager(string, *GovernanceRulesClientListOptions) *runtime.Pager[GovernanceRulesClientListResponse]`
- New function `*GovernanceRulesClient.OperationResults(context.Context, string, string, string, *GovernanceRulesClientOperationResultsOptions) (GovernanceRulesClientOperationResultsResponse, error)`
- New function `NewHealthReportClient(azcore.TokenCredential, *arm.ClientOptions) (*HealthReportClient, error)`
- New function `*HealthReportClient.Get(context.Context, string, string, *HealthReportClientGetOptions) (HealthReportClientGetResponse, error)`
- New function `NewHealthReportsClient(azcore.TokenCredential, *arm.ClientOptions) (*HealthReportsClient, error)`
- New function `*HealthReportsClient.NewListPager(string, *HealthReportsClientListOptions) *runtime.Pager[HealthReportsClientListResponse]`
- New function `NewOperatorsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*OperatorsClient, error)`
- New function `*OperatorsClient.CreateOrUpdate(context.Context, string, string, *OperatorsClientCreateOrUpdateOptions) (OperatorsClientCreateOrUpdateResponse, error)`
- New function `*OperatorsClient.Delete(context.Context, string, string, *OperatorsClientDeleteOptions) (OperatorsClientDeleteResponse, error)`
- New function `*OperatorsClient.Get(context.Context, string, string, *OperatorsClientGetOptions) (OperatorsClientGetResponse, error)`
- New function `*OperatorsClient.List(context.Context, string, *OperatorsClientListOptions) (OperatorsClientListResponse, error)`
- New function `NewSensitivitySettingsClient(azcore.TokenCredential, *arm.ClientOptions) (*SensitivitySettingsClient, error)`
- New function `*SensitivitySettingsClient.List(context.Context, *SensitivitySettingsClientListOptions) (SensitivitySettingsClientListResponse, error)`
- New struct `APICollectionProperties`
- New struct `APICollectionResponse`
- New struct `APICollectionResponseList`
- New struct `BuiltInInfoType`
- New struct `CspmMonitorGitLabOffering`
- New struct `DefenderCspmAwsOfferingDataSensitivityDiscovery`
- New struct `DefenderCspmAwsOfferingDatabasesDspm`
- New struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderFoDatabasesAwsOfferingDatabasesDspm`
- New struct `DefenderForDatabasesGcpOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderForDevOpsGitLabOffering`
- New struct `DefenderForServersAwsOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderForServersGcpOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderForServersGcpOfferingVMScanners`
- New struct `DefenderForServersGcpOfferingVMScannersConfiguration`
- New struct `EnvironmentDetails`
- New struct `ErrorDetail`
- New struct `ErrorDetailAutoGenerated`
- New struct `ErrorResponse`
- New struct `ErrorResponseAutoGenerated`
- New struct `Extension`
- New struct `GetSensitivitySettingsListResponse`
- New struct `GetSensitivitySettingsResponse`
- New struct `GetSensitivitySettingsResponseProperties`
- New struct `GetSensitivitySettingsResponsePropertiesMipInformation`
- New struct `GitlabScopeEnvironmentData`
- New struct `GovernanceRuleMetadata`
- New struct `HealthDataClassification`
- New struct `HealthReport`
- New struct `HealthReportProperties`
- New struct `HealthReportsList`
- New struct `Identity`
- New struct `InfoType`
- New struct `Issue`
- New struct `Label`
- New struct `OperationResultAutoGenerated`
- New struct `OperationStatus`
- New struct `OperatorList`
- New struct `OperatorResource`
- New struct `ResourceDetailsAutoGenerated`
- New struct `StatusAutoGenerated`
- New struct `UpdateSensitivitySettingsRequest`
- New field `AccountName` in struct `AwsEnvironmentData`
- New field `Regions` in struct `AwsEnvironmentData`
- New field `DataSensitivityDiscovery` in struct `DefenderCspmAwsOffering`
- New field `DatabasesDspm` in struct `DefenderCspmAwsOffering`
- New field `DatabasesDspm` in struct `DefenderFoDatabasesAwsOffering`
- New field `Configuration` in struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioning`
- New field `Configuration` in struct `DefenderForDatabasesGcpOfferingArcAutoProvisioning`
- New field `Configuration` in struct `DefenderForServersAwsOfferingArcAutoProvisioning`
- New field `VMScanners` in struct `DefenderForServersGcpOffering`
- New field `Configuration` in struct `DefenderForServersGcpOfferingArcAutoProvisioning`
- New field `OrganizationName` in struct `GcpOrganizationalDataOrganization`
- New field `ProjectName` in struct `GcpProjectDetails`
- New field `ExcludedScopes` in struct `GovernanceRuleProperties`
- New field `IncludeMemberScopes` in struct `GovernanceRuleProperties`
- New field `Metadata` in struct `GovernanceRuleProperties`
- New field `TenantID` in struct `GovernanceRuleProperties`
- New field `EnablementTime` in struct `PricingProperties`
- New field `Extensions` in struct `PricingProperties`
- New field `LastScanTime` in struct `ScanProperties`


## 0.10.1 (2023-04-14)
### Bug Fixes

- Fix serialization bug of empty value of `any` type.


## 0.10.0 (2023-03-27)
### Features Added

- New struct `ClientFactory` which is a client factory used to create any client in this module


## 0.9.0 (2022-11-15)
### Breaking Changes

- Type of `DefenderForServersAwsOfferingVMScannersConfiguration.ExclusionTags` has been changed from `interface{}` to `map[string]*string`
- Type of `ContactProperties.AlertNotifications` has been changed from `*AlertNotifications` to `*ContactPropertiesAlertNotifications`
- Type alias `AlertsToAdmins` has been removed
- Type alias `AlertNotifications` has been removed
- Function `*AWSEnvironmentData.GetEnvironmentData` has been removed
- Function `*ContactsClient.Update` has been removed
- Struct `AWSEnvironmentData` has been removed
- Struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioningServicePrincipalSecretMetadata` has been removed
- Struct `DefenderForDatabasesGcpOfferingArcAutoProvisioningConfiguration` has been removed
- Struct `DefenderForServersAwsOfferingArcAutoProvisioningServicePrincipalSecretMetadata` has been removed
- Struct `DefenderForServersGcpOfferingArcAutoProvisioningConfiguration` has been removed
- Field `AlertsToAdmins` of struct `ContactProperties` has been removed
- Field `Email` of struct `ContactProperties` has been removed
- Field `ServicePrincipalSecretMetadata` of struct `DefenderForServersAwsOfferingArcAutoProvisioning` has been removed
- Field `Configuration` of struct `DefenderForDatabasesGcpOfferingArcAutoProvisioning` has been removed
- Field `Configuration` of struct `DefenderForServersGcpOfferingArcAutoProvisioning` has been removed
- Field `ServicePrincipalSecretMetadata` of struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioning` has been removed

### Features Added

- New const `OfferingTypeDefenderCspmAws`
- New const `OfferingTypeDefenderCspmGcp`
- New const `OfferingTypeDefenderForDevOpsGithub`
- New const `OfferingTypeDefenderForDevOpsAzureDevOps`
- New const `ApplicationConditionOperatorEquals`
- New type alias `MinimalSeverity`
- New type alias `Roles`
- New function `*AwsEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `*DefenderForDevOpsAzureDevOpsOffering.GetCloudOffering() *CloudOffering`
- New function `*DefenderForDevOpsGithubOffering.GetCloudOffering() *CloudOffering`
- New function `*DefenderCspmGcpOffering.GetCloudOffering() *CloudOffering`
- New function `*DefenderCspmAwsOffering.GetCloudOffering() *CloudOffering`
- New struct `AwsEnvironmentData`
- New struct `ContactPropertiesAlertNotifications`
- New struct `ContactPropertiesNotificationsByRole`
- New struct `DefenderCspmAwsOffering`
- New struct `DefenderCspmAwsOfferingVMScanners`
- New struct `DefenderCspmAwsOfferingVMScannersConfiguration`
- New struct `DefenderCspmGcpOffering`
- New struct `DefenderFoDatabasesAwsOfferingRds`
- New struct `DefenderForDevOpsAzureDevOpsOffering`
- New struct `DefenderForDevOpsGithubOffering`
- New field `Rds` in struct `DefenderFoDatabasesAwsOffering`
- New field `Emails` in struct `ContactProperties`
- New field `NotificationsByRole` in struct `ContactProperties`


## 0.8.0 (2022-09-13)
### Breaking Changes

- Function `*AlertsClient.Simulate` has been removed
- Struct `AlertsClientSimulateOptions` has been removed
- Struct `ConnectorPropertiesOrganizationalData` has been removed
- Field `OrganizationalData` of struct `ConnectorProperties` has been removed
- Field `CloudName` of struct `ConnectorProperties` has been removed

### Features Added

- New const `ApplicationConditionOperatorIn`
- New const `GovernanceRuleConditionOperatorEquals`
- New const `ApplicationSourceResourceTypeAssessments`
- New const `OfferingTypeDefenderForDatabasesAws`
- New const `TypeTVM`
- New const `GovernanceRuleConditionOperatorIn`
- New const `OfferingTypeDefenderForDatabasesGcp`
- New const `ScanningModeDefault`
- New const `OfferingTypeDefenderForContainersGcp`
- New const `OfferingTypeCspmMonitorAzureDevOps`
- New const `GovernanceRuleOwnerSourceTypeByTag`
- New const `EnvironmentTypeAwsAccount`
- New const `CloudNameAzureDevOps`
- New const `CloudNameGithub`
- New const `SubPlanP1`
- New const `EnvironmentTypeAzureDevOpsScope`
- New const `EnvironmentTypeGithubScope`
- New const `OfferingTypeCspmMonitorGcp`
- New const `GovernanceRuleOwnerSourceTypeManually`
- New const `OfferingTypeDefenderForServersGcp`
- New const `BundleTypeCosmosDbs`
- New const `OfferingTypeCspmMonitorGithub`
- New const `SettingNameWDATPUNIFIEDSOLUTION`
- New const `EnvironmentTypeGcpProject`
- New const `GovernanceRuleSourceResourceTypeAssessments`
- New const `ApplicationConditionOperatorContains`
- New const `GovernanceRuleTypeServiceNow`
- New const `GovernanceRuleTypeIntegrated`
- New const `SubPlanP2`
- New const `TypeQualys`
- New const `AlertStatusInProgress`
- New type alias `GovernanceRuleOwnerSourceType`
- New type alias `ApplicationConditionOperator`
- New type alias `Type`
- New type alias `GovernanceRuleSourceResourceType`
- New type alias `ScanningMode`
- New type alias `SubPlan`
- New type alias `ApplicationSourceResourceType`
- New type alias `EnvironmentType`
- New type alias `GovernanceRuleType`
- New type alias `GovernanceRuleConditionOperator`
- New function `*GovernanceRulesClient.CreateOrUpdate(context.Context, string, GovernanceRule, *GovernanceRulesClientCreateOrUpdateOptions) (GovernanceRulesClientCreateOrUpdateResponse, error)`
- New function `*GovernanceRulesClient.BeginRuleIDExecuteSingleSecurityConnector(context.Context, string, string, string, *GovernanceRulesClientBeginRuleIDExecuteSingleSecurityConnectorOptions) (*runtime.Poller[GovernanceRulesClientRuleIDExecuteSingleSecurityConnectorResponse], error)`
- New function `*ConnectorGovernanceRuleClient.NewListPager(string, string, *ConnectorGovernanceRuleClientListOptions) *runtime.Pager[ConnectorGovernanceRuleClientListResponse]`
- New function `*GovernanceRulesClient.Delete(context.Context, string, *GovernanceRulesClientDeleteOptions) (GovernanceRulesClientDeleteResponse, error)`
- New function `*ApplicationClient.Get(context.Context, string, *ApplicationClientGetOptions) (ApplicationClientGetResponse, error)`
- New function `NewConnectorGovernanceRulesExecuteStatusClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ConnectorGovernanceRulesExecuteStatusClient, error)`
- New function `*ConnectorApplicationClient.Delete(context.Context, string, string, string, *ConnectorApplicationClientDeleteOptions) (ConnectorApplicationClientDeleteResponse, error)`
- New function `*ApplicationsClient.NewListPager(*ApplicationsClientListOptions) *runtime.Pager[ApplicationsClientListResponse]`
- New function `*DefenderForContainersGcpOffering.GetCloudOffering() *CloudOffering`
- New function `*CspmMonitorGithubOffering.GetCloudOffering() *CloudOffering`
- New function `*DefenderForDatabasesGcpOffering.GetCloudOffering() *CloudOffering`
- New function `*AlertsClient.UpdateResourceGroupLevelStateToInProgress(context.Context, string, string, string, *AlertsClientUpdateResourceGroupLevelStateToInProgressOptions) (AlertsClientUpdateResourceGroupLevelStateToInProgressResponse, error)`
- New function `PossibleEnvironmentTypeValues() []EnvironmentType`
- New function `PossibleScanningModeValues() []ScanningMode`
- New function `*GcpOrganizationalData.GetGcpOrganizationalData() *GcpOrganizationalData`
- New function `*AWSEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `*ApplicationClient.Delete(context.Context, string, *ApplicationClientDeleteOptions) (ApplicationClientDeleteResponse, error)`
- New function `*GithubScopeEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `NewConnectorApplicationsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ConnectorApplicationsClient, error)`
- New function `NewSubscriptionGovernanceRulesExecuteStatusClient(string, azcore.TokenCredential, *arm.ClientOptions) (*SubscriptionGovernanceRulesExecuteStatusClient, error)`
- New function `*GovernanceRuleClient.NewListPager(*GovernanceRuleClientListOptions) *runtime.Pager[GovernanceRuleClientListResponse]`
- New function `*ConnectorGovernanceRulesClient.Get(context.Context, string, string, string, *ConnectorGovernanceRulesClientGetOptions) (ConnectorGovernanceRulesClientGetResponse, error)`
- New function `*AwsOrganizationalData.GetAwsOrganizationalData() *AwsOrganizationalData`
- New function `*GovernanceAssignmentsClient.NewListPager(string, string, *GovernanceAssignmentsClientListOptions) *runtime.Pager[GovernanceAssignmentsClientListResponse]`
- New function `*SubscriptionGovernanceRulesExecuteStatusClient.BeginGet(context.Context, string, string, *SubscriptionGovernanceRulesExecuteStatusClientBeginGetOptions) (*runtime.Poller[SubscriptionGovernanceRulesExecuteStatusClientGetResponse], error)`
- New function `*AwsOrganizationalDataMaster.GetAwsOrganizationalData() *AwsOrganizationalData`
- New function `*GcpOrganizationalDataMember.GetGcpOrganizationalData() *GcpOrganizationalData`
- New function `PossibleGovernanceRuleSourceResourceTypeValues() []GovernanceRuleSourceResourceType`
- New function `*ConnectorApplicationClient.Get(context.Context, string, string, string, *ConnectorApplicationClientGetOptions) (ConnectorApplicationClientGetResponse, error)`
- New function `*EnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `PossibleApplicationSourceResourceTypeValues() []ApplicationSourceResourceType`
- New function `PossibleGovernanceRuleTypeValues() []GovernanceRuleType`
- New function `PossibleTypeValues() []Type`
- New function `NewConnectorGovernanceRulesClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ConnectorGovernanceRulesClient, error)`
- New function `*CspmMonitorGcpOffering.GetCloudOffering() *CloudOffering`
- New function `PossibleApplicationConditionOperatorValues() []ApplicationConditionOperator`
- New function `*AlertsClient.UpdateSubscriptionLevelStateToInProgress(context.Context, string, string, *AlertsClientUpdateSubscriptionLevelStateToInProgressOptions) (AlertsClientUpdateSubscriptionLevelStateToInProgressResponse, error)`
- New function `NewConnectorApplicationClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ConnectorApplicationClient, error)`
- New function `*GovernanceRulesClient.BeginRuleIDExecuteSingleSubscription(context.Context, string, *GovernanceRulesClientBeginRuleIDExecuteSingleSubscriptionOptions) (*runtime.Poller[GovernanceRulesClientRuleIDExecuteSingleSubscriptionResponse], error)`
- New function `*GovernanceAssignmentsClient.CreateOrUpdate(context.Context, string, string, string, GovernanceAssignment, *GovernanceAssignmentsClientCreateOrUpdateOptions) (GovernanceAssignmentsClientCreateOrUpdateResponse, error)`
- New function `*ConnectorApplicationClient.CreateOrUpdate(context.Context, string, string, string, Application, *ConnectorApplicationClientCreateOrUpdateOptions) (ConnectorApplicationClientCreateOrUpdateResponse, error)`
- New function `PossibleGovernanceRuleConditionOperatorValues() []GovernanceRuleConditionOperator`
- New function `*GcpProjectEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `*ApplicationClient.CreateOrUpdate(context.Context, string, Application, *ApplicationClientCreateOrUpdateOptions) (ApplicationClientCreateOrUpdateResponse, error)`
- New function `PossibleGovernanceRuleOwnerSourceTypeValues() []GovernanceRuleOwnerSourceType`
- New function `*AzureDevOpsScopeEnvironmentData.GetEnvironmentData() *EnvironmentData`
- New function `NewConnectorGovernanceRuleClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ConnectorGovernanceRuleClient, error)`
- New function `*CspmMonitorAzureDevOpsOffering.GetCloudOffering() *CloudOffering`
- New function `NewApplicationsClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ApplicationsClient, error)`
- New function `*DefenderFoDatabasesAwsOffering.GetCloudOffering() *CloudOffering`
- New function `*ConnectorGovernanceRulesClient.CreateOrUpdate(context.Context, string, string, string, GovernanceRule, *ConnectorGovernanceRulesClientCreateOrUpdateOptions) (ConnectorGovernanceRulesClientCreateOrUpdateResponse, error)`
- New function `*GcpOrganizationalDataOrganization.GetGcpOrganizationalData() *GcpOrganizationalData`
- New function `*AwsOrganizationalDataMember.GetAwsOrganizationalData() *AwsOrganizationalData`
- New function `*GovernanceRulesClient.Get(context.Context, string, *GovernanceRulesClientGetOptions) (GovernanceRulesClientGetResponse, error)`
- New function `NewGovernanceAssignmentsClient(azcore.TokenCredential, *arm.ClientOptions) (*GovernanceAssignmentsClient, error)`
- New function `NewGovernanceRuleClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GovernanceRuleClient, error)`
- New function `*ConnectorGovernanceRulesExecuteStatusClient.BeginGet(context.Context, string, string, string, string, *ConnectorGovernanceRulesExecuteStatusClientBeginGetOptions) (*runtime.Poller[ConnectorGovernanceRulesExecuteStatusClientGetResponse], error)`
- New function `*GovernanceAssignmentsClient.Get(context.Context, string, string, string, *GovernanceAssignmentsClientGetOptions) (GovernanceAssignmentsClientGetResponse, error)`
- New function `*AlertsClient.BeginSimulate(context.Context, string, AlertSimulatorRequestBody, *AlertsClientBeginSimulateOptions) (*runtime.Poller[AlertsClientSimulateResponse], error)`
- New function `NewGovernanceRulesClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GovernanceRulesClient, error)`
- New function `*ConnectorGovernanceRulesClient.Delete(context.Context, string, string, string, *ConnectorGovernanceRulesClientDeleteOptions) (ConnectorGovernanceRulesClientDeleteResponse, error)`
- New function `*DefenderForServersGcpOffering.GetCloudOffering() *CloudOffering`
- New function `*GovernanceAssignmentsClient.Delete(context.Context, string, string, string, *GovernanceAssignmentsClientDeleteOptions) (GovernanceAssignmentsClientDeleteResponse, error)`
- New function `PossibleSubPlanValues() []SubPlan`
- New function `NewApplicationClient(string, azcore.TokenCredential, *arm.ClientOptions) (*ApplicationClient, error)`
- New function `*ConnectorApplicationsClient.NewListPager(string, string, *ConnectorApplicationsClientListOptions) *runtime.Pager[ConnectorApplicationsClientListResponse]`
- New struct `AWSEnvironmentData`
- New struct `AlertPropertiesSupportingEvidence`
- New struct `AlertsClientBeginSimulateOptions`
- New struct `AlertsClientUpdateResourceGroupLevelStateToInProgressOptions`
- New struct `AlertsClientUpdateResourceGroupLevelStateToInProgressResponse`
- New struct `AlertsClientUpdateSubscriptionLevelStateToInProgressOptions`
- New struct `AlertsClientUpdateSubscriptionLevelStateToInProgressResponse`
- New struct `Application`
- New struct `ApplicationClient`
- New struct `ApplicationClientCreateOrUpdateOptions`
- New struct `ApplicationClientCreateOrUpdateResponse`
- New struct `ApplicationClientDeleteOptions`
- New struct `ApplicationClientDeleteResponse`
- New struct `ApplicationClientGetOptions`
- New struct `ApplicationClientGetResponse`
- New struct `ApplicationCondition`
- New struct `ApplicationProperties`
- New struct `ApplicationsClient`
- New struct `ApplicationsClientListOptions`
- New struct `ApplicationsClientListResponse`
- New struct `ApplicationsList`
- New struct `AwsOrganizationalData`
- New struct `AwsOrganizationalDataMaster`
- New struct `AwsOrganizationalDataMember`
- New struct `AzureDevOpsScopeEnvironmentData`
- New struct `Condition`
- New struct `ConnectorApplicationClient`
- New struct `ConnectorApplicationClientCreateOrUpdateOptions`
- New struct `ConnectorApplicationClientCreateOrUpdateResponse`
- New struct `ConnectorApplicationClientDeleteOptions`
- New struct `ConnectorApplicationClientDeleteResponse`
- New struct `ConnectorApplicationClientGetOptions`
- New struct `ConnectorApplicationClientGetResponse`
- New struct `ConnectorApplicationsClient`
- New struct `ConnectorApplicationsClientListOptions`
- New struct `ConnectorApplicationsClientListResponse`
- New struct `ConnectorGovernanceRuleClient`
- New struct `ConnectorGovernanceRuleClientListOptions`
- New struct `ConnectorGovernanceRuleClientListResponse`
- New struct `ConnectorGovernanceRulesClient`
- New struct `ConnectorGovernanceRulesClientCreateOrUpdateOptions`
- New struct `ConnectorGovernanceRulesClientCreateOrUpdateResponse`
- New struct `ConnectorGovernanceRulesClientDeleteOptions`
- New struct `ConnectorGovernanceRulesClientDeleteResponse`
- New struct `ConnectorGovernanceRulesClientGetOptions`
- New struct `ConnectorGovernanceRulesClientGetResponse`
- New struct `ConnectorGovernanceRulesExecuteStatusClient`
- New struct `ConnectorGovernanceRulesExecuteStatusClientBeginGetOptions`
- New struct `ConnectorGovernanceRulesExecuteStatusClientGetResponse`
- New struct `CspmMonitorAzureDevOpsOffering`
- New struct `CspmMonitorGcpOffering`
- New struct `CspmMonitorGcpOfferingNativeCloudConnection`
- New struct `CspmMonitorGithubOffering`
- New struct `DefenderFoDatabasesAwsOffering`
- New struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioning`
- New struct `DefenderFoDatabasesAwsOfferingArcAutoProvisioningServicePrincipalSecretMetadata`
- New struct `DefenderForContainersAwsOfferingContainerVulnerabilityAssessment`
- New struct `DefenderForContainersAwsOfferingContainerVulnerabilityAssessmentTask`
- New struct `DefenderForContainersGcpOffering`
- New struct `DefenderForContainersGcpOfferingDataPipelineNativeCloudConnection`
- New struct `DefenderForContainersGcpOfferingNativeCloudConnection`
- New struct `DefenderForDatabasesGcpOffering`
- New struct `DefenderForDatabasesGcpOfferingArcAutoProvisioning`
- New struct `DefenderForDatabasesGcpOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderForDatabasesGcpOfferingDefenderForDatabasesArcAutoProvisioning`
- New struct `DefenderForServersAwsOfferingMdeAutoProvisioning`
- New struct `DefenderForServersAwsOfferingSubPlan`
- New struct `DefenderForServersAwsOfferingVMScanners`
- New struct `DefenderForServersAwsOfferingVMScannersConfiguration`
- New struct `DefenderForServersAwsOfferingVaAutoProvisioning`
- New struct `DefenderForServersAwsOfferingVaAutoProvisioningConfiguration`
- New struct `DefenderForServersGcpOffering`
- New struct `DefenderForServersGcpOfferingArcAutoProvisioning`
- New struct `DefenderForServersGcpOfferingArcAutoProvisioningConfiguration`
- New struct `DefenderForServersGcpOfferingDefenderForServers`
- New struct `DefenderForServersGcpOfferingMdeAutoProvisioning`
- New struct `DefenderForServersGcpOfferingSubPlan`
- New struct `DefenderForServersGcpOfferingVaAutoProvisioning`
- New struct `DefenderForServersGcpOfferingVaAutoProvisioningConfiguration`
- New struct `EnvironmentData`
- New struct `ExecuteGovernanceRuleParams`
- New struct `ExecuteRuleStatus`
- New struct `GcpOrganizationalData`
- New struct `GcpOrganizationalDataMember`
- New struct `GcpOrganizationalDataOrganization`
- New struct `GcpProjectDetails`
- New struct `GcpProjectEnvironmentData`
- New struct `GithubScopeEnvironmentData`
- New struct `GovernanceAssignment`
- New struct `GovernanceAssignmentAdditionalData`
- New struct `GovernanceAssignmentProperties`
- New struct `GovernanceAssignmentsClient`
- New struct `GovernanceAssignmentsClientCreateOrUpdateOptions`
- New struct `GovernanceAssignmentsClientCreateOrUpdateResponse`
- New struct `GovernanceAssignmentsClientDeleteOptions`
- New struct `GovernanceAssignmentsClientDeleteResponse`
- New struct `GovernanceAssignmentsClientGetOptions`
- New struct `GovernanceAssignmentsClientGetResponse`
- New struct `GovernanceAssignmentsClientListOptions`
- New struct `GovernanceAssignmentsClientListResponse`
- New struct `GovernanceAssignmentsList`
- New struct `GovernanceEmailNotification`
- New struct `GovernanceRule`
- New struct `GovernanceRuleClient`
- New struct `GovernanceRuleClientListOptions`
- New struct `GovernanceRuleClientListResponse`
- New struct `GovernanceRuleEmailNotification`
- New struct `GovernanceRuleList`
- New struct `GovernanceRuleOwnerSource`
- New struct `GovernanceRuleProperties`
- New struct `GovernanceRulesClient`
- New struct `GovernanceRulesClientBeginRuleIDExecuteSingleSecurityConnectorOptions`
- New struct `GovernanceRulesClientBeginRuleIDExecuteSingleSubscriptionOptions`
- New struct `GovernanceRulesClientCreateOrUpdateOptions`
- New struct `GovernanceRulesClientCreateOrUpdateResponse`
- New struct `GovernanceRulesClientDeleteOptions`
- New struct `GovernanceRulesClientDeleteResponse`
- New struct `GovernanceRulesClientGetOptions`
- New struct `GovernanceRulesClientGetResponse`
- New struct `GovernanceRulesClientRuleIDExecuteSingleSecurityConnectorResponse`
- New struct `GovernanceRulesClientRuleIDExecuteSingleSubscriptionResponse`
- New struct `RemediationEta`
- New struct `SubscriptionGovernanceRulesExecuteStatusClient`
- New struct `SubscriptionGovernanceRulesExecuteStatusClientBeginGetOptions`
- New struct `SubscriptionGovernanceRulesExecuteStatusClientGetResponse`
- New field `MdeAutoProvisioning` in struct `DefenderForServersAwsOffering`
- New field `SubPlan` in struct `DefenderForServersAwsOffering`
- New field `VMScanners` in struct `DefenderForServersAwsOffering`
- New field `VaAutoProvisioning` in struct `DefenderForServersAwsOffering`
- New field `Deprecated` in struct `PricingProperties`
- New field `ReplacedBy` in struct `PricingProperties`
- New field `HierarchyIdentifierTrialEndDate` in struct `ConnectorProperties`
- New field `EnvironmentData` in struct `ConnectorProperties`
- New field `EnvironmentName` in struct `ConnectorProperties`
- New field `AutoProvisioning` in struct `DefenderForContainersAwsOffering`
- New field `ContainerVulnerabilityAssessment` in struct `DefenderForContainersAwsOffering`
- New field `EnableContainerVulnerabilityAssessment` in struct `DefenderForContainersAwsOffering`
- New field `ContainerVulnerabilityAssessmentTask` in struct `DefenderForContainersAwsOffering`
- New field `KubeAuditRetentionTime` in struct `DefenderForContainersAwsOffering`
- New field `ScubaExternalID` in struct `DefenderForContainersAwsOffering`
- New field `SubTechniques` in struct `AlertProperties`
- New field `Techniques` in struct `AlertProperties`
- New field `SupportingEvidence` in struct `AlertProperties`
- New field `Version` in struct `AlertProperties`
- New field `CloudRoleArn` in struct `DefenderForServersAwsOfferingArcAutoProvisioning`


## 0.7.0 (2022-05-17)

The package of `github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/security/armsecurity` is using our [next generation design principles](https://azure.github.io/azure-sdk/general_introduction.html) since version 0.7.0, which contains breaking changes.

To migrate the existing applications to the latest version, please refer to [Migration Guide](https://aka.ms/azsdk/go/mgmt/migration).

To learn more, please refer to our documentation [Quick Start](https://aka.ms/azsdk/go/mgmt).
