//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/securityinsights/armsecurityinsights/v2"
	"net/http"
	"net/url"
	"regexp"
)

// DataConnectorsCheckRequirementsServer is a fake server for instances of the armsecurityinsights.DataConnectorsCheckRequirementsClient type.
type DataConnectorsCheckRequirementsServer struct {
	// Post is the fake for method DataConnectorsCheckRequirementsClient.Post
	// HTTP status codes to indicate success: http.StatusOK
	Post func(ctx context.Context, resourceGroupName string, workspaceName string, dataConnectorsCheckRequirements armsecurityinsights.DataConnectorsCheckRequirementsClassification, options *armsecurityinsights.DataConnectorsCheckRequirementsClientPostOptions) (resp azfake.Responder[armsecurityinsights.DataConnectorsCheckRequirementsClientPostResponse], errResp azfake.ErrorResponder)
}

// NewDataConnectorsCheckRequirementsServerTransport creates a new instance of DataConnectorsCheckRequirementsServerTransport with the provided implementation.
// The returned DataConnectorsCheckRequirementsServerTransport instance is connected to an instance of armsecurityinsights.DataConnectorsCheckRequirementsClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewDataConnectorsCheckRequirementsServerTransport(srv *DataConnectorsCheckRequirementsServer) *DataConnectorsCheckRequirementsServerTransport {
	return &DataConnectorsCheckRequirementsServerTransport{srv: srv}
}

// DataConnectorsCheckRequirementsServerTransport connects instances of armsecurityinsights.DataConnectorsCheckRequirementsClient to instances of DataConnectorsCheckRequirementsServer.
// Don't use this type directly, use NewDataConnectorsCheckRequirementsServerTransport instead.
type DataConnectorsCheckRequirementsServerTransport struct {
	srv *DataConnectorsCheckRequirementsServer
}

// Do implements the policy.Transporter interface for DataConnectorsCheckRequirementsServerTransport.
func (d *DataConnectorsCheckRequirementsServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "DataConnectorsCheckRequirementsClient.Post":
		resp, err = d.dispatchPost(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (d *DataConnectorsCheckRequirementsServerTransport) dispatchPost(req *http.Request) (*http.Response, error) {
	if d.srv.Post == nil {
		return nil, &nonRetriableError{errors.New("fake for method Post not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.OperationalInsights/workspaces/(?P<workspaceName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.SecurityInsights/dataConnectorsCheckRequirements`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 3 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	raw, err := readRequestBody(req)
	if err != nil {
		return nil, err
	}
	body, err := unmarshalDataConnectorsCheckRequirementsClassification(raw)
	if err != nil {
		return nil, err
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	workspaceNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("workspaceName")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := d.srv.Post(req.Context(), resourceGroupNameParam, workspaceNameParam, body, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).DataConnectorRequirementsState, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
