//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/servicefabricmanagedclusters/armservicefabricmanagedclusters"
	"net/http"
	"net/url"
	"regexp"
)

// ManagedMaintenanceWindowStatusServer is a fake server for instances of the armservicefabricmanagedclusters.ManagedMaintenanceWindowStatusClient type.
type ManagedMaintenanceWindowStatusServer struct {
	// Get is the fake for method ManagedMaintenanceWindowStatusClient.Get
	// HTTP status codes to indicate success: http.StatusOK
	Get func(ctx context.Context, resourceGroupName string, clusterName string, options *armservicefabricmanagedclusters.ManagedMaintenanceWindowStatusClientGetOptions) (resp azfake.Responder[armservicefabricmanagedclusters.ManagedMaintenanceWindowStatusClientGetResponse], errResp azfake.ErrorResponder)
}

// NewManagedMaintenanceWindowStatusServerTransport creates a new instance of ManagedMaintenanceWindowStatusServerTransport with the provided implementation.
// The returned ManagedMaintenanceWindowStatusServerTransport instance is connected to an instance of armservicefabricmanagedclusters.ManagedMaintenanceWindowStatusClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewManagedMaintenanceWindowStatusServerTransport(srv *ManagedMaintenanceWindowStatusServer) *ManagedMaintenanceWindowStatusServerTransport {
	return &ManagedMaintenanceWindowStatusServerTransport{srv: srv}
}

// ManagedMaintenanceWindowStatusServerTransport connects instances of armservicefabricmanagedclusters.ManagedMaintenanceWindowStatusClient to instances of ManagedMaintenanceWindowStatusServer.
// Don't use this type directly, use NewManagedMaintenanceWindowStatusServerTransport instead.
type ManagedMaintenanceWindowStatusServerTransport struct {
	srv *ManagedMaintenanceWindowStatusServer
}

// Do implements the policy.Transporter interface for ManagedMaintenanceWindowStatusServerTransport.
func (m *ManagedMaintenanceWindowStatusServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "ManagedMaintenanceWindowStatusClient.Get":
		resp, err = m.dispatchGet(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (m *ManagedMaintenanceWindowStatusServerTransport) dispatchGet(req *http.Request) (*http.Response, error) {
	if m.srv.Get == nil {
		return nil, &nonRetriableError{errors.New("fake for method Get not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.ServiceFabric/managedClusters/(?P<clusterName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/getMaintenanceWindowStatus`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 3 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	clusterNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("clusterName")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := m.srv.Get(req.Context(), resourceGroupNameParam, clusterNameParam, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).ManagedMaintenanceWindowStatus, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
