//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armservicefabricmanagedclusters

// ApplicationTypeVersionsClientCreateOrUpdateResponse contains the response from method ApplicationTypeVersionsClient.BeginCreateOrUpdate.
type ApplicationTypeVersionsClientCreateOrUpdateResponse struct {
	// An application type version resource for the specified application type name resource.
	ApplicationTypeVersionResource
}

// ApplicationTypeVersionsClientDeleteResponse contains the response from method ApplicationTypeVersionsClient.BeginDelete.
type ApplicationTypeVersionsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationTypeVersionsClientGetResponse contains the response from method ApplicationTypeVersionsClient.Get.
type ApplicationTypeVersionsClientGetResponse struct {
	// An application type version resource for the specified application type name resource.
	ApplicationTypeVersionResource
}

// ApplicationTypeVersionsClientListByApplicationTypesResponse contains the response from method ApplicationTypeVersionsClient.NewListByApplicationTypesPager.
type ApplicationTypeVersionsClientListByApplicationTypesResponse struct {
	// The list of application type version resources for the specified application type name resource.
	ApplicationTypeVersionResourceList
}

// ApplicationTypeVersionsClientUpdateResponse contains the response from method ApplicationTypeVersionsClient.Update.
type ApplicationTypeVersionsClientUpdateResponse struct {
	// An application type version resource for the specified application type name resource.
	ApplicationTypeVersionResource
}

// ApplicationTypesClientCreateOrUpdateResponse contains the response from method ApplicationTypesClient.CreateOrUpdate.
type ApplicationTypesClientCreateOrUpdateResponse struct {
	// The application type name resource
	ApplicationTypeResource
}

// ApplicationTypesClientDeleteResponse contains the response from method ApplicationTypesClient.BeginDelete.
type ApplicationTypesClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationTypesClientGetResponse contains the response from method ApplicationTypesClient.Get.
type ApplicationTypesClientGetResponse struct {
	// The application type name resource
	ApplicationTypeResource
}

// ApplicationTypesClientListResponse contains the response from method ApplicationTypesClient.NewListPager.
type ApplicationTypesClientListResponse struct {
	// The list of application type names.
	ApplicationTypeResourceList
}

// ApplicationTypesClientUpdateResponse contains the response from method ApplicationTypesClient.Update.
type ApplicationTypesClientUpdateResponse struct {
	// The application type name resource
	ApplicationTypeResource
}

// ApplicationsClientCreateOrUpdateResponse contains the response from method ApplicationsClient.BeginCreateOrUpdate.
type ApplicationsClientCreateOrUpdateResponse struct {
	// The application resource.
	ApplicationResource
}

// ApplicationsClientDeleteResponse contains the response from method ApplicationsClient.BeginDelete.
type ApplicationsClientDeleteResponse struct {
	// placeholder for future response values
}

// ApplicationsClientGetResponse contains the response from method ApplicationsClient.Get.
type ApplicationsClientGetResponse struct {
	// The application resource.
	ApplicationResource
}

// ApplicationsClientListResponse contains the response from method ApplicationsClient.NewListPager.
type ApplicationsClientListResponse struct {
	// The list of application resources.
	ApplicationResourceList
}

// ApplicationsClientReadUpgradeResponse contains the response from method ApplicationsClient.BeginReadUpgrade.
type ApplicationsClientReadUpgradeResponse struct {
	// placeholder for future response values
}

// ApplicationsClientResumeUpgradeResponse contains the response from method ApplicationsClient.BeginResumeUpgrade.
type ApplicationsClientResumeUpgradeResponse struct {
	// placeholder for future response values
}

// ApplicationsClientStartRollbackResponse contains the response from method ApplicationsClient.BeginStartRollback.
type ApplicationsClientStartRollbackResponse struct {
	// placeholder for future response values
}

// ApplicationsClientUpdateResponse contains the response from method ApplicationsClient.Update.
type ApplicationsClientUpdateResponse struct {
	// The application resource.
	ApplicationResource
}

// ManagedApplyMaintenanceWindowClientPostResponse contains the response from method ManagedApplyMaintenanceWindowClient.Post.
type ManagedApplyMaintenanceWindowClientPostResponse struct {
	// placeholder for future response values
}

// ManagedAzResiliencyStatusClientGetResponse contains the response from method ManagedAzResiliencyStatusClient.Get.
type ManagedAzResiliencyStatusClientGetResponse struct {
	// Describes the result of the request to list Managed VM Sizes for Service Fabric Managed Clusters.
	ManagedAzResiliencyStatus
}

// ManagedClusterVersionClientGetByEnvironmentResponse contains the response from method ManagedClusterVersionClient.GetByEnvironment.
type ManagedClusterVersionClientGetByEnvironmentResponse struct {
	// The result of the Service Fabric runtime versions
	ManagedClusterCodeVersionResult
}

// ManagedClusterVersionClientGetResponse contains the response from method ManagedClusterVersionClient.Get.
type ManagedClusterVersionClientGetResponse struct {
	// The result of the Service Fabric runtime versions
	ManagedClusterCodeVersionResult
}

// ManagedClusterVersionClientListByEnvironmentResponse contains the response from method ManagedClusterVersionClient.ListByEnvironment.
type ManagedClusterVersionClientListByEnvironmentResponse struct {
	// The list results of the Service Fabric runtime versions.
	ManagedClusterCodeVersionResultArray []*ManagedClusterCodeVersionResult
}

// ManagedClusterVersionClientListResponse contains the response from method ManagedClusterVersionClient.List.
type ManagedClusterVersionClientListResponse struct {
	// The list results of the Service Fabric runtime versions.
	ManagedClusterCodeVersionResultArray []*ManagedClusterCodeVersionResult
}

// ManagedClustersClientCreateOrUpdateResponse contains the response from method ManagedClustersClient.BeginCreateOrUpdate.
type ManagedClustersClientCreateOrUpdateResponse struct {
	// The managed cluster resource
	ManagedCluster
}

// ManagedClustersClientDeleteResponse contains the response from method ManagedClustersClient.BeginDelete.
type ManagedClustersClientDeleteResponse struct {
	// placeholder for future response values
}

// ManagedClustersClientGetResponse contains the response from method ManagedClustersClient.Get.
type ManagedClustersClientGetResponse struct {
	// The managed cluster resource
	ManagedCluster
}

// ManagedClustersClientListByResourceGroupResponse contains the response from method ManagedClustersClient.NewListByResourceGroupPager.
type ManagedClustersClientListByResourceGroupResponse struct {
	// Managed Cluster list results
	ManagedClusterListResult
}

// ManagedClustersClientListBySubscriptionResponse contains the response from method ManagedClustersClient.NewListBySubscriptionPager.
type ManagedClustersClientListBySubscriptionResponse struct {
	// Managed Cluster list results
	ManagedClusterListResult
}

// ManagedClustersClientUpdateResponse contains the response from method ManagedClustersClient.Update.
type ManagedClustersClientUpdateResponse struct {
	// The managed cluster resource
	ManagedCluster
}

// ManagedMaintenanceWindowStatusClientGetResponse contains the response from method ManagedMaintenanceWindowStatusClient.Get.
type ManagedMaintenanceWindowStatusClientGetResponse struct {
	// Describes the maintenance window status of the Service Fabric Managed Cluster.
	ManagedMaintenanceWindowStatus
}

// ManagedUnsupportedVMSizesClientGetResponse contains the response from method ManagedUnsupportedVMSizesClient.Get.
type ManagedUnsupportedVMSizesClientGetResponse struct {
	// Describes a VM Sizes.
	ManagedVMSize
}

// ManagedUnsupportedVMSizesClientListResponse contains the response from method ManagedUnsupportedVMSizesClient.NewListPager.
type ManagedUnsupportedVMSizesClientListResponse struct {
	// Describes the result of the request to list Managed VM Sizes for Service Fabric Managed Clusters.
	ManagedVMSizesResult
}

// NodeTypeSKUsClientListResponse contains the response from method NodeTypeSKUsClient.NewListPager.
type NodeTypeSKUsClientListResponse struct {
	// Node type available sku list results
	NodeTypeListSKUResult
}

// NodeTypesClientCreateOrUpdateResponse contains the response from method NodeTypesClient.BeginCreateOrUpdate.
type NodeTypesClientCreateOrUpdateResponse struct {
	// Describes a node type in the cluster, each node type represents sub set of nodes in the cluster.
	NodeType
}

// NodeTypesClientDeleteNodeResponse contains the response from method NodeTypesClient.BeginDeleteNode.
type NodeTypesClientDeleteNodeResponse struct {
	// placeholder for future response values
}

// NodeTypesClientDeleteResponse contains the response from method NodeTypesClient.BeginDelete.
type NodeTypesClientDeleteResponse struct {
	// placeholder for future response values
}

// NodeTypesClientGetResponse contains the response from method NodeTypesClient.Get.
type NodeTypesClientGetResponse struct {
	// Describes a node type in the cluster, each node type represents sub set of nodes in the cluster.
	NodeType
}

// NodeTypesClientListByManagedClustersResponse contains the response from method NodeTypesClient.NewListByManagedClustersPager.
type NodeTypesClientListByManagedClustersResponse struct {
	// Node type list results
	NodeTypeListResult
}

// NodeTypesClientReimageResponse contains the response from method NodeTypesClient.BeginReimage.
type NodeTypesClientReimageResponse struct {
	// placeholder for future response values
}

// NodeTypesClientRestartResponse contains the response from method NodeTypesClient.BeginRestart.
type NodeTypesClientRestartResponse struct {
	// placeholder for future response values
}

// NodeTypesClientUpdateResponse contains the response from method NodeTypesClient.BeginUpdate.
type NodeTypesClientUpdateResponse struct {
	// Describes a node type in the cluster, each node type represents sub set of nodes in the cluster.
	NodeType
}

// OperationResultsClientGetResponse contains the response from method OperationResultsClient.Get.
type OperationResultsClientGetResponse struct {
	// Location contains the information returned from the Location header response.
	Location *string
}

// OperationStatusClientGetResponse contains the response from method OperationStatusClient.Get.
type OperationStatusClientGetResponse struct {
	// Long running operation result.
	LongRunningOperationResult
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Describes the result of the request to list Service Fabric resource provider operations.
	OperationListResult
}

// ServicesClientCreateOrUpdateResponse contains the response from method ServicesClient.BeginCreateOrUpdate.
type ServicesClientCreateOrUpdateResponse struct {
	// The service resource.
	ServiceResource
}

// ServicesClientDeleteResponse contains the response from method ServicesClient.BeginDelete.
type ServicesClientDeleteResponse struct {
	// placeholder for future response values
}

// ServicesClientGetResponse contains the response from method ServicesClient.Get.
type ServicesClientGetResponse struct {
	// The service resource.
	ServiceResource
}

// ServicesClientListByApplicationsResponse contains the response from method ServicesClient.NewListByApplicationsPager.
type ServicesClientListByApplicationsResponse struct {
	// The list of service resources.
	ServiceResourceList
}

// ServicesClientUpdateResponse contains the response from method ServicesClient.Update.
type ServicesClientUpdateResponse struct {
	// The service resource.
	ServiceResource
}
