//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.
// DO NOT EDIT.

package armservicefabricmesh

import (
	"github.com/Azure/azure-sdk-for-go/sdk/azcore"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/arm"
)

// ClientFactory is a client factory used to create any client in this module.
// Don't use this type directly, use NewClientFactory instead.
type ClientFactory struct {
	subscriptionID string
	credential     azcore.TokenCredential
	options        *arm.ClientOptions
}

// NewClientFactory creates a new instance of ClientFactory with the specified values.
// The parameter values will be propagated to any client created from this factory.
//   - subscriptionID - The customer subscription identifier
//   - credential - used to authorize requests. Usually a credential from azidentity.
//   - options - pass nil to accept the default values.
func NewClientFactory(subscriptionID string, credential azcore.TokenCredential, options *arm.ClientOptions) (*ClientFactory, error) {
	_, err := arm.NewClient(moduleName+".ClientFactory", moduleVersion, credential, options)
	if err != nil {
		return nil, err
	}
	return &ClientFactory{
		subscriptionID: subscriptionID, credential: credential,
		options: options.Clone(),
	}, nil
}

func (c *ClientFactory) NewOperationsClient() *OperationsClient {
	subClient, _ := NewOperationsClient(c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewSecretClient() *SecretClient {
	subClient, _ := NewSecretClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewSecretValueClient() *SecretValueClient {
	subClient, _ := NewSecretValueClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewVolumeClient() *VolumeClient {
	subClient, _ := NewVolumeClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewNetworkClient() *NetworkClient {
	subClient, _ := NewNetworkClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewGatewayClient() *GatewayClient {
	subClient, _ := NewGatewayClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewApplicationClient() *ApplicationClient {
	subClient, _ := NewApplicationClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewServiceClient() *ServiceClient {
	subClient, _ := NewServiceClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewServiceReplicaClient() *ServiceReplicaClient {
	subClient, _ := NewServiceReplicaClient(c.subscriptionID, c.credential, c.options)
	return subClient
}

func (c *ClientFactory) NewCodePackageClient() *CodePackageClient {
	subClient, _ := NewCodePackageClient(c.subscriptionID, c.credential, c.options)
	return subClient
}
