//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armservicelinker

// ConfigurationNamesClientListResponse contains the response from method ConfigurationNamesClient.NewListPager.
type ConfigurationNamesClientListResponse struct {
	// Configuration Name list which will be set based on different target resource, client type, auth type.
	ConfigurationNameResult
}

// ConnectorClientCreateDryrunResponse contains the response from method ConnectorClient.BeginCreateDryrun.
type ConnectorClientCreateDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// ConnectorClientCreateOrUpdateResponse contains the response from method ConnectorClient.BeginCreateOrUpdate.
type ConnectorClientCreateOrUpdateResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// ConnectorClientDeleteDryrunResponse contains the response from method ConnectorClient.DeleteDryrun.
type ConnectorClientDeleteDryrunResponse struct {
	// placeholder for future response values
}

// ConnectorClientDeleteResponse contains the response from method ConnectorClient.BeginDelete.
type ConnectorClientDeleteResponse struct {
	// placeholder for future response values
}

// ConnectorClientGenerateConfigurationsResponse contains the response from method ConnectorClient.GenerateConfigurations.
type ConnectorClientGenerateConfigurationsResponse struct {
	// Configurations for source resource, include appSettings, connectionString and serviceBindings
	ConfigurationResult
}

// ConnectorClientGetDryrunResponse contains the response from method ConnectorClient.GetDryrun.
type ConnectorClientGetDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// ConnectorClientGetResponse contains the response from method ConnectorClient.Get.
type ConnectorClientGetResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// ConnectorClientListDryrunResponse contains the response from method ConnectorClient.NewListDryrunPager.
type ConnectorClientListDryrunResponse struct {
	// The list of dryrun.
	DryrunList
}

// ConnectorClientListResponse contains the response from method ConnectorClient.NewListPager.
type ConnectorClientListResponse struct {
	// The list of Linker.
	ResourceList
}

// ConnectorClientUpdateDryrunResponse contains the response from method ConnectorClient.BeginUpdateDryrun.
type ConnectorClientUpdateDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// ConnectorClientUpdateResponse contains the response from method ConnectorClient.BeginUpdate.
type ConnectorClientUpdateResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// ConnectorClientValidateResponse contains the response from method ConnectorClient.BeginValidate.
type ConnectorClientValidateResponse struct {
	// The validation operation result for a Linker.
	ValidateOperationResult
}

// LinkerClientCreateOrUpdateResponse contains the response from method LinkerClient.BeginCreateOrUpdate.
type LinkerClientCreateOrUpdateResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// LinkerClientDeleteResponse contains the response from method LinkerClient.BeginDelete.
type LinkerClientDeleteResponse struct {
	// placeholder for future response values
}

// LinkerClientGetResponse contains the response from method LinkerClient.Get.
type LinkerClientGetResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// LinkerClientListConfigurationsResponse contains the response from method LinkerClient.ListConfigurations.
type LinkerClientListConfigurationsResponse struct {
	// Configurations for source resource, include appSettings, connectionString and serviceBindings
	ConfigurationResult
}

// LinkerClientListResponse contains the response from method LinkerClient.NewListPager.
type LinkerClientListResponse struct {
	// The list of Linker.
	ResourceList
}

// LinkerClientUpdateResponse contains the response from method LinkerClient.BeginUpdate.
type LinkerClientUpdateResponse struct {
	// Linker of source and target resource
	LinkerResource
}

// LinkerClientValidateResponse contains the response from method LinkerClient.BeginValidate.
type LinkerClientValidateResponse struct {
	// The validation operation result for a Linker.
	ValidateOperationResult
}

// LinkersClientCreateDryrunResponse contains the response from method LinkersClient.BeginCreateDryrun.
type LinkersClientCreateDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// LinkersClientDeleteDryrunResponse contains the response from method LinkersClient.DeleteDryrun.
type LinkersClientDeleteDryrunResponse struct {
	// placeholder for future response values
}

// LinkersClientGenerateConfigurationsResponse contains the response from method LinkersClient.GenerateConfigurations.
type LinkersClientGenerateConfigurationsResponse struct {
	// Configurations for source resource, include appSettings, connectionString and serviceBindings
	ConfigurationResult
}

// LinkersClientGetDryrunResponse contains the response from method LinkersClient.GetDryrun.
type LinkersClientGetDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// LinkersClientListDaprConfigurationsResponse contains the response from method LinkersClient.NewListDaprConfigurationsPager.
type LinkersClientListDaprConfigurationsResponse struct {
	// Dapr configuration list supported by Service Connector
	DaprConfigurationList
}

// LinkersClientListDryrunResponse contains the response from method LinkersClient.NewListDryrunPager.
type LinkersClientListDryrunResponse struct {
	// The list of dryrun.
	DryrunList
}

// LinkersClientUpdateDryrunResponse contains the response from method LinkersClient.BeginUpdateDryrun.
type LinkersClientUpdateDryrunResponse struct {
	// a dryrun job resource
	DryrunResource
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// A list of REST API operations supported by an Azure Resource Provider. It contains an URL link to get the next set of results.
	OperationListResult
}
