//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armstoragesync

// CloudEndpointsClientBeginCreateOptions contains the optional parameters for the CloudEndpointsClient.BeginCreate method.
type CloudEndpointsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginDeleteOptions contains the optional parameters for the CloudEndpointsClient.BeginDelete method.
type CloudEndpointsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginPostBackupOptions contains the optional parameters for the CloudEndpointsClient.BeginPostBackup
// method.
type CloudEndpointsClientBeginPostBackupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginPostRestoreOptions contains the optional parameters for the CloudEndpointsClient.BeginPostRestore
// method.
type CloudEndpointsClientBeginPostRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginPreBackupOptions contains the optional parameters for the CloudEndpointsClient.BeginPreBackup
// method.
type CloudEndpointsClientBeginPreBackupOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginPreRestoreOptions contains the optional parameters for the CloudEndpointsClient.BeginPreRestore
// method.
type CloudEndpointsClientBeginPreRestoreOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientBeginTriggerChangeDetectionOptions contains the optional parameters for the CloudEndpointsClient.BeginTriggerChangeDetection
// method.
type CloudEndpointsClientBeginTriggerChangeDetectionOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// CloudEndpointsClientGetOptions contains the optional parameters for the CloudEndpointsClient.Get method.
type CloudEndpointsClientGetOptions struct {
	// placeholder for future optional parameters
}

// CloudEndpointsClientListBySyncGroupOptions contains the optional parameters for the CloudEndpointsClient.NewListBySyncGroupPager
// method.
type CloudEndpointsClientListBySyncGroupOptions struct {
	// placeholder for future optional parameters
}

// CloudEndpointsClientRestoreheartbeatOptions contains the optional parameters for the CloudEndpointsClient.Restoreheartbeat
// method.
type CloudEndpointsClientRestoreheartbeatOptions struct {
	// placeholder for future optional parameters
}

// MicrosoftStorageSyncClientLocationOperationStatusOptions contains the optional parameters for the MicrosoftStorageSyncClient.LocationOperationStatus
// method.
type MicrosoftStorageSyncClientLocationOperationStatusOptions struct {
	// placeholder for future optional parameters
}

// OperationStatusClientGetOptions contains the optional parameters for the OperationStatusClient.Get method.
type OperationStatusClientGetOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// PrivateEndpointConnectionsClientBeginCreateOptions contains the optional parameters for the PrivateEndpointConnectionsClient.BeginCreate
// method.
type PrivateEndpointConnectionsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PrivateEndpointConnectionsClientBeginDeleteOptions contains the optional parameters for the PrivateEndpointConnectionsClient.BeginDelete
// method.
type PrivateEndpointConnectionsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// PrivateEndpointConnectionsClientGetOptions contains the optional parameters for the PrivateEndpointConnectionsClient.Get
// method.
type PrivateEndpointConnectionsClientGetOptions struct {
	// placeholder for future optional parameters
}

// PrivateEndpointConnectionsClientListByStorageSyncServiceOptions contains the optional parameters for the PrivateEndpointConnectionsClient.NewListByStorageSyncServicePager
// method.
type PrivateEndpointConnectionsClientListByStorageSyncServiceOptions struct {
	// placeholder for future optional parameters
}

// PrivateLinkResourcesClientListByStorageSyncServiceOptions contains the optional parameters for the PrivateLinkResourcesClient.ListByStorageSyncService
// method.
type PrivateLinkResourcesClientListByStorageSyncServiceOptions struct {
	// placeholder for future optional parameters
}

// RegisteredServersClientBeginCreateOptions contains the optional parameters for the RegisteredServersClient.BeginCreate
// method.
type RegisteredServersClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// RegisteredServersClientBeginDeleteOptions contains the optional parameters for the RegisteredServersClient.BeginDelete
// method.
type RegisteredServersClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// RegisteredServersClientBeginTriggerRolloverOptions contains the optional parameters for the RegisteredServersClient.BeginTriggerRollover
// method.
type RegisteredServersClientBeginTriggerRolloverOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// RegisteredServersClientGetOptions contains the optional parameters for the RegisteredServersClient.Get method.
type RegisteredServersClientGetOptions struct {
	// placeholder for future optional parameters
}

// RegisteredServersClientListByStorageSyncServiceOptions contains the optional parameters for the RegisteredServersClient.NewListByStorageSyncServicePager
// method.
type RegisteredServersClientListByStorageSyncServiceOptions struct {
	// placeholder for future optional parameters
}

// ServerEndpointsClientBeginCreateOptions contains the optional parameters for the ServerEndpointsClient.BeginCreate method.
type ServerEndpointsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServerEndpointsClientBeginDeleteOptions contains the optional parameters for the ServerEndpointsClient.BeginDelete method.
type ServerEndpointsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServerEndpointsClientBeginRecallActionOptions contains the optional parameters for the ServerEndpointsClient.BeginRecallAction
// method.
type ServerEndpointsClientBeginRecallActionOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServerEndpointsClientBeginUpdateOptions contains the optional parameters for the ServerEndpointsClient.BeginUpdate method.
type ServerEndpointsClientBeginUpdateOptions struct {
	// Any of the properties applicable in PUT request.
	Parameters *ServerEndpointUpdateParameters

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServerEndpointsClientGetOptions contains the optional parameters for the ServerEndpointsClient.Get method.
type ServerEndpointsClientGetOptions struct {
	// placeholder for future optional parameters
}

// ServerEndpointsClientListBySyncGroupOptions contains the optional parameters for the ServerEndpointsClient.NewListBySyncGroupPager
// method.
type ServerEndpointsClientListBySyncGroupOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientBeginCreateOptions contains the optional parameters for the ServicesClient.BeginCreate method.
type ServicesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServicesClientBeginDeleteOptions contains the optional parameters for the ServicesClient.BeginDelete method.
type ServicesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServicesClientBeginUpdateOptions contains the optional parameters for the ServicesClient.BeginUpdate method.
type ServicesClientBeginUpdateOptions struct {
	// Storage Sync Service resource.
	Parameters *ServiceUpdateParameters

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ServicesClientCheckNameAvailabilityOptions contains the optional parameters for the ServicesClient.CheckNameAvailability
// method.
type ServicesClientCheckNameAvailabilityOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientGetOptions contains the optional parameters for the ServicesClient.Get method.
type ServicesClientGetOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientListByResourceGroupOptions contains the optional parameters for the ServicesClient.NewListByResourceGroupPager
// method.
type ServicesClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// ServicesClientListBySubscriptionOptions contains the optional parameters for the ServicesClient.NewListBySubscriptionPager
// method.
type ServicesClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// SyncGroupsClientCreateOptions contains the optional parameters for the SyncGroupsClient.Create method.
type SyncGroupsClientCreateOptions struct {
	// placeholder for future optional parameters
}

// SyncGroupsClientDeleteOptions contains the optional parameters for the SyncGroupsClient.Delete method.
type SyncGroupsClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// SyncGroupsClientGetOptions contains the optional parameters for the SyncGroupsClient.Get method.
type SyncGroupsClientGetOptions struct {
	// placeholder for future optional parameters
}

// SyncGroupsClientListByStorageSyncServiceOptions contains the optional parameters for the SyncGroupsClient.NewListByStorageSyncServicePager
// method.
type SyncGroupsClientListByStorageSyncServiceOptions struct {
	// placeholder for future optional parameters
}

// WorkflowsClientAbortOptions contains the optional parameters for the WorkflowsClient.Abort method.
type WorkflowsClientAbortOptions struct {
	// placeholder for future optional parameters
}

// WorkflowsClientGetOptions contains the optional parameters for the WorkflowsClient.Get method.
type WorkflowsClientGetOptions struct {
	// placeholder for future optional parameters
}

// WorkflowsClientListByStorageSyncServiceOptions contains the optional parameters for the WorkflowsClient.NewListByStorageSyncServicePager
// method.
type WorkflowsClientListByStorageSyncServiceOptions struct {
	// placeholder for future optional parameters
}
