//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armsubscription

// AliasClientCreateResponse contains the response from method AliasClient.BeginCreate.
type AliasClientCreateResponse struct {
	// Subscription Information with the alias.
	AliasResponse
}

// AliasClientDeleteResponse contains the response from method AliasClient.Delete.
type AliasClientDeleteResponse struct {
	// placeholder for future response values
}

// AliasClientGetResponse contains the response from method AliasClient.Get.
type AliasClientGetResponse struct {
	// Subscription Information with the alias.
	AliasResponse
}

// AliasClientListResponse contains the response from method AliasClient.List.
type AliasClientListResponse struct {
	// The list of aliases.
	AliasListResult
}

// BillingAccountClientGetPolicyResponse contains the response from method BillingAccountClient.GetPolicy.
type BillingAccountClientGetPolicyResponse struct {
	// Billing account policies information.
	BillingAccountPoliciesResponse
}

// ClientAcceptOwnershipResponse contains the response from method Client.BeginAcceptOwnership.
type ClientAcceptOwnershipResponse struct {
	// placeholder for future response values
}

// ClientAcceptOwnershipStatusResponse contains the response from method Client.AcceptOwnershipStatus.
type ClientAcceptOwnershipStatusResponse struct {
	// Subscription Accept Ownership Response
	AcceptOwnershipStatusResponse
}

// ClientCancelResponse contains the response from method Client.Cancel.
type ClientCancelResponse struct {
	// The ID of the canceled subscription
	CanceledSubscriptionID
}

// ClientEnableResponse contains the response from method Client.Enable.
type ClientEnableResponse struct {
	// The ID of the subscriptions that is being enabled
	EnabledSubscriptionID
}

// ClientRenameResponse contains the response from method Client.Rename.
type ClientRenameResponse struct {
	// The ID of the subscriptions that is being renamed
	RenamedSubscriptionID
}

// OperationsClientListResponse contains the response from method OperationsClient.NewListPager.
type OperationsClientListResponse struct {
	// Result of the request to list operations. It contains a list of operations and a URL link to get the next set of results.
	OperationListResult
}

// PolicyClientAddUpdatePolicyForTenantResponse contains the response from method PolicyClient.AddUpdatePolicyForTenant.
type PolicyClientAddUpdatePolicyForTenantResponse struct {
	// Tenant policy Information.
	GetTenantPolicyResponse
}

// PolicyClientGetPolicyForTenantResponse contains the response from method PolicyClient.GetPolicyForTenant.
type PolicyClientGetPolicyForTenantResponse struct {
	// Tenant policy Information.
	GetTenantPolicyResponse
}

// PolicyClientListPolicyForTenantResponse contains the response from method PolicyClient.NewListPolicyForTenantPager.
type PolicyClientListPolicyForTenantResponse struct {
	// Tenant policy information list.
	GetTenantPolicyListResponse
}

// SubscriptionsClientGetResponse contains the response from method SubscriptionsClient.Get.
type SubscriptionsClientGetResponse struct {
	// Subscription information.
	Subscription
}

// SubscriptionsClientListLocationsResponse contains the response from method SubscriptionsClient.NewListLocationsPager.
type SubscriptionsClientListLocationsResponse struct {
	// Location list operation response.
	LocationListResult
}

// SubscriptionsClientListResponse contains the response from method SubscriptionsClient.NewListPager.
type SubscriptionsClientListResponse struct {
	// Subscription list operation response.
	ListResult
}

// TenantsClientListResponse contains the response from method TenantsClient.NewListPager.
type TenantsClientListResponse struct {
	// Tenant Ids information.
	TenantListResult
}
