# Release History

## 0.8.0 (2023-11-24)
### Features Added

- Support for test fakes and OpenTelemetry trace spans.


## 0.7.1 (2023-04-14)
### Bug Fixes

- Fix serialization bug of empty value of `any` type.


## 0.7.0 (2023-03-31)
### Features Added

- New struct `ClientFactory` which is a client factory used to create any client in this module


## 0.6.0 (2023-02-24)
### Breaking Changes

- Type of `ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentity.DesiredState` has been changed from `*ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentityDesiredState` to `*DesiredState`
- Type of `ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentity.ActualState` has been changed from `*ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentityActualState` to `*ActualState`
- Type alias `ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentityActualState` has been removed
- Type alias `ManagedIdentitySQLControlSettingsModelPropertiesGrantSQLControlToManagedIdentityDesiredState` has been removed
- Operation `*SQLPoolOperationResultsClient.GetLocationHeaderResult` has been changed to LRO, use `*SQLPoolOperationResultsClient.BeginGetLocationHeaderResult` instead.
- Operation `*SQLPoolsClient.Update` has been changed to LRO, use `*SQLPoolsClient.BeginUpdate` instead.
- Field `Interface` of struct `BigDataPoolsClientDeleteResponse` has been removed
- Field `Interface` of struct `IPFirewallRulesClientDeleteResponse` has been removed
- Field `Interface` of struct `SQLPoolsClientDeleteResponse` has been removed
- Field `Interface` of struct `SQLPoolsClientPauseResponse` has been removed
- Field `Interface` of struct `SQLPoolsClientResumeResponse` has been removed
- Field `Interface` of struct `WorkspacesClientDeleteResponse` has been removed

### Features Added

- New type alias `ActualState` with values `ActualStateDisabled`, `ActualStateDisabling`, `ActualStateEnabled`, `ActualStateEnabling`, `ActualStateUnknown`
- New type alias `DesiredState` with values `DesiredStateDisabled`, `DesiredStateEnabled`
- New type alias `WorkspaceStatus` with values `WorkspaceStatusFailed`, `WorkspaceStatusInProgress`, `WorkspaceStatusSucceeded`
- New function `NewGetClient(string, azcore.TokenCredential, *arm.ClientOptions) (*GetClient, error)`
- New function `*GetClient.IntegrationRuntimeEnableInteractivequery(context.Context, string, string, string, string, *GetClientIntegrationRuntimeEnableInteractivequeryOptions) (GetClientIntegrationRuntimeEnableInteractivequeryResponse, error)`
- New function `*GetClient.IntegrationRuntimeStart(context.Context, string, string, string, string, *GetClientIntegrationRuntimeStartOptions) (GetClientIntegrationRuntimeStartResponse, error)`
- New function `*GetClient.IntegrationRuntimeStop(context.Context, string, string, string, string, *GetClientIntegrationRuntimeStopOptions) (GetClientIntegrationRuntimeStopResponse, error)`
- New function `NewKustoPoolPrivateLinkResourcesClient(string, azcore.TokenCredential, *arm.ClientOptions) (*KustoPoolPrivateLinkResourcesClient, error)`
- New function `*KustoPoolPrivateLinkResourcesClient.NewListPager(string, string, string, *KustoPoolPrivateLinkResourcesClientListOptions) *runtime.Pager[KustoPoolPrivateLinkResourcesClientListResponse]`
- New struct `ErrorResponseAutoGenerated`
- New struct `GetClient`
- New struct `IntegrationRuntimeEnableinteractivequery`
- New struct `IntegrationRuntimeOperationStatus`
- New struct `IntegrationRuntimeStopOperationStatus`
- New struct `KustoPoolPrivateLinkResources`
- New struct `KustoPoolPrivateLinkResourcesClient`
- New struct `KustoPoolPrivateLinkResourcesClientListResponse`
- New struct `PrivateLinkResources`
- New struct `PrivateLinkResourcesProperties`
- New field `IsAutotuneEnabled` in struct `BigDataPoolResourceProperties`
- New anonymous field `BigDataPoolResourceInfo` in struct `BigDataPoolsClientDeleteResponse`
- New field `AADObjectID` in struct `ClusterPrincipalProperties`
- New field `AADObjectID` in struct `DatabasePrincipalProperties`
- New anonymous field `IPFirewallRuleInfo` in struct `IPFirewallRulesClientDeleteResponse`
- New anonymous field `SQLPool` in struct `SQLPoolOperationResultsClientGetLocationHeaderResultResponse`
- New anonymous field `SQLPool` in struct `SQLPoolsClientDeleteResponse`
- New anonymous field `SQLPool` in struct `SQLPoolsClientPauseResponse`
- New anonymous field `SQLPool` in struct `SQLPoolsClientResumeResponse`
- New field `ConfigMergeRule` in struct `SparkConfigurationInfo`
- New anonymous field `Workspace` in struct `WorkspacesClientDeleteResponse`


## 0.5.0 (2022-05-17)

The package of `github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/synapse/armsynapse` is using our [next generation design principles](https://azure.github.io/azure-sdk/general_introduction.html) since version 0.5.0, which contains breaking changes.

To migrate the existing applications to the latest version, please refer to [Migration Guide](https://aka.ms/azsdk/go/mgmt/migration).

To learn more, please refer to our documentation [Quick Start](https://aka.ms/azsdk/go/mgmt).