//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"encoding/json"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/synapse/armsynapse"
)

func unmarshalDataConnectionClassification(rawMsg json.RawMessage) (armsynapse.DataConnectionClassification, error) {
	if rawMsg == nil {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b armsynapse.DataConnectionClassification
	switch m["kind"] {
	case string(armsynapse.DataConnectionKindEventGrid):
		b = &armsynapse.EventGridDataConnection{}
	case string(armsynapse.DataConnectionKindEventHub):
		b = &armsynapse.EventHubDataConnection{}
	case string(armsynapse.DataConnectionKindIotHub):
		b = &armsynapse.IotHubDataConnection{}
	default:
		b = &armsynapse.DataConnection{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}

func unmarshalDatabaseClassification(rawMsg json.RawMessage) (armsynapse.DatabaseClassification, error) {
	if rawMsg == nil {
		return nil, nil
	}
	var m map[string]any
	if err := json.Unmarshal(rawMsg, &m); err != nil {
		return nil, err
	}
	var b armsynapse.DatabaseClassification
	switch m["kind"] {
	case string(armsynapse.KindReadOnlyFollowing):
		b = &armsynapse.ReadOnlyFollowingDatabase{}
	case string(armsynapse.KindReadWrite):
		b = &armsynapse.ReadWriteDatabase{}
	default:
		b = &armsynapse.Database{}
	}
	if err := json.Unmarshal(rawMsg, b); err != nil {
		return nil, err
	}
	return b, nil
}
