//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/synapse/armsynapse"
	"net/http"
	"net/url"
	"regexp"
)

// WorkspaceManagedSQLServerBlobAuditingPoliciesServer is a fake server for instances of the armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClient type.
type WorkspaceManagedSQLServerBlobAuditingPoliciesServer struct {
	// BeginCreateOrUpdate is the fake for method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.BeginCreateOrUpdate
	// HTTP status codes to indicate success: http.StatusOK, http.StatusAccepted
	BeginCreateOrUpdate func(ctx context.Context, resourceGroupName string, workspaceName string, blobAuditingPolicyName armsynapse.BlobAuditingPolicyName, parameters armsynapse.ServerBlobAuditingPolicy, options *armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientBeginCreateOrUpdateOptions) (resp azfake.PollerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientCreateOrUpdateResponse], errResp azfake.ErrorResponder)

	// Get is the fake for method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.Get
	// HTTP status codes to indicate success: http.StatusOK
	Get func(ctx context.Context, resourceGroupName string, workspaceName string, blobAuditingPolicyName armsynapse.BlobAuditingPolicyName, options *armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientGetOptions) (resp azfake.Responder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientGetResponse], errResp azfake.ErrorResponder)

	// NewListByWorkspacePager is the fake for method WorkspaceManagedSQLServerBlobAuditingPoliciesClient.NewListByWorkspacePager
	// HTTP status codes to indicate success: http.StatusOK
	NewListByWorkspacePager func(resourceGroupName string, workspaceName string, options *armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceOptions) (resp azfake.PagerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse])
}

// NewWorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport creates a new instance of WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport with the provided implementation.
// The returned WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport instance is connected to an instance of armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewWorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport(srv *WorkspaceManagedSQLServerBlobAuditingPoliciesServer) *WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport {
	return &WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport{
		srv:                     srv,
		beginCreateOrUpdate:     newTracker[azfake.PollerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientCreateOrUpdateResponse]](),
		newListByWorkspacePager: newTracker[azfake.PagerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse]](),
	}
}

// WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport connects instances of armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClient to instances of WorkspaceManagedSQLServerBlobAuditingPoliciesServer.
// Don't use this type directly, use NewWorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport instead.
type WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport struct {
	srv                     *WorkspaceManagedSQLServerBlobAuditingPoliciesServer
	beginCreateOrUpdate     *tracker[azfake.PollerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientCreateOrUpdateResponse]]
	newListByWorkspacePager *tracker[azfake.PagerResponder[armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse]]
}

// Do implements the policy.Transporter interface for WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport.
func (w *WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "WorkspaceManagedSQLServerBlobAuditingPoliciesClient.BeginCreateOrUpdate":
		resp, err = w.dispatchBeginCreateOrUpdate(req)
	case "WorkspaceManagedSQLServerBlobAuditingPoliciesClient.Get":
		resp, err = w.dispatchGet(req)
	case "WorkspaceManagedSQLServerBlobAuditingPoliciesClient.NewListByWorkspacePager":
		resp, err = w.dispatchNewListByWorkspacePager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (w *WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport) dispatchBeginCreateOrUpdate(req *http.Request) (*http.Response, error) {
	if w.srv.BeginCreateOrUpdate == nil {
		return nil, &nonRetriableError{errors.New("fake for method BeginCreateOrUpdate not implemented")}
	}
	beginCreateOrUpdate := w.beginCreateOrUpdate.get(req)
	if beginCreateOrUpdate == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Synapse/workspaces/(?P<workspaceName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/auditingSettings/(?P<blobAuditingPolicyName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 4 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		body, err := server.UnmarshalRequestAsJSON[armsynapse.ServerBlobAuditingPolicy](req)
		if err != nil {
			return nil, err
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		workspaceNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("workspaceName")])
		if err != nil {
			return nil, err
		}
		blobAuditingPolicyNameParam, err := parseWithCast(matches[regex.SubexpIndex("blobAuditingPolicyName")], func(v string) (armsynapse.BlobAuditingPolicyName, error) {
			p, unescapeErr := url.PathUnescape(v)
			if unescapeErr != nil {
				return "", unescapeErr
			}
			return armsynapse.BlobAuditingPolicyName(p), nil
		})
		if err != nil {
			return nil, err
		}
		respr, errRespr := w.srv.BeginCreateOrUpdate(req.Context(), resourceGroupNameParam, workspaceNameParam, blobAuditingPolicyNameParam, body, nil)
		if respErr := server.GetError(errRespr, req); respErr != nil {
			return nil, respErr
		}
		beginCreateOrUpdate = &respr
		w.beginCreateOrUpdate.add(req, beginCreateOrUpdate)
	}

	resp, err := server.PollerResponderNext(beginCreateOrUpdate, req)
	if err != nil {
		return nil, err
	}

	if !contains([]int{http.StatusOK, http.StatusAccepted}, resp.StatusCode) {
		w.beginCreateOrUpdate.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK, http.StatusAccepted", resp.StatusCode)}
	}
	if !server.PollerResponderMore(beginCreateOrUpdate) {
		w.beginCreateOrUpdate.remove(req)
	}

	return resp, nil
}

func (w *WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport) dispatchGet(req *http.Request) (*http.Response, error) {
	if w.srv.Get == nil {
		return nil, &nonRetriableError{errors.New("fake for method Get not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Synapse/workspaces/(?P<workspaceName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/auditingSettings/(?P<blobAuditingPolicyName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 4 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	workspaceNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("workspaceName")])
	if err != nil {
		return nil, err
	}
	blobAuditingPolicyNameParam, err := parseWithCast(matches[regex.SubexpIndex("blobAuditingPolicyName")], func(v string) (armsynapse.BlobAuditingPolicyName, error) {
		p, unescapeErr := url.PathUnescape(v)
		if unescapeErr != nil {
			return "", unescapeErr
		}
		return armsynapse.BlobAuditingPolicyName(p), nil
	})
	if err != nil {
		return nil, err
	}
	respr, errRespr := w.srv.Get(req.Context(), resourceGroupNameParam, workspaceNameParam, blobAuditingPolicyNameParam, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).ServerBlobAuditingPolicy, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

func (w *WorkspaceManagedSQLServerBlobAuditingPoliciesServerTransport) dispatchNewListByWorkspacePager(req *http.Request) (*http.Response, error) {
	if w.srv.NewListByWorkspacePager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListByWorkspacePager not implemented")}
	}
	newListByWorkspacePager := w.newListByWorkspacePager.get(req)
	if newListByWorkspacePager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Synapse/workspaces/(?P<workspaceName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/auditingSettings`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 3 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		workspaceNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("workspaceName")])
		if err != nil {
			return nil, err
		}
		resp := w.srv.NewListByWorkspacePager(resourceGroupNameParam, workspaceNameParam, nil)
		newListByWorkspacePager = &resp
		w.newListByWorkspacePager.add(req, newListByWorkspacePager)
		server.PagerResponderInjectNextLinks(newListByWorkspacePager, req, func(page *armsynapse.WorkspaceManagedSQLServerBlobAuditingPoliciesClientListByWorkspaceResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListByWorkspacePager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		w.newListByWorkspacePager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListByWorkspacePager) {
		w.newListByWorkspacePager.remove(req)
	}
	return resp, nil
}
