// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) Go Code Generator. DO NOT EDIT.

package fake

import (
	"errors"
	"fmt"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"net/http"
	"strings"
	"sync"
)

// ServerFactory is a fake server for instances of the armtrustedsigning.ClientFactory type.
type ServerFactory struct {
	// CertificateProfilesServer contains the fakes for client CertificateProfilesClient
	CertificateProfilesServer CertificateProfilesServer

	// CodeSigningAccountsServer contains the fakes for client CodeSigningAccountsClient
	CodeSigningAccountsServer CodeSigningAccountsServer

	// OperationsServer contains the fakes for client OperationsClient
	OperationsServer OperationsServer
}

// NewServerFactoryTransport creates a new instance of ServerFactoryTransport with the provided implementation.
// The returned ServerFactoryTransport instance is connected to an instance of armtrustedsigning.ClientFactory via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewServerFactoryTransport(srv *ServerFactory) *ServerFactoryTransport {
	return &ServerFactoryTransport{
		srv: srv,
	}
}

// ServerFactoryTransport connects instances of armtrustedsigning.ClientFactory to instances of ServerFactory.
// Don't use this type directly, use NewServerFactoryTransport instead.
type ServerFactoryTransport struct {
	srv                         *ServerFactory
	trMu                        sync.Mutex
	trCertificateProfilesServer *CertificateProfilesServerTransport
	trCodeSigningAccountsServer *CodeSigningAccountsServerTransport
	trOperationsServer          *OperationsServerTransport
}

// Do implements the policy.Transporter interface for ServerFactoryTransport.
func (s *ServerFactoryTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	client := method[:strings.Index(method, ".")]
	var resp *http.Response
	var err error

	switch client {
	case "CertificateProfilesClient":
		initServer(s, &s.trCertificateProfilesServer, func() *CertificateProfilesServerTransport {
			return NewCertificateProfilesServerTransport(&s.srv.CertificateProfilesServer)
		})
		resp, err = s.trCertificateProfilesServer.Do(req)
	case "CodeSigningAccountsClient":
		initServer(s, &s.trCodeSigningAccountsServer, func() *CodeSigningAccountsServerTransport {
			return NewCodeSigningAccountsServerTransport(&s.srv.CodeSigningAccountsServer)
		})
		resp, err = s.trCodeSigningAccountsServer.Do(req)
	case "OperationsClient":
		initServer(s, &s.trOperationsServer, func() *OperationsServerTransport { return NewOperationsServerTransport(&s.srv.OperationsServer) })
		resp, err = s.trOperationsServer.Do(req)
	default:
		err = fmt.Errorf("unhandled client %s", client)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func initServer[T any](s *ServerFactoryTransport, dst **T, src func() *T) {
	s.trMu.Lock()
	if *dst == nil {
		*dst = src()
	}
	s.trMu.Unlock()
}
