# Release History

## 1.1.0 (2023-11-24)
### Features Added

- Support for test fakes and OpenTelemetry trace spans.


## 1.0.1 (2023-04-14)
### Bug Fixes

- Fix serialization bug of empty value of `any` type.


## 1.0.0 (2023-03-24)
### Breaking Changes

- Function `NewContactsClient` has been removed
- Function `*ContactsClient.BeginCreateOrUpdate` has been removed
- Function `*ContactsClient.BeginDelete` has been removed
- Function `*ContactsClient.Get` has been removed
- Function `*ContactsClient.NewListByCommunicationsGatewayPager` has been removed
- Function `*ContactsClient.Update` has been removed
- Struct `Contact` has been removed
- Struct `ContactListResult` has been removed
- Struct `ContactProperties` has been removed
- Struct `ContactUpdate` has been removed
- Struct `ContactsClient` has been removed

### Features Added

- New struct `ClientFactory` which is a client factory used to create any client in this module
- New enum type `AutoGeneratedDomainNameLabelScope` with values `AutoGeneratedDomainNameLabelScopeNoReuse`, `AutoGeneratedDomainNameLabelScopeResourceGroupReuse`, `AutoGeneratedDomainNameLabelScopeSubscriptionReuse`, `AutoGeneratedDomainNameLabelScopeTenantReuse`
- New enum type `CheckNameAvailabilityReason` with values `CheckNameAvailabilityReasonAlreadyExists`, `CheckNameAvailabilityReasonInvalid`
- New function `NewNameAvailabilityClient(string, azcore.TokenCredential, *arm.ClientOptions) (*NameAvailabilityClient, error)`
- New function `*NameAvailabilityClient.CheckLocal(context.Context, string, CheckNameAvailabilityRequest, *NameAvailabilityClientCheckLocalOptions) (NameAvailabilityClientCheckLocalResponse, error)`
- New struct `CheckNameAvailabilityRequest`
- New struct `CheckNameAvailabilityResponse`
- New field `AutoGeneratedDomainNameLabel` in struct `CommunicationsGatewayProperties`
- New field `AutoGeneratedDomainNameLabelScope` in struct `CommunicationsGatewayProperties`
- New field `EmergencyDialStrings` in struct `CommunicationsGatewayProperties`
- New field `OnPremMcpEnabled` in struct `CommunicationsGatewayProperties`
- New field `TeamsVoicemailPilotNumber` in struct `CommunicationsGatewayProperties`
- New field `AllowedMediaSourceAddressPrefixes` in struct `PrimaryRegionProperties`
- New field `AllowedSignalingSourceAddressPrefixes` in struct `PrimaryRegionProperties`


## 0.1.0 (2023-02-27)

The package of `github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/voiceservices/armvoiceservices` is using our [next generation design principles](https://azure.github.io/azure-sdk/general_introduction.html).

To learn more, please refer to our documentation [Quick Start](https://aka.ms/azsdk/go/mgmt).
