//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armworkloads

// ClientSAPAvailabilityZoneDetailsOptions contains the optional parameters for the Client.SAPAvailabilityZoneDetails method.
type ClientSAPAvailabilityZoneDetailsOptions struct {
	// SAP Availability Zone Details Request body
	SAPAvailabilityZoneDetails *SAPAvailabilityZoneDetailsRequest
}

// ClientSAPDiskConfigurationsOptions contains the optional parameters for the Client.SAPDiskConfigurations method.
type ClientSAPDiskConfigurationsOptions struct {
	// SAP Disk Configurations Request body
	SAPDiskConfigurations *SAPDiskConfigurationsRequest
}

// ClientSAPSizingRecommendationsOptions contains the optional parameters for the Client.SAPSizingRecommendations method.
type ClientSAPSizingRecommendationsOptions struct {
	// SAP Sizing Recommendation Request body
	SAPSizingRecommendation *SAPSizingRecommendationRequest
}

// ClientSAPSupportedSKUOptions contains the optional parameters for the Client.SAPSupportedSKU method.
type ClientSAPSupportedSKUOptions struct {
	// SAP Supported SKU Request body
	SAPSupportedSKU *SAPSupportedSKUsRequest
}

// MonitorsClientBeginCreateOptions contains the optional parameters for the MonitorsClient.BeginCreate method.
type MonitorsClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// MonitorsClientBeginDeleteOptions contains the optional parameters for the MonitorsClient.BeginDelete method.
type MonitorsClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// MonitorsClientGetOptions contains the optional parameters for the MonitorsClient.Get method.
type MonitorsClientGetOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListByResourceGroupOptions contains the optional parameters for the MonitorsClient.NewListByResourceGroupPager
// method.
type MonitorsClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientListOptions contains the optional parameters for the MonitorsClient.NewListPager method.
type MonitorsClientListOptions struct {
	// placeholder for future optional parameters
}

// MonitorsClientUpdateOptions contains the optional parameters for the MonitorsClient.Update method.
type MonitorsClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// ProviderInstancesClientBeginCreateOptions contains the optional parameters for the ProviderInstancesClient.BeginCreate
// method.
type ProviderInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProviderInstancesClientBeginDeleteOptions contains the optional parameters for the ProviderInstancesClient.BeginDelete
// method.
type ProviderInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// ProviderInstancesClientGetOptions contains the optional parameters for the ProviderInstancesClient.Get method.
type ProviderInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// ProviderInstancesClientListOptions contains the optional parameters for the ProviderInstancesClient.NewListPager method.
type ProviderInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPApplicationServerInstancesClientBeginCreateOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginCreate
// method.
type SAPApplicationServerInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginDeleteOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginDelete
// method.
type SAPApplicationServerInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginStartInstance
// method.
type SAPApplicationServerInstancesClientBeginStartInstanceOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginStopInstance
// method.
type SAPApplicationServerInstancesClientBeginStopInstanceOptions struct {
	// SAP Application server instance stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginUpdateOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginUpdate
// method.
type SAPApplicationServerInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientGetOptions contains the optional parameters for the SAPApplicationServerInstancesClient.Get
// method.
type SAPApplicationServerInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPApplicationServerInstancesClientListOptions contains the optional parameters for the SAPApplicationServerInstancesClient.NewListPager
// method.
type SAPApplicationServerInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPCentralInstancesClientBeginCreateOptions contains the optional parameters for the SAPCentralInstancesClient.BeginCreate
// method.
type SAPCentralInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginDeleteOptions contains the optional parameters for the SAPCentralInstancesClient.BeginDelete
// method.
type SAPCentralInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPCentralInstancesClient.BeginStartInstance
// method.
type SAPCentralInstancesClientBeginStartInstanceOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPCentralInstancesClient.BeginStopInstance
// method.
type SAPCentralInstancesClientBeginStopInstanceOptions struct {
	// SAP Central Services instance stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginUpdateOptions contains the optional parameters for the SAPCentralInstancesClient.BeginUpdate
// method.
type SAPCentralInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientGetOptions contains the optional parameters for the SAPCentralInstancesClient.Get method.
type SAPCentralInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPCentralInstancesClientListOptions contains the optional parameters for the SAPCentralInstancesClient.NewListPager method.
type SAPCentralInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPDatabaseInstancesClientBeginCreateOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginCreate
// method.
type SAPDatabaseInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginDeleteOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginDelete
// method.
type SAPDatabaseInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginStartInstance
// method.
type SAPDatabaseInstancesClientBeginStartInstanceOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginStopInstance
// method.
type SAPDatabaseInstancesClientBeginStopInstanceOptions struct {
	// Stop request for the database instance of the SAP system.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginUpdateOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginUpdate
// method.
type SAPDatabaseInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientGetOptions contains the optional parameters for the SAPDatabaseInstancesClient.Get method.
type SAPDatabaseInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPDatabaseInstancesClientListOptions contains the optional parameters for the SAPDatabaseInstancesClient.NewListPager
// method.
type SAPDatabaseInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientBeginCreateOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginCreate
// method.
type SAPVirtualInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginDeleteOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginDelete
// method.
type SAPVirtualInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginStartOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginStart
// method.
type SAPVirtualInstancesClientBeginStartOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginStopOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginStop
// method.
type SAPVirtualInstancesClientBeginStopOptions struct {
	// The Virtual Instance for SAP solutions resource stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientGetOptions contains the optional parameters for the SAPVirtualInstancesClient.Get method.
type SAPVirtualInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientListByResourceGroupOptions contains the optional parameters for the SAPVirtualInstancesClient.NewListByResourceGroupPager
// method.
type SAPVirtualInstancesClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientListBySubscriptionOptions contains the optional parameters for the SAPVirtualInstancesClient.NewListBySubscriptionPager
// method.
type SAPVirtualInstancesClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientUpdateOptions contains the optional parameters for the SAPVirtualInstancesClient.Update method.
type SAPVirtualInstancesClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// SapLandscapeMonitorClientCreateOptions contains the optional parameters for the SapLandscapeMonitorClient.Create method.
type SapLandscapeMonitorClientCreateOptions struct {
	// placeholder for future optional parameters
}

// SapLandscapeMonitorClientDeleteOptions contains the optional parameters for the SapLandscapeMonitorClient.Delete method.
type SapLandscapeMonitorClientDeleteOptions struct {
	// placeholder for future optional parameters
}

// SapLandscapeMonitorClientGetOptions contains the optional parameters for the SapLandscapeMonitorClient.Get method.
type SapLandscapeMonitorClientGetOptions struct {
	// placeholder for future optional parameters
}

// SapLandscapeMonitorClientListOptions contains the optional parameters for the SapLandscapeMonitorClient.List method.
type SapLandscapeMonitorClientListOptions struct {
	// placeholder for future optional parameters
}

// SapLandscapeMonitorClientUpdateOptions contains the optional parameters for the SapLandscapeMonitorClient.Update method.
type SapLandscapeMonitorClientUpdateOptions struct {
	// placeholder for future optional parameters
}
