//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package armworkloadssapvirtualinstance

// OperationsClientListOptions contains the optional parameters for the OperationsClient.NewListPager method.
type OperationsClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPApplicationServerInstancesClientBeginCreateOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginCreate
// method.
type SAPApplicationServerInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginDeleteOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginDelete
// method.
type SAPApplicationServerInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginStartInstance
// method.
type SAPApplicationServerInstancesClientBeginStartInstanceOptions struct {
	// SAP Application server instance start request body.
	Body *StartRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPApplicationServerInstancesClient.BeginStopInstance
// method.
type SAPApplicationServerInstancesClientBeginStopInstanceOptions struct {
	// SAP Application server instance stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPApplicationServerInstancesClientGetOptions contains the optional parameters for the SAPApplicationServerInstancesClient.Get
// method.
type SAPApplicationServerInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPApplicationServerInstancesClientListOptions contains the optional parameters for the SAPApplicationServerInstancesClient.NewListPager
// method.
type SAPApplicationServerInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPApplicationServerInstancesClientUpdateOptions contains the optional parameters for the SAPApplicationServerInstancesClient.Update
// method.
type SAPApplicationServerInstancesClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// SAPCentralInstancesClientBeginCreateOptions contains the optional parameters for the SAPCentralInstancesClient.BeginCreate
// method.
type SAPCentralInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginDeleteOptions contains the optional parameters for the SAPCentralInstancesClient.BeginDelete
// method.
type SAPCentralInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPCentralInstancesClient.BeginStartInstance
// method.
type SAPCentralInstancesClientBeginStartInstanceOptions struct {
	// SAP Central Services instance start request body.
	Body *StartRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPCentralInstancesClient.BeginStopInstance
// method.
type SAPCentralInstancesClientBeginStopInstanceOptions struct {
	// SAP Central Services instance stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPCentralInstancesClientGetOptions contains the optional parameters for the SAPCentralInstancesClient.Get method.
type SAPCentralInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPCentralInstancesClientListOptions contains the optional parameters for the SAPCentralInstancesClient.NewListPager method.
type SAPCentralInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPCentralInstancesClientUpdateOptions contains the optional parameters for the SAPCentralInstancesClient.Update method.
type SAPCentralInstancesClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// SAPDatabaseInstancesClientBeginCreateOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginCreate
// method.
type SAPDatabaseInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginDeleteOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginDelete
// method.
type SAPDatabaseInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginStartInstanceOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginStartInstance
// method.
type SAPDatabaseInstancesClientBeginStartInstanceOptions struct {
	// SAP Database server instance start request body.
	Body *StartRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientBeginStopInstanceOptions contains the optional parameters for the SAPDatabaseInstancesClient.BeginStopInstance
// method.
type SAPDatabaseInstancesClientBeginStopInstanceOptions struct {
	// Stop request for the database instance of the SAP system.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPDatabaseInstancesClientGetOptions contains the optional parameters for the SAPDatabaseInstancesClient.Get method.
type SAPDatabaseInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPDatabaseInstancesClientListOptions contains the optional parameters for the SAPDatabaseInstancesClient.NewListPager
// method.
type SAPDatabaseInstancesClientListOptions struct {
	// placeholder for future optional parameters
}

// SAPDatabaseInstancesClientUpdateOptions contains the optional parameters for the SAPDatabaseInstancesClient.Update method.
type SAPDatabaseInstancesClientUpdateOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientBeginCreateOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginCreate
// method.
type SAPVirtualInstancesClientBeginCreateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginDeleteOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginDelete
// method.
type SAPVirtualInstancesClientBeginDeleteOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginStartOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginStart
// method.
type SAPVirtualInstancesClientBeginStartOptions struct {
	// The Virtual Instance for SAP solutions resource start request body.
	Body *StartRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginStopOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginStop
// method.
type SAPVirtualInstancesClientBeginStopOptions struct {
	// The Virtual Instance for SAP solutions resource stop request body.
	Body *StopRequest

	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientBeginUpdateOptions contains the optional parameters for the SAPVirtualInstancesClient.BeginUpdate
// method.
type SAPVirtualInstancesClientBeginUpdateOptions struct {
	// Resumes the LRO from the provided token.
	ResumeToken string
}

// SAPVirtualInstancesClientGetOptions contains the optional parameters for the SAPVirtualInstancesClient.Get method.
type SAPVirtualInstancesClientGetOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientListByResourceGroupOptions contains the optional parameters for the SAPVirtualInstancesClient.NewListByResourceGroupPager
// method.
type SAPVirtualInstancesClientListByResourceGroupOptions struct {
	// placeholder for future optional parameters
}

// SAPVirtualInstancesClientListBySubscriptionOptions contains the optional parameters for the SAPVirtualInstancesClient.NewListBySubscriptionPager
// method.
type SAPVirtualInstancesClientListBySubscriptionOptions struct {
	// placeholder for future optional parameters
}

// WorkloadsClientSAPAvailabilityZoneDetailsOptions contains the optional parameters for the WorkloadsClient.SAPAvailabilityZoneDetails
// method.
type WorkloadsClientSAPAvailabilityZoneDetailsOptions struct {
	// SAP Availability Zone Details Request body
	SAPAvailabilityZoneDetails *SAPAvailabilityZoneDetailsRequest
}

// WorkloadsClientSAPDiskConfigurationsOptions contains the optional parameters for the WorkloadsClient.SAPDiskConfigurations
// method.
type WorkloadsClientSAPDiskConfigurationsOptions struct {
	// SAP Disk Configurations Request body
	SAPDiskConfigurations *SAPDiskConfigurationsRequest
}

// WorkloadsClientSAPSizingRecommendationsOptions contains the optional parameters for the WorkloadsClient.SAPSizingRecommendations
// method.
type WorkloadsClientSAPSizingRecommendationsOptions struct {
	// SAP Sizing Recommendation Request body
	SAPSizingRecommendation *SAPSizingRecommendationRequest
}

// WorkloadsClientSAPSupportedSKUOptions contains the optional parameters for the WorkloadsClient.SAPSupportedSKU method.
type WorkloadsClientSAPSupportedSKUOptions struct {
	// SAP Supported SKU Request body
	SAPSupportedSKU *SAPSupportedSKUsRequest
}
