//go:build go1.18
// +build go1.18

// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) AutoRest Code Generator. DO NOT EDIT.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

package fake

import (
	"context"
	"errors"
	"fmt"
	azfake "github.com/Azure/azure-sdk-for-go/sdk/azcore/fake"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/fake/server"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/runtime"
	"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
	"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/sql/armsql/v2"
	"net/http"
	"net/url"
	"regexp"
)

// DatabaseSQLVulnerabilityAssessmentScanResultServer is a fake server for instances of the armsql.DatabaseSQLVulnerabilityAssessmentScanResultClient type.
type DatabaseSQLVulnerabilityAssessmentScanResultServer struct {
	// Get is the fake for method DatabaseSQLVulnerabilityAssessmentScanResultClient.Get
	// HTTP status codes to indicate success: http.StatusOK
	Get func(ctx context.Context, resourceGroupName string, serverName string, databaseName string, vulnerabilityAssessmentName armsql.SQLVulnerabilityAssessmentName, scanID string, scanResultID string, options *armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientGetOptions) (resp azfake.Responder[armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientGetResponse], errResp azfake.ErrorResponder)

	// NewListByScanPager is the fake for method DatabaseSQLVulnerabilityAssessmentScanResultClient.NewListByScanPager
	// HTTP status codes to indicate success: http.StatusOK
	NewListByScanPager func(resourceGroupName string, serverName string, databaseName string, vulnerabilityAssessmentName armsql.SQLVulnerabilityAssessmentName, scanID string, options *armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientListByScanOptions) (resp azfake.PagerResponder[armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientListByScanResponse])
}

// NewDatabaseSQLVulnerabilityAssessmentScanResultServerTransport creates a new instance of DatabaseSQLVulnerabilityAssessmentScanResultServerTransport with the provided implementation.
// The returned DatabaseSQLVulnerabilityAssessmentScanResultServerTransport instance is connected to an instance of armsql.DatabaseSQLVulnerabilityAssessmentScanResultClient via the
// azcore.ClientOptions.Transporter field in the client's constructor parameters.
func NewDatabaseSQLVulnerabilityAssessmentScanResultServerTransport(srv *DatabaseSQLVulnerabilityAssessmentScanResultServer) *DatabaseSQLVulnerabilityAssessmentScanResultServerTransport {
	return &DatabaseSQLVulnerabilityAssessmentScanResultServerTransport{
		srv:                srv,
		newListByScanPager: newTracker[azfake.PagerResponder[armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientListByScanResponse]](),
	}
}

// DatabaseSQLVulnerabilityAssessmentScanResultServerTransport connects instances of armsql.DatabaseSQLVulnerabilityAssessmentScanResultClient to instances of DatabaseSQLVulnerabilityAssessmentScanResultServer.
// Don't use this type directly, use NewDatabaseSQLVulnerabilityAssessmentScanResultServerTransport instead.
type DatabaseSQLVulnerabilityAssessmentScanResultServerTransport struct {
	srv                *DatabaseSQLVulnerabilityAssessmentScanResultServer
	newListByScanPager *tracker[azfake.PagerResponder[armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientListByScanResponse]]
}

// Do implements the policy.Transporter interface for DatabaseSQLVulnerabilityAssessmentScanResultServerTransport.
func (d *DatabaseSQLVulnerabilityAssessmentScanResultServerTransport) Do(req *http.Request) (*http.Response, error) {
	rawMethod := req.Context().Value(runtime.CtxAPINameKey{})
	method, ok := rawMethod.(string)
	if !ok {
		return nil, nonRetriableError{errors.New("unable to dispatch request, missing value for CtxAPINameKey")}
	}

	var resp *http.Response
	var err error

	switch method {
	case "DatabaseSQLVulnerabilityAssessmentScanResultClient.Get":
		resp, err = d.dispatchGet(req)
	case "DatabaseSQLVulnerabilityAssessmentScanResultClient.NewListByScanPager":
		resp, err = d.dispatchNewListByScanPager(req)
	default:
		err = fmt.Errorf("unhandled API %s", method)
	}

	if err != nil {
		return nil, err
	}

	return resp, nil
}

func (d *DatabaseSQLVulnerabilityAssessmentScanResultServerTransport) dispatchGet(req *http.Request) (*http.Response, error) {
	if d.srv.Get == nil {
		return nil, &nonRetriableError{errors.New("fake for method Get not implemented")}
	}
	const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Sql/servers/(?P<serverName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/databases/(?P<databaseName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/sqlVulnerabilityAssessments/(?P<vulnerabilityAssessmentName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/scans/(?P<scanId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/scanResults/(?P<scanResultId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)`
	regex := regexp.MustCompile(regexStr)
	matches := regex.FindStringSubmatch(req.URL.EscapedPath())
	if matches == nil || len(matches) < 7 {
		return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
	}
	resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
	if err != nil {
		return nil, err
	}
	serverNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("serverName")])
	if err != nil {
		return nil, err
	}
	databaseNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("databaseName")])
	if err != nil {
		return nil, err
	}
	vulnerabilityAssessmentNameParam, err := parseWithCast(matches[regex.SubexpIndex("vulnerabilityAssessmentName")], func(v string) (armsql.SQLVulnerabilityAssessmentName, error) {
		p, unescapeErr := url.PathUnescape(v)
		if unescapeErr != nil {
			return "", unescapeErr
		}
		return armsql.SQLVulnerabilityAssessmentName(p), nil
	})
	if err != nil {
		return nil, err
	}
	scanIDParam, err := url.PathUnescape(matches[regex.SubexpIndex("scanId")])
	if err != nil {
		return nil, err
	}
	scanResultIDParam, err := url.PathUnescape(matches[regex.SubexpIndex("scanResultId")])
	if err != nil {
		return nil, err
	}
	respr, errRespr := d.srv.Get(req.Context(), resourceGroupNameParam, serverNameParam, databaseNameParam, vulnerabilityAssessmentNameParam, scanIDParam, scanResultIDParam, nil)
	if respErr := server.GetError(errRespr, req); respErr != nil {
		return nil, respErr
	}
	respContent := server.GetResponseContent(respr)
	if !contains([]int{http.StatusOK}, respContent.HTTPStatus) {
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", respContent.HTTPStatus)}
	}
	resp, err := server.MarshalResponseAsJSON(respContent, server.GetResponse(respr).VulnerabilityAssessmentScanResults, req)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

func (d *DatabaseSQLVulnerabilityAssessmentScanResultServerTransport) dispatchNewListByScanPager(req *http.Request) (*http.Response, error) {
	if d.srv.NewListByScanPager == nil {
		return nil, &nonRetriableError{errors.New("fake for method NewListByScanPager not implemented")}
	}
	newListByScanPager := d.newListByScanPager.get(req)
	if newListByScanPager == nil {
		const regexStr = `/subscriptions/(?P<subscriptionId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/resourceGroups/(?P<resourceGroupName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/providers/Microsoft\.Sql/servers/(?P<serverName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/databases/(?P<databaseName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/sqlVulnerabilityAssessments/(?P<vulnerabilityAssessmentName>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/scans/(?P<scanId>[!#&$-;=?-\[\]_a-zA-Z0-9~%@]+)/scanResults`
		regex := regexp.MustCompile(regexStr)
		matches := regex.FindStringSubmatch(req.URL.EscapedPath())
		if matches == nil || len(matches) < 6 {
			return nil, fmt.Errorf("failed to parse path %s", req.URL.Path)
		}
		resourceGroupNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("resourceGroupName")])
		if err != nil {
			return nil, err
		}
		serverNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("serverName")])
		if err != nil {
			return nil, err
		}
		databaseNameParam, err := url.PathUnescape(matches[regex.SubexpIndex("databaseName")])
		if err != nil {
			return nil, err
		}
		vulnerabilityAssessmentNameParam, err := parseWithCast(matches[regex.SubexpIndex("vulnerabilityAssessmentName")], func(v string) (armsql.SQLVulnerabilityAssessmentName, error) {
			p, unescapeErr := url.PathUnescape(v)
			if unescapeErr != nil {
				return "", unescapeErr
			}
			return armsql.SQLVulnerabilityAssessmentName(p), nil
		})
		if err != nil {
			return nil, err
		}
		scanIDParam, err := url.PathUnescape(matches[regex.SubexpIndex("scanId")])
		if err != nil {
			return nil, err
		}
		resp := d.srv.NewListByScanPager(resourceGroupNameParam, serverNameParam, databaseNameParam, vulnerabilityAssessmentNameParam, scanIDParam, nil)
		newListByScanPager = &resp
		d.newListByScanPager.add(req, newListByScanPager)
		server.PagerResponderInjectNextLinks(newListByScanPager, req, func(page *armsql.DatabaseSQLVulnerabilityAssessmentScanResultClientListByScanResponse, createLink func() string) {
			page.NextLink = to.Ptr(createLink())
		})
	}
	resp, err := server.PagerResponderNext(newListByScanPager, req)
	if err != nil {
		return nil, err
	}
	if !contains([]int{http.StatusOK}, resp.StatusCode) {
		d.newListByScanPager.remove(req)
		return nil, &nonRetriableError{fmt.Errorf("unexpected status code %d. acceptable values are http.StatusOK", resp.StatusCode)}
	}
	if !server.PagerResponderMore(newListByScanPager) {
		d.newListByScanPager.remove(req)
	}
	return resp, nil
}
